import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.serial.*; 
import javax.swing.ImageIcon; 
import java.awt.Dimension; 
import java.io.BufferedWriter; 
import java.io.FileWriter; 
import processing.net.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class NLEDAurora extends PApplet {

/*
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES 
PROVIDE THE PROGRAM \u201cAS IS\u201d WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
NECESSARY SERVICING, REPAIR OR CORRECTION.
Original Author: Jeffrey Nygaard
Company: Northern Lights Electronic Design, LLC
Date: May 26, 2017
Contact: JNygaard@NLEDshop.com
NLED Aurora Control Software Version: 2a
Written in Processing v3.3.3
Copyright\u00a9 2017 by Northern Lights Electronic Design, LLC. All Rights Reserved
This is proprietary software and the source code is not available. If you have any questions on customization or bug fixes
please contact above author.
Code is mostly obfuscated so don't even try to reverse engineer it! Why are you even reading this?
*/

//import processing.video.*;

java.awt.Insets insets;



BufferedWriter bw = null;
 
/*
Specs: 
Max Frames: 65,535(not quite)
Max Channels: 512
Max USB Live Control Through GUI: 233 channels
Max Index Sequences: 256
Max Sequences In Software: 256
Hotkeys:
s - autosaves
m - empty command request, test if alive
left and right arrows - adjust previously slected slider	
Escape - Closes Color Picker & Overlay Menus
Enter/Return: 
- If textfield is selected it commits the change
- If color picker is open it applies the color selection
- While Resizing Graphic Layout Image - Press Enter/Return to apply
- Closes Technical mode radial menu
Sub Menus:
Stand alone control, USB live control sliders, live control rects, sequence select, gamma correction, tech radials
*/
final int IASoqAE = color(0x2A,0xAC,0xE3);
final int HoBBOyq = color(43, 55, 144);
final int VySlFUN = color(204,0,0);
final int wwboXgE = color(255);
final int DqoHydg = color(65);
final int JCZFGSk = color(190);
final int WcWJAym = color(200);
final int emrZzJV = color(120);
final int JOHAtnJ = color(100);
final int mlIVvlI = color(255);
final int PlmGjjm = color(0);
final int vziUGrB = color(0, 104, 55);
final int mYkuUaE = color(255);
final int DYViHZj = color(90,0,255);

final String[] cPixelChipsetStrings = {"DEFAULT", "WS2801", "WS2811", "WS2812", "WS2812B", "LPD1886", "LPD6803", "LPD8806", "TM1803", "TM1814", "APA102", "APA104", "SK6812","DMX-512", "APA106"};
final String[] cPixelChipsetColorID = {"varies / unknown", "varies / R>G>B", "varies", "G>R>B", "G>R>B", "TEST", "TEST", "TEST", "varies / G>B>R", "TEST", "B>G>R", "TEST", "G>R>B>W","R>G>B","R>G>B"};
final String cModeString[] = {"Stall", "Fade", "Gradient", "Instant", "Technical", "POV", "File Play", "Linked", "DMX", "Serial", "USB"};
final String cPixelIDStr[] = {"Single", "RGB", "RGBW"};
final String cNoneStr[] = {"None"};
final String cColorSwapStr[] = {"None", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B"};
final String cGlobalColSwapStr[] = {"R>G>B(>W)", "B>R>G", "G>B>R", "R>B>G", "B>G>R", "G>R>B","G>R>B>W"};
final String cDDBaudstring[] = {"9600", "19200", "38400", "57600", "115200", "230400", "250000", "460800", "500000", "1Mbit"}; 
final String cDDLEDMstring[] = {"Both", "Stand-Alone", "RX", "Disabled"};
final String cDDPOVModeString[] = {"Normal Mode", "Mode 1mS", "Mode 2mS", "Mode 3mS", "Mode 4mS", "Mode 5mS", "Mode 6mS", "Mode 8mS", "Mode 16mS"};
final int cDDPOVModeValues[] = {0, 1, 2, 3, 4, 5, 6, 8, 16};
final String cRevisionIDstr[] = {"a", "b", "c", "d", "e", "f", "g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"};
final String cDDAutoDetectModesT1[] = {"None/Disabled", "Auto-Detect DMX", "Auto-Detect Serial"};
final String cDDAutoDetectModesT2[] = {"None/Disabled", "Auto-Detect DMX"};
final String cDDAutoDetectModesT3[] = {"None/Disabled", "Auto-Detect"};
final String cDDMasterModes8Bit[] = {"None/Slave", "Master Full Pkts", "Master Partial Pkts"};
final String cDDMasterModesMultiBit[] = {"None/Slave", "Master Full Pkts 8-Bit", "Master Full Pkts 16-Bit", "Master Partial Pkts 8-Bit", "Master Partial Pkts 16-Bit"};
final String cDDDisplayModes[] = {"Always On", "Countdown", "Dim", "Countdown+Dim"};
final String cDDShapeOptions[] = {"Round", "Square", "Spiral", "Line", "Pixel Map", "Manual"};
final String cDDAccMeterShutOff[] = {"Disabled", "5 Sec.", "10 Sec.", "20 Sec.", "30 Sec", "40 Sec.", "60 Sec.","80 Sec."};
final String cDDAccMeterShutOffMode[] = {"Blank","Idle Sequence"};
final int cAccMeterShutOffVals[] = {0,16,32,64,96,128,192,250};
final String cDDPowerTimeOut[] = {"Disabled", "5 Min.", "10 Min.", "15 Min."};
final String cDDAccMeterTapMode[] = {"Disabled", "Sensitive", "Normal", "Strong"};
final String cDDSequenceMode[] = {"Fade", "Gradient", "Instant", "Technical", "POV", "File Play", "Linked"}; 
final String cDDSequenceModeBasic1[] = {"Fade", "Instant", "Gradient", "-----", "-----", "-----"};
final String cDDSequenceModeBasic2[] = {"Fade", "Instant", "Gradient", "-----", "Linked", "-----"};
final String cDDPacketClone[] = {"No Clone","Clone x1","Clone x2","Clone x3","Clone x4","Clone x5","Clone x6","Clone x7","Clone x8"};
final String cDDGroupSelect[] = {"1","2","3","4","5","6","7","8"};
final String cDDFrameSeqTech[] = {"Ramp", "Solid"};
final String cDDFrameSeqInstant[] = {"Instant", "Slide Up", "Slide Down"};
final String cDDPWMFreqA[] = {"31 KHz", "7.8 KHz", "1.95 KHz", "488 Hz"};
final String cDDStandAloneA[] = {"Hold", "Blank", "Fade Out", "Stand-Alone"};
final String cDDSeqTransistion[] = {"Instant", "Fast Fade In", "Slow Fade In"}; 
final String cDDSeqPlayMode[] = {"Loop", "One-Shot Next", "One-Shot Start", "One-Shot End", "One-Shot Blank", "One-Shot Idle"};
final String cConfirmBoxText[] = {"Null-Bad ID Number",
"Confirm Full Upload to connected device. Device sequence data will be erased and new data uploaded",
"Are you sure you would like to delete ", 
"Are you sure you want to delete all sequences?",
"Are you sure you would like to reset the index and clear it?", 
"Would you like to update the utilized Channel amount? Doing so may make some sequences not work til updated.",
"The selected Sequences file is corrupt or errored. Either load a different file, contact support for help recovering the file. Or try restarting the software.",
"Bad Start Values have been detected, various issues can occur, recommend fixing them. Ignore and Send Anyway?",
"This device has a firmware update available, see the included 'Update' folder for details", 
"This will enter the device into bootloader mode, you wil need to close the software and open the bootloader software.",
"The selected file is for a different device, errors may occur. Continue to load sequence file?",		
"Device has responded with unverified firmware, functions disabled. Contact Support.", 
"Are you sure you would like to upload the configuration settings currently shown the the hardware tab?", 
"Are you sure you would like to add this layout to the current group ID? This cannot be undone", 
"Are you sure you would like to merge all groups to current ID? This cannot be undone", 
"Are you sure you would like to clear all icons from the current group ID? This cannot be undone", 
"Are you sure you want to reset the Start Values?", 
"This will overwrite the current Gamma table with the default. Continue?",
"This will overwrite the current Gamma table with the user selected. Ensure user data has been loaded. Continue?",	
"Request configurations from device? It will overwrite software settings."
};
final String cNotificationText[] = {"none", "Command Successful","Start Values Reset","QuickSave Successful","Not Enough Memory","Sequence to Large to Preview","Device Timeout",
"Command Timeout","Port Not Open","Not Yet Added","Frame Data Copied","No Painting Gradients","Disable Paint Before Closing", 
"Can Not Change Channel Amount","Reached Maximum Linked Sequences","Cannot Send With 0 Sequences On Index","Bad ID's or Device File, Attempt Reconnect",
"Coordinates Missing, Check Pixel Map", "Sequence Duplicated","Sequence User ID Changed", 
"No More Sequences Can Be Added", "Upload Cancelled", "Serial Port In Use", "Software Update Available", 
"Graphic Layout Image Not Found","Deleted, a Linked Sequence Requires Updating", 
"The POV file that was loaded is too large,\n please check settings", "Video file must be reloaded to change config", 
"Configurations Uploaded" 
};		
final String cPOVDescriptions[] = {"First Pixel Is On The Left. Rows Are Displayed Top To Bottom.",
"First Pixel Is Bottom Left. Columns Are Displayed Left To Right.",								   
"First Pixel Is On The Right. Rows Are Displayed Top To Bottom.",
"First Pixel Is Top Left. Columns Are Displayed Left To Right."								 									
};		
final String cPOVDescriptionsSecond[] = {"Width Is Amount Of Pixels, Height Is Frames.",
"Height is Amount Of Pixels, Width is Frames",
"Width Is Amount Of Pixels, Height Is Frames.",
"Height is Amount Of Pixels, Width is Frames"								 									
};										
final int rbVpcAx = 0;
final int EqPnOUb = 1;
final int kRMfOXG = 2;
final int lMBafjD = 3;
final int mTKKGDu = 4;
final int XyiEbAJ = 5;
final int xvXsTNs = 6;
final int qzXknoY = 7;
final int orXQXKN = 100;
final int VrjUaNV = 101;
final int tPkEylv = 102;
final int SjzAVjL = 0xFFFF;
final int wqajEny = 512;
final int XwgQulc = 256;
final int TATbaZv = 2;
final int OhKywff = 2;
final int MNxHTMd = 20;
final int zIQLTNT = 100; 
final int XuFFMGQ = 65;  
final int osqIpiO = 135;  
final int ZpIfePQ = 475;  
final int dodEQlf = 30;
final int TXbHser = 20; 
final int sGOqkUb = 670; 
final int UZtwAsu = 670;
final int mzFoUAv = 510; 
final int fSAlYpX = 110;
final int ZtBHbDg = 85;
final int GDlXxCI = 95;
final int ZtBHbDgorizSpace = 120;
final int tuCbyyd = 500;
final int qxXNcNf = 670;
final int AqFFYoX = 130;
final int aoXExLf = 665;
final int ehtEwNl = 400;
final int AEcZkIL = 150;
final int OvprrrD = 130;
final int aVMHNFe = 125;  
final int gEfHGFk = 35;  
final int hwAmagv = 95;
final int WTkKqlA = 0;
final int xsyaBOR = 1;
final int dqimCOA = 2;
final int cfXHabo = 8888;
final int bgpbnOG = 19999;
final int CguezcT = 29999;
final int ntxqOwz = 3000; 
final int smFWXrf = 16;
final int[] IconGroupColors = {color(255,0,0), color(0,255,0), color(0,0,255), color(255,0,255), color(255,255,0), color(0,255,255), color(255,255,255), color(0,0,0)};
final String cTextFieldMethods[] = {"txtHandleSeqSpeed", "txtHandleChannels","txtHandlePixelIcon","txtGradientSteps","txtHandleMultiplier","txtHandleGenericNumber","txtHandleGenericNumber"};

final int[] cDefaultGammaTable = {
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2,
2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5,
6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10, 11, 11,
11, 12, 12, 13, 13, 13, 14, 14, 15, 15, 16, 16, 17, 17, 18, 18,
19, 19, 20, 21, 21, 22, 22, 23, 23, 24, 25, 25, 26, 27, 27, 28,
29, 29, 30, 31, 31, 32, 33, 34, 34, 35, 36, 37, 37, 38, 39, 40,
40, 41, 42, 43, 44, 45, 46, 46, 47, 48, 49, 50, 51, 52, 53, 54,
55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70,
71, 72, 73, 74, 76, 77, 78, 79, 80, 81, 83, 84, 85, 86, 88, 89,
90, 91, 93, 94, 95, 96, 98, 99,100,102,103,104,106,107,109,110,
111,113,114,116,117,119,120,121,123,124,126,128,129,131,132,134,
135,137,138,140,142,143,145,146,148,150,151,153,155,157,158,160,
162,163,165,167,169,170,172,174,176,178,179,181,183,185,187,189,
191,193,194,196,198,200,202,204,206,208,210,212,214,216,218,220,
222,224,227,229,231,233,235,237,239,241,244,246,248,250,252,255};

int gTaWjjx = height;  
int rJUZtcV = width;
float gwFwycD = 1;
int YLWNFLV = 0; 
int fdJgaNC = 0;
int uqdivtD = 0;
int EMCDldB = 0;
int bJxobsd = 0;
boolean AzUdiEH = false;
boolean emEPIOg = false;
boolean DXcJNIU = false;
boolean AJcBVWK = false;
boolean XEfHstU = false;
int NHYXqPY = 0;
boolean DACOCBN = false;
int wtoALPx = 0;
int CrytrWK = 0;
int dDtnlfP = 0;
int sXdSznK = 0;
String wpDDAOi = "";
String wnluxLL = "";
int TDWCxom = 0;
String baRtlHT = "None";
String UPCYumR = "Unconnected";
String netOeFl = "192.168.4.1"; 
int ZhEGIBX = 23;
int[] oxBdCTX = {0,0,0,0};
int[][] paletteColors = new int[6][4];
int UoTDXgS = 0;
int UkmBkwh = 0;
int wSEGOyM = 0;
int YuOyzOP = 0;
int dfXKrgk = 0; 
boolean hSgZeBG = false;
int AkOQmUe = 0;
int lQGtaTe = 0;
int uBYXrqM = 1;
int iVuTrwr = 0;
int oiHkAsJ = 0;
int ByoKxya = 3; 
int QCZOouc = 1; 
int uZYECeH = color(0);
float ZhmkwyF  = 0;
float IwpariG = 0;
float dyrGyHh = 0;
float roIonSV = 0;
String wSlKztR = "";
String iKxwBtq = "";
String iKxwBtqCondensed = "";
int FileBrowserAction = 0;
int[] IndexMapArray = new int[257]; 
int IndexMapPointer = -1;
int SequenceLength = 0; 
int IndexedSequenceLength = 0; 
int TimeLineCellSize = 0;
int RXByte1 = -1;    
int RXByte2 = 0;
int RXByte3 = 0;
int RXByte4 = 0;
int RXByte5 = 0;
int SendCounter = 0;
int SendCounterB = 0;
int USBpacketCount = 0;
byte[] USBPacket = new byte[64];
int dkTdtDh = 0;
boolean eitvFtJ = false;
boolean gMLtdVm = false;
boolean PtdjnQH = false;
boolean tZWSTuf = false;
boolean wsIWRkt = false;
boolean iuxjTaT = false;
boolean yQKiGIj = false;
boolean OJQfYqn = false;
boolean WQDHyMM = false;
int QcuyJWJ = 0; 
int iGloTVf = 0;
float wImTTMr = 0;
int tTmDDfP = 0;
int HXIqjvk = 0;
int HbWelkq = 0;
int rYrXIPl = 4; 
int cmdData[] = {0, 0, 0, 0};
int yDxiDYy = 0;
int jRsrlqO = 0;
int NyqOxsk = 0; 
int NyqOxskCounter = 0;
int gQWmajl = 0; 
int kgkVOtw = 0;
boolean NyqOxskMinFlag = false;
int LiveConTotalColChan = 0; 
int LiveConDataMult = 3; 
int LiveConDataType = 1; 
byte[] tempBytes;
int[] LEDIconCoordX = new int[10];
int[] LEDIconCoordY = new int[10];
int naJDfWm = 0;
int nRudTeq = 0;
int ATLudLs = 0;
int SDdpJto = -1000; 
byte vXzCEzG = 0;
int gdHgLUO = 0;
byte LEDSize = MNxHTMd;
int LEDSizeID = 2;
int PixelIconAmount = 0;
int TempnaJDfWm = 0;
int GradientDrawState = 0; 
int GradientDrawStartX = 0;	
int GradientDrawStartY = 0;	
int GradientDrawEndX = 0;	
int GradientDrawEndY = 0;	
int[] GradientDrawID = new int[10];
boolean GraphicImageEnabled =  false;	
boolean GraphicImageResize = false;
int ImageDraggingState = 0; 
int GraphicImageX = 0;	
int GraphicImageY = 0;		
int GraphicImageInitX = 0;	
int GraphicImageInitY = 0;	
int GraphicImageWidth = 0;
int GraphicImageHeight = 0;
int SelectedTechID = 0;
int SelectedTechFrame = 0;
int tempoiHkAsJ = 0;
int UserGammaTableArray[] = new int[256];
int POVVidFrame = 0;
boolean HoldMovieTranscribe = true;
boolean PlayVideoFlag = false;
int MovieFrameCount = 0;
boolean TranscribingFinished = false;
int CurrentPOVW = 1;		
int CurrentPOVH = 1;
int temp = 0;
int modulePosX = 90;
int modulePosY = 380;
int moduleHoldX = 0;
int moduleHoldY = 0;
int moduleHoldSz = 0;
String graphicImgFilePath = "imagelayouts/default.png";
int[] CopyBuffer = new int[10];
int PaintRectID = 0;
boolean oxBdCTXPick = false;
boolean GradientDrawInit = false;	
int MultiplierToolValue = 10; 
int prevSliderSetNum = 1000;
int X1, X2, Y1, Y2, X3, Y3, X4, Y4;
int[] PixelChipsetID  = new int[2];
int gSXKHak = 0;
int RFNePZg = 0;
boolean TFbtzSb = false;
int FqANxaN = 0;
int IndexSerialAssignedIDNum = cfXHabo;
int IndexDMXAssignedIDNum = cfXHabo;
int LCVaxUK = 0;
int mFPrNqq = 0;
String[] gTUpKrI = new String[16];
int dtSTkNT = 0;
int MrXmLxA = 1000; 
int hBOcXPy = 99;
int MqOzTWA = 100;
int pOnViaX = 101;
int XhobtaL = 102;
int WojVIii = 140;
int sIaCksP = 4;
int DuhNPWj = 70;
int DuhNPWjIncrease = 72;
int DuhNPWjDecrease = 71;
int QvyJPPj = 75;
int pmnGOnK = 90;
int pNWXnGU = 92;
int lfEkUTG = 91;
int UjXqAgR = 82;
int QwTfHDT = 85;
int IQXbmvv = 81;
int ojafBuR = 60;
int OApOuYM = 120;
int yoJFiGp = 3000; 
boolean jKPfCnq = false;
int OcYeYMu = 0; 
PFont fNormal, fDigital;
PImage[] povButtonsImgs = new PImage[4];
PImage sequencesImg, fullNameImg, gradientImg, auroraLogoImg, fullNameRGB;
PImage POVImg, graphicImg, TempImgTimeLine, TempImgIndex;
PGraphics TimeLineBuffer, IndexScrollBuffer, GraphicLayoutBuffer, LinkedScrollBuffer, SeqIconBuffer, POVBuffer;
PGraphics TechnicalBuffer, FilePlayBuffer;
PGraphics[] PreviewBuffer = new PGraphics[wqajEny]; 
PGraphics POVGraphicBuffer;
Client TCPClient; 
Serial myPort;      
DeviceObj device;
UserSequenceObj[] UserSequences;
SpecHWModules[] InputModule;  
ColorPickerObj ColorSelector;
DropDown DMXModesDD, PixelChipsetDD;
DropDown BaudRateDD, LEDIndicatorModeADD, LEDIndicatorModeBDD, DropDownPointer, POVModeDD;
DropDown StandAloneDD, DisplayModeDD, DisplayModeBDD, ShapeOptionsDD;
DropDown AutoDetectDD, MasterModeDD, HardwareColSwapDD;
DropDown AccMeterAutoDetectDD, AccMeterAutoDetectModeDD, AccMeterTapDD, PowerDownTimeOutDD;
DropDown SequenceModeDD, PacketCloneDD, FrameSeqToolInsantDD, FrameSeqToolTechDD, StandAloneADD, PWMFreqADD;
DropDown SeqTransistionDD, PlayModeDD;
ArrayList<DropDown> DropDownList; 
DropDown DropDownListPointer;
int DropDownMouseOverID = 0;
TabButton[] MenuTabs, ToolTabs;
TLTriangle[] TLStartIndicators;
ColorRect[] GradientRects, ControlRects, PaintRects;
ColorRect TechnicalColorStart, TechnicalColorEnd;
OverlayMenu[] OverlayMenus;
LEDgraphic[] PixelIcon;
Button[] TimeLineLabelButtons, TechChanLabelButtons, TechColorModeButton, TechAddFrameButtons;
Button[] COMButtons, FrameButtons;
Button[] HardwareButtons, SoftwareButtons, ConnectionButtons;
Button[] StandaloneButtons, POVOptionButtons;
Button[] TimeLineFrameButtons;
Button[] RadialMenuTechColorMode;
Button RadialTechFadeButton, RadialTechSolidButton;
Button LiveControlClose, LiveControlToggle, HardwarePrevIcon, DMXSequenceIcon, SerialSequenceIcon, IdleSequenceIcon, StartValReset;
Button DeviceConnect, ConfirmButtonYes, ConfirmButtonNo, StandAloneClose, GraphicLayoutExpandOpt;
Button GroupIDDecf, GroupIDIncf, GammaOverlayCloseButton, GammaLoadFileButton, GammaUploadButton, GammaUploadDefaultButton;
Button FilePlayLoadButton;
Button AddFrame, RemoveFrame, IncFrameBar,DecFrameBar, SequenceMenuButton, SequenceSelectAdd;
Button ColorSelectorApply, ColorSelectorCancel, MainToolsAllSame, DeviceWebpage;
Button GradientGenerate, POVModeButton, GraphicFuncPaintButton, EnableGroupMode;
Button RequestConfigurations, CopyFrameButton, PasteFrameButton, EnterBootloaderButton, SequenceSelectClose;
Button GradientDrawRadialButton, GradientDrawLinearButton, OpenTCPButton, HardwareTabUploadConfigurations;
Button ImageRemoveButton, ImagePlaceButton, ImageResizeButton, ImageResetButton;
Button ImageHandleTR, ImageHandleTL, ImageHandleBR, ImageHandleBL, ImageHandleCenter;
Button MouseIconPlace, MouseIconReset,  MouseIconRemove;
Button IconToolGroupIDDec, IconToolGroupIDInc, LayoutGroupInc, LayoutGroupDec;
Button MainToolsColorGroup, UploadProgressCancel, MainToolsShowStartValues;
Button POVPlay, POVPause, POVRestart;
ArrayList<Button> ButtonList; 
Button PointerButton;
//Movie moviePOV;
SliderBar TimeLineScrollBar, IndexScrollBar, LinkedScrollBar, SequenceSelectScrollBar;
SliderBar TechnicalScrollHoriz, TechnicalScrollVert;
SliderBar GradientDrawSlider;
SliderBar[] ColorSelectorSliders, ControlSliders, StandaloneSliders; 
SliderBar SliderPointer;
CheckBox[] SeqCheckBoxes, FrameCheckBoxes;
CheckBox[] HardwareCheckBox, SoftwareCheckBox;
CheckBox[] LiveControlCheckBox;
CheckBox[] StandaloneCheckBox;
CheckBox[] LinkedCheckBox;
CheckBox[] LinkedTimerCheckBox;
CheckBox IntensityOverrideCheckBox, IconLayoutAdvancedMode, POVVideoModeCheckBox;
TextField[] TextFields;
TextField TXTFSeqIntensity, TXTFTechTime, textFieldPtr;
TextFieldObject SequenceChannelObject, SequenceSpeedObject, PixelAmountObject,GradientStepsObject,GradientMultiplierObject;
Button[] ObjButtonPlus, ObjButtonMinus, LObjButtonPlus, LObjButtonMinus;
TextField[] ObjTextField, LObjTextField;
TextFieldObjectL[] LinkedTextFieldObject;
public void LoadDeviceFile()
{String BuildString = "devices"+File.separator+""+device.HardwareID+"-nled-contr-revs.txt"; 	
String[] lines = loadStrings(BuildString); 
String[] WorkString = new String[30]; 
BuildString = "";	
for(int i = 0; i != lines.length;i++)
{WorkString = split(lines[i], '\t');
AppendLogFile(PApplet.parseInt(WorkString[0])+" : "+PApplet.parseInt(WorkString[1]));		
if(PApplet.parseInt(WorkString[0]) == device.FirmwareVersion)
{if(PApplet.parseInt(WorkString[1]) < device.FirmwareRevision && i == 0)
{AppendLogFile("Revison higher than local "+device.FirmwareRevision);
BuildString = "devices"+File.separator+""+device.HardwareID+"-"+PApplet.parseInt(WorkString[0])+"-"+PApplet.parseInt(WorkString[1])+"-nled-contr.txt";
break;
} 
if(PApplet.parseInt(WorkString[1]) == device.FirmwareRevision)
{AppendLogFile("REVISION FOUND with "+i);
BuildString = "devices"+File.separator+""+device.HardwareID+"-"+PApplet.parseInt(WorkString[0])+"-"+PApplet.parseInt(WorkString[1])+"-nled-contr.txt";
break;
} 
} 
}if(BuildString.equals(""))
{AppendLogFile("Device File For V. & Rev. Not Found - Using Most Recent Version");	
lines = loadStrings("devices"+File.separator+""+device.HardwareID+"-nled-contr-revs.txt"); 
WorkString = split(lines[0], '\t');
BuildString = "devices"+File.separator+""+device.HardwareID+"-"+PApplet.parseInt(WorkString[0])+"-"+PApplet.parseInt(WorkString[1])+"-nled-contr.txt";	
}AppendLogFile("LoadDeviceFile() - "+BuildString);	
lines = loadStrings(BuildString); 
int LinePointer = 1;
WorkString = split(lines[LinePointer++], '\t');
device.Name = WorkString[1]; 
WorkString = split(lines[LinePointer++], '\t');
device.WebpageURL = WorkString[1];  	
WorkString = split(lines[LinePointer++], '\t');
if(device.FirmwareVersion < PApplet.parseInt(WorkString[1]))
{AppendLogFile("FIRMWARE OUTDATED "+PApplet.parseInt(WorkString[1])+" vs "+device.FirmwareVersion);
if(eitvFtJ == true) 
{	
gQWmajl = 8;
}}
WorkString = split(lines[LinePointer++], '\t');
if(device.FirmwareRevision < PApplet.parseInt(WorkString[1]))
{AppendLogFile("FIRMWARE REVISION OUTDATED "+PApplet.parseInt(WorkString[1])+" vs "+device.FirmwareRevision);
if(eitvFtJ == true) 
{gQWmajl = 8;
}}	
LinePointer++;	
WorkString = split(lines[LinePointer++], '\t');
device.Channels = PApplet.parseInt(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.LockChannelAmt = PApplet.parseBoolean(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.DataSpace = PApplet.parseInt(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.IndexBlockSize = PApplet.parseInt(WorkString[1]);
try { 	
device.HPVBlockSize = PApplet.parseInt(WorkString[2]);   
device.SeqMemoryBlockSize = PApplet.parseInt(WorkString[3]);   
}catch(Exception e) 
{AppendLogFile("Error loading block sizes, using single value");
device.CurrentBlockSize	= device.IndexBlockSize;
device.HPVBlockSize = device.CurrentBlockSize;   
device.SeqMemoryBlockSize = device.CurrentBlockSize;  	
}WorkString = split(lines[LinePointer++], '\t');
device.EraseBlockSize = PApplet.parseInt(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.HWPVSpace = PApplet.parseInt(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.MaxIndexedSequences = PApplet.parseInt(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.IndexMemoryModel = PApplet.parseInt(WorkString[1]);  		
WorkString = split(lines[LinePointer++], '\t');
device.FillUpperData = PApplet.parseBoolean(WorkString[1]); 
WorkString = split(lines[LinePointer++], '\t');
device.Bit16Processor = PApplet.parseBoolean(WorkString[1]);  	
WorkString = split(lines[LinePointer++], '\t');
device.Bit16Mode = PApplet.parseBoolean(WorkString[1]);    
WorkString = split(lines[LinePointer++], '\t');
device.BasicVersion = PApplet.parseInt(WorkString[1]);      
WorkString = split(lines[LinePointer++], '\t');
device.LinkedSupport = PApplet.parseBoolean(WorkString[1]);   
WorkString = split(lines[LinePointer++], '\t');
device.GammaCorrection = PApplet.parseInt(WorkString[1]);  
WorkString = split(lines[LinePointer++], '\t');
device.AccelerometerMode = PApplet.parseInt(WorkString[1]);
WorkString = split(lines[LinePointer++], '\t');
device.MaxSpeed = PApplet.parseInt(WorkString[1]);  	
WorkString = split(lines[LinePointer++], '\t');
device.MaxFrames = PApplet.parseInt(WorkString[1]); 		
device.MaxFramesGlobal = PApplet.parseInt(WorkString[2]);  
WorkString = split(lines[LinePointer++], '\t');
device.dtSTkNTStr = WorkString[1];  
WorkString = split(lines[LinePointer++], '\t');
device.ConfigBytesStr = WorkString[1];  	
WorkString = split(lines[LinePointer++], '\t');
device.DMXModeLabels = new String[16];
device.DMXModeLabels = split(WorkString[1], ',');
device.DMXModeAmt = device.DMXModeLabels.length;   	
DMXModesDD.Labels = device.DMXModeLabels; 	
DMXModesDD.numStrs = device.DMXModeAmt; 	
WorkString = split(lines[LinePointer++], '\t');
device.ListedChipsets = PApplet.parseInt( WorkString[1]);   
if(device.ListedChipsets > 0)
{	
String[] tempPixLables = new String[16];
tempPixLables = new String[device.ListedChipsets]; 
PixelChipsetID = new int[device.ListedChipsets];
for (int i = LinePointer; i != (LinePointer+device.ListedChipsets);i++)
{WorkString = split(lines[i], '\t');
tempPixLables[i-LinePointer] = WorkString[1];
PixelChipsetID[i-LinePointer] = PApplet.parseInt(WorkString[2]);
}PixelChipsetDD.Labels = tempPixLables;
PixelChipsetDD.numStrs = device.ListedChipsets;	
}	
if(device.BasicVersion > 0)
{switch(device.BasicVersion)
{case 1: 
device.BasicMaxSequences = 8;
device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
AppendLogFile("============"+device.BasicSeqLength+"================");
AutoDetectDD.Labels = cDDAutoDetectModesT2;
AutoDetectDD.numStrs = cDDAutoDetectModesT2.length;
break;
case 2: 
case 3: 
device.BasicMaxSequences = 32;
device.BasicSeqLength = (device.BasicMaxSequences*4)+(device.BasicMaxSequences * (device.Channels*2))+device.DataSpace+(device.DataSpace/device.Channels);
AutoDetectDD.Labels = cDDAutoDetectModesT3;
AutoDetectDD.numStrs = cDDAutoDetectModesT3.length;
break;		
}}
if(device.DataSpace > 1000000) device.MemorySpaceString = nf((((float)device.DataSpace/1048576)),1,2)+"MB";
else device.MemorySpaceString = nf((((float)device.DataSpace/1024)),1,2)+"KB";	
if(MrXmLxA != device.HardwareID)uqdivtD = device.Channels;
if(device.Bit16Mode == true)
{ColorSelectorSliders[0].Maximum = 65535;
ColorSelectorSliders[1].Maximum = 65535;
ColorSelectorSliders[2].Maximum = 65535;
}else
{ColorSelectorSliders[0].Maximum = 255;
ColorSelectorSliders[1].Maximum = 255;
ColorSelectorSliders[2].Maximum = 255;
ColorSelectorSliders[3].Maximum = 255;
}if(device.LockChannelAmt == true) uqdivtD = device.Channels; 
TextFields[11].maxValue = device.Channels;
TextFields[11].Label = ""+uqdivtD;
ObjTextField[SequenceSpeedObject.ObjID].maxValue = device.MaxSpeed;
ObjTextField[SequenceChannelObject.ObjID].maxValue = device.Channels;
if(device.GammaCorrection == 0) ConnectionButtons[5].Status = 1;
else ConnectionButtons[5].Status = 0;	
AppendLogFile("Device File Successfully Loaded - Starting Configuration Modules");
modulePosX = 140; 
modulePosY = 190;
moduleHoldX = 0;
moduleHoldY = 0;
moduleHoldSz = 0;
for (int i = 0; i != InputModule.length;i++) InputModule[i].Enabled = false; 
dtSTkNT = 0; 
gTUpKrI = split(device.dtSTkNTStr, ',');
String[] ModuleString = new String[16];	
String[] ByteStrArray = new String[16];
ByteStrArray = split(device.ConfigBytesStr, ',');	
for(int z = 260; z > 0; z-=10)
{	
for(int y = 0; y != InputModule.length;y++)
{	
if(InputModule[y].Enabled == false && InputModule[y].Priority >= z)
{ModuleString = split(InputModule[y].ModuleFlagStr, ','); 
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != gTUpKrI.length; i++)
{	
if(gTUpKrI[i].equals(ModuleString[q]) == true) 
{if(InputModule[y].Enabled == false) 
{InputModule[y].PlaceTile();
}}
} 
} 
ModuleString = split(InputModule[y].ModuleByteStr, ','); 
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != ByteStrArray.length; i++)
{	
if(ByteStrArray[i].equals(ModuleString[q]) == true) 
{if(InputModule[y].Enabled == false) 
{InputModule[y].PlaceTile();
}}
} 
} 
}} 
}	
for(int y = 0; y != InputModule.length;y++)
{	
if(InputModule[y].Enabled == false)
{ModuleString = split(InputModule[y].ModuleFlagStr, ',');
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != gTUpKrI.length; i++)
{	
if(gTUpKrI[i].equals(ModuleString[q]) == true) 
{if(InputModule[y].Enabled == false) 
{						
InputModule[y].PlaceTile();
}}
} 
} 
ModuleString = split(InputModule[y].ModuleByteStr, ',');
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != ByteStrArray.length; i++)
{	
if(ByteStrArray[i].equals(ModuleString[q]) == true) 
{if(InputModule[y].Enabled == false) 
{					
InputModule[y].PlaceTile();
}}
} 
} 
}
} 
if(device.Bit16Mode == true || IsOndtSTkNT("f8or16Bit")) device.Bit16LiveMode = true;
if(device.BasicVersion > 0)
{if(device.BasicVersion == 1) 
{SequenceModeDD.Labels = cDDSequenceModeBasic1;
SequenceModeDD.numStrs = cDDSequenceModeBasic1.length;
}if(device.LinkedSupport == true)
{SequenceModeDD.Labels = cDDSequenceModeBasic2;
SequenceModeDD.numStrs = cDDSequenceModeBasic2.length;
}	
IdleSequenceIcon.Status = 1;
ConnectionButtons[4].Status = 1; 
} 
else
{IdleSequenceIcon.Status = 0;
ConnectionButtons[4].Status = 0; 
}if(device.HWPVSpace == 0) 	HardwarePrevIcon.Status = 1;
else 	HardwarePrevIcon.Status = 0;
if(device.LockChannelAmt == true)
{SequenceChannelObject.setStatus(1); 
TextFields[11].Status = 1; 
SoftwareButtons[10].Status = 1; 
}else
{SequenceChannelObject.setStatus(0); 
TextFields[11].Status = 0; 
SoftwareButtons[10].Status = 0; 
}AppendLogFile("Configuration Modules Successfully Loaded - end LoadDeviceFile()");
}public void bitSet(int pointer)
{dtSTkNT |= (1 << pointer); 
} 
public void SendConfigurations()
{AppendLogFile("SendConfigurations()"); 
String[] ModuleString = new String[16];	
int[] TransmitByteArray = new int[16];	
gTUpKrI = split(device.dtSTkNTStr, ',');
dtSTkNT = 0; 
for(int y = 0; y != InputModule.length;y++)
{	
if(InputModule[y].Enabled == true)
{ModuleString = split(InputModule[y].ModuleFlagStr, ',');
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != gTUpKrI.length; i++)
{	
if(gTUpKrI[i].equals(ModuleString[q]) == true) 
{if(InputModule[y].GetBitValues(q) == 1) bitSet(i); 
}} 
} 
} 
} 
AppendLogFile("dtSTkNT: "+binary(dtSTkNT,16));
for(int i = 0; i != TransmitByteArray.length;i++) TransmitByteArray[i] = 0; 
TransmitByteArray[0] = (dtSTkNT >> 8); 
TransmitByteArray[1] = dtSTkNT & 0xFF;
gTUpKrI = split(device.ConfigBytesStr, ',');
for(int y = 0; y != InputModule.length;y++)
{		
if(InputModule[y].Enabled == true)
{ModuleString = split(InputModule[y].ModuleByteStr, ',');
for(int q = 0; q != ModuleString.length; q++)
{	
for(int i = 0; i != gTUpKrI.length; i++)
{	
if(gTUpKrI[i].equals(ModuleString[q]) == true) 
{TransmitByteArray[i+2] = InputModule[y].GetByteValues(q);
}} 
} 
} 
} 
printArray(TransmitByteArray);
for(int i = 0; i != (gTUpKrI.length+2); i++)SendSingleDataByte(TransmitByteArray[i]); 
AppendLogFile("SendConfigurations() finished");	
NyqOxsk(28);
} 
public boolean IsOndtSTkNT(String passedStr)
{for(int i = 0; i != gTUpKrI.length; i++)
{	
if(gTUpKrI[i].equals(passedStr) == true) 
{AppendLogFile("IsOndtSTkNT() found "+passedStr);
return true;
}} 
return false;
}public void BuildUSBPacket(int dataValue)
{SendCounter++; 
SendCounterB++; 
if (SendCounter >= device.EraseBlockSize)
{delay(5); 
SendCounter = 0;
}USBPacket[dkTdtDh] =  PApplet.parseByte(dataValue);
dkTdtDh++;
if(dkTdtDh == 64)
{	
dkTdtDh = 0;
try {		
if(QcuyJWJ == 0) myPort.write(USBPacket); 
else if(QcuyJWJ == 1) TCPClient.write(USBPacket);
USBpacketCount++;
if(SendCounter == device.CurrentBlockSize)
{AppendLogFile("Waiting for ACK, USBPacket: "+USBpacketCount+"    SendCounter: "+SendCounter);
SendCounter = 0;
while(OJQfYqn == false) 
{delay(1); 
if(WQDHyMM == true) { break; } 
}
OJQfYqn = false; 
redraw();
}}
catch(Exception e)
{AppendLogFile("Unable to Send Packet");	
redraw();
}}	
}	
public void SendSingleDataChar(char passedValue)
{try {
if(QcuyJWJ == 0) myPort.write(passedValue);
else if(QcuyJWJ == 1) TCPClient.write(passedValue);
}catch(Exception e) { }
}
public void SendSingleDataByte(int passedValue)
{try {
if(QcuyJWJ == 0) myPort.write(passedValue);
else if(QcuyJWJ == 1) TCPClient.write(passedValue);
}catch(Exception e) { }
}public void SendAckedCommand() 
{AppendLogFile("Cmd Request Acknowledged, Sending - CmdByte: "+rYrXIPl+" : "+cmdData[0]+" : "+cmdData[1]+" : "+cmdData[2]+" : "+cmdData[3]);
gMLtdVm = false;
SendSingleDataByte(rYrXIPl);
SendSingleDataByte(cmdData[0]);  
SendSingleDataByte(cmdData[1]);   
SendSingleDataByte(cmdData[2]);  
SendSingleDataByte(cmdData[3]); 
jKPfCnq = true; 
}public void clientEvent(Client someClient) 
{TCPDataRecieved();
}public void serialEvent(Serial myPort) 
{RXByte5 = RXByte4;
RXByte4 = RXByte3;
RXByte3 = RXByte2;
RXByte2 = RXByte1;
RXByte1 = myPort.read();
DataRecieved(); 
}	
public void TCPDataRecieved()
{RXByte5 = RXByte4;	
RXByte4 = RXByte3;
RXByte3 = RXByte2;
RXByte2 = RXByte1;
RXByte1 = TCPClient.read();
DataRecieved(); 
if(TCPClient.available() > 0) TCPDataRecieved();
}	
public void DataRecieved()	
{AppendLogFile("Received: "+RXByte1+"  Char: "+PApplet.parseChar(RXByte1));
if (PtdjnQH == true && RXByte2 == 'a' && RXByte1 == '9')
{gMLtdVm = true;
PtdjnQH = false;
EnableTransmissionTimeOut();
SendSingleDataChar('n'); 
SendSingleDataChar('l');  
SendSingleDataChar('e');
SendSingleDataChar('d');  
SendSingleDataChar('9');   
SendSingleDataChar('9');
AppendLogFile("Sent Acknowledge");
}else if (gMLtdVm == true  && RXByte2 == 'f' && RXByte1 == '0')
{thread("SendAckedCommand");
}else if(wsIWRkt == true)
{switch(HXIqjvk)
{case 0: 
yDxiDYy = RXByte1;
break;      
case 1: 
jRsrlqO = RXByte1;
wsIWRkt = false;
AppendLogFile("Requested and Recieved Configurations "+binary(yDxiDYy,8)+" "+binary(jRsrlqO,8));
break;	
} 
HXIqjvk++;
}else if (tZWSTuf == true)
{switch(HXIqjvk)
{case 0:
MrXmLxA = device.HardwareID; 
device.HardwareID = RXByte1;
break;      
case 1:
device.HardwareVersion = RXByte1;
break;
case 2:
device.FirmwareVersion = RXByte1;
break;
case 3:
device.FirmwareRevision = RXByte1;
break;
case 4:	
break;			
case 5:	
device.BootloaderVersion = RXByte1;
break;			
case 6:	
device.UserConfiguredIDNum = RXByte1;
tZWSTuf = false;
eitvFtJ = true;
UPCYumR = "Connected";
DeviceConnect.Selected = true; 
SaveSoftwareConfigFile();	
for (int x =0; x != Serial.list().length; x++) 
{if(baRtlHT.equals(Serial.list()[x]))
{		
try {
for (int q =0; q != COMButtons.length; q++) COMButtons[q].Selected = false;	
COMButtons[x].Selected = true;
}catch(Exception e)	{	}	
}}			
try {
LoadDeviceFile();
String temp = cRevisionIDstr[device.FirmwareRevision]; 
}catch(Exception e) { NyqOxsk(16); }
if(device.FirmwareVersion > 100) gQWmajl = 11; 
redraw();
break;
}  
HXIqjvk++;
}else if(yQKiGIj == true)
{if(RXByte4 == 'z' && RXByte3 == 'A' && RXByte2 == 'c' && RXByte1 == 'k')	
{OJQfYqn = true;
AppendLogFile("ACK RECEIVED FOR PACKET# "+USBpacketCount);
redraw();
}
}else if(jKPfCnq == true)
{if(RXByte5 == 'c' && RXByte4 == 'm' && RXByte3 == 'd' && RXByte2 == 0)	
{jKPfCnq = false;
AppendLogFile("COMMAND #"+RXByte1+" AUTHENTICATED");
SendCounter = 0;
SendCounterB = 0;
USBpacketCount = 0; 
dkTdtDh = 0; 
switch(rYrXIPl)
{case 4: 
tZWSTuf = true;
HXIqjvk = 0;
break;
case 60:	
if(cmdData[0] == 1) iuxjTaT = true; 
else if(cmdData[0] == 0) iuxjTaT = false; 
break;	
case 99: 
yQKiGIj = true;
SequenceLength = UserSequences[RFNePZg].Length;   
thread("SendHardwarePreview"); 
break;		
case 100: 
yQKiGIj = true;
if(device.BasicVersion > 0) thread("SendLegacyData"); 
else thread("FullUpload");
break;
case 101:	
yQKiGIj = true;
SendConfigurations();	
yQKiGIj = false;
break;	
case 102:	
yQKiGIj = true;
if(device.FillUpperData == true ) SequenceLength = 384;
else SequenceLength = 256;
thread("UploadGammaTable");
break;	
case 120:
wsIWRkt = true;
HXIqjvk = 0;
break;			
}	
} 
} 
} 
public void RequestCommand()
{WQDHyMM = false; 
OJQfYqn = false; 
try {
SendSingleDataChar('N'); 
SendSingleDataChar('L');  
SendSingleDataChar('E');   
SendSingleDataChar('D');  
SendSingleDataChar('1');   
SendSingleDataChar('1');
PtdjnQH = true; 
EnableTransmissionTimeOut();
}catch(Exception e)
{AppendLogFile("Port Not Open, Or Unable to Send"); 
PtdjnQH = false;
CloseCommunicationPort();
NyqOxsk(8);
}} 
public void OpenConnection()
{AppendLogFile("Attempting Connection");
rYrXIPl = sIaCksP; 
cmdData[0] = 0;
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
eitvFtJ = false;
RequestCommand();
}public void RequestDeviceConfigurations()
{AppendLogFile("Attempting Connection");
rYrXIPl = OApOuYM; 
cmdData[0] = 0;
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
}public void RequestToSendPreview(int passedVal)
{AppendLogFile("RequestToSendPreview() with "+passedVal);
SaveUserSequencesFile("saves"+File.separator+"tempSave.txt");
AppendLogFile("HWPV Sequence Length: "+UserSequences[passedVal].Length+" : Device HWPV Space: "+device.HWPVSpace);
RFNePZg = passedVal;
if(UserSequences[passedVal].SeqMode == qzXknoY || UserSequences[passedVal].Length > device.HWPVSpace) 
{	  
NyqOxsk(5); 
return; 
}device.CurrentBlockSize = device.HPVBlockSize;
rYrXIPl = hBOcXPy; 
cmdData[0] = ((ceil((float)UserSequences[passedVal].Length/device.CurrentBlockSize)+1) >> 8) & 0xFF; 
cmdData[1] = (ceil((float)UserSequences[passedVal].Length/device.CurrentBlockSize)) & 0xFF; 
cmdData[2] = 0;  
cmdData[3] = 0;  
AppendLogFile("Expected HWPV Packets: "+(ceil((float)(UserSequences[passedVal].Length/device.CurrentBlockSize))+1));
RequestCommand();
}public void RequestConfigurationUploadType2()
{AppendLogFile("RequestConfigurationUploadType2() for Basic Version Type 2");
rYrXIPl = pOnViaX; 
cmdData[0] = 0; 
switch(PowerDownTimeOutDD.SelStr) 
{case 0: 
cmdData[0] = 0x00;
break;
case 1: 
cmdData[0] = 0x01;
break;
case 2: 
cmdData[0] =  0x02;
break;
case 3: 
cmdData[0] = 0x03;
break;
}	
kgkVOtw = yoJFiGp;
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
}public void RequestConfigurationUpload()
{AppendLogFile("RequestConfigurationUpload()");
rYrXIPl = pOnViaX; 
cmdData[0] = 0; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
} 
public void BreakUSBValue(int passedValue)
{switch(device.IndexMemoryModel)
{case 0: 
BuildUSBPacket(passedValue); 
BuildUSBPacket((passedValue>>8)); 
if(device.FillUpperData == true)	BuildUSBPacket(0); 
break;
case 1: 
BuildUSBPacket(passedValue); 
BuildUSBPacket((passedValue>>8)); 
if(device.FillUpperData == true)	BuildUSBPacket(0); 
BuildUSBPacket((passedValue>>16)); 
BuildUSBPacket((passedValue>>24));	
if(device.FillUpperData == true)	BuildUSBPacket(0); 
break;
} 
} 
public void RequestGammaTableUpload(int passedID)
{AppendLogFile("RequestGammaTableUpload() with ID "+passedID);
HbWelkq = passedID;
rYrXIPl = XhobtaL;
if(device.FillUpperData == true)  	cmdData[0] = 2; 
else 	cmdData[0] = ceil(256 / (float)device.IndexBlockSize); 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();	
} 
public void UploadGammaTable()
{int tempCount = 0;
int i = 0;
device.CurrentBlockSize = device.IndexBlockSize; 
if(HbWelkq == 1)
{AppendLogFile("UploadGammaTable() - User Defined");
for(i = 0; i != 256; i++) 
{	
if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
BuildUSBPacket(UserGammaTableArray[i]);
}if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
}else
{AppendLogFile("UploadGammaTable() - Default");	
for(i = 0; i != 256; i++) 
{	
if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
BuildUSBPacket(cDefaultGammaTable[i]);
}if(device.FillUpperData == true && ((1+i+tempCount)%3) == 0) { BuildUSBPacket(0x00); 	tempCount++; }
}yQKiGIj = false;
redraw();
} 
public void RequestFullUpload()
{AppendLogFile("RequestFullUpload() "+IndexMapPointer);
if(IndexMapPointer == -1)
{NyqOxsk(15); 
return;
}SaveUserSequencesFile("saves"+File.separator+"tempSave.txt");
for (int i = 0; i != IndexMapPointer+1; i++) 
{	
try { 	
CheckStartVals(i);
if(UserSequences[IndexMapArray[i]].StartValError == true && DACOCBN == false)
{AppendLogFile("Start Values for "+IndexMapArray[i]+" are bad");
if(UserSequences[IndexMapArray[i]].SeqMode == XyiEbAJ || UserSequences[IndexMapArray[i]].SeqMode == xvXsTNs) 
{ResetStartValuesCommon(IndexMapArray[i]);	
AppendLogFile("===================  Sequence Start Values Reset  ==================");	
break;
}if(UserSequences[IndexMapArray[i]].SeqMode == qzXknoY) break; 
gQWmajl = 7;
NHYXqPY = IndexMapArray[i];
return;
} 
} 
catch(Exception e)	{
AppendLogFile("Some sort of error checking start values for"+IndexMapArray[i]);
}}
DACOCBN = false;
RunParseIndex(); 
int tempExpectedPacketsIndex = 0;
if(device.IndexMemoryModel == 0)
{tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 2;
if(device.FillUpperData == true) tempExpectedPacketsIndex +=  device.MaxIndexedSequences;
}else if(device.IndexMemoryModel == 1)
{tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 4;
if(device.FillUpperData == true) tempExpectedPacketsIndex +=  device.MaxIndexedSequences * 2;
}int tempExpectedPacketsSequence = ceil((float)IndexedSequenceLength/device.SeqMemoryBlockSize); 
SequenceLength = IndexedSequenceLength; 
SequenceLength += tempExpectedPacketsIndex; 
AppendLogFile("Index Space Length, in Bytes: "+tempExpectedPacketsIndex);
tempExpectedPacketsIndex =  ceil((float)tempExpectedPacketsIndex/device.IndexBlockSize); 
device.CurrentBlockSize = device.IndexBlockSize;	
AppendLogFile("RequestFullUpload() "+SequenceLength+" : MapPointer: "+IndexMapPointer+"    CurrentBlockSize: "+device.CurrentBlockSize);
rYrXIPl = MqOzTWA; 
cmdData[0] = ((tempExpectedPacketsIndex+tempExpectedPacketsSequence) >> 8) & 0xFF; 
cmdData[1] = (tempExpectedPacketsIndex+tempExpectedPacketsSequence) & 0xFF; 
cmdData[2] = IndexMapPointer;  
cmdData[3] = UserSequences[device.UserIdleSequence].assignedIDNum;   
RequestCommand();
AppendLogFile("ExpectedPackets: "+(tempExpectedPacketsIndex+tempExpectedPacketsSequence)+"    "+tempExpectedPacketsIndex+"     "+tempExpectedPacketsSequence);
}public void FullUpload()
{AppendLogFile("FullUpload() - Sending Sequences");
int tempIDnum = 0;
int tempVal = 0;
int tempOffset = 0;
for (int i = 0; i != device.MaxIndexedSequences; i++) 
{	
tempVal = IndexMapArray[i];
if(cfXHabo == tempVal)
{break; 
}
if(CguezcT == tempVal)
{BreakUSBValue(LCVaxUK);
tempIDnum++;
AppendLogFile("Value DMX: "+LCVaxUK);
}else if(bgpbnOG == tempVal)
{BreakUSBValue(mFPrNqq);
tempIDnum++;
AppendLogFile("Value Serial: "+mFPrNqq);
}	
else
{BreakUSBValue(UserSequences[tempVal].mappedROMAdr);	
AppendLogFile("Value Seq"+tempVal+": "+UserSequences[tempVal].mappedROMAdr+"   "+tempIDnum);
tempIDnum++;
}
}AppendLogFile("Start extended index "+tempIDnum);
for (int q = 1; q != UserSequences.length; q++) 
{if(UserSequences[q].assignedIDNum == tempIDnum)
{	
AppendLogFile("SEQUENCE "+q+" on extended index");
BreakUSBValue(UserSequences[q].mappedROMAdr);
AppendLogFile("Value Exte: "+UserSequences[q].mappedROMAdr);
tempIDnum++;
q = 0;				
}}	
AppendLogFile("Done extended index "+tempIDnum);
for (int i = (tempIDnum+tempOffset); i != device.MaxIndexedSequences; i++) 	BreakUSBValue(0);	
AppendLogFile("Sent "+SendCounterB+" index bytes");
device.CurrentBlockSize = device.SeqMemoryBlockSize;
for (int q = 1; q != UserSequences.length; q++) AppendLogFile("SoftSeq#: "+q+" - Assigned: "+UserSequences[q].assignedIDNum+" - LinkerAssiD: "+UserSequences[q].assignedLinkedIDNum);
tempIDnum = 0;
for (int q = 0; q != device.MaxIndexedSequences; q++)
{for (int i = 1; i != UserSequences.length; i++) 
{if(UserSequences[i].assignedIDNum == tempIDnum)
{	
if(UserSequences[i].SeqMode == qzXknoY)
{PackSendLinked(i);
}else	
{SendSequence(i);				
}tempIDnum++;
i = 0; 
}else if(IndexDMXAssignedIDNum == tempIDnum)
{SendSequenceDataModeHeader(VrjUaNV, LCVaxUK);
tempIDnum++;
i = 0; 
}else if(IndexSerialAssignedIDNum == tempIDnum)
{SendSequenceDataModeHeader(tPkEylv, mFPrNqq);
tempIDnum++;
i = 0; 
}}	
tempIDnum++;
}AppendLogFile("TotalSent: "+SendCounterB);     
AppendLogFile("Left to Send: "+(device.CurrentBlockSize - (SendCounter%device.CurrentBlockSize)));
while((float)(SendCounterB%device.CurrentBlockSize) != 0)
{  
BuildUSBPacket(33); 
} 
AppendLogFile("Indexed & Sequences Sent");
yQKiGIj = false;
redraw();
}public void SendHardwarePreview()
{int SelSeq = RFNePZg; 
AppendLogFile("SendHardwarePreview() with "+SelSeq);
AppendLogFile("HWPV Length: "+UserSequences[SelSeq].Length);
AppendLogFile("Data Frames: "+(UserSequences[SelSeq].SeqFrameAmount+1));
SendSequence(SelSeq);
AppendLogFile("TotalSent: "+SendCounterB);     
AppendLogFile("Left to Send: "+(device.CurrentBlockSize - (SendCounter%device.CurrentBlockSize)));
while((float)(SendCounterB%device.CurrentBlockSize) != 0)
{BuildUSBPacket(33); 
}AppendLogFile("HWPV Sent");
yQKiGIj = false;
redraw();
} 
public void PackSendLinked(int SelSeq)
{AppendLogFile("PackSendLinked() : "+SelSeq+"    with "+UserSequences[SelSeq].SeqFrameAmount+" frames.");
SendSequenceHeader(SelSeq);
for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++)
{BuildUSBPacket(UserSequences[UserSequences[SelSeq].SlideFlags[i]].assignedIDNum); 	
AppendLogFile("Linked SeqAssignedID: "+(UserSequences[UserSequences[SelSeq].SlideFlags[i]].assignedIDNum)+"    On SoftID#: "+UserSequences[SelSeq].SlideFlags[i]);
}	
for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++)
{BuildUSBPacket((byte)UserSequences[SelSeq].DataFrameVar[i]);
AppendLogFile("LinkedFlags: "+UserSequences[UserSequences[SelSeq].SlideFlags[i]].DataFrameVar[i]);	
}for(int i=0;i != (UserSequences[SelSeq].SeqFrameAmount+1); i++) 
{BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]);  
BuildUSBPacket((UserSequences[SelSeq].SlideValues[i])>>8);	 
AppendLogFile("Iterations: "+UserSequences[SelSeq].SlideValues[i]);
}		
} 
public void stop()
{try {
myPort.dispose();
}catch(Exception e) {
}}
public void SendLiveControlData()		
{AppendLogFile("SendLiveControlData()");
try {
if(QcuyJWJ == 0) myPort.write(tempBytes);
else if(QcuyJWJ == 1) TCPClient.write(tempBytes);
}catch(Exception e) { AppendLogFile("Problem with SendLiveControlData()"); }
}public void BreakValueForUSBPacket(int passedValue, int passedType)
{switch(passedType)
{case 0: 
BuildUSBPacket((passedValue>>8)); 
BuildUSBPacket(passedValue); 
break;
case 1: 
BuildUSBPacket((passedValue>>24));
BuildUSBPacket((passedValue>>16)); 
BuildUSBPacket((passedValue>>8)); 
BuildUSBPacket(passedValue); 
break;
} 
} 
public void SendSequenceDataModeHeader(int passedMode,int passedAdr)
{AppendLogFile("SendSequenceDataModeHeader() with "+passedMode);
BreakValueForUSBPacket(passedAdr, 1);
BuildUSBPacket(passedMode); 
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);
BuildUSBPacket(0);	
BuildUSBPacket(0x33); 
}public void SendSequenceHeader(int SelSeq)
{BreakValueForUSBPacket(UserSequences[SelSeq].mappedROMAdr, 1);
BuildUSBPacket(UserSequences[SelSeq].SeqMode);
if(UserSequences[SelSeq].SeqMode == XyiEbAJ  && UserSequences[SelSeq].POVVideoMode == true)
BreakValueForUSBPacket(UserSequences[SelSeq].POVFramesAmount-1, 0); 
else BreakValueForUSBPacket(UserSequences[SelSeq].SeqFrameAmount, 0); 
BreakValueForUSBPacket(UserSequences[SelSeq].Speed, 1); 
BreakValueForUSBPacket(UserSequences[SelSeq].DataSize, 0);   
int tempStorage = 0; 
tempStorage = UserSequences[SelSeq].DataType;
tempStorage = (UserSequences[SelSeq].SeqPlayMode << 2) | tempStorage;
tempStorage = (UserSequences[SelSeq].SeqTransitionFlags << 5) | tempStorage;
BuildUSBPacket(tempStorage); 
if(UserSequences[SelSeq].SeqMode == XyiEbAJ) BuildUSBPacket(cDDPOVModeValues[UserSequences[SelSeq].POVUsageMode]); 
else if(UserSequences[SelSeq].SeqMode == mTKKGDu)
{tempoiHkAsJ = updateTechTotalColorChannel(SelSeq); 
BuildUSBPacket(tempoiHkAsJ); 
}else BuildUSBPacket(UserSequences[SelSeq].SeqTransSpeed); 	
if(device.LockChannelAmt == true)	BuildUSBPacket(0); 
else BuildUSBPacket(UserSequences[SelSeq].PacketCloneMode); 
} 
public void SendSequence(int SelSeq)
{AppendLogFile("SendSequence() "+SelSeq+"    Start SendCounterB="+SendCounterB);
SendSequenceHeader(SelSeq); 
float GlobalIntensity = (float)PApplet.parseInt(TextFields[14].Label) / 100;	
if(IntensityOverrideCheckBox.Selected == true) GlobalIntensity = (float)UserSequences[SelSeq].SequenceIntensity / 100;
int tempData = 0; 
int start = 0;
int end = 0;
AppendLogFile("=========="+GlobalIntensity+"==============");
if(device.Bit16Mode == true)
{AppendLogFile("Sent 16-bit data");
} 
else 
{AppendLogFile("Sending 8-bit data, SeqDataSize: "+UserSequences[SelSeq].DataSize);
AppendLogFile("Using Intensity: "+GlobalIntensity);
if(UserSequences[SelSeq].SeqMode == EqPnOUb || UserSequences[SelSeq].SeqMode == kRMfOXG || UserSequences[SelSeq].SeqMode == lMBafjD || UserSequences[SelSeq].SeqMode == mTKKGDu)
{if(UserSequences[SelSeq].SeqMode == lMBafjD)
{	
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i] * GlobalIntensity));			
}	
} 
else if(UserSequences[SelSeq].SeqMode == mTKKGDu)
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[0][i] * GlobalIntensity));	
}}				
else
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{start = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]][i];
if(UserSequences[SelSeq].DataFrameVar[i] == UserSequences[SelSeq].SeqFrameAmount) end = UserSequences[SelSeq].DataFrames[0][i]; 
else end = UserSequences[SelSeq].DataFrames[UserSequences[SelSeq].DataFrameVar[i]+1][i]; 
if(start == end) BuildUSBPacket(UserSequences[SelSeq].StartValues[i]); 
else BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].StartValues[i] * GlobalIntensity)); 
}					
}if(UserSequences[SelSeq].SeqMode == mTKKGDu)
{}
else
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
{	  
BuildUSBPacket(UserSequences[SelSeq].DataFrameVar[i]);
}}
} 
if(UserSequences[SelSeq].SeqMode == lMBafjD)
{for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
{BuildUSBPacket(UserSequences[SelSeq].SlideValues[i]); 	  
}for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
{BuildUSBPacket(UserSequences[SelSeq].SlideFlags[i]); 
}} 
else if(UserSequences[SelSeq].SeqMode == mTKKGDu) 
{      
for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++) 
{for (int i=0; i != tempoiHkAsJ;i++) 
{BuildUSBPacket(UserSequences[SelSeq].TechFlags[q][i]); 	  
} 	  
}for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++) 
{for (int i=0; i != tempoiHkAsJ;i++) 
{BuildUSBPacket(UserSequences[SelSeq].TechTime[q][i]>>8); 
BuildUSBPacket(UserSequences[SelSeq].TechTime[q][i]); 
}	
}}   
else if(UserSequences[SelSeq].SeqMode == XyiEbAJ)
{}
else if(UserSequences[SelSeq].SeqMode == qzXknoY)
{}	
if (UserSequences[SelSeq].SeqMode == kRMfOXG)
{for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
{for (int i=0; i != 4;i++)
{BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}}
else if(UserSequences[SelSeq].SeqMode == mTKKGDu)
{for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++)
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{	
BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}}
else if(UserSequences[SelSeq].SeqMode == XyiEbAJ && UserSequences[SelSeq].POVVideoMode == true)
{for (int q=0; q != UserSequences[SelSeq].POVFramesAmount;q++)
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{	
BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}}
else
{for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
{for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{	
BuildUSBPacket(PApplet.parseInt(UserSequences[SelSeq].DataFrames[q][i] * GlobalIntensity));
} 
}}
}	
} 
public String trimString(String passedStr, int passedAmt)
{if (passedStr.length()  > passedAmt) 
{ 
int varStart = passedStr.length()  - passedAmt; 
int varEnd =  passedStr.length() ;
passedStr = passedStr.substring(varStart, varEnd);
}	
return passedStr;
}public void draw() 
{background(DqoHydg);
scale(gwFwycD, gwFwycD);
stroke(JCZFGSk);
strokeWeight(2);
line(125, 30, 125, 600); 
line(0, 30, 800, 30); 
line(0, 80, 125, 80); 
noStroke();  
EMCDldB = round((float)mouseX / gwFwycD); 
bJxobsd = round((float)mouseY / gwFwycD);
image(fullNameImg, 3, 3, fullNameImg.width, fullNameImg.height);
textAlign(LEFT);
fill(mYkuUaE);
textSize(12);
if(QcuyJWJ == 0) text("Status:\n"+trimString(baRtlHT,7), 5, 50);
else if(QcuyJWJ == 1)  text("Status:\nTCP\n"+netOeFl+":"+ZhEGIBX, 5, 50); 
DeviceConnect.display();
if(GraphicImageResize == true && ImageDraggingState > 0)
{int newWidth = 0;
int newHeight = 0;
switch(ImageDraggingState)
{case 1:
newWidth = (EMCDldB - GraphicImageInitX);
newHeight = (bJxobsd - GraphicImageInitY);
newWidth = GraphicImageWidth - newWidth;
newHeight = GraphicImageHeight - newHeight;
GraphicImageWidth = newWidth;
GraphicImageHeight = newHeight;
GraphicImageInitX = EMCDldB; 
GraphicImageInitY = bJxobsd;
GraphicImageX = EMCDldB-AqFFYoX;
GraphicImageY = bJxobsd-gEfHGFk;
break;
case 2:	
break;
case 3:	
newWidth = (GraphicImageInitX - EMCDldB);
newHeight = (GraphicImageInitY - bJxobsd);
newWidth = GraphicImageWidth - newWidth;
newHeight = GraphicImageHeight - newHeight;
GraphicImageWidth = newWidth;
GraphicImageHeight = newHeight;
GraphicImageInitX = EMCDldB; 
GraphicImageInitY = bJxobsd;
break;	
case 5: 
newWidth = (GraphicImageInitX - EMCDldB);
newHeight = (GraphicImageInitY - bJxobsd);
GraphicImageInitX = EMCDldB; 
GraphicImageInitY = bJxobsd;
GraphicImageX = GraphicImageX - newWidth;
GraphicImageY = GraphicImageY - newHeight;
GraphicImageWidth = GraphicImageWidth - newWidth;
GraphicImageHeight = GraphicImageHeight - newHeight;
break;
} 
GraphicLayoutBuffer.beginDraw();
GraphicLayoutBuffer.background(DqoHydg);
handlerDrawImageHandles();
GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,(ImageHandleTR.xpos - ImageHandleTL.xpos)+10,(ImageHandleBL.ypos - ImageHandleTR.ypos)+10);
handlerDrawImageHandles();
GraphicLayoutBuffer.endDraw();
}	
if (uBYXrqM == 0 || uBYXrqM == 1)
{fill(JCZFGSk);
rect(0,80,125,60);
ToolTabs[0].display();
ToolTabs[1].display();
ToolTabs[2].display();
ToolTabs[3].display();
switch(TDWCxom)
{case 0:
stroke(JCZFGSk);
strokeWeight(2);
line(0, 350, 125, 350); 
noStroke(); 
textSize(11);
text("Single - RGB - RGBW", SeqCheckBoxes[0].xpos-10, SeqCheckBoxes[0].ypos-5);  				
textAlign(CENTER);
textSize(14);
text("Speed: ", 62, SequenceSpeedObject.ypos-5);  
text(UserSequences[AkOQmUe].UserID+"\nID #"+AkOQmUe, 62, 160);
text("Num. of Channels:", 62, 370); 	
text("Extended Pixels:\n"+(UserSequences[AkOQmUe].DataSize*(UserSequences[AkOQmUe].PacketCloneMode+1))/ByoKxya, 62, 460); 
if(nRudTeq < naJDfWm)text("Displayed:"+nRudTeq, 62, 490); 
else text("Displayed:"+naJDfWm, 62, 490); 
text("Transition In:", 62, SeqTransistionDD.ypos-5); 	
text("Play Mode:", 62, PlayModeDD.ypos-5); 	
textAlign(LEFT);  		
text("Intensity: ", 5, TXTFSeqIntensity.ypos+20);  	
for (int i =0; i != SeqCheckBoxes.length; i++) SeqCheckBoxes[i].display();
TXTFSeqIntensity.display();	
SequenceChannelObject.display();
SequenceSpeedObject.display();
SequenceModeDD.display();
PacketCloneDD.display();
SeqTransistionDD.display();
PlayModeDD.display();
break;
case 1:
StartValReset.display();
GradientGenerate.display();	
GradientStepsObject.display();
GradientMultiplierObject.display();
GradientDrawRadialButton.display();
GradientDrawLinearButton.display();				
MainToolsAllSame.display();
GraphicFuncPaintButton.display();
MainToolsColorGroup.display();	
MainToolsShowStartValues.display();
for (int i =0; i != PaintRects.length; i++) 
{if(PaintRectID == i)
{fill(VySlFUN);
rect(PaintRects[i].xpos-2,PaintRects[i].ypos-2,PaintRects[i].bWidth+4,PaintRects[i].bHeight+4);
}
PaintRects[i].display();
} 
fill(255);
textSize(14);
textAlign(LEFT);
text("Gradient Steps:", 10, GradientStepsObject.ypos-5);		
textAlign(CENTER);	
text("Multiplier:", 62, 465);
text("Start ValueTools:",62, 305);
text("Graphic Tools:",62, 380);
text("Paint Multiple:",62,255);			
textSize(18);		
text("Main Tools:",62,165);		
stroke(JCZFGSk);
strokeWeight(2);
line(0, 505, 125, 505);
noStroke();  		
break;
case 2:
CopyFrameButton.display();
PasteFrameButton.display();
for (int i =0; i != FrameCheckBoxes.length; i++) FrameCheckBoxes[i].display();
TextFields[0].display(); 
TextFields[6].display(); 
textSize(12);
textAlign(CENTER);
fill(mYkuUaE);
text("Single-RGB-RGBW", 62, FrameCheckBoxes[0].ypos-10);
textSize(14);		
text("Slide Value:", 62, TextFields[0].ypos-5);
text("Frame Mode:", 62, FrameSeqToolInsantDD.ypos-5); 
text("Cell Speed:",62,TextFields[6].ypos-5);
if(UserSequences[AkOQmUe].SeqMode != mTKKGDu) text("Special Frame\nOptions:" , 62, 260);
else text("Frame Options:\n\nTech Mode:\nChannel: "+(SelectedTechID+1)+"\nFrame: "+(((SelectedTechFrame+1)/2)+1), 62, 250);	
textSize(18);			
text("Slide Options", 62, TextFields[0].ypos-30); 		
text("Frame Tools:\nFrame "+(lQGtaTe+1),62,165);
FrameSeqToolInsantDD.display(); 
FrameSeqToolTechDD.display();
break;		
case 3: 
MouseIconPlace.display();
MouseIconRemove.display();
MouseIconReset.display();
EnableGroupMode.display(); 
IconToolGroupIDDec.display();
IconToolGroupIDInc.display();
fill(255);
textAlign(CENTER);
textSize(18);		
text((vXzCEzG+1),62, IconToolGroupIDDec.ypos+20);
text("LED Icon\nTool Options:",62,165);
textSize(14);	
text("Icon Placement:\n(Manual Only)",62, MouseIconPlace.ypos-25);
text("Enable Group\nAssignment:",62, EnableGroupMode.ypos-25);
text("Assigned\nGroup ID:",62, IconToolGroupIDDec.ypos-30);		
break;
} 
} 
for (int i =0; i != MenuTabs.length; i++) MenuTabs[i].display();  
if (AzUdiEH == true)
{HandleSliders(true); 
} 
switch(uBYXrqM)
{case 0: 
DisplayFrameButtons();
if(AkOQmUe == 0)
{textAlign(CENTER);
fill(mlIVvlI);
textSize(18);	
text("Please connect a device or\nload a device file to create a Sequence.", 465, 270);
textAlign(LEFT);
break;
}if (UserSequences[AkOQmUe].SeqMode == qzXknoY)
{DrawLinkedBuffer(); 
break;
}else if(UserSequences[AkOQmUe].SlideFlags[lQGtaTe] > 0)
{	
textAlign(CENTER);
fill(mlIVvlI);
textSize(18);
text("Frame is Set as Slide. Edit Variables on Left Side Menu.", 465, 270);
textAlign(LEFT);
break;
}		
else
{image(GraphicLayoutBuffer, AqFFYoX, gEfHGFk, GraphicLayoutBuffer.width, GraphicLayoutBuffer.height);
} 
if(GradientDrawInit == true) 	
{	
stroke(255);
strokeWeight(2);	
switch(GradientDrawState)
{case 1: 
line(GradientDrawStartX,GradientDrawStartY,EMCDldB, bJxobsd); 
float maxDistX = dist(GradientDrawStartX, 0, EMCDldB, 0);
float maxDistY = dist(0, GradientDrawStartY, 0, bJxobsd);
stroke(JCZFGSk);
if(EMCDldB > GradientDrawStartX)
{if(bJxobsd > GradientDrawStartY)
{line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX - maxDistX), (GradientDrawStartY - maxDistY));	
}else
{line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX - maxDistX), (GradientDrawStartY + maxDistY));	
}}
else
{if(bJxobsd > GradientDrawStartY)
{line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX + maxDistX), (GradientDrawStartY - maxDistY));		
}else
{line(GradientDrawStartX,GradientDrawStartY, (GradientDrawStartX + maxDistX), (GradientDrawStartY + maxDistY));
}}
break;
case 2: 
line(GradientDrawStartX,GradientDrawStartY,EMCDldB, bJxobsd); 
stroke(0);
X1 = GradientDrawStartX + (bJxobsd - GradientDrawStartY);
Y1 = GradientDrawStartY + (GradientDrawStartX - EMCDldB);
X2 = GradientDrawStartX + (GradientDrawStartY - bJxobsd);
Y2 = GradientDrawStartY + (EMCDldB - GradientDrawStartX);
line(X1,Y1, X2, Y2); 
X3 = EMCDldB + (bJxobsd - GradientDrawStartY); 
Y3 = bJxobsd + (GradientDrawStartX - EMCDldB); 
X4 = EMCDldB + (GradientDrawStartY - bJxobsd);
Y4 = bJxobsd + (EMCDldB - GradientDrawStartX);
break;		
} 
noStroke();
} 
for (int i = 0; i != nRudTeq; i++)
{try {
if (PixelIcon[i].over() && PixelIcon[i].GroupID == gdHgLUO)
{								
textSize(14);
fill(0);
text((PixelIcon[i].ChanID+1),EMCDldB+1,bJxobsd+1);
fill(255);
text((i+1),EMCDldB,bJxobsd);
}}
catch(Exception e){}
}	
break;
case 1: 
if(AkOQmUe == 0)
{textAlign(CENTER);
fill(mlIVvlI);
textSize(18);			
text("Please connect a device or\nload a device file to create a Sequence.", 465, 270);
textAlign(LEFT);
break;
}if (UserSequences[AkOQmUe].SeqMode == qzXknoY)
{DrawLinkedBuffer();			
}else if(UserSequences[AkOQmUe].SeqMode == XyiEbAJ)
{POVModeButton.display();
POVVideoModeCheckBox.display();
for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].display();			
image(povButtonsImgs[3], POVOptionButtons[3].xpos,POVOptionButtons[3].ypos);	
image(povButtonsImgs[2], POVOptionButtons[2].xpos,POVOptionButtons[2].ypos);	
image(povButtonsImgs[1], POVOptionButtons[1].xpos,POVOptionButtons[1].ypos);	
image(povButtonsImgs[0], POVOptionButtons[0].xpos,POVOptionButtons[0].ypos);		
textSize(16);
text(cPOVDescriptionsSecond[UserSequences[AkOQmUe].POVConfigType]+"\n"+cPOVDescriptions[UserSequences[AkOQmUe].POVConfigType],OvprrrD+10,555,520,100);
fill(255);
textSize(14);
text("Point of Vision(POV) Mode:", OvprrrD+10,55);
text("Enable POV Video Mode\n(Load Video File To Enable)", POVVideoModeCheckBox.xpos+25, POVVideoModeCheckBox.ypos+15);				
textSize(12);
text("View Width: "+POVGraphicBuffer.width+" View Height: "+POVGraphicBuffer.height+"\nImage Width:"+POVImg.width+" Image Height: "+POVImg.height, 460, 50);
text("P.O.V. Usage Mode:\nAllows a gap/empty space to be placed between frames.\nMakes it look like a grid instead of streaks.", POVModeDD.xpos, POVModeDD.ypos-35);	
if(POVVideoModeCheckBox.Selected == true)
{text("Frame Number: "+(MovieFrameCount+1)+" / "+((float)UserSequences[AkOQmUe].POVFramesAmount / (float)(UserSequences[AkOQmUe].SeqFrameAmount+1)), 140, 145);
POVRestart.display();
POVPlay.display();
POVPause.display();	
if(PlayVideoFlag == true)
{						
DrawPOVBuffer(); 
POVVidFrame+=(UserSequences[AkOQmUe].SeqFrameAmount+1);
MovieFrameCount++;
if(POVVidFrame == UserSequences[AkOQmUe].POVFramesAmount)
{AppendLogFile("Draw() resetting POVVidFrame & MovieFrameCount");
POVVidFrame = 0;
MovieFrameCount = 0;
}				
}else noLoop();
if(TranscribingFinished == true)
{TranscribingFinished = false;	
//moviePOV.dispose();			
DrawPOVBuffer();
}} 
try
{image(POVBuffer, OvprrrD, AEcZkIL, aoXExLf, ehtEwNl);
}catch(Exception e)
{AppendLogFile("Null POVBuffer");
}if(HoldMovieTranscribe == false)
{fill(255);
textSize(24);	
text("VIDEO TRANSCRIBING - WAIT",OvprrrD+150+2, AEcZkIL+150+2);
fill(255,0,0);			
text("VIDEO TRANSCRIBING - WAIT",OvprrrD+150, AEcZkIL+150);
}POVModeDD.display();
}	
else if(UserSequences[AkOQmUe].SeqMode == xvXsTNs)
{		
fill(255);
textSize(16);
text("File Play Mode: ", 135,55);		
TempImgTimeLine = TimeLineBuffer.get(0, YLWNFLV, sGOqkUb, ZpIfePQ); 
image(TempImgTimeLine, osqIpiO, XuFFMGQ, TempImgTimeLine.width, TempImgTimeLine.height);
FilePlayLoadButton.display();
TimeLineScrollBar.display();
DisplayFrameButtons();
}else if(UserSequences[AkOQmUe].SeqMode == mTKKGDu)
{		
fill(255);
textSize(14);
text("Technical Mode: ", 260,55);	
textSize(12);			
text("Pixel#   Info", 135,60);	
image(TechnicalBuffer, osqIpiO, XuFFMGQ, TechnicalBuffer.width, TechnicalBuffer.height);
TechnicalScrollHoriz.display();
TechnicalScrollVert.display();	
DisplayFrameButtons();
}		
else
{try {
for (int i =0; i != TimeLineFrameButtons.length; i++) TimeLineFrameButtons[i].display();				
}catch(Exception e) {  }
noStroke();
textFont(fNormal, 48);
textSize(14);
fill(255);	
try {
TempImgTimeLine = TimeLineBuffer.get(0, YLWNFLV, sGOqkUb, ZpIfePQ); 
image(TempImgTimeLine, osqIpiO, XuFFMGQ, TempImgTimeLine.width, TempImgTimeLine.height);
}catch(Exception e)  { }
TimeLineScrollBar.display();
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{noStroke();
fill(255);
rect(35+osqIpiO+(TimeLineCellSize*q), XuFFMGQ-5, 1, ZpIfePQ); 
}DisplayFrameButtons();		
}	
break;
case 2: 
try {
TempImgIndex = IndexScrollBuffer.get(0, (IndexScrollBar.Value*GDlXxCI), 180, 580); 
image(TempImgIndex, 596, gEfHGFk, TempImgIndex.width, TempImgIndex.height);
}catch(Exception e) { } 
for (int i =0; i != ConnectionButtons.length; i++) ConnectionButtons[i].display();
IndexScrollBar.display();
HardwarePrevIcon.displaySq();
IntensityOverrideCheckBox.display();	
TextFields[14].display();
IdleSequenceIcon.displaySq(); 
if(device.UserIdleSequence > 0) UserSequences[device.UserIdleSequence].displayIcon(IdleSequenceIcon.xpos,IdleSequenceIcon.ypos);
fill(mYkuUaE);   
textSize(18);
text("User Settings and Upload:", 135, 110);
text("Upload To Device:", 135, 440);	
textSize(14);
text("Hardware Preview:", HardwarePrevIcon.xpos-10, HardwarePrevIcon.ypos-10);		
text("Global Intensity(%):", TextFields[14].xpos-30, TextFields[14].ypos-5);		
text("Idle Sequence:", IdleSequenceIcon.xpos+5, IdleSequenceIcon.ypos-10);				
text("Use Per\nSequence\nIntensity:", IntensityOverrideCheckBox.xpos-80, IntensityOverrideCheckBox.ypos-10);				
textSize(12);
text("Select which sequences you wish to upload to the controller and the order they will be selected when pressing the device's button(s)\nUsage: Click a sequence tile or the Add a Sequence tile.", 135, 120, 450, 500);
text("Complete Your Color Sequences and Create the Index to the left. When ready, click 'Upload Sequences and Index' button. To upload Configurations(options on Hardware Tab), press the 'Upload Configurations' button.", 135, 450, 450, 500);
textAlign(CENTER);		
text("Uses Global or Per Sequence Intensity\n(Enable Below)", HardwarePrevIcon.xpos, HardwarePrevIcon.ypos+90, 120, 100);
text("(Click to Select)\n(Right Click to Clear)\nUploaded with Index\n& Sequences", IdleSequenceIcon.xpos+55, IdleSequenceIcon.ypos+100);
textAlign(LEFT);
stroke(JCZFGSk);
strokeWeight(2);
line(aVMHNFe, 410, 596, 410);
line(aVMHNFe, 80, 596, 80);
noStroke();  
break; 
case 3: 
for (int i =0; i != SoftwareButtons.length; i++) SoftwareButtons[i].display();
for (int i =0; i != SoftwareCheckBox.length; i++) SoftwareCheckBox[i].display();
if(fdJgaNC != 5) SoftwareButtons[3].Status = 1;
else  SoftwareButtons[3].Status = 0;
TextFields[3].display(); 
TextFields[11].display(); 
PixelAmountObject.display();
IconLayoutAdvancedMode.display();
image(auroraLogoImg, 145, 45, 120, 140);
fill(mYkuUaE);
textSize(16);
textAlign(CENTER);
text("Click the function button then click on an Icon to the right.", 600, 195, 200, 240);
text("Default Channel Amount:\n"+uqdivtD+" out of "+device.Channels, 230, 340);  
textAlign(LEFT);	
textSize(14);	
text("Only used for Live Control and for the default channel amount when creating a new sequence. It does not affect any sequences already created.", 330, 330,265,400);  	
text("Written in Proccesing\nwww.Processing.org", 290, 60);
text("Software Version: "+TATbaZv+"\nSoftware Revision: "+cRevisionIDstr[OhKywff], 290, 150);
text("Graphic Layout\nImage Options:", 140, 425);  		
text("Window Size:", 5, 100);  
text("Graphic Layout Options:", 290, 420);  		
textSize(12);		
textAlign(RIGHT);	
text("Small:\n\nMedium:\n\nLarge:", 755, 450);  
textAlign(LEFT);	
textSize(14);		
text("Selected Pixel Map File: "+iKxwBtqCondensed, 295, 595);  
text("LED Icon Size:", 700, 425);  		
text("Advanced Layout Mode", IconLayoutAdvancedMode.xpos+25, IconLayoutAdvancedMode.ypos+15);  
text("(Native)",SoftwareButtons[11].xpos+20,SoftwareButtons[11].ypos+40);
textSize(12);	
text("Updates and Information: www.NLEDshop.com/nledaurora\nCopyright\u00a9 2016 Northern Lights Electronic Design, LLC", 140, 200);
textSize(16);
text("Group Function ID:",LayoutGroupDec.xpos-20,LayoutGroupDec.ypos-10);
text("Pixel Icon Amount:",PixelAmountObject.xpos-20,PixelAmountObject.ypos-10);		
textSize(20);			
text(vXzCEzG+1,LayoutGroupDec.xpos+45,LayoutGroupDec.ypos+20);
image(fullNameRGB, 130, 235, 350, 90);
ImageRemoveButton.display();
ImagePlaceButton.display();
ImageResizeButton.display();		
ImageResetButton.display();
LayoutGroupInc.display();	
LayoutGroupDec.display();	
ShapeOptionsDD.display();	
stroke(JCZFGSk);
strokeWeight(2);  
line(280, 400, 280, 600);		
line(125, 400, 800, 400);
line(600, 30, 600, 400);	
line(125, 225, 600, 225);	
line(600, 145, 800, 145);	
line(125, 320, 600, 320);	
noStroke();
break;		
case 4: 
try {
for (int i =0; i != COMButtons.length; i++) COMButtons[i].display();
}catch(Exception e) { }
float tempUsage = ((float)IndexedSequenceLength/(float)device.DataSpace) * 100;
DeviceWebpage.display();
RequestConfigurations.display();
EnterBootloaderButton.display();
OpenTCPButton.display();
HardwareTabUploadConfigurations.display();
if(device.BasicVersion > 0) 
{	
int tempHold = 0;
for (int i =1; i != UserSequences.length; i++) tempHold = tempHold + UserSequences[i].SeqFrameAmount;
tempUsage = tempHold / ((float)device.DataSpace / (float)device.Channels);	
tempUsage = tempUsage * 100;
}	
textSize(16);
fill(mYkuUaE);
textAlign(LEFT);
text(device.Name, 140, 55);
textSize(14); 
textLeading(20);
try {
if(device.FirmwareVersion > 100)
{text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: Unverified-"+(device.FirmwareVersion-100)+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 135, 80);
}else
{	
text("Hardware Version: "+device.HardwareVersion+"\nFirmware Version: "+device.FirmwareVersion+cRevisionIDstr[device.FirmwareRevision]+"\nMax Channels: "+device.Channels+"\nMemory Space: "+device.MemorySpaceString, 135, 80);  
}}
catch(Exception e) { }
text("Bootloader Version: "+device.BootloaderVersion+"\nUser Configured ID#: "+device.UserConfiguredIDNum, 320, 80);  	
text("Usage: "+nfs(tempUsage, 1, 2)+"%", 320, 140);   
textAlign(CENTER); 	
text("TCP/IP: ", 65, 100);
text("Select\nCOM Port: ", 65, 160);
textSize(20);	
textAlign(LEFT); 		
text("Device Configurations", 140, 180);
for (int i =0; i != InputModule.length; i++) InputModule[i].display();
if(DropDownPointer.Selected)	DropDownPointer.display();
stroke(JCZFGSk);
strokeWeight(2);
line(125, 150, 800, 150); 
fill(0, 255, 0); 
rect(440, 125, 140, 15); 
fill(255, 0, 0);	
rect(440, 125, round(tempUsage*1.4f), 15); 
break;
}
if (uBYXrqM == 0 || uBYXrqM == 1) image(sequencesImg, 675, 0, sequencesImg.width, sequencesImg.height);
if(CrytrWK > 0)
{	
fill(DqoHydg, 128);
rect(0,0,800,600);	
OverlayMenus[CrytrWK].display();
}if (DXcJNIU == true)    ColorSelector.display();
if (TFbtzSb == true) DisplayDragIndicator();
if (AJcBVWK == true)
{if(LiveControlCheckBox[3].Selected == true) 
{tempBytes = new byte[uqdivtD*2];
int xx = 0;
for (int i =0; i != uqdivtD; i++) 
{tempBytes[xx] = (byte)((ControlSliders[i].Value >> 8)  & 0xFF); 
tempBytes[xx+1] = (byte)(ControlSliders[i].Value & 0xFF); 
xx += 2;
}
}else
{tempBytes = new byte[uqdivtD];
for (int i =0; i != uqdivtD; i++) 
{tempBytes[i] = PApplet.parseByte(ControlSliders[i].Value);
}		
} 
try {
thread("SendLiveControlData");
}catch(Exception e)
{AppendLogFile("Port Not Open");
}AJcBVWK = false;
}if(yQKiGIj==true)
{fill(DqoHydg, 128);
rect(0,0,800,600); 
stroke(VySlFUN);
strokeWeight(4);
fill(DqoHydg);
rect(250,260,300,115);
stroke(255);	
fill(0);	
strokeWeight(2);
rect(270,305,260,25);
textFont(fDigital, 48);
textSize(48);
fill(255);
text("Upload In Progress:", 265, 290);
textFont(fNormal, 48);
noStroke();
UploadProgressCancel.display();
wImTTMr = (float)SendCounterB / (float)(ceil((float)SequenceLength/(float)device.CurrentBlockSize) * device.CurrentBlockSize);
if(SendCounterB > 10) 
{	
for (int i =0; i != PApplet.parseInt(wImTTMr*21); i++)
{colorMode(HSB, 25);
fill(i, 25, 25);
rect(275+(i*12),310,8,16, 6);	
}	
colorMode(RGB, 255);
}} 	
if(NyqOxsk > 0)
{	
pushStyle();
fill(DqoHydg, 128);
rect(0,0,800,600);	
textAlign(CENTER);	
textFont(fDigital, 48);
textSize(48);
stroke(VySlFUN);
strokeWeight(4);
fill(DqoHydg);
int tempStrW = PApplet.parseInt(textWidth(cNotificationText[NyqOxsk]))+20;
rect(400-(tempStrW/2),250,tempStrW,80);
fill(255);
text(cNotificationText[NyqOxsk], 400, 300);
popStyle();
} 
if(gQWmajl > 0)
{fill(DqoHydg, 128);
rect(0,0,width,height);
fill(JCZFGSk);
stroke(VySlFUN);
strokeWeight(3);
rect((800/2)-120,(600/2)-60, 240, 120, 20);
fill(0);
textSize(14);
textAlign(CENTER);
if(gQWmajl == 2) text(cConfirmBoxText[gQWmajl]+UserSequences[dfXKrgk].UserID+"?", (800/2)-110, (600/2)-50, 220, 100); 
else text(cConfirmBoxText[gQWmajl], (800/2)-110, (600/2)-50, 220, 100);
textAlign(LEFT);
ConfirmButtonYes.display();
ConfirmButtonNo.display();
}		
if (rJUZtcV != width || gTaWjjx != height)
{AppendLogFile("Window Resized to: "+width+" : "+height+" from "+rJUZtcV+" : "+gTaWjjx);    
if(width < 480) { width = 480; rJUZtcV = width;}
if(displayHeight < (width/4) *3)
{width = 1280; 
if(displayHeight < (width/4) *3)
{width = 800; 
}}
surface.setSize(width, (width/4) *3);	
insets = frame.getInsets();	
surface.setSize(width+(insets.left+insets.right),height+(insets.top+insets.bottom));	
gTaWjjx = height;  
rJUZtcV = width;
SaveSoftwareConfigFile();	
gwFwycD = (float)width / 800; 
}}
public void LoadFilePlayModeFile(String passedFileName)
{AppendLogFile("LoadFilePlayModeFile()");	
String[] lines = loadStrings(passedFileName); 
String[] WorkString = new String[wqajEny];
AppendLogFile(lines.length+"    "+lines[0]);
WorkString = split(lines[0], ',');	
if(lines.length > device.MaxFramesGlobal) AppendLogFile("FilePlay file too large");
else {	
SetlQGtaTe(0); 
UserSequences[AkOQmUe].SeqFrameAmount = (lines.length-1); 
UserSequences[AkOQmUe].DataSize = WorkString.length; 
ResizeSequenceFrameAmt(AkOQmUe);
for(int q = 0; q < lines.length; q++)	
{		
WorkString = split(lines[q], ',');
//AppendLogFile(WorkString.length);
for(int i = 0; i < WorkString.length; i++)	
{	
WorkString[i] = trim(WorkString[i]);
if(WorkString[i].equals("") == false)
{UserSequences[AkOQmUe].DataFrames[q][i] = PApplet.parseInt(WorkString[i]);
}} 
} 
UpdateSequence(AkOQmUe);
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
} 
} 
public void LoadGammaTable(String passedFileName)
{AppendLogFile("LoadGammaTable()");
String[] lines = loadStrings(passedFileName); 
String[] WorkString = new String[256];	
int lineCount = 0;
int counter  = 0;
while(lineCount < lines.length)	
{WorkString = split(lines[lineCount], ',');
for(int i = 0; i < WorkString.length; i++)	
{	
WorkString[i] = trim(WorkString[i]); 
if(WorkString[i].equals("") == false)
{UserGammaTableArray[counter] = PApplet.parseInt(WorkString[i]);
counter++;
}}
lineCount++;
}} 
public void QuickSaveFunciton()
{SaveUserSequencesFile("saves"+File.separator+"quicksave.txt");
}public void LoadConfigFile()
{String[] lines = loadStrings("software.ini"); 
String[] WorkString = new String[7]; 
WorkString = split(lines[0], '\t');
int tempWidth = PApplet.parseInt(WorkString[1]);
WorkString = split(lines[1], '\t');
int tempHeight = PApplet.parseInt(WorkString[1]);
surface.setSize(tempWidth, tempHeight);
WorkString = split(lines[2], '\t');
if(baRtlHT != WorkString[1])OpenCOMPort(WorkString[1]);
WorkString = split(lines[3], '\t');	
iGloTVf = PApplet.parseInt(WorkString[1]);
WorkString = split(lines[4], '\t');	
netOeFl = WorkString[1]; 
WorkString = split(lines[5], '\t');	
ZhEGIBX = PApplet.parseInt(WorkString[1]);
WorkString = split(lines[6], '\t');	
wtoALPx = PApplet.parseInt(WorkString[1]);
}
public void SaveSoftwareConfigFile()
{AppendLogFile("SaveSoftwareConfigFile() - Saving software.ini");
String[] WorkString = new String[7]; 
WorkString[0] = "ScreenW\t" + width;
WorkString[1] = "ScreenH\t" + height;
WorkString[2] = "COMPort\t" + baRtlHT;
WorkString[3] = "Baud\t" + iGloTVf;
WorkString[4] = "IP\t" + netOeFl;
WorkString[5] = "Port\t" + ZhEGIBX;
if(wtoALPx == 1)WorkString[6] = "mouseOver\t1";
else	WorkString[6] = "mouseOver\t0"; 
saveStrings("software.ini", WorkString);
}public void fileSelected(File selection) 
{if (selection == null) {
AppendLogFile("Window was closed or the user hit cancel.");
} 
else {
AppendLogFile("User selected " + selection.getAbsolutePath());
iKxwBtq = selection.getAbsolutePath();
switch(FileBrowserAction)  
{case 0: 
break;
case 1: 
if(!CheckSequenceFileHardwareID(iKxwBtq))
{try {
LoadUserSequencesFile(iKxwBtq);
}catch(Exception e)	{
gQWmajl = 6;
}					
}	
break;
case 2: 
SaveUserSequencesFile(iKxwBtq);
break;
case 3: 
UPCYumR = "Emulated";
String[] lines = loadStrings(iKxwBtq); 
device.HardwareID = PApplet.parseInt(split(lines[0], '\t')[1]);  
device.HardwareVersion = 0;
device.FirmwareVersion = 0;
device.FirmwareRevision = 0;		
LoadDeviceFile();
break;	  
case 4: 
POVFileLoadFunc();
break;  
case 5: 
graphicImgFilePath = iKxwBtq;
graphicImg = loadImage(graphicImgFilePath);
GraphicImageEnabled =  true;
GraphicImageResize = true;
MenuTabs[uBYXrqM].Selected = false;  
uBYXrqM = 0;
MenuTabs[0].Selected = true;			
MenuTabs[0].refresh(); 
break; 	
case 6: 
MenuTabs[0].refresh(); 
iKxwBtqCondensed = iKxwBtq;
if (iKxwBtq.length() > 44)  iKxwBtqCondensed = iKxwBtq.substring(0, 14) + "......"+iKxwBtq.substring(iKxwBtq.length()-36);
ImportCustomPixelMap();
break; 			
case 7: 
LoadGammaTable(iKxwBtq);
break; 	
case 8: 
LoadFilePlayModeFile(iKxwBtq);
break; 
}}
redraw();
}public boolean CheckSequenceFileHardwareID(String PassedLocation)
{AppendLogFile("CheckSequenceFileHardwareID() with "+PassedLocation); 
String[] lines = loadStrings(PassedLocation); 
int sLines = 0;  
String[] WorkString = new String[20]; 
WorkString = split(lines[sLines], '\t');
if(device.HardwareID != PApplet.parseInt(WorkString[4]) && device.HardwareID != 0)
{AppendLogFile("Save file loaded different from currently connected hardware");
gQWmajl = 10; 
return true;
}return false;
} 
public void LoadUserSequencesFile(String PassedLocation)
{AppendLogFile("LoadUserSequencesFile() - Version Independent"); 
String[] lines = loadStrings(PassedLocation); 
int sLines = 0;  
String[] WorkString = new String[300]; 
AppendLogFile("Loading from "+PassedLocation+" : Length: "+lines.length);
int SelSeq = 0;
WorkString = split(lines[sLines], '\t');
if(PApplet.parseInt(WorkString[1]) == 1 || WorkString[1].equals("0.99") ) { LoadUserSequencesFileVersion1(PassedLocation); return; }
AppendLogFile("Sequence File is Version 2 - Loading From: "+PassedLocation); 
if(eitvFtJ == false) 
{device.HardwareID = PApplet.parseInt(WorkString[4]);			
LoadDeviceFile(); 
}uqdivtD = PApplet.parseInt(WorkString[5]); 
if(uqdivtD > device.Channels) uqdivtD = device.Channels;
TextFields[11].Label = ""+uqdivtD;
SequenceLength =  PApplet.parseInt(WorkString[7]); 
fdJgaNC = PApplet.parseInt(WorkString[8]);
ShapeOptionsDD.SelStr = fdJgaNC-1; 
LEDSizeID = PApplet.parseInt(WorkString[9]);
SetLEDSizeCheckBoxes();
IconLayoutAdvancedMode.Selected = PApplet.parseBoolean(WorkString[10]);	
if(IconLayoutAdvancedMode.Selected == true)
{SoftwareButtons[17].Status = 0; 
SoftwareButtons[16].Status = 0; 
SoftwareButtons[15].Status = 0; 
PixelAmountObject.setStatus(0);
LayoutGroupInc.Status = 0;
LayoutGroupDec.Status = 0;
}	
GraphicImageEnabled  = PApplet.parseBoolean(WorkString[11]);
if(GraphicImageEnabled == true)
{AppendLogFile("Using Graphic: "+WorkString[12]);		
graphicImgFilePath = WorkString[12];
graphicImg = loadImage(graphicImgFilePath); 		
if(graphicImg == null)
{AppendLogFile("Error Loading Image Shape, defaulting");
GraphicImageEnabled = false;
NyqOxsk(24);
} 
else
{GraphicImageX = PApplet.parseInt(WorkString[13]); 	
GraphicImageY = PApplet.parseInt(WorkString[14]);
GraphicImageWidth = PApplet.parseInt(WorkString[15]); 	
GraphicImageHeight = PApplet.parseInt(WorkString[16]);	
GraphicLayoutBuffer.beginDraw();
handlerDrawImageHandles();
GraphicLayoutBuffer.endDraw();	
}
} 
TextFields[14].Label = WorkString[17];	
IntensityOverrideCheckBox.Selected = PApplet.parseBoolean(WorkString[18]);	
device.UserIdleSequence = PApplet.parseInt(WorkString[19]);	
UserSequences = new UserSequenceObj[SequenceLength+1];
for (int i = 0; i != UserSequences.length; i++)
{UserSequences[i] = new UserSequenceObj("User Seq "+i, i, device.Channels); 
}for (SelSeq = 1; SelSeq != SequenceLength+1;SelSeq++) 
{sLines++;
WorkString = split(lines[sLines], '\t');
AppendLogFile("Loading " +SelSeq+"     Starting line#: "+(sLines+1));
UserSequences[SelSeq].UserID = WorkString[1].replaceAll("[^\\x00-\\x7f]", ""); 
UserSequences[SelSeq].Length = PApplet.parseInt(WorkString[2]);
if(PApplet.parseInt(WorkString[3]) > device.Channels) UserSequences[SelSeq].DataSize = device.Channels;
else UserSequences[SelSeq].DataSize = PApplet.parseInt(WorkString[3]);	
UserSequences[SelSeq].SeqFrameAmount = PApplet.parseInt(WorkString[4]);
UserSequences[SelSeq].Speed = PApplet.parseInt(WorkString[5]);
UserSequences[SelSeq].SeqMode = PApplet.parseInt(WorkString[6]);	
UserSequences[SelSeq].DataType = PApplet.parseInt(WorkString[7]);
UserSequences[SelSeq].SeqPlayMode = PApplet.parseInt(WorkString[8]);
UserSequences[SelSeq].SeqTransitionFlags = PApplet.parseInt(WorkString[9]);
UserSequences[SelSeq].SeqTransSpeed = PApplet.parseInt(WorkString[10]);
UserSequences[SelSeq].SequenceIntensity = PApplet.parseInt(WorkString[11]);
if(UserSequences[SelSeq].SeqMode == XyiEbAJ)
{try {
UserSequences[SelSeq].POVConfigType = PApplet.parseInt(WorkString[12]) & 0xFF; 
if((UserSequences[SelSeq].POVConfigType & 0x80) > 0) 
{	
UserSequences[SelSeq].POVVideoMode = true; 
UserSequences[SelSeq].POVConfigType = UserSequences[SelSeq].POVConfigType & 0x7F; 
}UserSequences[SelSeq].POVUsageMode = (PApplet.parseInt(WorkString[12]) >> 8); 
UserSequences[SelSeq].POVFramesAmount = PApplet.parseInt(WorkString[13]);
}catch(Exception e)
{AppendLogFile("CATCH: POV Header values missing");
}}
else
{try {
UserSequences[SelSeq].gradientSteps = PApplet.parseInt(WorkString[12]); 
}catch(Exception e)
{UserSequences[SelSeq].gradientSteps = 0; 
}	
}try {
UserSequences[SelSeq].PacketCloneMode = PApplet.parseInt(WorkString[14]);	
}catch(Exception e) {
UserSequences[SelSeq].PacketCloneMode = 0;
}		
int seqFrameAmt = UserSequences[SelSeq].SeqFrameAmount+1; 
if(UserSequences[SelSeq].SeqMode == mTKKGDu) seqFrameAmt = ((UserSequences[SelSeq].SeqFrameAmount+1)*2);
UserSequences[SelSeq].StartValues = new int[device.Channels];		
UserSequences[SelSeq].DataFrameVar = new int[device.Channels]; 
UserSequences[SelSeq].SlideValues = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; 
UserSequences[SelSeq].SlideFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; 
UserSequences[SelSeq].TechTime = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];
UserSequences[SelSeq].TechFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];			
if(UserSequences[SelSeq].SeqMode == XyiEbAJ && UserSequences[SelSeq].POVVideoMode == true) seqFrameAmt = UserSequences[SelSeq].POVFramesAmount;
UserSequences[SelSeq].DataFrames = new int[seqFrameAmt][device.Channels]; 
if(UserSequences[SelSeq].SeqMode == qzXknoY)
{sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
}   
}else	
{if(UserSequences[SelSeq].SeqMode == EqPnOUb || UserSequences[SelSeq].SeqMode == kRMfOXG || UserSequences[SelSeq].SeqMode == lMBafjD || UserSequences[SelSeq].SeqMode == mTKKGDu) 
{		
if(UserSequences[SelSeq].SeqMode != lMBafjD)
{	
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].StartValues[i] = PApplet.parseInt(WorkString[i+1]);
}    
}sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
}       
} 
if (UserSequences[SelSeq].SeqMode == lMBafjD) 
{sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
{UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
}sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
{UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
}}
if(UserSequences[SelSeq].SeqMode == mTKKGDu) 
{			
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].TechFlags[q][i] = PApplet.parseInt(WorkString[i+1]);
}}
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].TechTime[q][i] = PApplet.parseInt(WorkString[i+1]);
}}
} 
if (UserSequences[SelSeq].SeqMode == kRMfOXG)
{int tempDataMult = 0;
switch(UserSequences[SelSeq].DataType)
{	
case 0:
tempDataMult = 1;
break;
case 1:
tempDataMult = 3;
break;
case 2:
tempDataMult = 4;
break;
}	
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{				
sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[(i%tempDataMult)+1]);
}}
}else 
{			
for (int q=0; q != seqFrameAmt;q++)
{					
sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
}}
AppendLogFile("Sequence# "+SelSeq+" has completed loading");
}}
}IndexedSequenceLength = 0; 
IndexMapPointer = 0;
sLines++;
WorkString = split(lines[sLines], '\t');  
for (int q=0; q != XwgQulc;q++)
{IndexMapArray[q] = PApplet.parseInt(WorkString[q+1]);
if(IndexMapArray[q] != cfXHabo) IndexMapPointer++; 
} 
IndexMapPointer--; 
IndexScrollBar.Value = 0;	
if(fdJgaNC == 5 || fdJgaNC == 6) 
{	
sLines++;	
WorkString = split(lines[sLines], '\t'); 
LEDIconCoordX = new int[uqdivtD]; 
LEDIconCoordY = new int[uqdivtD];
for (int q=0; q != (uqdivtD);q++)LEDIconCoordX[q] = PApplet.parseInt(WorkString[q+1]);
sLines++;	
WorkString = split(lines[sLines], '\t'); 
for (int q=0; q != (uqdivtD);q++)LEDIconCoordY[q] = PApplet.parseInt(WorkString[q+1]);
}if(SequenceLength > 0)
{	
AkOQmUe = 1; 
UserSequences[AkOQmUe].Highlighted = true;
LoadSequence();
}	
DrawUserSeqIconBuffer(9999); 
DrawIndexScrollArea();	
naJDfWm = 0;
nRudTeq = 0;
GraphicLayoutUpdateIcons();
GraphicLayoutBuild(0); 
try 
{sLines++;
WorkString = split(lines[sLines], '\t'); 	
for (int q=0; q != (uqdivtD);q++)
{try 
{	
PixelIcon[q].GroupID = (byte)PApplet.parseInt(WorkString[q+1]); 
}catch(Exception e) 
{ 
PixelIcon[q].GroupID = 0;
}}
}catch(Exception e) { AppendLogFile("No Group IDs to load"); }	
AppendLogFile("Loaded Sequences File");	
} 
public void LoadUserSequencesFileVersion1(String PassedLocation)
{AppendLogFile("LoadUserSequencesFileVersion1() - Loading From: "+PassedLocation); 
String[] lines = loadStrings(PassedLocation); 
int sLines = 0;  
String[] WorkString = new String[300]; 
AppendLogFile("Loading from "+PassedLocation+" : Length: "+lines.length);
int SelSeq = 0;
WorkString = split(lines[sLines], '\t');
if(device.HardwareID != PApplet.parseInt(WorkString[4]) && device.HardwareID != 0)
{AppendLogFile("Save file loaded different from currently connected hardware");
CloseCommunicationPort();
device.HardwareID = PApplet.parseInt(WorkString[4]);	
LoadDeviceFile();
gQWmajl = 10; 
}device.HardwareID = PApplet.parseInt(WorkString[4]);	
if(eitvFtJ == false) LoadDeviceFile(); 
uqdivtD = PApplet.parseInt(WorkString[5]); 
if(uqdivtD > device.Channels) uqdivtD = device.Channels;
TextFields[11].Label = ""+uqdivtD;
fdJgaNC = PApplet.parseInt(WorkString[8]);
ShapeOptionsDD.SelStr = fdJgaNC-1; 
LEDSizeID = PApplet.parseInt(WorkString[9]);
SetLEDSizeCheckBoxes();
SequenceLength =  PApplet.parseInt(WorkString[10]); 
AppendLogFile("V1 load made it here");	
try {
AppendLogFile("Using Graphic: "+WorkString[11]);
graphicImgFilePath = WorkString[11];
graphicImg = loadImage(graphicImgFilePath); 
GraphicImageEnabled = true;
GraphicLayoutBuffer.beginDraw();
handlerDrawImageHandles();
GraphicLayoutBuffer.endDraw();	
}
catch(Exception e)	{
AppendLogFile("Error Loading Image Shape, defaulting");
graphicImgFilePath = "imagelayouts"+File.separator+"default.png";	
graphicImg = loadImage(graphicImgFilePath); 			
}try {
IconLayoutAdvancedMode.Selected = PApplet.parseBoolean(WorkString[13]);
GraphicImageEnabled  = PApplet.parseBoolean(WorkString[14]);
GraphicImageX = PApplet.parseInt(WorkString[15]); 	
GraphicImageY = PApplet.parseInt(WorkString[16]);
GraphicImageWidth = PApplet.parseInt(WorkString[17]); 	
GraphicImageHeight = PApplet.parseInt(WorkString[18]);
handlerDrawImageHandles();
}
catch(Exception e) 
{AppendLogFile("Could not load header info for v.1h updates");
}UserSequences = new UserSequenceObj[SequenceLength+1];
for (int i = 0; i != UserSequences.length; i++)
{UserSequences[i] = new UserSequenceObj("User Seq "+i, i, device.Channels); 
}for (SelSeq = 1; SelSeq != SequenceLength+1;SelSeq++) 
{sLines++;
WorkString = split(lines[sLines], '\t');
UserSequences[SelSeq].UserID = WorkString[1].replaceAll("[^\\x00-\\x7f]", ""); 
AppendLogFile("Loading v1: " +SelSeq+"     "+UserSequences[SelSeq].UserID);		
UserSequences[SelSeq].Length = PApplet.parseInt(WorkString[2]);
if(PApplet.parseInt(WorkString[3]) > device.Channels) UserSequences[SelSeq].DataSize = device.Channels;
else UserSequences[SelSeq].DataSize = PApplet.parseInt(WorkString[3]);			
UserSequences[SelSeq].SeqFrameAmount = PApplet.parseInt(WorkString[5]); 
UserSequences[SelSeq].Speed = PApplet.parseInt(WorkString[6]);
UserSequences[SelSeq].SeqMode = PApplet.parseInt(WorkString[7]);
UserSequences[SelSeq].DataType = PApplet.parseInt(WorkString[8]);
UserSequences[SelSeq].PacketCloneMode = 0;	
if(UserSequences[SelSeq].SeqMode == 3) UserSequences[SelSeq].SeqMode = kRMfOXG;
else if(UserSequences[SelSeq].SeqMode == 2) UserSequences[SelSeq].SeqMode = lMBafjD;
else if(UserSequences[SelSeq].SeqMode == 5) { UserSequences[SelSeq].SeqMode = qzXknoY; UserSequences[SelSeq].SeqFrameAmount--; }
else if(UserSequences[SelSeq].SeqMode == 6) UserSequences[SelSeq].SeqMode = XyiEbAJ;
else if(UserSequences[SelSeq].SeqMode == 4) 
{AppendLogFile("Sequence "+SelSeq+" is a combo, not loading");
SelSeq--;
break;
}	
if(UserSequences[SelSeq].SeqMode == XyiEbAJ)
{try {
UserSequences[SelSeq].POVConfigType = PApplet.parseInt(WorkString[9]) & 0xFF; 
UserSequences[SelSeq].POVUsageMode = (PApplet.parseInt(WorkString[9]) >> 8); 
}catch(Exception e)
{UserSequences[SelSeq].POVConfigType = 0; 
}}
else
{try {
UserSequences[SelSeq].gradientSteps = PApplet.parseInt(WorkString[9]); 
}catch(Exception e)
{UserSequences[SelSeq].gradientSteps = 0; 
}	
}try {
UserSequences[SelSeq].SequenceIntensity = PApplet.parseInt(WorkString[10]);
}catch(Exception e)
{UserSequences[SelSeq].SequenceIntensity = 100;
}	
UserSequences[SelSeq].DataFrameVar = new int[device.Channels]; 
UserSequences[SelSeq].StartValues = new int[device.Channels];
UserSequences[SelSeq].SlideValues = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; 
UserSequences[SelSeq].SlideFlags = new int[(UserSequences[SelSeq].SeqFrameAmount+1)]; 
UserSequences[SelSeq].DataFrames = new int[(UserSequences[SelSeq].SeqFrameAmount+1)][device.Channels];	
if(UserSequences[SelSeq].SeqMode == qzXknoY)
{sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].SlideFlags[i] = PApplet.parseInt(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
}   
sLines++;
WorkString = split(lines[sLines], '\t');		
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++)
{UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
}  
}
else	
{sLines++;
WorkString = split(lines[sLines], '\t');
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].StartValues[i] = PApplet.parseInt(WorkString[i+1]);
}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrameVar[i] = PApplet.parseInt(WorkString[i+1]);
}    
sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
{}    
if (UserSequences[SelSeq].SeqMode == lMBafjD) 
{sLines++;
WorkString = split(lines[sLines], '\t');    
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++)
{UserSequences[SelSeq].SlideValues[i] = PApplet.parseInt(WorkString[i+1]);
}}
if (UserSequences[SelSeq].SeqMode == kRMfOXG) 
{int tempDataMult = 0;
switch(UserSequences[SelSeq].DataType)
{	
case 0:
tempDataMult = 1;
break;
case 1:
tempDataMult = 3;
break;
case 2:
tempDataMult = 4;
break;
}	
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[(i%tempDataMult)+1]);
}}
}else if (UserSequences[SelSeq].SeqMode == lMBafjD) 
{for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{if(UserSequences[SelSeq].SlideValues[q] == 0) 
{sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
}}    
}}
else
{for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{sLines++;
WorkString = split(lines[sLines], '\t');     
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{UserSequences[SelSeq].DataFrames[q][i] = PApplet.parseInt(WorkString[i+1]);
}}
}}
}AppendLogFile("V1 finished loading seqences");
IndexMapPointer = 0;
sLines++;
WorkString = split(lines[sLines], '\t');  
int tempconvert = 0;
for (int q=0; q != 32;q++)
{tempconvert = PApplet.parseInt(WorkString[q+1]);
if(tempconvert == 255) tempconvert = cfXHabo;
IndexMapArray[q] = tempconvert;
if(tempconvert != cfXHabo) 
{				
IndexMapPointer++; 
}	
}IndexMapPointer--; 
IndexScrollBar.Value = 0;	
if(fdJgaNC == 5 || fdJgaNC == 6) 
{	
sLines++;	
WorkString = split(lines[sLines], '\t'); 
LEDIconCoordX = new int[uqdivtD]; 
LEDIconCoordY = new int[uqdivtD];
for (int q=0; q != (uqdivtD);q++)LEDIconCoordX[q] = PApplet.parseInt(WorkString[q+1]);
sLines++;	
WorkString = split(lines[sLines], '\t'); 
for (int q=0; q != (uqdivtD);q++)LEDIconCoordY[q] = PApplet.parseInt(WorkString[q+1]);
}if(SequenceLength > 0)
{	
AkOQmUe = 1; 
UserSequences[AkOQmUe].Highlighted = true;
LoadSequence();
}	
DrawUserSeqIconBuffer(9999); 
DrawIndexScrollArea();	
naJDfWm = 0;
nRudTeq = 0;
GraphicLayoutBuild(0); 
try 
{sLines++;
WorkString = split(lines[sLines], '\t'); 	
for (int q=0; q != (uqdivtD);q++)
{try 
{	
PixelIcon[q].GroupID = (byte)PApplet.parseInt(WorkString[q+1]); 
}catch(Exception e) 
{ 
PixelIcon[q].GroupID = 0;
}}
}catch(Exception e) { AppendLogFile("No Group IDs to load"); }	
AppendLogFile("Loaded Sequences File");
}public void SaveUserSequencesFile(String PassedLocation)
{AppendLogFile("SaveUserSequencesFile()  Saving To: "+PassedLocation);
ArrayList strs = new ArrayList(); 
String TempS="";
int SelSeq = 0;
SequenceLength = 0; 
strs.add("\t"+TATbaZv+"\t"+OhKywff+"\t"+month()+"/"+day()+"/"+year()+"\t"+device.HardwareID+"\t"+uqdivtD+"\t"+device.Channels+"\t"+(UserSequences.length-1)
+"\t"+fdJgaNC+"\t"+LEDSizeID+"\t"+IconLayoutAdvancedMode.Selected+"\t"+GraphicImageEnabled+"\t"+graphicImgFilePath
+"\t"+GraphicImageX+"\t"+GraphicImageY+"\t"+GraphicImageWidth+"\t"+GraphicImageHeight+"\t"+TextFields[14].Label
+"\t"+IntensityOverrideCheckBox.Selected+"\t"+device.UserIdleSequence); 
AppendLogFile("Save File header written");		
for (SelSeq = 1; SelSeq != UserSequences.length; SelSeq++) 
{int holdLastValue1 = 0; 
int holdLastValue2 = 0; 
if(UserSequences[SelSeq].SeqMode == XyiEbAJ) 
{	
if(UserSequences[SelSeq].POVVideoMode == true) 
{	
holdLastValue1 = (UserSequences[SelSeq].POVUsageMode << 8) | (0x80 | UserSequences[SelSeq].POVConfigType); 
holdLastValue2 = UserSequences[SelSeq].POVFramesAmount; 
}else holdLastValue1 = (UserSequences[SelSeq].POVUsageMode << 8) | UserSequences[SelSeq].POVConfigType; 
}else holdLastValue1 = UserSequences[SelSeq].gradientSteps;			
strs.add("\t"+UserSequences[SelSeq].UserID+"\t"+UserSequences[SelSeq].Length+"\t"+UserSequences[SelSeq].DataSize+"\t"+UserSequences[SelSeq].SeqFrameAmount+"\t"+
UserSequences[SelSeq].Speed+"\t"+UserSequences[SelSeq].SeqMode+"\t"+UserSequences[SelSeq].DataType+"\t"+UserSequences[SelSeq].SeqPlayMode+"\t"+
UserSequences[SelSeq].SeqTransitionFlags+"\t"+UserSequences[SelSeq].SeqTransSpeed+"\t"+UserSequences[SelSeq].SequenceIntensity+"\t"+holdLastValue1+"\t"+
holdLastValue2+"\t"+UserSequences[SelSeq].PacketCloneMode);
MeasureSequenceLength(SelSeq); 
SequenceLength = SequenceLength + UserSequences[SelSeq].Length;		
if(UserSequences[SelSeq].SeqMode == qzXknoY)
{TempS = "";
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].SlideFlags[i];
}strs.add(TempS); 		
TempS = "";
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].SlideValues[i];
}strs.add(TempS);	
TempS = "";
for (int i=0; i != UserSequences[SelSeq].SeqFrameAmount+1;i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrameVar[i];
}strs.add(TempS);		
}else 
{if(UserSequences[SelSeq].SeqMode == EqPnOUb || UserSequences[SelSeq].SeqMode == kRMfOXG || UserSequences[SelSeq].SeqMode == lMBafjD || UserSequences[SelSeq].SeqMode == mTKKGDu) 
{if(UserSequences[SelSeq].SeqMode != lMBafjD)
{	
TempS = "";
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].StartValues[i];
}strs.add(TempS);   
}TempS = "";
for (int i=0; i != UserSequences[SelSeq].DataSize;i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrameVar[i];
}strs.add(TempS);   
}if(UserSequences[SelSeq].SeqMode == lMBafjD) 
{TempS = "";
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].SlideValues[i];
}strs.add(TempS);
TempS = "";
for (int i=0; i != (UserSequences[SelSeq].SeqFrameAmount+1);i++) 
{TempS = TempS+"\t"+UserSequences[SelSeq].SlideFlags[i];
}strs.add(TempS);				
}if (UserSequences[SelSeq].SeqMode == mTKKGDu) 
{for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{TempS = "";  
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].TechFlags[q][i];
}strs.add(TempS);
}for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{TempS = "";  
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].TechTime[q][i];
}strs.add(TempS);
}}	
if (UserSequences[SelSeq].SeqMode == kRMfOXG)
{for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{TempS = "";  
for (int i=0; i != 4;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
}strs.add(TempS);
}}
else if (UserSequences[SelSeq].SeqMode == mTKKGDu)
{for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++)
{TempS = "";  
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
}strs.add(TempS);
}}
else if (UserSequences[SelSeq].SeqMode == XyiEbAJ && UserSequences[SelSeq].POVVideoMode == true)
{for (int q=0; q != UserSequences[SelSeq].POVFramesAmount;q++)
{TempS = "";  
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
}strs.add(TempS);
}}
else
{for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{TempS = "";  
for (int i=0; i != UserSequences[SelSeq].DataSize;i++)
{TempS = TempS+"\t"+UserSequences[SelSeq].DataFrames[q][i];
}strs.add(TempS);
}} 
} 
}TempS = "";  
for (int q=0; q != XwgQulc;q++) TempS = TempS+"\t"+IndexMapArray[q];
strs.add(TempS);
if(fdJgaNC == 5 || fdJgaNC == 6 || IconLayoutAdvancedMode.Selected == true) 
{AppendLogFile("saving PixelIcon Coords, length: "+PixelIcon.length);	
TempS = ""; 	
for (int i=0;i != (PixelIcon.length);i++)	
{try {	
TempS = TempS+"\t"+PixelIcon[i].xpos;
}catch(Exception e)	{
TempS = TempS+"\t"+0;	
}} 
strs.add(TempS);	
TempS = ""; 	
for (int i=0;i != uqdivtD;i++)
{try {	
TempS = TempS+"\t"+PixelIcon[i].ypos;
}catch(Exception e)	{
TempS = TempS+"\t"+0;	
}} 
strs.add(TempS);	
}TempS = ""; 	
for (int i=0;i != uqdivtD;i++)
{try {	
TempS = TempS+"\t"+PixelIcon[i].GroupID;
}catch(Exception e)	{
TempS = TempS+"\t"+0;	
}} 
strs.add(TempS);			
String[] lines = new String[strs.size()]; 
for (int q=0; q != strs.size();q++)  
{lines[q]=(String) strs.get(q);
if(q == 0) lines[q] += "\t"+SequenceLength; 
} 
String[]  ExtensionStripped = split(PassedLocation, '.');
saveStrings(ExtensionStripped[0]+".txt", lines);
AppendLogFile("Completed SaveUserSequencesFile()");
} 
public void PortMonitorThread()
{while(uBYXrqM == 4 && DeviceConnect.Selected == false)
{try {
if(COMButtons.length != Serial.list().length) 
{InitCOMButtons();	
}}
catch(Exception e) {  }		
delay(500); 
} 
} 
public void TransmissionTimerThread()
{int myStart = millis();
while((millis() - myStart) < yoJFiGp)
{delay(1);	
if(PtdjnQH == false && gMLtdVm == false) { return; } 
}CloseCommunicationPort();
NyqOxsk(6); 
OJQfYqn = false;
yQKiGIj = false;
gMLtdVm = false;
PtdjnQH = false;
AppendLogFile("Command Timed Out "+(millis() - myStart));
redraw();
} 
public void EnableTransmissionTimeOut()
{AppendLogFile("EnableTransmissionTimeOut()");
redraw();
thread("TransmissionTimerThread");
} 
public void NotificationTimerThread()
{int myStart = millis();
while((millis() - myStart) < 3000)
{delay(1);	
if((millis() - myStart) > 1000) NyqOxskMinFlag = true; 
if(NyqOxsk == 0) { break; } 
}NyqOxsk = 0; 
AppendLogFile("Timer end "+(millis() - myStart));
redraw();
} 
public void NyqOxsk(int passedID)
{AppendLogFile("NyqOxsk() with "+passedID+" -  "+cNotificationText[passedID]);
NyqOxsk = passedID;
redraw();
NyqOxskMinFlag = false;
thread("NotificationTimerThread");
} 
public void RunParseIndex()
{AppendLogFile("RunParseIndex()");
IndexedSequenceLength = 0; 
for (int q = 1; q != UserSequences.length; q++) 
{UserSequences[q].LinkerUtilized = false;
UserSequences[q].assignedIDNum = cfXHabo;
UserSequences[q].assignedLinkedIDNum = cfXHabo;
UserSequences[q].IDassigned = false;
UserSequences[q].mappedROMAdr = 0; 
} 
int offsetVar = 0;	
int i = 0; 
IndexSerialAssignedIDNum = cfXHabo;
IndexDMXAssignedIDNum = cfXHabo;
for (i = 0; i < device.MaxIndexedSequences; i++) 
{	 
if(IndexMapArray[i] == CguezcT)
{AppendLogFile("CguezcT on index, assigned "+i+", adding to length: "+smFWXrf);
IndexDMXAssignedIDNum = i;
LCVaxUK = IndexedSequenceLength;
IndexedSequenceLength += smFWXrf; 
}
else if(IndexMapArray[i] == bgpbnOG)
{AppendLogFile("bgpbnOG on index, assigned "+i+", adding to length: "+smFWXrf);
IndexSerialAssignedIDNum = i;	
mFPrNqq = IndexedSequenceLength;
IndexedSequenceLength += smFWXrf; 
}		
else if(IndexMapArray[i] != cfXHabo && UserSequences[IndexMapArray[i]].IDassigned == false)
{UserSequences[IndexMapArray[i]].LinkerUtilized = true;
UserSequences[IndexMapArray[i]].assignedIDNum = i - offsetVar;
UserSequences[IndexMapArray[i]].IDassigned = true;
UserSequences[IndexMapArray[i]].mappedROMAdr = IndexedSequenceLength;
IndexedSequenceLength += UserSequences[IndexMapArray[i]].Length;		
} 
else if(IndexMapArray[i] != cfXHabo && UserSequences[IndexMapArray[i]].IDassigned == true)
{	
AppendLogFile("Sequence "+IndexMapArray[i]+" is on the index again "+offsetVar+"   use adr: "+UserSequences[IndexMapArray[i]].mappedROMAdr);
offsetVar++;
}else
{for (int q = 1; q != UserSequences.length; q++)
{if(UserSequences[q].SeqMode == qzXknoY && UserSequences[q].LinkerUtilized == true)
{	
AppendLogFile("Found a linked "+q);
for (int yy = 0; yy != UserSequences[q].SeqFrameAmount+1; yy++)
{if(UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized == false && UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned == false)
{	
AppendLogFile("One sequence to be linked, SoftID: "+UserSequences[q].SlideFlags[yy]+" will be "+(i - offsetVar)+" instead of "+(i));
UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized = true;
UserSequences[UserSequences[q].SlideFlags[yy]].assignedIDNum = i;
UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned = true;
i++; 

UserSequences[UserSequences[q].SlideFlags[yy]].mappedROMAdr = IndexedSequenceLength;
IndexedSequenceLength += UserSequences[UserSequences[q].SlideFlags[yy]].Length;
}	
}} 
}	
AppendLogFile("If it gets here, all linked sequences have been parsed and sequences assigned "+i);	
break;		
}	
} 
if(device.UserIdleSequence > 0 && device.UserIdleSequence <= UserSequences.length)
{if(UserSequences[device.UserIdleSequence].LinkerUtilized == false) 
{	
AppendLogFile("IDLE NOT ON INDEX USING "+(i - offsetVar));
UserSequences[device.UserIdleSequence].LinkerUtilized = true;
UserSequences[device.UserIdleSequence].assignedIDNum = i - offsetVar;
UserSequences[device.UserIdleSequence].IDassigned = true;
IndexedSequenceLength += UserSequences[device.UserIdleSequence].Length;
}else AppendLogFile("IDLE ON INDEX");
}	
for (int q = 1; q != UserSequences.length; q++) AppendLogFile("Seq#"+q+" : assignedID: "+UserSequences[q].assignedIDNum+" : Indexed: "+UserSequences[q].LinkerUtilized); 
AppendLogFile("Total Sequences Length in Bytes: "+IndexedSequenceLength);
}public void FillManualGradient(int rollingIDnumber, int maxDist)
{float LocationVar = (256 * (UserSequences[AkOQmUe].SeqFrameAmount+1)); 
float StepFactorH = LocationVar / ((float)rollingIDnumber / ((float)MultiplierToolValue/10));
int FrameVarCurrent = 0; 
int FrameVarNext = 1; 
float StepFactor = 0; 
int HoldCurrent=0;
int HoldNext=0;	
AppendLogFile("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH+"  : rollingIDnumber"+(float)rollingIDnumber+"  : maxDist: "+(int)maxDist); 
LocationVar = 0;
for(int raidusVal = 1;raidusVal!= maxDist;raidusVal++) 
{for (int i = 0; i != nRudTeq; i++) 
{if(GradientDrawID[i] == raidusVal)	
{for(int q=0;q != ByoKxya;q++)
{if (q == 0)
{LocationVar += StepFactorH; 
if (LocationVar > 255)
{LocationVar -= 256;    
if (FrameVarNext == (UserSequences[AkOQmUe].SeqFrameAmount))
{FrameVarNext = 0; 
FrameVarCurrent = (UserSequences[AkOQmUe].SeqFrameAmount);
}else
{FrameVarNext++;
FrameVarCurrent++;	
if(FrameVarCurrent > UserSequences[AkOQmUe].SeqFrameAmount) FrameVarCurrent = 0;
}} 
}int tempThis = (i*ByoKxya)+q;
StepFactor = (float)LocationVar / 256; 
HoldCurrent = UserSequences[AkOQmUe].DataFrames[FrameVarCurrent][tempThis];
HoldNext = UserSequences[AkOQmUe].DataFrames[FrameVarNext][tempThis];
if (HoldCurrent == HoldNext) 
{ 
UserSequences[AkOQmUe].StartValues[tempThis] = PApplet.parseInt(255*StepFactor); 
}  
else if (HoldCurrent < HoldNext)  
{UserSequences[AkOQmUe].StartValues[tempThis] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
}else
{UserSequences[AkOQmUe].StartValues[tempThis] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
}UserSequences[AkOQmUe].DataFrameVar[tempThis] = FrameVarCurrent;
} 
} 
} 
} 
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
} 
public void GenerateLinearGradient()
{AppendLogFile("GenerateLinearGradient() "+PixelIcon.length);
GradientDrawID = new int[nRudTeq]; 
for (int i = 0; i != nRudTeq; i++) 
{	
if(PixelIcon[i].GroupID == gdHgLUO) GradientDrawID[i] = 0; 
else GradientDrawID[i] = 0xFFFF; 
}float maxDist = dist(GradientDrawStartX, GradientDrawStartY, GradientDrawEndX, GradientDrawEndY);
int lineDist = PApplet.parseInt(maxDist);	
int rollingIDnumber = 1;	
float lerp1, lerp2, lerp3, lerp4;
float lerpFactor = 1/maxDist;
for(int i = 0; i!=lineDist;i++) 
{lerp1 = lerp(X1, X3, i*lerpFactor);
lerp2 = lerp(Y1, Y3, i*lerpFactor);
lerp3 = lerp(X2, X4, i*lerpFactor);
lerp4 = lerp(Y2, Y4, i*lerpFactor);
line(lerp1, lerp2, lerp3, lerp4);
for (int q = 0; q != nRudTeq; q++) 
{try 
{	
if(((X2 - X1) * ((PixelIcon[q].ypos+35) - Y1) - (Y2 - Y1) * ((PixelIcon[q].xpos+85) - X1)) < 0) 
{if(((lerp3 - lerp1) * ((PixelIcon[q].ypos+35) - lerp2) - (lerp4 - lerp2) * ((PixelIcon[q].xpos+85) - lerp1)) > 0) 
{if(GradientDrawID[q] == 0)
{GradientDrawID[q] = rollingIDnumber;
} 
} 
} 
}catch(Exception e) { break; } 
} 
rollingIDnumber++;
} 
FillManualGradient(rollingIDnumber, PApplet.parseInt(maxDist)); 
}
public void GenerateRadialGradient()
{AppendLogFile("GenerateRadialGradient() "+PixelIcon.length);
GradientDrawID = new int[nRudTeq]; 
for (int i = 0; i != nRudTeq; i++) 
{	
if(PixelIcon[i].GroupID == gdHgLUO) GradientDrawID[i] = 0; 
else GradientDrawID[i] = 0xFFFF; 
}float maxDist = dist(GradientDrawStartX, GradientDrawStartY, GradientDrawEndX, GradientDrawEndY);
GradientDrawStartX -= 125; 
GradientDrawStartY -= 35;
int rollingIDnumber = 1;
int lineDist = PApplet.parseInt(maxDist);
float disX = 0; 
float disY = 0;	
for(int i = 1; i != lineDist; i++) 
{for (int q = 0; q != nRudTeq; q++)  
{try {
disX = GradientDrawStartX - PixelIcon[q].xpos;
}catch(Exception e) { break; } 
disY = GradientDrawStartY - PixelIcon[q].ypos;
if (sqrt(sq(disX) + sq(disY)) < i ) 
{if(GradientDrawID[q] == 0)
{GradientDrawID[q] = rollingIDnumber;
}
} 
}rollingIDnumber++;
} 
FillManualGradient(rollingIDnumber, PApplet.parseInt(maxDist)); 
} 
public void ResetStartValuesCommon(int passedSeq)
{AppendLogFile("ResetStartValuesCommon()");
for (int i =0; i != UserSequences[passedSeq].DataSize; i++)
{			
UserSequences[passedSeq].DataFrameVar[i] = 0;	
UserSequences[passedSeq].StartValues[i] = UserSequences[passedSeq].DataFrames[0][i];
}} 
public void AppendLogFile(String newData)
{println(newData);
try 
{FileWriter fw = new FileWriter(sketchPath(File.separator+"logs"+File.separator+""+wSlKztR), true); 
bw = new BufferedWriter(fw);
bw.write(newData + "\n");
} 
catch (IOException e) 
{println("Log file appending erorr");
}finally
{if (bw != null)
{try { 
bw.close();
} 
catch (IOException e) {	}
}}
} 
public boolean WithinStartLimits(int value, int start, int end)
{if(start == end) return true; 
if(start >= end) 
{if(value < end || value > start) return false;
else return true;	
}
else if(end > start) 
{if(value < start || value > end) return false;
else return true;	
}	
return false; 
} 
public void UpdateSideBarButtonStates()
{AppendLogFile("UpdateSideBarButtonStates()");
TextFields[0].Status = 1; 
TextFields[0].Label = ""+UserSequences[AkOQmUe].SlideValues[lQGtaTe];
SetSlideDataTypeBoxStates(0); 
SequenceSpeedObject.setValue(""+UserSequences[AkOQmUe].Speed);
SequenceChannelObject.setValue(""+UserSequences[AkOQmUe].DataSize);
GradientStepsObject.setValue(""+UserSequences[AkOQmUe].gradientSteps);
TXTFSeqIntensity.Label = ""+UserSequences[AkOQmUe].SequenceIntensity;
PlayModeDD.SelStr = UserSequences[AkOQmUe].SeqPlayMode;
PacketCloneDD.SelStr = UserSequences[AkOQmUe].PacketCloneMode;
SeqTransistionDD.SelStr = UserSequences[AkOQmUe].SeqTransitionFlags;
SequenceModeDD.SelStr = UserSequences[AkOQmUe].SeqMode-1; 
SeqCheckBoxes[0].Selected = false; 
SeqCheckBoxes[1].Selected = false; 
SeqCheckBoxes[2].Selected = false; 
SeqCheckBoxes[UserSequences[AkOQmUe].DataType].Selected = true; 
if(device.LockChannelAmt == true) PacketCloneDD.Status = 1;
else PacketCloneDD.Status = 0;
StartValReset.Status = 0; 
GradientGenerate.Status = 0; 
GradientStepsObject.Status = 0; 
GradientMultiplierObject.Status = 0; 
GradientDrawRadialButton.Status = 0; 
GradientDrawLinearButton.Status = 0; 
MainToolsAllSame.Status = 0; 
GraphicFuncPaintButton.Status = 0; 
MainToolsColorGroup.Status = 0; 
MainToolsShowStartValues.Status = 0; 
FrameSeqToolInsantDD.Status = 1;	 
FrameSeqToolTechDD.Status = 1; 
TextFields[6].Status = 1; 
switch(UserSequences[AkOQmUe].SeqMode)
{case XyiEbAJ:
StartValReset.Status = 1; 
GradientGenerate.Status = 1; 
GradientStepsObject.Status = 1; 
GradientMultiplierObject.Status = 1; 
GradientDrawRadialButton.Status = 1; 
GradientDrawLinearButton.Status = 1; 
MainToolsAllSame.Status = 1; 
GraphicFuncPaintButton.Status = 1; 
MainToolsColorGroup.Status = 1; 
MainToolsShowStartValues.Status = 1; 
SeqCheckBoxes[0].Status = 1; 
SeqCheckBoxes[2].Status = 1; 
case EqPnOUb: 
case kRMfOXG:
FrameSeqToolInsantDD.SelStr = 0;	
FrameSeqToolInsantDD.Status = 1; 
FrameSeqToolTechDD.SelStr = 0;	
FrameSeqToolTechDD.Status = 2; 
TextFields[0].Status = 1; 
break;
case lMBafjD: 
FrameSeqToolInsantDD.SelStr = 0;
FrameSeqToolInsantDD.Status = 0;	 
FrameSeqToolTechDD.Status = 2; 
if(UserSequences[AkOQmUe].SlideFlags[lQGtaTe] > 0)
{AppendLogFile("ITS A SLIDE FRAME "+binary(UserSequences[AkOQmUe].SlideFlags[lQGtaTe],8));
if((UserSequences[AkOQmUe].SlideFlags[lQGtaTe] & 0x40) > 0) FrameSeqToolInsantDD.SelStr = 1;
else FrameSeqToolInsantDD.SelStr = 2;
TextFields[0].Status = 0; 
SetSlideDataTypeBoxStates((UserSequences[AkOQmUe].SlideFlags[lQGtaTe] & 0x07)+1); 
}		
break;
case mTKKGDu:
AppendLogFile("NO FINISHED METHOD FOR mTECH YET");
FrameSeqToolInsantDD.Status = 2; 
FrameSeqToolTechDD.SelStr = 0;	
FrameSeqToolTechDD.Status = 0; 
TextFields[6].Status = 0; 
break;
}} 
public void holdgraphicfunc(PGraphics GBuffer, int passedID, int SelSeq)
{int qTemp = 0;
int ColorTemp = color(0);
int c = color(0);  
int uZYECeH = color(0);
int currentOffset = 0;
int tempPxLength= 0;
int tempChan = getTechChannelNum(passedID); 
int tempColorDataType = 0;	
int[][] HoldDataFrames = new int[((UserSequences[SelSeq].SeqFrameAmount+1)*2)][UserSequences[SelSeq].DataSize];
GBuffer.beginDraw();
GBuffer.background(DqoHydg); 
GBuffer.noStroke();
for (int q=0; q != ((UserSequences[SelSeq].SeqFrameAmount+1)*2);q++) arrayCopy(UserSequences[SelSeq].DataFrames[q], HoldDataFrames[q], UserSequences[SelSeq].DataSize);
for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
{tempColorDataType = getTechChanColorMode(passedID);
tempPxLength = (UserSequences[SelSeq].TechTime[q][passedID] / 10)+10;
if((UserSequences[SelSeq].TechFlags[q][passedID] & 0x08) == 0)
{GBuffer.noStroke();
switch(tempColorDataType)
{case 0: 
if(device.Bit16Mode == true)	GBuffer.fill((HoldDataFrames[qTemp][tempChan]>>8));
else	GBuffer.fill(HoldDataFrames[qTemp][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)	GBuffer.fill((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
else	GBuffer.fill(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);  
break;	
}		
GBuffer.rect(currentOffset,0,tempPxLength,dodEQlf); 
if(tempColorDataType == 2)  
{GBuffer.fill(HoldDataFrames[qTemp][tempChan+3]);	
GBuffer.rect(currentOffset,10,tempPxLength,(dodEQlf/2));
}}
else
{float inter;
c = color(0);  
uZYECeH = color(0);
switch(tempColorDataType)
{case 0: 
if(device.Bit16Mode == true)uZYECeH = color((HoldDataFrames[qTemp][tempChan]>>8));
else uZYECeH = color(HoldDataFrames[qTemp][tempChan]);
if(device.Bit16Mode == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8));
else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)uZYECeH = color((HoldDataFrames[qTemp][tempChan]>>8), (HoldDataFrames[qTemp][tempChan+1]>>8), (HoldDataFrames[qTemp][tempChan+2]>>8));
else uZYECeH = color(HoldDataFrames[qTemp][tempChan], HoldDataFrames[qTemp][tempChan+1], HoldDataFrames[qTemp][tempChan+2]);
if(device.Bit16Mode == true)	ColorTemp = color((HoldDataFrames[qTemp+1][tempChan]>>8), (HoldDataFrames[qTemp+1][tempChan+1]>>8), (HoldDataFrames[qTemp+1][tempChan+2]>>8));
else	ColorTemp = color(HoldDataFrames[qTemp+1][tempChan], HoldDataFrames[qTemp+1][tempChan+1], HoldDataFrames[qTemp+1][tempChan+2]);  
break;	
} 
AppendLogFile("qTemp: "+qTemp);
for (int i = 0; i <= tempPxLength; i++) 
{inter = map(i, 0, tempPxLength, 0, 1);
if(tempColorDataType == 0) c = lerpColor(uZYECeH, ColorTemp, inter);
else c = lerpColor(color(uZYECeH), ColorTemp, inter);
GBuffer.stroke(c); 
GBuffer.line(currentOffset+i, 0, currentOffset+i, TXbHser);
}			
if(tempColorDataType == 2)  
{GBuffer.noStroke();
GBuffer.fill(255);
for (int i = 0; i <= tempPxLength; i++) 
{inter = map(i, 0, tempPxLength, 0, 1);
if(i == 0)
{if(device.Bit16Mode == true) 
{ColorTemp = color((HoldDataFrames[qTemp+1][tempChan+3]>>8));
}			 
else 
{ColorTemp = color(HoldDataFrames[qTemp+1][tempChan+3]);
}		
}	 
if(device.Bit16Mode == true)  c = lerpColor(color((HoldDataFrames[qTemp][tempChan+3]>>8)), ColorTemp, inter);
else	c = lerpColor(color(HoldDataFrames[qTemp][tempChan+3]), ColorTemp, inter);
GBuffer.stroke(c);
GBuffer.line(currentOffset+i, 10, currentOffset+i, TXbHser); 
}	
} 
} 
qTemp+=2;
currentOffset += tempPxLength;
} 
GBuffer.endDraw();
}public void DrawTechnicalBuffer()
{AppendLogFile("DrawTechnicalBuffer()");
String tempColorStr = "RGB";
String tempChanStr = "1";
int currentOffset = 0;
int channelCounter = 0;
oiHkAsJ = updateTechTotalColorChannel(AkOQmUe);
TechnicalBuffer = createGraphics(UZtwAsu, mzFoUAv);
TechnicalBuffer.beginDraw();
TechnicalBuffer.background(DqoHydg);
TechnicalBuffer.textFont(fDigital, 48);
TechChanLabelButtons = new Button[oiHkAsJ];
TechColorModeButton = new Button[oiHkAsJ];
channelCounter = 1;
for (int i = 0; i != oiHkAsJ; i++)
{TechnicalBuffer.stroke(WcWJAym);
TechnicalBuffer.strokeWeight(2);
TechnicalBuffer.line(0, (i*dodEQlf), (TimeLineBuffer.width-30), (i*dodEQlf));
TechChanLabelButtons[i] = new Button(""+(i+1), 0, 5+(i*dodEQlf), 30, 20, DYViHZj, VySlFUN, wwboXgE, true, false, false);
TechChanLabelButtons[i].displayTech();
switch((UserSequences[AkOQmUe].TechFlags[0][i] & 0x03)) 
{case 0:
tempColorStr = "Single";
tempChanStr = ""+channelCounter;
channelCounter++;
break;		
case 1:
tempColorStr = "RGB";
tempChanStr = channelCounter+","+(channelCounter+1)+","+(channelCounter+2);	
channelCounter += 3;		
break;
case 2:
tempColorStr = "RGBW";
tempChanStr = channelCounter+","+(channelCounter+1)+","+(channelCounter+2)+","+(channelCounter+3);	
channelCounter += 4;			
break;
}TechColorModeButton[i]  = new Button(tempColorStr, 85, 5+(i*dodEQlf), 35, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, false);
TechColorModeButton[i].displayTech();
TechnicalBuffer.text("Channels:\n"+tempChanStr,35,12+(i*dodEQlf));
} 
TechnicalBuffer.stroke(WcWJAym);
TechnicalBuffer.strokeWeight(1);
TechnicalBuffer.line(125,0,125,mzFoUAv);
TechnicalBuffer.noStroke();		
for (int i = 0; i != oiHkAsJ; i++)
{PreviewBuffer[i] = createGraphics(sGOqkUb, TXbHser);
holdgraphicfunc(PreviewBuffer[i], i, AkOQmUe);
TechnicalBuffer.image(PreviewBuffer[i], 125, 5+(i*dodEQlf), sGOqkUb, TXbHser);
currentOffset = 0;
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{currentOffset += (UserSequences[AkOQmUe].TechTime[q][i] / 10)+10; 
TechnicalBuffer.stroke(WcWJAym);
TechnicalBuffer.strokeWeight(1);
TechnicalBuffer.line(125+currentOffset,(i*dodEQlf),125+currentOffset,(i*dodEQlf)+dodEQlf);
}TechnicalBuffer.noStroke();	
} 
TechnicalBuffer.endDraw();
} 
public void DrawFilePlayBuffer()
{AppendLogFile("DrawFilePlayBuffer()");
FilePlayBuffer = createGraphics(sGOqkUb, (oiHkAsJ*dodEQlf));
FilePlayBuffer.beginDraw();
FilePlayBuffer.fill(0,0,255);
FilePlayBuffer.rect(100,100,100,100);
FilePlayBuffer.endDraw();		
} 
public void DrawPOVBuffer()
{switch(UserSequences[AkOQmUe].POVConfigType)
{default:
case 0:
CurrentPOVW = UserSequences[AkOQmUe].DataSize / ByoKxya;
CurrentPOVH = UserSequences[AkOQmUe].SeqFrameAmount;
POVGraphicBuffer = createGraphics(CurrentPOVW,CurrentPOVH+1);	
break;
case 1:
CurrentPOVW = UserSequences[AkOQmUe].SeqFrameAmount;
CurrentPOVH = UserSequences[AkOQmUe].DataSize / ByoKxya;
POVGraphicBuffer = createGraphics(CurrentPOVW+1,CurrentPOVH);	
break;
case 2:
CurrentPOVW = UserSequences[AkOQmUe].DataSize / ByoKxya;
CurrentPOVH = UserSequences[AkOQmUe].SeqFrameAmount;
POVGraphicBuffer = createGraphics(CurrentPOVW,CurrentPOVH+1);		
break;
case 3:
CurrentPOVW = UserSequences[AkOQmUe].SeqFrameAmount;
CurrentPOVH = UserSequences[AkOQmUe].DataSize / ByoKxya;
POVGraphicBuffer = createGraphics(CurrentPOVW+1,CurrentPOVH);			
break;
} 
if(POVVideoModeCheckBox.Selected == false || POVVidFrame == 0) 
AppendLogFile("DrawPOVBuffer() using w: "+CurrentPOVW+" h: "+CurrentPOVH+" Type: "+UserSequences[AkOQmUe].POVConfigType+"    VidFrame: "+POVVidFrame);
POVBuffer = createGraphics(aoXExLf, ehtEwNl);
POVBuffer.beginDraw();
POVBuffer.background(30, 30, 30);
POVBuffer.noStroke();
float tempSz;		
int x = 0;
int tempCenterX = 0;
int tempCenterY = 0;	
if(floor((float)(ehtEwNl-40) / CurrentPOVH) < floor((float)(aoXExLf-40) / CurrentPOVW)) 
{tempSz = CurrentPOVH;
tempSz = floor((float)(ehtEwNl-40) / tempSz); 
}else {
tempSz = CurrentPOVW;
tempSz = floor((float)(aoXExLf-40) / tempSz); 
}POVGraphicBuffer.beginDraw();
POVGraphicBuffer.background(255,0,0);
POVGraphicBuffer.noStroke();
oiHkAsJ = UserSequences[AkOQmUe].DataSize / ByoKxya; 
try
{switch(UserSequences[AkOQmUe].POVConfigType)
{case 0: 
tempCenterX = 20+PApplet.parseInt(((aoXExLf-40) - (tempSz * oiHkAsJ))/2);
tempCenterY = 20+PApplet.parseInt(((ehtEwNl-40) - (tempSz * CurrentPOVH)) / 2);
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{x = 0;
for(int i = oiHkAsJ-1; i >= 0; i--)
{POVBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+((q)*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);					
x+=3;
} 
}break;
case 1: 
tempCenterX = PApplet.parseInt(((aoXExLf-40) - (tempSz * (UserSequences[AkOQmUe].SeqFrameAmount+1))) / 2);
tempCenterY = 20+PApplet.parseInt((ehtEwNl-40) - (tempSz * oiHkAsJ)) / 2;
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{POVBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}break;
case 2: 
tempCenterX = 20+PApplet.parseInt((aoXExLf-40) - (tempSz * oiHkAsJ)) / 2;
tempCenterY = PApplet.parseInt((ehtEwNl) - (tempSz * (UserSequences[AkOQmUe].SeqFrameAmount+1))) / 2;
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{POVBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVBuffer.rect(tempCenterX+(i*tempSz), tempCenterY+(q*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);		
x+=3;
} 
}break;
case 3: 
tempCenterX = PApplet.parseInt((aoXExLf-40) - (tempSz * (UserSequences[AkOQmUe].SeqFrameAmount+1))) / 2;
tempCenterY = 20+PApplet.parseInt(((ehtEwNl-40) - (tempSz * oiHkAsJ)) / 2);
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{x = 0;
for (int i=oiHkAsJ-1; i >= 0;i--)
{POVBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVBuffer.rect(tempCenterX+(q*tempSz), tempCenterY+(i*tempSz), tempSz, tempSz);
POVGraphicBuffer.fill(UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1], UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}break;		
} 
}catch(Exception e)
{			
AppendLogFile("error, reload image file");
}POVGraphicBuffer.endDraw();
POVBuffer.endDraw();
} 
public void UpdateColorChannelBuffer(int passedID)
{	
AppendLogFile("UpdateColorChannelBuffer() with "+passedID);
try {
PreviewBuffer[passedID] = createGraphics(600, TXbHser);
GenerateSeqPreview(PreviewBuffer[passedID], passedID, AkOQmUe); 
TimeLineBuffer.beginDraw();
TimeLineBuffer.image(PreviewBuffer[passedID], 35, 5+(passedID*dodEQlf), 600, TXbHser);
TLStartIndicators[passedID].display();	 
TimeLineBuffer.endDraw();
}catch(Exception e) {AppendLogFile("Unable to Run UpdateColorChannelBuffer()"); }
} 
public void DrawTimeLineBuffer()
{if(UserSequences[AkOQmUe].SeqMode == XyiEbAJ)
{	
DrawPOVBuffer();
return;
}	
if(UserSequences[AkOQmUe].SeqMode == mTKKGDu)
{DrawTechnicalBuffer();
return;
}AppendLogFile("DrawTimeLineBuffer() - oiHkAsJ: "+oiHkAsJ+" Sequence#: "+AkOQmUe);
int tempButtonCounter = 0;
int tempFrameVar = 0;
float tempVar = 0; 
boolean TempFlag = false;
int RStart = 0;
int GStart = 0;
int BStart = 0;
int WStart = 0;
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0;
float DifferenceR = 0;
float DifferenceG = 0;
float DifferenceB = 0;
float DifferenceW = 0;	
int tempR = 0;
int tempG = 0;
int tempB = 0;
int tempW = 0;
int tempX = 0;
int tempY = 0;
int sameOffset = 0;
boolean TempStartIndicatorError = false;
UserSequences[AkOQmUe].StartValError = false; 
if(TimeLineBuffer == null) return;
int tempA = 600 / (UserSequences[AkOQmUe].SeqFrameAmount+1); 
TimeLineCellSize = tempA;
int qTemp = 0;
TimeLineFrameButtons = new Button[(UserSequences[AkOQmUe].SeqFrameAmount+1)];
for (int q=0; q != UserSequences[AkOQmUe].SeqFrameAmount+1;q++)
{if (q == lQGtaTe) TempFlag = true; 
else TempFlag = false;
TimeLineFrameButtons[tempButtonCounter] = new Button(""+(1+q), osqIpiO+22+(tempA*qTemp), XuFFMGQ-25, 25, 20, HoBBOyq, VySlFUN, wwboXgE, true, TempFlag, false);
tempButtonCounter++;
qTemp++;
}
TimeLineBuffer.beginDraw();
TimeLineBuffer.background(DqoHydg);
TimeLineBuffer.strokeWeight(2);
TimeLineBuffer.textFont(fDigital, 48);
TLStartIndicators =  new TLTriangle[oiHkAsJ];
TimeLineLabelButtons = new Button[oiHkAsJ];
for (int i = 0; i != oiHkAsJ; i++)
{TimeLineBuffer.stroke(WcWJAym);
TimeLineBuffer.line(0, (i*dodEQlf), (TimeLineBuffer.width-30), (i*dodEQlf));
TimeLineLabelButtons[i] = new Button(""+(i+1), 0, 5+(i*dodEQlf), 30, 20, DYViHZj, VySlFUN, wwboXgE, true, false, false);
TimeLineLabelButtons[i].displayTL();
TimeLineBuffer.noStroke();
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG && i != 0)
{	
TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(i*dodEQlf), 600, TXbHser);
}else
{PreviewBuffer[i] = createGraphics(600, TXbHser);
GenerateSeqPreview(PreviewBuffer[i], i, AkOQmUe); 
TimeLineBuffer.image(PreviewBuffer[i], 35, 5+(i*dodEQlf), 600, TXbHser);
}if (UserSequences[AkOQmUe].SeqMode != lMBafjD && UserSequences[AkOQmUe].SeqMode != xvXsTNs)
{switch(QCZOouc)
{case 2: 
WStart = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)+3]; 
case 1: 
RStart = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)];
GStart = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)+1];
BStart = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)+2];
break;
case 0: 
WStart = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)]; 
break;	
}	
tempFrameVar = UserSequences[AkOQmUe].DataFrameVar[(i*ByoKxya)]; 
switch(QCZOouc)
{case 2: 
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+3];
case 1: 
CurrentStartR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)];
CurrentStartG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+1];
CurrentStartB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+2];
break;
case 0: 
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)];
break;	
}	  	  
if (tempFrameVar < UserSequences[AkOQmUe].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(QCZOouc)
{case 2: 
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+3];
case 1: 
CurrentEndR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)];
CurrentEndG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+1]; 
CurrentEndB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)+2];
break;
case 0: 
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(i*ByoKxya)];
break;	
}	 	  	
switch(QCZOouc)
{case 0: 
if(CurrentStartW == CurrentEndW)
{sameOffset = WStart;
WStart = CurrentStartW; 
}	
break;
case 2: 
if(CurrentStartW == CurrentEndW)
{sameOffset = WStart;
WStart = CurrentStartW; 
}			
case 1: 
if(CurrentStartR == CurrentEndR)
{RStart = CurrentStartR; 
}if(CurrentStartG == CurrentEndG)
{GStart = CurrentStartG; 
}if(CurrentStartB == CurrentEndB)
{BStart = CurrentStartB; 
}if(QCZOouc == 1)
{if(CurrentStartR == CurrentEndR && CurrentStartG == CurrentEndG && CurrentStartB == CurrentEndB)
{sameOffset = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)];
}}
else if(QCZOouc == 2)
{if(CurrentStartR == CurrentEndR && CurrentStartG == CurrentEndG && CurrentStartB == CurrentEndB && CurrentStartW == CurrentEndW)
{sameOffset = UserSequences[AkOQmUe].StartValues[(i*ByoKxya)];
}	
}break;	
} 
tempFrameVar = UserSequences[AkOQmUe].DataFrameVar[(i*ByoKxya)]; 
switch(QCZOouc)
{case 0: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[AkOQmUe].StartValError = true;
break;	
case 2: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[AkOQmUe].StartValError = true;
case 1: 
if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) UserSequences[AkOQmUe].StartValError = true;
if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) UserSequences[AkOQmUe].StartValError = true;
if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) UserSequences[AkOQmUe].StartValError = true;
break;
}	
DifferenceR = 0;
DifferenceG = 0;
DifferenceB = 0;
DifferenceW = 0;
if(CurrentStartR >= CurrentEndR) DifferenceR = CurrentStartR - RStart;
else DifferenceR = RStart - CurrentStartR;
if(CurrentStartG >= CurrentEndG) DifferenceG = CurrentStartG - GStart;
else DifferenceG = GStart - CurrentStartG;			
if(CurrentStartB >= CurrentEndB) DifferenceB = CurrentStartB - BStart;
else DifferenceB = BStart - CurrentStartB;
if(CurrentStartW >= CurrentEndB) DifferenceW = CurrentStartW - WStart;
else DifferenceW = WStart - CurrentStartW;
if (DifferenceR < 0) DifferenceR = (DifferenceR * -1); 
if (DifferenceG < 0) DifferenceG = (DifferenceG * -1);
if (DifferenceB < 0) DifferenceB = (DifferenceB * -1);      
if (DifferenceW < 0) DifferenceW = (DifferenceW * -1); 		
tempR = (CurrentEndR - CurrentStartR);
tempG = (CurrentEndG - CurrentStartG);
tempB = (CurrentEndB - CurrentStartB);				
tempW = (CurrentEndW - CurrentStartW);				
if (tempR < 0) tempR = (tempR * -1); 
if (tempG < 0) tempG = (tempG * -1);
if (tempB < 0) tempB = (tempB * -1);      
if (tempW < 0) tempW = (tempW * -1); 
DifferenceR = DifferenceR / (float)tempR;
DifferenceG = DifferenceG / (float)tempG;	
DifferenceB = DifferenceB / (float)tempB;
DifferenceW = DifferenceW / (float)tempW;		
if (DifferenceR > 0xFFFF) DifferenceR = 0; 
if (DifferenceG > 0xFFFF) DifferenceG = 0;  
if (DifferenceB > 0xFFFF) DifferenceB = 0;
if (DifferenceW > 0xFFFF) DifferenceW = 0;				
if (Float.isNaN(DifferenceR)) DifferenceR = 0;
if (Float.isNaN(DifferenceG)) DifferenceG = 0;
if (Float.isNaN(DifferenceB)) DifferenceB = 0;			
if (Float.isNaN(DifferenceW)) DifferenceW = 0;
switch(QCZOouc)
{case 0: 
tempVar = DifferenceW;
break;
case 1: 
tempVar =  max(max(DifferenceR, DifferenceG), DifferenceB);
break;	
case 2: 
tempVar =  max(max(DifferenceR, DifferenceG), max(DifferenceB, DifferenceW));
break;
}		
if(tempVar == 0) tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA)+PApplet.parseInt(((float)sameOffset/255)*(float)tempA);
else tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);
tempY =  5+(i*dodEQlf);
sameOffset = 0;
if(tempX > (597+35) || tempX < 35) 
{UserSequences[AkOQmUe].StartValError = true;
tempX = 35;
TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), wwboXgE, false, false);
}	
else if(UserSequences[AkOQmUe].StartValError == true)
{TempStartIndicatorError = true;	
UserSequences[AkOQmUe].StartValError = false;
tempX = 35;
TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, color(255, 0, 255), color(255, 0, 255), wwboXgE, false, false);
}else TLStartIndicators[i] = new TLTriangle(""+i, tempX, tempY, 0, 10, VySlFUN, VySlFUN, wwboXgE, false, false);
TLStartIndicators[i].display(); 
}else
{tempFrameVar = UserSequences[AkOQmUe].DataFrameVar[(i*ByoKxya)];
tempX = 35+round(tempVar*(float)tempA)+(tempFrameVar*tempA);
try {	
for (int q = 0; q != UserSequences[AkOQmUe].DataSize; q++) 
UserSequences[AkOQmUe].StartValues[q] = UserSequences[AkOQmUe].DataFrames[0][UserSequences[AkOQmUe].DataFrameVar[q]];
}catch(Exception e)
{AppendLogFile("Unable to create startvals from DataFrame - Graphicsbuffer.pde");	
}if(UserSequences[AkOQmUe].SeqMode != xvXsTNs)
{TLStartIndicators[i] = new TLTriangle(""+i, tempX, 5+(i*dodEQlf), 0, 10, VySlFUN, VySlFUN, wwboXgE, false, false);
TLStartIndicators[i].display(); 
}}
} 
TimeLineBuffer.endDraw();
UserSequences[AkOQmUe].StartValError = TempStartIndicatorError;
if(UserSequences[AkOQmUe].StartValError == true) AppendLogFile("Bad Start Value(s) Detected");
}public void DrawIndexScrollArea()
{AppendLogFile("DrawIndexScrollArea() "+IndexMapPointer);
for (int i = 1; i != UserSequences.length; i++)	 MeasureSequenceLength(i); 
RunParseIndex(); 
if (420 < (IndexMapPointer*GDlXxCI)) 
{if((IndexMapPointer+1) == device.MaxIndexedSequences)
{IndexScrollBar.Maximum = (IndexMapPointer-5);
IndexScrollBuffer = createGraphics(180, (IndexMapPointer+1)*GDlXxCI);
}		
else
{				
IndexScrollBar.Maximum = (IndexMapPointer-4);	
IndexScrollBuffer = createGraphics(180, (IndexMapPointer+2)*GDlXxCI);
}if(IndexScrollBar.Maximum < 0) IndexScrollBar.Maximum = 0; 
IndexScrollBar.Value = IndexScrollBar.Maximum;
}else IndexScrollBar.Maximum = 0; 
IndexScrollBuffer.beginDraw();
IndexScrollBuffer.background(JOHAtnJ);
for (int i = 0; i != IndexMapPointer+2; i++)
{if((i+1) != (device.MaxIndexedSequences+1))
{	
IndexScrollBuffer.fill(255);
IndexScrollBuffer.textSize(36);
IndexScrollBuffer.textFont(fDigital, 48);
IndexScrollBuffer.text((i+1)+"", 5, 50+(i*GDlXxCI));
IndexScrollBuffer.textFont(fNormal, 48);
}if (IndexMapArray[i] == cfXHabo) 
{	
if(i != device.MaxIndexedSequences)
{	
AppendLogFile("No more UserSequences to Draw");
IndexScrollBuffer.fill(HoBBOyq); 
IndexScrollBuffer.stroke(0);
IndexScrollBuffer.rect(60, (5+(i*GDlXxCI)), fSAlYpX, (ZtBHbDg-10)); 
float tempFloat = (float)((float)IndexedSequenceLength/(float)device.DataSpace);
if(IndexedSequenceLength > device.DataSpace)
{AppendLogFile("Memory Overfilled");
IndexScrollBuffer.fill(255);
IndexScrollBuffer.textSize(12);
IndexScrollBuffer.textAlign(CENTER);
IndexScrollBuffer.text("The Memory is over filled, remove Sequences.", 65, (15+(i*GDlXxCI)), (fSAlYpX-5), ZtBHbDg);
IndexScrollBuffer.textAlign(LEFT);			
}else
{IndexScrollBuffer.strokeWeight(2);		
IndexScrollBuffer.fill(0,255,0);	
IndexScrollBuffer.rect(68, (52+(i*GDlXxCI)), 94, 18);
IndexScrollBuffer.fill(VySlFUN);
IndexScrollBuffer.rect(68, (52+(i*GDlXxCI)), tempFloat*94, 18);
IndexScrollBuffer.noStroke();
IndexScrollBuffer.fill(255);
IndexScrollBuffer.textSize(12);
IndexScrollBuffer.textAlign(CENTER);
IndexScrollBuffer.text("Click To Add A Sequence", 65, (15+(i*GDlXxCI)), (fSAlYpX-5), ZtBHbDg);
IndexScrollBuffer.fill(0);			
IndexScrollBuffer.text("Usage: "+IndexedSequenceLength, 60, (57+(i*GDlXxCI)), (fSAlYpX-5), ZtBHbDg);
IndexScrollBuffer.textAlign(LEFT);
}}
break; 
}else if(IndexMapArray[i] == bgpbnOG)
{SerialSequenceIcon.displaySqIndex(60, (5+(i*GDlXxCI)));
}else if(IndexMapArray[i] == CguezcT)
{DMXSequenceIcon.displaySqIndex(60, (5+(i*GDlXxCI)));
}		
else
{UserSequences[IndexMapArray[i]].displayIconB(60, (5+(i*GDlXxCI))); 
}}
IndexScrollBuffer.endDraw();
} 
public void InitLinkedBuffer()
{AppendLogFile("InitLinkedBuffer()");
LinkedScrollBar.Maximum = (UserSequences[AkOQmUe].SeqFrameAmount+1)-5;
if(LinkedScrollBar.Maximum < 1) LinkedScrollBar.Maximum = 0;
if(LinkedScrollBar.Value > LinkedScrollBar.Maximum ) LinkedScrollBar.Value = LinkedScrollBar.Maximum;
if(device.BasicVersion > 0)
{if(UserSequences[AkOQmUe].SeqFrameAmount >= device.Channels) UserSequences[AkOQmUe].SeqFrameAmount = device.Channels-1;
}int startY = gEfHGFk+30;
int LCBtemp = 0;
LinkedCheckBox = new CheckBox[20]; 
LinkedTimerCheckBox = new CheckBox[5];
for (int i = 0; i != (LinkedCheckBox.length/4); i++) 
{LinkedCheckBox[LCBtemp] =  new CheckBox(osqIpiO+465, 30+(i*hwAmagv)+startY, 20, 20, color(255), color(0), color(0), false);
LinkedCheckBox[LCBtemp+1] =  new CheckBox(osqIpiO+465, 60+(i*hwAmagv)+startY, 20, 20, color(255), color(0), color(0), false); 
LinkedCheckBox[LCBtemp+2] =  new CheckBox(osqIpiO+465+140, 30+(i*hwAmagv)+startY, 20, 20, color(255), color(0), color(0), false);
LinkedCheckBox[LCBtemp+3] =  new CheckBox(osqIpiO+465+140, 60+(i*hwAmagv)+startY, 20, 20, color(255), color(0), color(0), false);
LCBtemp+=4;
LinkedTimerCheckBox[i] =  new CheckBox(osqIpiO+300, 65+(i*hwAmagv)+startY, 20, 20, color(255), color(0), color(0), false);
}} 
public void DrawLinkedBuffer()
{AppendLogFile("DrawLinkedBuffer()");
int startY = gEfHGFk+30-(LinkedScrollBar.Value*hwAmagv);
int startX = aVMHNFe+10;
if(emEPIOg == false)
{for (int i = 0; i != 5; i++)	
{LObjTextField[i].Label = ""+UserSequences[AkOQmUe].SlideValues[i+LinkedScrollBar.Value]; 
if(i == UserSequences[AkOQmUe].SeqFrameAmount) break; 
}}
try 
{ 
for (int i = 0; i != 5; i++)
{		
LinkedCheckBox[(i*4)].Selected = false;  
LinkedCheckBox[(i*4)+1].Selected = false;  
LinkedCheckBox[(i*4)+2].Selected = false;  
LinkedCheckBox[(i*4)+3].Selected = false;  
LinkedTimerCheckBox[i].Selected = false;
if((UserSequences[AkOQmUe].DataFrameVar[i+LinkedScrollBar.Value] & 0x80) == 128) LinkedTimerCheckBox[i].Selected = true;
switch(UserSequences[AkOQmUe].DataFrameVar[i+LinkedScrollBar.Value] & 0x7F)
{case 0:	
LinkedCheckBox[(i*4)].Selected = true; 
break;
case 1: 
LinkedCheckBox[(i*4)+1].Selected = true; 
break;	
case 2: 
LinkedCheckBox[(i*4)+3].Selected = true; 
break;
case 7: 
LinkedCheckBox[(i*4)+2].Selected = true; 
break;							
}if(i == UserSequences[AkOQmUe].SeqFrameAmount) break; 
} 
for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1); i++) if(i < LinkedTextFieldObject.length)LinkedTextFieldObject[i].display();
for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1)*4; i++) if(i < LinkedCheckBox.length) LinkedCheckBox[i].display();
for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1); i++) if(i < LinkedTimerCheckBox.length) LinkedTimerCheckBox[i].display();
for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1); i++)
{if((i-LinkedScrollBar.Value) > -1 && (i-LinkedScrollBar.Value) < 5)
{stroke(255);
strokeWeight(2);
line(startX, ((i+1)*hwAmagv)+startY, 765, ((i+1)*hwAmagv)+startY);
stroke(WcWJAym);
fill(mlIVvlI);
textSize(36); 
textFont(fDigital, 48);
text((i+1)+"", startX, startY+60+(i*hwAmagv));
noStroke();
textFont(fNormal, 48);
textSize(14);
fill(mlIVvlI);
if(LinkedTimerCheckBox[(i-LinkedScrollBar.Value)].Selected == false)
text("Loops/Iterations: ", startX+200, startY+20+(i*hwAmagv));
else
text("Time(Seconds): ", startX+200, startY+20+(i*hwAmagv));
text("Enable Timer: ", startX+200, startY+80+(i*hwAmagv));
text("Transition Type:", startX+480, startY+20+(i*hwAmagv));
text("Instant:", startX+410, startY+45+(i*hwAmagv));
text("Per Sequence:", startX+500, startY+45+(i*hwAmagv));
text("Fast Fade:", startX+390, startY+75+(i*hwAmagv));
text("Slow Fade:", startX+530, startY+75+(i*hwAmagv));
if (UserSequences[AkOQmUe].SlideFlags[i] != 0)
{UserSequences[UserSequences[AkOQmUe].SlideFlags[i]].displayIconSmall(startX+60, (10+(i*hwAmagv)+startY));
}else
{fill(JCZFGSk);
rect(startX+60, startY+(10+(i*hwAmagv)), 110, 75);
fill(0);
textSize(12);
textAlign(CENTER);
text("Click This Icon\nTo Select a\nSequence", startX+65, startY+(25+(i*hwAmagv)), 105, 70);
textAlign(LEFT);
}}
} 
} 
catch(Exception e) { AppendLogFile("Exception Caught"); }
stroke(255);
strokeWeight(2);
line(osqIpiO, XuFFMGQ, 765, XuFFMGQ);
fill(mlIVvlI);
textSize(14);
text("Use the Add/Remove buttons to set the amount of Linked Sequences available.", aVMHNFe+5, gEfHGFk+15);
LinkedScrollBar.display();
DisplayFrameButtons();	
}public void DrawUserSeqIconBuffer(int methodArgument)
{AppendLogFile("DrawUserSeqIconBuffer() "+methodArgument);
if(methodArgument == 9999) 
{	
AppendLogFile("DrawUserSeqIconBuffer() - Update All Icons");
if(UserSequences.length >= 1)
{	
for (int i = 1; i != UserSequences.length; i++)
{UserSequences[i].previewImage = createGraphics(PApplet.parseInt(UserSequences[i].bWidth*0.9f), PApplet.parseInt(TXbHser*0.9f));
GenerateSeqPreview(UserSequences[i].previewImage , 0, i); 
}}
}	
else
{AppendLogFile("DrawUserSeqIconBuffer() - Single Icon Update "+methodArgument);		
UserSequences[methodArgument].previewImage = createGraphics(PApplet.parseInt(UserSequences[methodArgument].bWidth*0.9f), PApplet.parseInt(TXbHser*0.9f));
GenerateSeqPreview(UserSequences[methodArgument].previewImage, 0, methodArgument); 
} 
}public void GenerateSeqPreview(PGraphics GBuffer, int PassedID, int SelSeq)
{int tempChan = PassedID * ByoKxya; 
int tempA = GBuffer.width / (UserSequences[SelSeq].SeqFrameAmount+1);
if (PassedID == oiHkAsJ) tempChan = PassedID;
GBuffer.beginDraw();
GBuffer.background(DqoHydg); 
GBuffer.noStroke();
if(UserSequences[SelSeq].SeqMode == qzXknoY)
{GBuffer.background(0, 0, 0, 0); 
GBuffer.endDraw();
return;
}else if(UserSequences[SelSeq].SeqMode == XyiEbAJ)
{AppendLogFile("Generate as POV "+SelSeq+" : oiHkAsJ: "+oiHkAsJ);
POVGraphicBuffer = createGraphics(UserSequences[SelSeq].SeqFrameAmount+1, oiHkAsJ);
POVGraphicBuffer.beginDraw();
POVGraphicBuffer.background(65);
POVGraphicBuffer.noStroke();
int x = 0;
switch(UserSequences[SelSeq].POVConfigType)
{case 0: 
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(i, q, 1, 1);					
x+=3;
} 
}break;
case 1: 
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{		
POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}break;
case 2: 
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{x = 0;
for (int i=oiHkAsJ; i != 0;i--)
{		
POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}break;
case 3: 
for (int q=0; q != UserSequences[SelSeq].SeqFrameAmount+1;q++)
{x = 0;
for (int i = oiHkAsJ; i != 0;i--)
{		
POVGraphicBuffer.fill(UserSequences[SelSeq].DataFrames[q][x], UserSequences[SelSeq].DataFrames[q][x+1], UserSequences[SelSeq].DataFrames[q][x+2]);
POVGraphicBuffer.rect(q, i, 1, 1);				
x+=3;
} 
}break;							
}POVGraphicBuffer.endDraw();
GBuffer.image(POVGraphicBuffer,0,0,600,oiHkAsJ);
GBuffer.endDraw();
return;
}int qTemp = 0;
int ColorTemp = color(0);
int c = color(0);  
int uZYECeH = color(0);
for (int q=0; q != (UserSequences[SelSeq].SeqFrameAmount+1);q++)
{if (UserSequences[SelSeq].SeqMode == EqPnOUb || UserSequences[SelSeq].SeqMode == kRMfOXG)
{if (qTemp == UserSequences[SelSeq].SeqFrameAmount)
{		  
switch(UserSequences[SelSeq].DataType)
{case 0: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan]>>8));
else	ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan]);   
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan]>>8), (UserSequences[SelSeq].DataFrames[0][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[0][tempChan+2]>>8)); 
else	ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan], UserSequences[SelSeq].DataFrames[0][tempChan+1], UserSequences[SelSeq].DataFrames[0][tempChan+2]);   
break;	
}}
else 
{switch(UserSequences[SelSeq].DataType)
{case 0: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]>>8));
else	ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+2]>>8));
else	ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan], UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+2]);  
break;	
}		  		  
}						
float inter;
c = color(0);  
uZYECeH = color(0);
switch(UserSequences[SelSeq].DataType)
{case 0: 
if(device.Bit16Mode == true)uZYECeH = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8));
else uZYECeH = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan]);
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)uZYECeH = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
else uZYECeH = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);
break;	
} 
for (int i = 0; i <= tempA; i++) 
{inter = map(i, 0, tempA, 0, 1);
if(UserSequences[SelSeq].DataType == 0) c = lerpColor(uZYECeH, ColorTemp, inter);
else c = lerpColor(color(uZYECeH), ColorTemp, inter);
GBuffer.stroke(c); 
GBuffer.line(i+(qTemp*tempA), 0, i+(qTemp*tempA), TXbHser);
}			
if(UserSequences[SelSeq].DataType == 2)  
{GBuffer.noStroke();
GBuffer.fill(255);
for (int i = 0; i <= tempA; i++) 
{inter = map(i, 0, tempA, 0, 1);
if(i == 0)
{if(device.Bit16Mode == true) 
{if ((qTemp+1) > UserSequences[SelSeq].SeqFrameAmount) ColorTemp = color((UserSequences[SelSeq].DataFrames[0][tempChan+3]>>8));
else ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+3]>>8));
}			 
else 
{if ((qTemp+1) > UserSequences[SelSeq].SeqFrameAmount) ColorTemp = color(UserSequences[SelSeq].DataFrames[0][tempChan+3]);
else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp+1][tempChan+3]);
}		
}	 
if(device.Bit16Mode == true)  c = lerpColor(color((UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]>>8)), ColorTemp, inter);
else	c = lerpColor(color(UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]), ColorTemp, inter);
GBuffer.stroke(c);
GBuffer.line(i+(qTemp*tempA), 10, i+(qTemp*tempA), TXbHser); 
}	
} 
}else if (UserSequences[SelSeq].SeqMode == lMBafjD || UserSequences[SelSeq].SeqMode == xvXsTNs)
{	
if(UserSequences[SelSeq].SlideFlags[q] > 0 && UserSequences[SelSeq].SeqMode != xvXsTNs)
{if ((UserSequences[SelSeq].SlideFlags[q] & 0x40) > 0) 
{float tempC = (float)tempA /  (float)UserSequences[SelSeq].SlideValues[q];
GBuffer.noStroke();
for (int i = 0; i != UserSequences[SelSeq].SlideValues[q]; i++) 
{if (i%2 == 0)
{GBuffer.fill(100);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, TXbHser);
}else
{GBuffer.fill(20);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, TXbHser);
}}
GBuffer.fill(255, 0, 0);
for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 1, 15+(tempA * qTemp)+(zz*15), 9, 20+(tempA * qTemp)+(zz*15), 1);
GBuffer.noStroke();
} 
else
{		
float tempC = (float)tempA /  (float)UserSequences[SelSeq].SlideValues[q];
GBuffer.noStroke();
for (int i = 0; i !=  UserSequences[SelSeq].SlideValues[q]; i++) 
{if (i%2 == 0)
{GBuffer.fill(100);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, TXbHser);
}else
{GBuffer.fill(20);
GBuffer.rect((tempA * qTemp)+(tempC * i), 0, tempC, TXbHser);
}} 
GBuffer.fill(255, 0, 0);
for(int zz = 0; zz != (tempA / 15); zz++)	GBuffer.triangle(10+(tempA * qTemp)+(zz*15), 9, 15+(tempA * qTemp)+(zz*15), 1, 20+(tempA * qTemp)+(zz*15), 9);
}    
} 
else
{GBuffer.noStroke();
switch(UserSequences[SelSeq].DataType)
{case 0: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8));	
else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan]);	
break;
case 1: 
if(device.Bit16Mode == true)	ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);
break;	
case 2: 
if(device.Bit16Mode == true) ColorTemp = color((UserSequences[SelSeq].DataFrames[qTemp][tempChan]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+1]>>8), (UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]>>8));
else ColorTemp = color(UserSequences[SelSeq].DataFrames[qTemp][tempChan], UserSequences[SelSeq].DataFrames[qTemp][tempChan+1], UserSequences[SelSeq].DataFrames[qTemp][tempChan+2]);
break;
} 
GBuffer.fill(ColorTemp);
GBuffer.rect((tempA * qTemp), 0, tempA, TXbHser);
if(UserSequences[SelSeq].DataType == 2) 
{if(device.Bit16Mode == true) GBuffer.fill(color((UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]>>8)));
else GBuffer.fill(color(UserSequences[SelSeq].DataFrames[qTemp][tempChan+3]));
GBuffer.rect((tempA * qTemp), 10, tempA, TXbHser);
}} 
}  
qTemp++;
} 
GBuffer.endDraw();
} 
public void SetlQGtaTe(int passedID)
{AppendLogFile("SetlQGtaTe() with "+passedID);
try {
TimeLineFrameButtons[lQGtaTe].Selected = false;
}catch(Exception e) { }
for(int i = 0; i != FrameButtons.length;i++) FrameButtons[i].Selected = false; 
for(int i = 0; i != GradientRects.length;i++) GradientRects[i].Selected = false; 
lQGtaTe = passedID;
try {
TimeLineFrameButtons[lQGtaTe].Selected = true;
}
catch(Exception e) { }
try {
FrameButtons[passedID-UkmBkwh].Selected = true;
GradientRects[passedID-UkmBkwh].Selected = true;
}catch(Exception e) { }	
UpdateSideBarButtonStates();
}public void ResetLEDIcons()
{AppendLogFile("ResetLEDIcons()");
nRudTeq = 0;
naJDfWm = 0;
PixelIcon = new LEDgraphic[wqajEny];
MenuTabs[0].refresh(); 
}public void GraphicLayoutUpdateIcons()
{AppendLogFile("GraphicLayoutUpdateIcons()    gdHgLUO: "+gdHgLUO);
if(GraphicLayoutBuffer == null && IconLayoutAdvancedMode.Selected == false)  GraphicLayoutBuild(0);
nRudTeq = oiHkAsJ * (UserSequences[AkOQmUe].PacketCloneMode+1); 
AppendLogFile("oiHkAsJ: "+oiHkAsJ+"    nRudTeq: "+nRudTeq+"   naJDfWm: "+naJDfWm);  
GraphicLayoutBuffer.beginDraw(); 
GraphicLayoutBuffer.background(DqoHydg);
if(GraphicImageEnabled == true)
{GraphicLayoutBuffer.beginDraw(); 
try {
if(GraphicImageX == 0 && GraphicImageY == 0)
{graphicImg = loadImage(graphicImgFilePath);
GraphicImageWidth = graphicImg.width;
GraphicImageHeight = graphicImg.height;
if(GraphicImageWidth > qxXNcNf) GraphicImageWidth = qxXNcNf;
if(GraphicImageHeight > tuCbyyd) GraphicImageHeight = tuCbyyd;
graphicImg.resize(GraphicImageWidth,GraphicImageHeight);
GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,GraphicImageWidth,GraphicImageHeight);
}else GraphicLayoutBuffer.image(graphicImg, GraphicImageX, GraphicImageY,(ImageHandleTR.xpos - ImageHandleTL.xpos)+10,(ImageHandleBL.ypos - ImageHandleTR.ypos)+10);
}catch(Exception e) { }
if(GraphicImageResize == true)
{handlerDrawImageHandles();
} 
} 
if(fdJgaNC == 6)
{MouseIconPlace.Status = 0;
MouseIconRemove.Status = 0;
MouseIconReset.Status = 0;
}else
{MouseIconPlace.Status = 1;
MouseIconRemove.Status = 1;
MouseIconReset.Status = 1;
}int i = 0;
try 
{		
for (i = 0; i != nRudTeq; i++)
{if(PixelIcon[i].GroupID == gdHgLUO)  PixelIcon[i].display(); 
} 
}catch(Exception e) {
AppendLogFile("Error Displaying Icon at "+i); 
} 
GraphicLayoutBuffer.endDraw();	
}public void AddToLayout()
{AppendLogFile("AddToLayout()");
GraphicLayoutBuild(naJDfWm);
} 
public void GraphicLayoutBuild(int passedStarting)
{fdJgaNC = (ShapeOptionsDD.SelStr+1); 
AppendLogFile("GraphicLayoutBuild() with "+fdJgaNC+"    oiHkAsJ: "+oiHkAsJ);
CalMNxHTMd();
int centX = 335;
int centY = 255;
int LocalPixelAmt = oiHkAsJ; 
int LocalBuildID = passedStarting; 
AppendLogFile("LocalPixelAmt: "+LocalPixelAmt);
if(IconLayoutAdvancedMode.Selected == false) 
{if(fdJgaNC != 6)
{naJDfWm = 0; 
nRudTeq = 0; 
if(UserSequences[AkOQmUe].PacketCloneMode > 0) LocalPixelAmt = LocalPixelAmt + (oiHkAsJ * (UserSequences[AkOQmUe].PacketCloneMode+1));
}}
else
{LocalPixelAmt = PixelAmountObject.value();
AppendLogFile("Adding With "+LocalPixelAmt+"    oiHkAsJ: "+oiHkAsJ+"    nRudTeq: "+nRudTeq+"   naJDfWm: "+naJDfWm);  
AppendLogFile("Group ID#: "+vXzCEzG);
}if(fdJgaNC == 0 || fdJgaNC > 6) fdJgaNC = 1; 
AppendLogFile("Changed LocalPixelAmt: "+LocalPixelAmt);
int LEDCounter = 0;	
switch(fdJgaNC)
{case 1:	
float degreeChange = (float)360 / LocalPixelAmt;
float Angle=0;
for (int i=0;i != LocalPixelAmt; i++)
{ 
double Xa = centX+(230*Math.sin(Angle*Math.PI/180));
double Ya = centY+(230*-Math.cos(Angle*Math.PI/180));
Angle = Angle + degreeChange; 
PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)Xa, (int)Ya, LEDSize); 
LocalBuildID++;
}	
LEDCounter = LocalPixelAmt;
break;
case 2:	
int ShapeSize = 425;
float Spacing = (float)ShapeSize / ((float)(LocalPixelAmt)/4);
for (int i=0;i != (LocalPixelAmt)/4;i++)
{    
PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), centY+(ShapeSize/2), LEDSize);
LocalBuildID++;			
LEDCounter++;
}for (int i=0;i!=(LocalPixelAmt)/4;i++)
{PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (centX+(ShapeSize/2)), (int)((centY+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), LEDSize);	
LocalBuildID++;
LEDCounter++;
}for (int i=0;i != (LocalPixelAmt)/4;i++)
{PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY-(ShapeSize/2)), LEDSize);
LocalBuildID++;			
LEDCounter++;
}for (int i=0;i != (LocalPixelAmt)/4;i++)
{   
PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, centX-(ShapeSize/2), (int)((centY-(ShapeSize/2))+(Spacing/2)+(Spacing*i)), LEDSize);
LocalBuildID++;
LEDCounter++;
}break;
case 3: 
int radius = 287;
int coils = 15; 
int rotation = 0;
if(LocalPixelAmt <= 170)
{coils = 16;
radius = 500;
}final float thetaMax = coils * 2 * PI;
final float awayStep = radius / thetaMax;
final int chord = LEDSize+(LEDSize/2);
int iterationcounter=0;
for (float theta = chord / awayStep; theta <= thetaMax; ) 
{if(iterationcounter == LocalPixelAmt) break; 
float away = awayStep * theta;
float around = theta + rotation;
int x = (int)round(centX + cos( around ) * away);
int y = (int)round(centY + sin( around ) * away);
PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)x, (int)y, LEDSize); 
LocalBuildID++;			
LEDCounter++;		
theta += chord / away;
iterationcounter++;
} 
break;   
case 4: 
ShapeSize = 640;
Spacing = ShapeSize / ((float)(LocalPixelAmt));
for (int i=0;i != (LocalPixelAmt);i++)
{PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, (int)((centX+(ShapeSize/2))-(Spacing/2)-(Spacing*i)), (centY), LEDSize);	
LocalBuildID++;
LEDCounter++;
}   
break; 
case 5:	
case 6:   
for (int q = 0; q != LEDIconCoordX.length; q++)	
{try {	
if(LEDIconCoordX[q] != 0 || LEDIconCoordY[q] != 0)
{	
PixelIcon[LocalBuildID] = new LEDgraphic(LocalBuildID, LEDIconCoordX[q], LEDIconCoordY[q], LEDSize);	
LocalBuildID++;
LEDCounter++;
}}
catch(Exception e)
{	
AppendLogFile("Errror Building Graphic/PixelMap");
}} 
SDdpJto = -1000;
break;			
}if(IconLayoutAdvancedMode.Selected == false) { vXzCEzG = 0; gdHgLUO = 0; }
for (int i = passedStarting; i != (nRudTeq + LEDCounter); i++)
{try {
PixelIcon[i].GroupID = vXzCEzG;
}catch(Exception e) { AppendLogFile("errored at "+i); break;}
}AppendLogFile("LocalBuildID = "+LocalBuildID);	
AppendLogFile("LEDCounter = "+LEDCounter);	
nRudTeq = nRudTeq + LEDCounter; 
naJDfWm = naJDfWm + LEDCounter; 
}public void DisplayDragIndicator()
{int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0; 
EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);  
TLStartIndicators[FqANxaN].ColBG = color(VySlFUN); 
TimeLineBuffer.beginDraw();
TimeLineBuffer.fill(DqoHydg); 
TimeLineBuffer.rect(TLStartIndicators[FqANxaN].xpos-(TLStartIndicators[FqANxaN].bSize)-1, TLStartIndicators[FqANxaN].ypos-1, (float)(TLStartIndicators[FqANxaN].bSize*2.25f), (float)(TLStartIndicators[FqANxaN].bSize*1.3f));
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG) TimeLineBuffer.image(PreviewBuffer[0], 35, 5+(FqANxaN*dodEQlf), 600, TXbHser);
else TimeLineBuffer.image(PreviewBuffer[FqANxaN], 35, 5+(FqANxaN*dodEQlf), 600, TXbHser);
TLStartIndicators[FqANxaN].xpos = EMCDldB - osqIpiO; 
if (TLStartIndicators[FqANxaN].xpos < 35)  TLStartIndicators[FqANxaN].xpos = 35;
else if (TLStartIndicators[FqANxaN].xpos > 600+35) TLStartIndicators[FqANxaN].xpos = 600+35;
TimeLineBuffer.textFont(fDigital, 48);
TimeLineLabelButtons[FqANxaN].displayTL();
int tempA = 600 / (UserSequences[AkOQmUe].SeqFrameAmount+1); 
if(UserSequences[AkOQmUe].SeqMode == mTKKGDu) tempA = 600 / (UserSequences[AkOQmUe].SeqFrameAmount+1);
if(UserSequences[AkOQmUe].SeqMode != lMBafjD)TLStartIndicators[FqANxaN].display(); 
TimeLineBuffer.endDraw();	
int tempFrameVar = floor((TLStartIndicators[FqANxaN].xpos - 35) / tempA);
if(tempFrameVar > UserSequences[AkOQmUe].SeqFrameAmount) tempFrameVar = UserSequences[AkOQmUe].SeqFrameAmount;
float tempLocation = ((float)(TLStartIndicators[FqANxaN].xpos - 35) / (float)tempA) - tempFrameVar;
if(UserSequences[AkOQmUe].SeqMode == lMBafjD)
{TimeLineBuffer.beginDraw();	
TLStartIndicators[FqANxaN].xpos = 35+tempFrameVar * tempA;
TLStartIndicators[FqANxaN].display();
TimeLineBuffer.endDraw();	
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)] = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempFrameVar;
break;
case 2: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+3] = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+3];
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+3] = tempFrameVar;
case 1: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)] = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+1] = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+1]; 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+2] = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+2];
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+1] = tempFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+2] = tempFrameVar;
break;
}}
else
{int tempDataFrameVar = 0; 
for(int q = 0; q != tempFrameVar+1;q++)
{if (UserSequences[AkOQmUe].SlideFlags[q] > 0)
{}
else
{switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempDataFrameVar;
break;
case 2: 
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+3] = tempDataFrameVar;
case 1: 
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempDataFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+1] = tempDataFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+2] = tempDataFrameVar;
break;
}tempDataFrameVar++;
} 
} 
switch(QCZOouc)
{case 0: 
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
break;
case 1: 
CurrentStartR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
CurrentStartG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+1];
CurrentStartB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+2];
break;
case 2: 
CurrentStartR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
CurrentStartG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+1];
CurrentStartB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+2];
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+3]; 
break;
}if (tempFrameVar < UserSequences[AkOQmUe].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(QCZOouc)
{case 0: 
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
break;
case 1: 
CurrentEndR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
CurrentEndG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+1]; 
CurrentEndB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+2];
break;
case 2: 
CurrentEndR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)];
CurrentEndG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+1]; 
CurrentEndB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+2];
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(FqANxaN*ByoKxya)+3]; 
break;
}float RedLerp = lerp(CurrentStartR,CurrentEndR, tempLocation);
float GreenLerp = lerp(CurrentStartG,CurrentEndG, tempLocation);
float BlueLerp = lerp(CurrentStartB,CurrentEndB, tempLocation);
float WhiteLerp = lerp(CurrentStartW,CurrentEndW, tempLocation);
tempFrameVar = floor((TLStartIndicators[FqANxaN].xpos - 35) / tempA); 
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)] = (int)WhiteLerp; 
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempFrameVar;
break;
case 2: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+3] = (int)WhiteLerp;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+3] = tempFrameVar;
case 1: 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)] = (int)RedLerp;
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+1] = (int)GreenLerp; 
UserSequences[AkOQmUe].StartValues[(FqANxaN*ByoKxya)+2] = (int)BlueLerp;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)] = tempFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+1] = tempFrameVar;
UserSequences[AkOQmUe].DataFrameVar[(FqANxaN*ByoKxya)+2] = tempFrameVar;
break;
}if(EMCDldB < 125) EMCDldB = 125;
else if(EMCDldB > 690) EMCDldB = 690;
textSize(12);
fill(JCZFGSk);
stroke(VySlFUN);
rect(EMCDldB-10, TLStartIndicators[FqANxaN].ypos+85-YLWNFLV, 90, 65);
fill(0);
noStroke();
text("Red: "+PApplet.parseInt(RedLerp)+"\nGreen "+PApplet.parseInt(GreenLerp)+"\nBlue: "+PApplet.parseInt(BlueLerp)+"\nWhite: "+PApplet.parseInt(WhiteLerp), EMCDldB, TLStartIndicators[FqANxaN].ypos+100-YLWNFLV);
}} 
public void CloseLiveControlMenu()
{rYrXIPl = ojafBuR; 
cmdData[0] = 0; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
} 
public void OpenLiveControlMenu()
{rYrXIPl = ojafBuR; 
cmdData[0] = 1; 
if(LiveControlCheckBox[3].Selected == true)  cmdData[1] = 1; 
else  cmdData[1] = 0; 
cmdData[2] = (uqdivtD >> 8) & 0xFF;  
cmdData[3] = uqdivtD & 0xFF;   
RequestCommand();  
LiveControlCheckBox[0].xpos = OverlayMenus[1].xpos+60;
LiveControlCheckBox[1].xpos = OverlayMenus[1].xpos+100;
LiveControlCheckBox[2].xpos = OverlayMenus[1].xpos+140;
LiveControlCheckBox[3].xpos = OverlayMenus[1].xpos+240;
LiveControlCheckBox[0].ypos = OverlayMenus[1].ypos+20;
LiveControlCheckBox[1].ypos = OverlayMenus[1].ypos+20;
LiveControlCheckBox[2].ypos = OverlayMenus[1].ypos+20;
LiveControlCheckBox[3].ypos = OverlayMenus[1].ypos+20;
LiveControlClose.xpos = OverlayMenus[1].xpos+680;
LiveControlClose.ypos = OverlayMenus[1].ypos+15;
LiveControlToggle.xpos = OverlayMenus[1].xpos+560;
LiveControlToggle.ypos = OverlayMenus[1].ypos+15;
TextFields[4].xpos = OverlayMenus[2].xpos+145;
TextFields[4].ypos = OverlayMenus[2].ypos+10;
TextFields[5].xpos = OverlayMenus[2].xpos+280;
TextFields[5].ypos = OverlayMenus[2].ypos+10; 	
if(IsOndtSTkNT("f8or16Bit") == true) LiveControlCheckBox[3].Status = 0;
else LiveControlCheckBox[3].Status = 1; 
try {
ControlSliders = new SliderBar[uqdivtD];
ControlRects = new ColorRect[uqdivtD];
}catch(Exception e)
{return; 
}  
int tempMaxVal = 255;
if(LiveControlCheckBox[3].Selected == true)
{tempMaxVal = 0xFFFF;
}LiveConTotalColChan = uqdivtD / LiveConDataMult;
float rectgwFwycD = 1;
int column = 0;
int row = 0;
int ControlRectSize = 50;
int ControlRectSpace = 10;			
int ControlRectAdjSize = PApplet.parseInt(ControlRectSize * rectgwFwycD);
int ControlRectAdjSpace = PApplet.parseInt(ControlRectSpace * rectgwFwycD);
for (int i = 0; i != LiveConTotalColChan; i++) 
{ControlRectAdjSize = PApplet.parseInt(ControlRectSize * rectgwFwycD);
ControlRectAdjSpace = PApplet.parseInt(ControlRectSpace * rectgwFwycD);
column++;
if(((column+1) * (ControlRectAdjSize+ControlRectAdjSpace)) >= (OverlayMenus[1].Width-(ControlRectAdjSpace*2))) 
{column = 0;
row++;
}if(((row+1)*(ControlRectAdjSize+ControlRectAdjSpace)) >= ((OverlayMenus[1].Height+ControlRectAdjSpace)-55))
{i = 0;
column = 0;
row = 0;
rectgwFwycD = rectgwFwycD - 0.05f;
}}	
column = 0;
row = 0;
ControlRectSize = PApplet.parseInt(ControlRectSize * rectgwFwycD);
ControlRectSpace = PApplet.parseInt(ControlRectSpace * rectgwFwycD);
for (int i = 0; i != LiveConTotalColChan; i++) 
{	
ControlRects[i] = new ColorRect(OverlayMenus[1].xpos+(ControlRectSpace*2), OverlayMenus[1].ypos+50, ControlRectSize, ControlRectSize, 0, 0, 0, 0, ""+(i+1));			
ControlRects[i].xpos = ControlRects[i].xpos + round(column*(ControlRectSize+ControlRectSpace));
ControlRects[i].ypos = ControlRects[i].ypos + round(row*(ControlRectSize+ControlRectSpace));				
ControlRects[i].Label = ""+(i+1);
column++;
if(((column+1) * (ControlRectSize+ControlRectSpace)) > (OverlayMenus[1].Width-(ControlRectSpace*2))) 
{column = 0;
row++;
}}
if(uqdivtD > 104 && uqdivtD <= 130)
{rectgwFwycD = 0.7f;
}else if(uqdivtD > 130 && uqdivtD <= 156)
{rectgwFwycD = 0.6f;
}			
else if(uqdivtD > 156 && uqdivtD <= 182)
{rectgwFwycD = 0.48f;
}		
else if(uqdivtD > 182 && uqdivtD <= 208)
{rectgwFwycD = 0.38f;
}	
else if(uqdivtD > 208) rectgwFwycD = 0.5f;
AppendLogFile("using: "+rectgwFwycD+" with "+uqdivtD+" sliders");
column = 0;
row = 0;
for (int i = 0; i != ControlSliders.length; i++) 
{			
ControlSliders[i] = new SliderBar(8, OverlayMenus[1].xpos+35,  OverlayMenus[1].ypos+50, round(100*rectgwFwycD), 14, 0, 0, tempMaxVal, color(255), color(0), JCZFGSk, color(0), true, false, false);
if(column == 0) ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*rectgwFwycD)));
else if(rectgwFwycD == 0.5f && i > 233) { ControlSliders[i].xpos = 100; ControlSliders[i].ypos = 610; }
else  ControlSliders[i].xpos = ControlSliders[i].xpos + (column*round((100*rectgwFwycD))) + (35*column);
ControlSliders[i].ypos = ControlSliders[i].ypos + (row*19);		
row++;
if((row*19) > (490))
{row = 0;
column++;
}} 
AppendLogFile("Sliders Built, Total: "+ControlSliders.length);	
}  
public void DisplayFrameButtons()
{stroke(0);
strokeWeight(2);
fill(JCZFGSk);
rect(130,545,560,50, 15);
line(600,545,600,595);
noStroke();
GroupIDDecf.display();
GroupIDIncf.display();
textAlign(CENTER);
textSize(18);
text(gdHgLUO+1,750,585);
textSize(14);
text("Group View:",750,555);
textAlign(LEFT);
if ((UserSequences[AkOQmUe].SeqFrameAmount+1) != GradientRects.length && UserSequences[AkOQmUe].SeqMode == kRMfOXG) BuildGradientMenu();
int ii;
for (ii = 0; ii != FrameButtons.length; ii++) 
{if(ii == (UserSequences[AkOQmUe].SeqFrameAmount+1)) break; 
if (UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{GradientRects[ii].display();
GradientRects[ii].Label = ""+(1+ii+UkmBkwh);
}else
{FrameButtons[ii].display();
FrameButtons[ii].Label = ""+(1+ii+UkmBkwh);
}} 
AddFrame.display();
RemoveFrame.display();
IncFrameBar.display();
DecFrameBar.display();
}public void BuildGradientMenu()
{for (int i =0; i != GradientRects.length; i++) 
{ 
if(i == (UserSequences[AkOQmUe].SeqFrameAmount+1)) break;
GradientRects[i].Red = UserSequences[AkOQmUe].DataFrames[i+UkmBkwh][0];
GradientRects[i].Green = UserSequences[AkOQmUe].DataFrames[i+UkmBkwh][1];
GradientRects[i].Blue = UserSequences[AkOQmUe].DataFrames[i+UkmBkwh][2];
GradientRects[i].White = UserSequences[AkOQmUe].DataFrames[i+UkmBkwh][3];
GradientRects[i].Label = ""+(1+i+UkmBkwh);
}} 
public void handlerDrawImageHandles()
{ImageHandleTL.xpos = GraphicImageX;
ImageHandleTL.ypos = GraphicImageY;
ImageHandleTR.xpos = GraphicImageWidth-10;
ImageHandleTR.ypos = GraphicImageY;
ImageHandleBR.xpos = GraphicImageWidth-10;
ImageHandleBR.ypos = GraphicImageHeight-10;
ImageHandleBL.xpos = GraphicImageX;
ImageHandleBL.ypos = GraphicImageHeight-10; 
ImageHandleCenter.xpos = GraphicImageX+(((ImageHandleTR.xpos - ImageHandleTL.xpos)+10)/2)-10;
ImageHandleCenter.ypos = GraphicImageY+(((ImageHandleBL.ypos - ImageHandleTR.ypos)+10)/2)-10;
ImageHandleCenter.displayGLBuf();
GraphicLayoutBuffer.stroke(255);
GraphicLayoutBuffer.strokeWeight(2);
GraphicLayoutBuffer.line(ImageHandleTL.xpos,ImageHandleTL.ypos,ImageHandleTR.xpos,ImageHandleTR.ypos);
GraphicLayoutBuffer.line(ImageHandleTR.xpos+10,ImageHandleTR.ypos,ImageHandleBR.xpos+10,ImageHandleBR.ypos+10);
GraphicLayoutBuffer.line(ImageHandleBL.xpos,ImageHandleBL.ypos+10,ImageHandleTL.xpos,ImageHandleTL.ypos+10); 
GraphicLayoutBuffer.line(ImageHandleBR.xpos+10,ImageHandleBR.ypos+10,ImageHandleBL.xpos,ImageHandleBL.ypos+10);
ImageHandleTL.displayGLBuf(); 
ImageHandleBR.displayGLBuf();
}
public void SetLEDSizeCheckBoxes()
{SoftwareCheckBox[0].Selected = false;
SoftwareCheckBox[1].Selected = false;
SoftwareCheckBox[2].Selected = false;
SoftwareCheckBox[LEDSizeID].Selected = true;	
}public void CalMNxHTMd()
{switch(LEDSizeID)
{case 0:
LEDSize = 10;		
break;
case 1:
LEDSize = 16;	
break;
case 2:
LEDSize = 20;		
break;
}}
public void ImportCustomPixelMap()
{AppendLogFile("ImportCustomPixelMap()");
String[] lines = loadStrings(iKxwBtq); 
String[] WorkString = new String[3]; 
WorkString = split(lines[0], '\t');
int MaxPixels = PApplet.parseInt(WorkString[0]);
int MinX=1000;
int MinY=1000;
int MaxX=0;
int MaxY=0;
int countvar = 0; 
try 
{for (int i=1;i != lines.length;i++)
{WorkString = split(lines[i], '\t');
if (PApplet.parseInt(WorkString[0]) > MaxX) MaxX = PApplet.parseInt(WorkString[0]);
if (PApplet.parseInt(WorkString[0]) < MinX) MinX = PApplet.parseInt(WorkString[0]);
if (PApplet.parseInt(WorkString[1]) > MaxY) MaxY = PApplet.parseInt(WorkString[1]);
if (PApplet.parseInt(WorkString[1]) < MinY) MinY = PApplet.parseInt(WorkString[1]);
countvar++;
}}
catch(Exception e)
{AppendLogFile("Coordinates missing or other error with PixelMap file, found "+countvar+" coordinates");
NyqOxsk(17);
MaxPixels = countvar; 
}final int cLocalWidth = qxXNcNf-20;
final int cLocalHeight = tuCbyyd-20;
int Xdifference = MaxX - MinX;
int Ydifference = MaxY - MinY;
AppendLogFile("Coord Differences: "+Xdifference+" : "+Ydifference);
int tempSz = 0;
if(Xdifference >= Ydifference) tempSz =  cLocalWidth / (Xdifference+1);
else tempSz = cLocalHeight / (Ydifference+1);
if(tempSz > LEDSize) tempSz = PApplet.parseInt((float)tempSz * 0.75f);
int[] PatchCoordX = new int[MaxPixels]; 
int[] PatchCoordY = new int[MaxPixels];
for (int i=0;i != MaxPixels;i++)
{WorkString = split(lines[i+1], '\t');
PatchCoordX[i] = PApplet.parseInt(WorkString[0]) - MinX;
PatchCoordY[i] = PApplet.parseInt(WorkString[1]) - MinY;
} 
int offsetX = (cLocalWidth - (tempSz * Xdifference)) / 2;
int offsetY = (cLocalHeight - (tempSz * Ydifference)) / 2; 
LEDIconCoordX = new int[MaxPixels]; 
LEDIconCoordY = new int[MaxPixels]; 
for (int i=0;i != MaxPixels;i++)
{LEDIconCoordX[i] = offsetX+(PatchCoordX[i]*tempSz);
LEDIconCoordY[i] = offsetY+(PatchCoordY[i]*tempSz);
}if(IconLayoutAdvancedMode.Selected == false) 	GraphicLayoutBuild(0);
else PixelAmountObject.setValue(""+MaxPixels); 
}
class ColorRect
{int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int Red;
int Green;
int Blue;
int White;
boolean MouseOverFlag;
boolean Selected;
String Label;
ColorRect(int ixpos, int iypos, int ibWidth, int ibHeight, int iRed, int iGreen, int iBlue, int iWhite, String iLabel)
{xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
Red = iRed;
Green = iGreen;
Blue = iBlue;
White = iWhite;
Label = iLabel;
Selected = false;
MouseOverFlag = false;
}public void display()
{strokeWeight(1);
stroke(mYkuUaE);
if(device.Bit16Mode == true)	fill((Red>>8), (Green>>8), (Blue>>8));	
else fill(Red, Green, Blue);
int holdPixelType = QCZOouc;
if(uBYXrqM == 2 && CrytrWK == 1) 
{holdPixelType = LiveConDataType;
}	
switch(holdPixelType)
{case 0: 
if(device.Bit16Mode == true)	fill((White>>8));
else fill(White);	
rect(xpos, ypos, bWidth, bHeight);
break;
case 1: 
rect(xpos, ypos, bWidth, bHeight);
break;	
case 2: 
rect(xpos, ypos, bWidth, bHeight); 
if(device.Bit16Mode == true)	fill((White>>8));
else fill(White); 
rect(xpos, ypos+(((float)bHeight/3)*2), bWidth, ((float)bHeight/3));	
break;
}	
if(!Label.equals(""))
{textAlign(CENTER);
textSize((bHeight/1.75f));
fill(255);
if(device.Bit16Mode == true)	fill(0xFFFF-(Red>>8), 0xFFFF-(Green>>8), 0xFFFF-(Blue>>8));	
else fill((255 - Red),(255- Green),(255 - Blue));
text(Label, xpos+(bWidth/2), ypos+(bHeight/1.35f));	
}if(MouseOverFlag == true || Selected == true)
{stroke(VySlFUN);
strokeWeight(2);
fill(0,0,0,0); 
rect(xpos-2, ypos-2, bWidth+4, bHeight+4);
}noStroke();
} 
public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}}
public boolean mouseOver() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight)
{      
MouseOverFlag = true;	
return true;
} 
else {
MouseOverFlag = false;	
return false;
}}
} 
class ColorPickerObj
{int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int selPointX;
int selPointY;
int slRed;
int slGreen;
int slBlue;
int slWhite;
int mode; 
int passedFrame;
int passedChan;
ColorPickerObj(int ixpos, int iypos, int ibWidth, int ibHeight, int iselPointX, int iselPointY, int islRed, int islGreen, int islBlue, int islWhite)
{xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
selPointX = iselPointX;
selPointY = iselPointY;
slRed = islRed;
slGreen = islGreen;
slBlue = islBlue;
slWhite = islWhite;
mode = 0;
passedFrame = 0;
passedChan = 0;
}public void display()
{image(gradientImg, xpos, ypos, bWidth, bHeight);
int holdPixelType = QCZOouc;
if(uBYXrqM == 2 && CrytrWK == 1) 
{holdPixelType = LiveConDataType;
}switch(holdPixelType)
{case 0: 
ColorSelectorSliders[0].Value = 0;
ColorSelectorSliders[1].Value = 0;
ColorSelectorSliders[2].Value = 0;		
ColorSelectorSliders[3].Value = slWhite; 
break;
case 1: 
ColorSelectorSliders[0].Value = slRed;
ColorSelectorSliders[1].Value = slGreen;
ColorSelectorSliders[2].Value = slBlue;	
ColorSelectorSliders[3].Value = 0;
break;	
case 2: 
ColorSelectorSliders[0].Value = slRed;
ColorSelectorSliders[1].Value = slGreen;
ColorSelectorSliders[2].Value = slBlue;	
ColorSelectorSliders[3].Value = slWhite;
break;
}fill(255);
textSize(12);
textLeading(14);	
textAlign(RIGHT);
text("Red:\nGreen:\nBlue:\nWhite:", xpos+45, ypos+215);
text(slRed+"\n"+slGreen+"\n"+slBlue+"\n"+slWhite, xpos+85, ypos+215);
textAlign(LEFT);
if(mode  == 1)     text("Coloring All",xpos+10, ypos+280);
else if(mode == 2)     text("Color Group: "+(gdHgLUO+1),xpos+10, ypos+280);
else if(GraphicFuncPaintButton.Selected == true)  text("Paint Color",xpos+10, ypos+280);
else text("LED#: "+(ATLudLs+1),xpos+10, ypos+280);
text("Recent\nPalette:",xpos+20, ypos+185);		
textSize(10);	
textAlign(CENTER);
text("Selected", xpos+245, ypos+215);
textAlign(LEFT);
strokeWeight(1);
stroke(0);
for (int i=0; i != paletteColors.length;i++)
{fill(paletteColors[i][0],paletteColors[i][1],paletteColors[i][2]);
rect(xpos+70+(i*30), ypos+175,25,25);		
}switch(holdPixelType)
{case 0: 
if(device.Bit16Mode == true)	fill((slWhite>>8));
else	fill(slWhite);
rect(xpos+230, ypos+220, 30, 30);	
break;
case 1: 
case 2: 
if(device.Bit16Mode == true)	fill((slRed>>8),(slGreen>>8),(slBlue>>8));
else	fill(slRed,slGreen,slBlue);
rect(xpos+230, ypos+220, 30, 30);
if(holdPixelType == 1) break;
if(device.Bit16Mode == true)	fill((slWhite>>8));
else fill(slWhite); 
rect(xpos+230, ypos+240, 30, 10);	
for (int i=0; i != paletteColors.length;i++)
{fill(paletteColors[i][3]);
rect(xpos+70+(i*30), ypos+190,25,10);		
}			
break;
}	
noStroke();
switch(holdPixelType)
{case 0: 
ColorSelectorSliders[3].display(); 
break;
case 1: 
ColorSelectorSliders[0].display();
ColorSelectorSliders[1].display();
ColorSelectorSliders[2].display();	
break;	
case 2: 
ColorSelectorSliders[0].display();
ColorSelectorSliders[1].display();
ColorSelectorSliders[2].display();
ColorSelectorSliders[3].display(); 	
break;
}ColorSelectorApply.display();
ColorSelectorCancel.display();
TextFields[10].display();	
fill(0, 0, 0, 0); 
stroke(255);
rect(round(selPointX/gwFwycD)-2, round(selPointY/gwFwycD)-2, 4, 4);
stroke(0);
rect(round(selPointX/gwFwycD)-3, round(selPointY/gwFwycD)-3, 4, 4);
} 
public void InitPosition(int passedType, int passedC, int passedF)
{AppendLogFile("Init Color Selector, Type: "+passedType+"   "+passedC+"   "+passedF);
EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);  
this.xpos = EMCDldB;
this.ypos = bJxobsd;
mode = passedType;
passedChan = passedC;		
passedFrame = passedF;
DXcJNIU = true;
if ((this.xpos+bWidth) > round(width/gwFwycD)) this.xpos = round(width/gwFwycD) - bWidth;
if ((this.ypos+bHeight) > round(height/gwFwycD)) this.ypos = round(height/gwFwycD) - bHeight;    
ColorSelectorSliders[0].xpos = this.xpos +90;
ColorSelectorSliders[0].ypos = this.ypos+205;
ColorSelectorSliders[1].xpos = this.xpos +90;
ColorSelectorSliders[1].ypos = this.ypos+220;
ColorSelectorSliders[2].xpos = this.xpos + 90;
ColorSelectorSliders[2].ypos = this.ypos+235;  
ColorSelectorSliders[3].xpos = this.xpos +90;
ColorSelectorSliders[3].ypos = this.ypos+250;  
TextFields[10].xpos = this.xpos +100;
TextFields[10].ypos = this.ypos+265; 
ColorSelectorApply.xpos = this.xpos+170;
ColorSelectorApply.ypos = this.ypos+265; 
ColorSelectorCancel.xpos = this.xpos+220;
ColorSelectorCancel.ypos = this.ypos+265; 
selPointX = xpos + (xpos/2);
selPointY = ypos + (ypos/2);
if(GraphicFuncPaintButton.Selected == true || oxBdCTXPick == true)
{AppendLogFile("Ran color fill for painting");	
ColorSelectorSliders[0].Value = PaintRects[PaintRectID].Red;
ColorSelectorSliders[1].Value = PaintRects[PaintRectID].Green;
ColorSelectorSliders[2].Value = PaintRects[PaintRectID].Blue;
ColorSelectorSliders[3].Value = PaintRects[PaintRectID].White;	
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;		
}else if(mode == 1)
{AppendLogFile("All the same no color setup - Color Sliders Not Initialized");
ColorSelectorSliders[0].Value = 0;
ColorSelectorSliders[1].Value = 0;
ColorSelectorSliders[2].Value = 0;
ColorSelectorSliders[3].Value = 0;
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;			
}else if(mode == 3)
{		
switch(LiveConDataType)
{case 0: 
ColorSelectorSliders[3].Value = ControlSliders[passedChan*LiveConDataMult].Value;
slRed = 0;
slGreen = 0;
slBlue = 0;
slWhite = ControlSliders[passedChan*LiveConDataMult].Value;		   
break;
case 1: 
ColorSelectorSliders[0].Value = ControlSliders[(passedChan*LiveConDataMult)].Value;
ColorSelectorSliders[1].Value = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
ColorSelectorSliders[2].Value = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
slRed = ControlSliders[(passedChan*LiveConDataMult)].Value;
slGreen = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
slBlue = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
slWhite	= 0;		
break;
case 2: 
AppendLogFile("This: "+passedChan);
ColorSelectorSliders[0].Value = ControlSliders[(passedChan*LiveConDataMult)].Value;
ColorSelectorSliders[1].Value = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
ColorSelectorSliders[2].Value = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
ColorSelectorSliders[3].Value = ControlSliders[passedChan*LiveConDataMult+3].Value;
slRed = ControlSliders[(passedChan*LiveConDataMult)].Value;
slGreen = ControlSliders[(passedChan*LiveConDataMult)+1].Value;
slBlue = ControlSliders[(passedChan*LiveConDataMult)+2].Value;
slWhite = ControlSliders[passedChan*LiveConDataMult+3].Value;			
break;
}}	
else if(UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{		
ColorSelectorSliders[0].Value = GradientRects[lQGtaTe].Red;
ColorSelectorSliders[1].Value = GradientRects[lQGtaTe].Green;
ColorSelectorSliders[2].Value = GradientRects[lQGtaTe].Blue;
ColorSelectorSliders[3].Value = GradientRects[lQGtaTe].White;
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;	
}			
else
{			
switch(QCZOouc)
{case 0: 
ColorSelectorSliders[3].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan];
slRed = 0;
slGreen = 0;
slBlue = 0;
slWhite = ColorSelectorSliders[3].Value;				
break;
case 1: 
ColorSelectorSliders[0].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya];
ColorSelectorSliders[1].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya+1];
ColorSelectorSliders[2].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya+2];
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = 0;		
break;
case 2: 
ColorSelectorSliders[0].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya];
ColorSelectorSliders[1].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya+1];
ColorSelectorSliders[2].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya+2];
ColorSelectorSliders[3].Value = UserSequences[AkOQmUe].DataFrames[passedFrame][passedChan * ByoKxya+3];
slRed = ColorSelectorSliders[0].Value;
slGreen = ColorSelectorSliders[1].Value;
slBlue = ColorSelectorSliders[2].Value;
slWhite = ColorSelectorSliders[3].Value;			
break;
}}	  
if(QCZOouc == 0) SliderPointer = ColorSelectorSliders[3]; 
else SliderPointer = ColorSelectorSliders[0]; 
TextFields[10].Label = ""+SliderPointer.Value;
} 
public void PickColor()
{   
this.selPointX = mouseX;
this.selPointY = mouseY; 
uZYECeH = get(mouseX, mouseY);      
ZhmkwyF = uZYECeH >> 16 & 0xFF; 
IwpariG = uZYECeH >> 8 & 0xFF;
dyrGyHh = uZYECeH & 0xFF;    
int holdPixelType = QCZOouc;
if(mode == 3) 
{holdPixelType = LiveConDataType;
}	
if(device.Bit16Mode == true)
{if(ZhmkwyF != 0)ZhmkwyF = (ZhmkwyF+1) * 256;
if(IwpariG != 0)IwpariG = (IwpariG+1) * 256;
if(dyrGyHh != 0)dyrGyHh = (dyrGyHh+1) * 256;
if(roIonSV != 0)roIonSV = (roIonSV+1) * 256;
AppendLogFile("Color Picked Multiplied");
if(ZhmkwyF > 0xFFFF)ZhmkwyF = 0xFFFF;
if(IwpariG > 0xFFFF)IwpariG = 0xFFFF;
if(dyrGyHh > 0xFFFF)dyrGyHh = 0xFFFF;
if(roIonSV > 0xFFFF)roIonSV = 0xFFFF;
}switch(holdPixelType)
{case 0: 
this.slRed = 0;
this.slGreen = 0;
this.slBlue = 0;
this.slWhite = PApplet.parseInt((ZhmkwyF+IwpariG+dyrGyHh)/3);
break;
case 1: 
this.slRed = (int)ZhmkwyF;
this.slGreen = (int)IwpariG;
this.slBlue = (int)dyrGyHh;
this.slWhite = 0;		
break;	
case 2: 
this.slRed = (int)ZhmkwyF;
this.slGreen = (int)IwpariG;
this.slBlue = (int)dyrGyHh;
break;
}	
} 
public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}} 
public boolean overPicker() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight-90) 
{      
return true;
} 
else {
return false;
}}
}class CheckBox
{int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int ColBG;
int ColHL;
int ColOut;  
boolean Selected;
int Status = 0; 
CheckBox(int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iSelected)
{xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = iSelected;
}public void display()
{strokeWeight(1);
stroke(ColOut);
fill(ColBG);
rect(xpos, ypos, bWidth, bHeight);  
if (Selected==true)
{line(xpos, ypos, xpos+bWidth, ypos+bHeight);
line(xpos+bWidth, ypos, xpos, ypos+bHeight);
}handleStatus();
}public void handleStatus()
{noStroke();
if(Status == 1) 
{strokeWeight(2);
stroke(DqoHydg, 200); 
fill(DqoHydg, 200); 
rect(xpos, ypos, bWidth, bHeight);  
noStroke();
}}
public boolean over() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0)
{     
Selected =! Selected;	
return true;
} 
else {
return false;
}}
public boolean overB() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0)
{     
return true;
} 
else {
return false;
}}
}
class TabButton
{String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int ColBG;
int ColHL;
int ColOut;  
boolean Selected;  
boolean ReqRefresh;
TabButton(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iSelected, boolean iReqRefresh)
{Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = iSelected;
ReqRefresh = iReqRefresh;
}public void refresh()
{this.ReqRefresh = false;
switch(uBYXrqM)
{case 0:
if (this == MenuTabs[0]) 
{	
if(IconLayoutAdvancedMode.Selected == false)
{if(fdJgaNC < 5) 
{	
GraphicLayoutBuild(0); 
}
}GraphicLayoutUpdateIcons();
}
else this.ReqRefresh = true;	
break;
case 1:
if (this == MenuTabs[1]) DrawTimeLineBuffer();
else this.ReqRefresh = true;	
break;		
case 2:
break;
default:
this.ReqRefresh = true;	
break;		
}} 
public void display()
{noStroke();
if (Selected==true)
{fill(ColHL);
rect(xpos, ypos, bWidth, bHeight, bHeight/2);   
rect(xpos, ypos+(bHeight/1.75f), bWidth, (float)bHeight/2.1f);
}else       
{fill(ColBG, 128);
rect(xpos, ypos, bWidth, bHeight, bHeight/8);
}textAlign(LEFT);
fill(ColOut);
textSize((bHeight/1.75f));
text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
}public boolean over() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight) 
{    
Selected =! Selected;	
return true;
} 
else {
return false;
}}
} 
class DropDown
{String[] Labels;
int numStrs;
int SelStr;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int ColBG;
int ColHL;
int ColOut;  
boolean Selected;
int Status;
boolean DirMode; 
boolean MouseOverFlag;
DropDown(String[] iLabels, int inumStrs, int iSelStr, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iDirMode)
{Labels = iLabels; 
numStrs = inumStrs;
SelStr = iSelStr;
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Selected = false;
DirMode = iDirMode;
Status = 0; 
DropDownList.add(this);	
}public void handleStatus()
{noStroke();
if(Status == 1) 
{strokeWeight(2);
stroke(DqoHydg, 200); 
fill(DqoHydg, 200); 
rect(xpos, ypos, bWidth, bHeight);  
noStroke();
}}	
public void displayNormal()
{strokeWeight(1);
stroke(ColOut);
if (Selected==true) 
{	
fill(ColHL);
if(Status == 0 && MouseOverFlag == true) 
{fill(ColHL,128);
}}		
else  
{	
fill(ColBG);
if(Status == 0 && MouseOverFlag == true) 
{fill(ColBG,64);
}}
rect(xpos, ypos, bWidth, bHeight);  
textAlign(LEFT);
fill(ColOut);
textSize((bHeight/1.75f));
text(Labels[SelStr], xpos+(bWidth/20), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
fill(255);
int tempSize = (bWidth/4);
if(tempSize >  (bHeight/4)) tempSize = (bHeight);
triangle(xpos+(bWidth-tempSize), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/2), ypos+(bHeight/4), xpos+(bWidth-tempSize)+(bHeight/4), ypos+(bHeight/4)+(bHeight/2));
noStroke();
}public void selectDD()
{Selected =! Selected;	
if(Selected == true)
{	
DropDownPointer = this;
XEfHstU = true;
DropDownMouseOverID = SelStr;
}else
{XEfHstU = false; 
}}
public void display()
{if(Status == 2) return; 
if(Selected == false)
{displayNormal();
}else
{if(DirMode == false)	
{	
fill(ColBG);
displayNormal();
strokeWeight(1);
stroke(ColOut);  
for (int i = 0; i != numStrs; i++)
{fill(ColBG);
rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
if(i == SelStr) fill(ColHL);
else fill(ColBG);
if(DropDownMouseOverID > 0 && DropDownMouseOverID == (i+1) && MouseOverFlag == true)
{if(i == SelStr) fill(ColHL,128);
else fill(0,0,0,64);
}rect(5+xpos, ypos+(bHeight*(i+1)), bWidth-5, bHeight);
fill(ColOut);
textSize((bHeight/1.75f));
text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f)+(bHeight*(i+1)), bWidth, bHeight);
}   
noStroke();			
}else
{						
displayNormal(); 
strokeWeight(1);
stroke(ColOut);  
for (int i = 0; i != numStrs; i++)
{fill(ColBG);
rect(5+xpos, ypos+(bHeight*(i-numStrs)), bWidth-5, bHeight); 
if(((numStrs-1)-i) == SelStr) fill(ColHL);
else fill(ColBG);
if(DropDownMouseOverID > 0 && DropDownMouseOverID == (i+1) && MouseOverFlag == true)
{if(((numStrs-1)-i) == SelStr) fill(ColHL,128);
else fill(0,0,0,64);
}rect(5+xpos, ypos+(bHeight*(i-numStrs)), bWidth-5, bHeight);
} 
for (int i = 0; i != numStrs; i++)
{fill(ColOut);
textSize((bHeight/1.75f));
text(Labels[i], 5+xpos+((bWidth - textWidth(Labels[i]))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f)-(bHeight*(i+1)), bWidth, bHeight);
}   
noStroke();
}	
}handleStatus();
} 
public boolean overOpen()
{if(DirMode == false)	
{		
if(Selected == false)
{return false;
}else
{for (int i = 0; i != numStrs; i++)
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos+(bHeight*(i+1)) && bJxobsd <= ypos+bHeight+(bHeight*(i+1)) && Status == 0)
{    
Selected = false;
SelStr = i;	
XEfHstU = false;
return true;
}}
Selected = false;
return false;
}	
}else
{	
if(Selected == false)
{return false;
}else
{for (int i = 0; i != numStrs; i++)
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos-(bHeight*(i+1)) && bJxobsd <= ypos+bHeight-(bHeight*(i-1)) && Status == 0)
{    
Selected = false;
SelStr = i;	
XEfHstU = false;
return true;
}}
Selected = false;
return false;
}}
} 
public boolean over() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight  && Status == 0) 
{    
if(XEfHstU == true) return false; 
selectDD();
return true;
} 
else {
return false;
}}
public boolean mouseOver() 
{if ( EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight  && Status == 0) 
{      
MouseOverFlag = true;	
return true;
} 
else {
MouseOverFlag = false;
return false;
}}
public boolean mouseOverOpen()
{if(DirMode == false)	
{		
if(Selected == false)
{return false;
}		
else
{for (int i = 0; i != numStrs; i++)
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos+(bHeight*(i+1)) && bJxobsd <= ypos+bHeight+(bHeight*(i+1)) && Status == 0)
{    
MouseOverFlag = true;
DropDownMouseOverID = i+1;				
return true;
}}
DropDownMouseOverID = 0;
MouseOverFlag = false;
return false;
}	
}else
{	
if(Selected == false)
{return false;
}else
{for (int i = 0; i != numStrs; i++)
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos-(bHeight*(i+1)) && bJxobsd <= ypos+bHeight-(bHeight*(i-1)) && Status == 0)
{    
MouseOverFlag = true;
DropDownMouseOverID = (numStrs-i);				
return true;
}}
DropDownMouseOverID = 0;
MouseOverFlag = false;
return false;
}}
} 
} 
class TLTriangle
{String Label;
int xpos; 
int ypos ; 
int zpos ; 
int bSize;
int ColBG;
int ColHL;
int ColOut;  
boolean Toggle;
boolean Selected;
TLTriangle(String iLabel, int ixpos, int iypos, int izpos, int ibSize, int iColBG, int iColHL, int iColOut, boolean iToggle, boolean iSelected)
{Label = iLabel; 
xpos = ixpos;
ypos = iypos; 
zpos = izpos;     
bSize = ibSize;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Toggle = iToggle;
Selected = iSelected;
}public void display()
{TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.stroke(ColOut);
if (Selected==true)  TimeLineBuffer.fill(ColHL);
else  TimeLineBuffer.fill(ColBG);
TimeLineBuffer.stroke(255);
TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.triangle(xpos-(bSize), ypos, xpos+(bSize), ypos, xpos, ypos+bSize);
TimeLineBuffer.line(xpos,ypos+(bSize),xpos, ypos+(bSize)+8);
TimeLineBuffer.noStroke();
if (Toggle==false) Selected = false;
}public boolean over() 
{if (EMCDldB >= (xpos+osqIpiO)-(bSize) && EMCDldB <= (xpos+osqIpiO+(bSize)) && bJxobsd >= XuFFMGQ+(ypos-YLWNFLV) && bJxobsd <= (XuFFMGQ+(bSize+8))+(ypos-YLWNFLV)) 
{   
Selected =! Selected;		
return true;
} 
else {
return false;
}}
} 
class Button
{String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int ColBG;
int ColHL;
int ColOut;  
boolean Toggle;
boolean Selected;
int Status; 
boolean MouseOverFlag;
Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iColOut, boolean iToggle, boolean iSelected, boolean iAllowMouseOver)
{Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
ColOut = iColOut;
Toggle = iToggle;
Selected = iSelected;
Status = 0; 
if(iAllowMouseOver == true) ButtonList.add(this);
MouseOverFlag = false;
}public void handleStatus()
{noStroke();
if(Status == 1) 
{strokeWeight(2);
stroke(DqoHydg, 200); 
fill(DqoHydg, 200); 
rect(xpos, ypos, bWidth, bHeight);  
noStroke();
}}
public void display()
{strokeWeight(1);
stroke(ColOut);
if (Selected==true) 
{	
fill(ColHL);
if(Status == 0 && MouseOverFlag == true) 
{fill(ColHL,128);
}}		
else  
{	
fill(ColBG);
if(Status == 0 && MouseOverFlag == true) 
{fill(ColBG,64);
}
}textAlign(LEFT);
rect(xpos, ypos, bWidth, bHeight, bHeight/4);  
fill(ColOut);
textSize((bHeight/1.75f));
text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
handleStatus();
if (Toggle==false) Selected = false;
}public void displaySq()
{strokeWeight(1);
stroke(ColOut);
if (Selected==true) fill(ColHL);
else  fill(ColBG);
rect(xpos, ypos, bWidth, bHeight);  
fill(ColOut);
textSize(12);
textAlign(CENTER);
text(Label, xpos+(bWidth/2), ypos+20);
textAlign(LEFT);   
handleStatus();
if (Toggle==false) Selected = false;
} 
public void displaySqIndex(int xposB, int yposB)
{IndexScrollBuffer.strokeWeight(1);
IndexScrollBuffer.stroke(ColOut);
IndexScrollBuffer.fill(ColBG);
IndexScrollBuffer.rect(xposB, yposB, bWidth, bHeight);  
IndexScrollBuffer.fill(ColOut);
IndexScrollBuffer.textSize(12);
IndexScrollBuffer.textAlign(CENTER);
IndexScrollBuffer.text(Label, xposB+(bWidth/2), yposB+20);
IndexScrollBuffer.textAlign(LEFT);   
} 	
public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0) 
{      
Selected =! Selected;	
return true;
} 
else {
return false;
}} 
public boolean overB() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0) 
{      
return true;
} 
else {
return false;
}} 
public boolean mouseOver() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0) 
{      
MouseOverFlag = true;	
return true;
} 
else {
MouseOverFlag = false;
return false;
}} 
public void displayGLBuf() 
{GraphicLayoutBuffer.strokeWeight(2);
GraphicLayoutBuffer.stroke(0);
GraphicLayoutBuffer.rect(xpos, ypos, bWidth, bHeight);  
}	
public boolean overGLBuf() 
{if (EMCDldB >= (xpos+AqFFYoX) && EMCDldB <= (xpos+AqFFYoX+bWidth) && bJxobsd >= (ypos+gEfHGFk) && bJxobsd <= (gEfHGFk+ypos+bHeight)) 
{    
Selected =! Selected;	
return true;
} 
else {
return false;
}}		
public void displayTL() 
{TimeLineBuffer.strokeWeight(1);
TimeLineBuffer.stroke(ColOut);
if (Selected==true)  TimeLineBuffer.fill(ColHL);
else  TimeLineBuffer.fill(ColBG);
TimeLineBuffer.rect(xpos, ypos, bWidth, bHeight, bHeight/4);  
TimeLineBuffer.fill(ColOut);
TimeLineBuffer.textSize(bHeight*1.2f); 
if(Label.length() > 2) TimeLineBuffer.textSize(bHeight/1.25f);
TimeLineBuffer.textAlign(CENTER);
TimeLineBuffer.text(Label,xpos,ypos+((float)bHeight/3.5f),bWidth,bHeight);
TimeLineBuffer.textAlign(LEFT);
TimeLineBuffer.noStroke();
if (Toggle==false) Selected = false;
}public boolean overTL() 
{if ( EMCDldB >= (xpos+osqIpiO) && EMCDldB <= (xpos+osqIpiO+bWidth) && bJxobsd >= XuFFMGQ+(ypos-YLWNFLV) && bJxobsd <= (XuFFMGQ+bHeight)+(ypos-YLWNFLV)) 
{      
Selected =! Selected;		
return true;
} 
else {
return false;
}}
public void displayTech() 
{TechnicalBuffer.strokeWeight(1);
TechnicalBuffer.stroke(ColOut);
if (Selected==true)  TechnicalBuffer.fill(ColHL);
else  TechnicalBuffer.fill(ColBG);
TechnicalBuffer.rect(xpos, ypos, bWidth, bHeight, bHeight/4);  
TechnicalBuffer.fill(ColOut);
TechnicalBuffer.textSize(bHeight*1.2f); 
if(Label.length() > 2) TechnicalBuffer.textSize(bHeight/1.25f);
TechnicalBuffer.textAlign(CENTER);
TechnicalBuffer.text(Label,xpos,ypos+((float)bHeight/3.5f),bWidth,bHeight);
TechnicalBuffer.textAlign(LEFT);
TechnicalBuffer.noStroke();
if (Toggle==false) Selected = false;
}	
} 
class SliderBar
{int xpos; 
int ypos ; 
int slWidth; 
int slHeight; 
int Value; 
int Minimum; 
int Maximum;
int BgColor;
int slHandleColor;
int slSelectColor; 
int slStrokeColor;
boolean CircleHandle;  
boolean HorizVertToggle;
boolean ScrollBarToggle;
int  SetNumber;
float temp1=slWidth;
float temp2=Maximum;
float temp3=Value;
float temp4=Minimum;
float MathVar=0;
SliderBar(int iSetNumber, int ixp, int iyp, int iw, int ih, int iValue, int iMin, int iMax, int iBgColor, int islHandleColor, int islSelectColor, int islStrokeColor, boolean iCircleHandle, boolean iHorizVertToggle, boolean iScrollBarToggle) 
{   
xpos = ixp;
ypos = iyp;  
slWidth = iw;
slHeight = ih;
Value=iValue;
Maximum=iMax;
Minimum=iMin;
BgColor=iBgColor;
slHandleColor=islHandleColor;
slSelectColor=islSelectColor;
slStrokeColor=islStrokeColor;
CircleHandle=iCircleHandle;  		
HorizVertToggle=iHorizVertToggle; 
ScrollBarToggle=iScrollBarToggle; 
SetNumber = iSetNumber;
}public void setValue(int passedVal)
{if (passedVal > Maximum) { 
passedVal = Maximum;
}if (passedVal < Minimum) { 
passedVal = Minimum;
}Value = passedVal;		
}public int getValue()
{if (Value > Maximum) { 
Value = Maximum;
}if (Value < Minimum) { 
Value = Minimum;
AppendLogFile("HAPPENED====================================");
}	
return Value;
}public void move(int uX, int uY) 
{if(ScrollBarToggle == true)
{if(HorizVertToggle == false) 
{temp1 = slWidth - (slHeight * 2);   
temp3 = Value;
MathVar = ((((uX-xpos)-slHeight) / temp1)-1) *-1; 
MathVar = Maximum - (MathVar*(Maximum-Minimum));   
if (MathVar > Maximum) { 
MathVar=Maximum;
}if (MathVar < Minimum) { 
MathVar=Minimum;
}  	
Value=PApplet.parseInt(MathVar); 
}else
{temp1 = slHeight - (slWidth * 2);   
temp3 = Value;
MathVar = ((((uY-ypos)-slWidth) / temp1)-1) *-1; 
MathVar = Maximum - (MathVar*(Maximum-Minimum));   
if (MathVar > Maximum) { 
MathVar=Maximum;
}if (MathVar < Minimum) { 
MathVar=Minimum;
}  
Value=PApplet.parseInt(MathVar); 
}	
}	
else
{if(HorizVertToggle == false) 
{temp1 = slWidth;   
temp3 = Value;
temp4 = Minimum;
MathVar = (((uX-xpos) / temp1)-1) *-1; 
MathVar = Maximum - (MathVar*(Maximum-Minimum));   
if (MathVar > Maximum) { 
MathVar=Maximum;
}if (MathVar < Minimum) { 
MathVar=Minimum;
}  
Value = PApplet.parseInt(MathVar); 
}else
{AppendLogFile("NO SLIDER MOVE() HANDLER");	
}}		
} 
public void display() 
{   
if(ScrollBarToggle == true)
{if(HorizVertToggle == false) 
{ 
stroke(slStrokeColor);
strokeWeight(1);
fill(BgColor); 
rect(xpos, ypos, slWidth, slHeight);   
fill(200); 
rect(xpos+(slHeight/10)+slHeight, ypos+(slHeight/10), slWidth-(slHeight/5)-(slHeight*2), (slHeight-(slHeight/5)));   
rect(xpos+(slHeight/10), ypos+(slHeight/10), slHeight-(slHeight/5), slHeight-(slHeight/5)); 
rect(xpos+(slHeight/10)+(slWidth-slHeight), ypos+(slHeight/10), slHeight-(slHeight/5), slHeight-(slHeight/5));  
stroke(slStrokeColor);
fill(slHandleColor);
strokeWeight(1);
triangle(xpos+slHeight-(slHeight/5),ypos+(slHeight/5),xpos+slHeight-(slHeight/5),ypos+(slHeight-(slHeight/5)),xpos+(slHeight/5),ypos+(slHeight/2));	
triangle(xpos+slWidth-slHeight+(slHeight/5),ypos+(slHeight/5),xpos+slWidth-slHeight+(slHeight/5),ypos+(slHeight-(slHeight/5)),xpos+slWidth-slHeight+slHeight-(slHeight/5), ypos+(slHeight/2));
temp1 = (slWidth - (slHeight*3));
temp2 = Maximum;  
temp3 = Value;    
temp4 = Minimum;			
float MathVar;
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2+slHeight;
fill(slHandleColor); 
ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-2, slHeight-2); 
}else
{stroke(slStrokeColor);
strokeWeight(1);
fill(BgColor); 
rect(xpos, ypos, slWidth, slHeight);  
fill(200); 
rect(xpos+(slWidth/10), ypos+(slWidth/10)+slWidth, slWidth-(slWidth/5), (slHeight-(slWidth/5))-(slWidth*2));   
rect(xpos+(slWidth/10), ypos+(slWidth/10), slWidth-(slWidth/5), slWidth-(slWidth/5));   
rect(xpos+(slWidth/10), ypos+(slWidth/10)+slHeight-slWidth, slWidth-(slWidth/5), slWidth-(slWidth/5));   
stroke(slStrokeColor);
fill(slHandleColor);
strokeWeight(1);
triangle(xpos+(slWidth/5), ypos+(slWidth/4)+(slWidth/2), xpos+(slWidth/2), ypos+(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+(slWidth/2));
triangle(xpos+(slWidth/5), ypos+(slWidth/4)+slHeight-slWidth, xpos+(slWidth/2), ypos+slHeight-(slWidth/5), (xpos+slWidth) - (slWidth/5), ypos+(slWidth/4)+slHeight-slWidth);
temp1 = (slHeight - (slWidth*3));
temp2 = Maximum;  
temp3 = Value;    
temp4 = Minimum;
float MathVar;
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slWidth/2+slWidth;
fill(slHandleColor); 
ellipse(xpos+(slWidth/2), ypos+MathVar, slWidth-2, slWidth-2); 
noStroke();
}}
else
{stroke(slStrokeColor);
strokeWeight(1);
fill(BgColor); 
rect(xpos, ypos, slWidth, slHeight);   
if (CircleHandle==true) temp1 = slWidth - slHeight;
else temp1=slWidth-(slWidth/20);
temp2=Maximum;  
temp3=Value;    
temp4 = Minimum;
float MathVar;
if (CircleHandle==true)
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + slHeight/2;
else  
MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 
fill(color(slSelectColor)); 
rect(xpos, ypos, MathVar, slHeight);
fill(slHandleColor); 
if (CircleHandle==true)   ellipse(xpos+MathVar, ypos+(slHeight/2), slHeight-1, slHeight-1); 
else   rect((xpos+MathVar), ypos, slWidth/20, slHeight); 
}			
}public void selectSlider()
{SliderPointer = this;
AzUdiEH = true;
}public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+slWidth && bJxobsd >= ypos && bJxobsd <= ypos+slHeight) 
{          
return true;
} 
else {
return false;
}}
}class TextField
{String Label;
int xpos; 
int ypos ; 
int bWidth;
int bHeight;
int ColBG;
int ColHL;
int InputMethod; 
int minValue; 
int maxValue; 
boolean Toggle;
boolean Selected;
String txtfCallback;
int Status; 
TextField(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, int iColBG, int iColHL, int iInputMethod, int iminValue, int imaxValue, boolean iToggle, boolean iSelected, String itxtfCallback)
{Label = iLabel; 
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ColBG = iColBG;
ColHL = iColHL;
Toggle = iToggle;
Selected = iSelected;
InputMethod = iInputMethod;
minValue = iminValue; 
maxValue = imaxValue; 
txtfCallback = itxtfCallback;
Status = 0; 
}public void handleStatus()
{noStroke();
if(Status == 1) 
{strokeWeight(2);
stroke(DqoHydg, 200); 
fill(DqoHydg, 200); 
rect(xpos, ypos, bWidth, bHeight);  
noStroke();
}}	
public void display()
{translate(0, 0);
strokeWeight(2);
fill(ColBG);
if (Selected==true)
{stroke(ColHL); 
rect(xpos, ypos, bWidth, bHeight);
}else       
{stroke(0, 0, 255);
rect(xpos, ypos, bWidth, bHeight);
}noStroke();
fill(0);
textSize((bHeight/1.75f));
textAlign(LEFT);
if(InputMethod != 2) text(Label, xpos+((bWidth - textWidth(Label))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
else  text(Label+"%", xpos+((bWidth - textWidth(Label+1))/2), ypos+((bHeight-(textAscent()+textDescent()))/1.5f), bWidth, bHeight);
handleStatus();
if (Toggle==false) Selected = false;
}public void SelectField()
{try {
textFieldPtr.Selected = false; 
}catch(Exception e) { }
textFieldPtr = this;
wnluxLL = Label;
Label = "";
Selected = true; 
emEPIOg = true;
}public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight && Status == 0) 
{     
Selected =! Selected;		
return true;
} 
else {
return false;
}}
} 
class LEDgraphic
{short ChanID;
short xpos; 
short ypos ; 
byte bSize;
byte GroupID;
LEDgraphic(int iChanID, int ixpos, int iypos, byte ibSize)
{ChanID = (short)iChanID; 
xpos = (short)ixpos;
ypos = (short)iypos;  
bSize = ibSize;
}public void display()
{   
GraphicLayoutBuffer.beginDraw();
int IDOffset = 0;
if(ChanID >= oiHkAsJ)  
{	
IDOffset = floor(ChanID / oiHkAsJ);
if(IDOffset > 0) IDOffset = IDOffset * oiHkAsJ;
else IDOffset = 0;
}GraphicLayoutBuffer.noStroke();
int tempFrameVar = UserSequences[AkOQmUe].DataFrameVar[(ChanID*ByoKxya)]; 
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0;
switch(QCZOouc)
{case 2: 
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+3];
case 1: 
CurrentStartR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)];
CurrentStartG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+1];
CurrentStartB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+2];
break;
case 0: 
CurrentStartW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)];
break;	
}	  	  
if (tempFrameVar < UserSequences[AkOQmUe].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(QCZOouc)
{case 2: 
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+3];
case 1: 
CurrentEndR = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)];
CurrentEndG = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+1]; 
CurrentEndB = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)+2];
break;
case 0: 
CurrentEndW = UserSequences[AkOQmUe].DataFrames[tempFrameVar][(ChanID*ByoKxya)];
break;	
}	 	  	
switch(QCZOouc)
{case 0: 
if(CurrentStartW == CurrentEndW)
{roIonSV = CurrentStartW; 
}	
else roIonSV =  UserSequences[AkOQmUe].StartValues[((ChanID-IDOffset)* ByoKxya)+3];
ZhmkwyF = roIonSV;
IwpariG = roIonSV;
dyrGyHh = roIonSV;
if(MainToolsShowStartValues.Selected == true)
{GraphicLayoutBuffer.fill(color(UserSequences[AkOQmUe].DataFrames[lQGtaTe][(ChanID-IDOffset)* ByoKxya]));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.4f, bSize*1.4f);	
}break;
case 2: 
if(CurrentStartW == CurrentEndW)
{roIonSV = CurrentStartW; 
}			
else roIonSV =  UserSequences[AkOQmUe].StartValues[((ChanID-IDOffset)* ByoKxya)+3];
case 1: 
if(CurrentStartR == CurrentEndR)
{ZhmkwyF = CurrentStartR; 
}				
else ZhmkwyF =  UserSequences[AkOQmUe].StartValues[((ChanID-IDOffset)* ByoKxya)];
if(CurrentStartG == CurrentEndG)
{IwpariG = CurrentStartG;
}else IwpariG =  UserSequences[AkOQmUe].StartValues[((ChanID-IDOffset)* ByoKxya)+1];
if(CurrentStartB == CurrentEndB)
{dyrGyHh = CurrentStartB;
}else dyrGyHh =  UserSequences[AkOQmUe].StartValues[((ChanID-IDOffset)* ByoKxya)+2];
if(MainToolsShowStartValues.Selected == true)
{GraphicLayoutBuffer.fill(color(UserSequences[AkOQmUe].DataFrames[lQGtaTe][(ChanID-IDOffset)* ByoKxya], UserSequences[AkOQmUe].DataFrames[lQGtaTe][(ChanID-IDOffset) * ByoKxya+1],UserSequences[AkOQmUe].DataFrames[lQGtaTe][(ChanID-IDOffset) * ByoKxya+2]));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize*1.4f, bSize*1.4f);
if(QCZOouc == 2) 
{GraphicLayoutBuffer.fill(color(UserSequences[AkOQmUe].DataFrames[lQGtaTe][((ChanID-IDOffset)* ByoKxya)+3]));
GraphicLayoutBuffer.arc(xpos, ypos, bSize*1.4f, bSize*1.4f, 0, PI, OPEN);
}}	
break;	
} 
if(QCZOouc == 2)
{GraphicLayoutBuffer.stroke(roIonSV);
GraphicLayoutBuffer.strokeWeight(3);
}else
{GraphicLayoutBuffer.stroke(0);
GraphicLayoutBuffer.strokeWeight(1);	
}GraphicLayoutBuffer.fill(color(ZhmkwyF, IwpariG, dyrGyHh));
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize, bSize); 
GraphicLayoutBuffer.fill((255 - ZhmkwyF), (255 - IwpariG), (255 - dyrGyHh));
if ((ZhmkwyF < 200 && ZhmkwyF > 55) || (IwpariG < 200 && IwpariG > 55) || (dyrGyHh < 200 && dyrGyHh > 55))
{GraphicLayoutBuffer.fill(255);
}  
GraphicLayoutBuffer.textSize((bSize/1.75f));
GraphicLayoutBuffer.textAlign(CENTER, CENTER); 
GraphicLayoutBuffer.text((ChanID+1), xpos, ypos-(bSize/10));
GraphicLayoutBuffer.textAlign(LEFT, BASELINE);
GraphicLayoutBuffer.noStroke();
GraphicLayoutBuffer.endDraw();
}public void displayBasic()
{   
GraphicLayoutBuffer.beginDraw();
GraphicLayoutBuffer.noStroke();
GraphicLayoutBuffer.strokeWeight(1); 
GraphicLayoutBuffer.stroke(0);
GraphicLayoutBuffer.fill(255);
GraphicLayoutBuffer.ellipse(xpos, ypos, bSize, bSize); 
GraphicLayoutBuffer.fill(0);
GraphicLayoutBuffer.textSize((bSize/1.75f));
GraphicLayoutBuffer.textAlign(CENTER, CENTER); 
GraphicLayoutBuffer.text((ChanID+1), xpos, ypos-(bSize/10));
GraphicLayoutBuffer.textAlign(LEFT, BASELINE);
GraphicLayoutBuffer.noStroke();
GraphicLayoutBuffer.endDraw();
}public boolean over() 
{if (EMCDldB >= (xpos+aVMHNFe)-(bSize/2) && EMCDldB <= (xpos+aVMHNFe)+(bSize/2) && bJxobsd >= ypos+35-(bSize/2) && bJxobsd <= (ypos+35)+(bSize/2)) 
{      
return true;
} 
else {
return false;
}}
}public void CloseCommunicationPort()
{if(QcuyJWJ == 0) CloseCOMPort();
else if(QcuyJWJ == 1) CloseTCP();
} 
public void OpenTCP()
{AppendLogFile("OpenTCP()");
try {
TCPClient.clear();
TCPClient.dispose();
TCPClient.stop();
}catch(Exception e) { }
CloseCOMPort();	
try {
UPCYumR = "Trying TCP";
TCPClient = new Client(this, netOeFl, ZhEGIBX); 
if(TCPClient.active() == true) 
{AppendLogFile("Connected to TCP Server at "+TCPClient.ip()+" on port 23");
QcuyJWJ = 1; 
baRtlHT = "TCP/IP";
OpenConnection();
}else
{TCPClient.stop();
if(DeviceConnect.Selected == false) 
{UPCYumR = "TCP Failed";
baRtlHT = "None";
}}
}catch(Exception e)
{AppendLogFile("Could Not Connect To TCP/IP Server");
}} 
public void CloseTCP()
{AppendLogFile("CloseTCP()");
DeviceConnect.Selected = false;		
UPCYumR = "Unconnected";
QcuyJWJ = 0;
try {
TCPClient.clear();
TCPClient.dispose();
TCPClient.stop();
}catch(Exception e) { }
} 
public void CloseCOMPort()
{AppendLogFile("CloseCOMPort() - Closing Port");  	
DeviceConnect.Selected = false;		
UPCYumR = "Unconnected";
for (int i=0; i < COMButtons.length;i++)	COMButtons[i].Selected = false;
try	 
{	
myPort.stop();
myPort.dispose();
eitvFtJ = false;
}catch(Exception e)
{AppendLogFile("No Port To Close");
}	
if(uBYXrqM == 4) thread("PortMonitorThread"); 
AppendLogFile("COM Port Closed");
}public void OpenCOMPort(String NameID)
{AppendLogFile("OpenCOMPort() with "+NameID+" at baud: "+iGloTVf);
redraw();
if(NameID.equals("TCP/IP"))
{thread("OpenTCP");
return;
}try {
myPort.stop();
myPort.dispose();     
}catch(Exception e) { }
int x = 0; 
try 
{for (x =0; x != Serial.list().length; x++) 
{if(NameID.equals(Serial.list()[x]))
{	
baRtlHT = Serial.list()[x];
myPort = new Serial(this, baRtlHT, iGloTVf);
try {
for (int q =0; q != COMButtons.length; q++) COMButtons[q].Selected = false;	
}
catch(Exception e)	{	}	
AppendLogFile("Connected to "+baRtlHT);
OpenConnection();
break;
}else
{}	
}	
}catch(Exception e)
{AppendLogFile("Could Not Open COM Port "+Serial.list()[x]);
baRtlHT = "None";
DeviceConnect.Selected = false;		
UPCYumR = "Unconnected";
NyqOxsk(22);
}
} 
public void FuncRecommendColorShift()
{	
try
{for(int i=0;i<=PixelChipsetDD.numStrs+1;i++)
{if(PixelChipsetDD.Labels[PixelChipsetDD.SelStr].indexOf(cPixelChipsetStrings[i])>=0)
{InputModule[3].Label = "Select The Pixel Chipset:\n\n\nRecommended Color: "+cPixelChipsetColorID[i];
return; 
}} 
}catch(Exception e)
{}
InputModule[3].Label = "Select The Pixel Chipset:\n\n\nRecommended Color: Unknown / Test";	
} 
class SpecHWModules
{int IDnumber;
String Label;
int xpos;
int ypos;
int bWidth;
int bHeight;
int Priority;
String ModuleFlagStr;
String ModuleByteStr;
boolean Enabled;
SpecHWModules(int iIDnumber, String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, String iModuleFlagStr, String iModuleByteStr, int iPriority)
{IDnumber = iIDnumber;
Label = iLabel;
xpos = ixpos;
ypos = iypos;  
bWidth = ibWidth;
bHeight = ibHeight;
ModuleFlagStr = iModuleFlagStr;
ModuleByteStr = iModuleByteStr;
Priority = iPriority;
}public void display()
{if(Enabled == false) return;
stroke(0);
strokeWeight(2);
fill(JCZFGSk, 200);
rect(xpos, ypos, bWidth, bHeight);
noStroke();
switch(IDnumber)
{case 0:	
HardwareButtons[0].display();		
break;		
case 1:		
LEDIndicatorModeBDD.display();
if(LEDIndicatorModeBDD.Selected == true)	DropDownPointer = LEDIndicatorModeBDD;		
break;		  
case 2:	
HardwareColSwapDD.display();	
if(HardwareColSwapDD.Selected == true)	DropDownPointer = HardwareColSwapDD;	
break;		  
case 3:	
PixelChipsetDD.display();	
if(PixelChipsetDD.Selected == true)	DropDownPointer = PixelChipsetDD;
break;				
case 4:	
HardwareButtons[2].display();	
break;			
case 5: 
TextFields[2].display(); 
break;			
case 6:
Label = "DMX Reception\nMode - ID Number: "+DMXModesDD.SelStr;
DMXModesDD.display(); 
if(DMXModesDD.Selected == true)	DropDownPointer = DMXModesDD;			
break;	
case 7:
MasterModeDD.display();
if(MasterModeDD.Selected == true)	DropDownPointer = MasterModeDD;
break;
case 8:
HardwareCheckBox[0].display();
fill(0);
textAlign(LEFT);
text("16-Bit Serial", HardwareCheckBox[0].xpos+25 , HardwareCheckBox[0].ypos+15); 
Label = "Serial Baud Rate:\nID Number: "+BaudRateDD.SelStr;
BaudRateDD.display();	
if(BaudRateDD.Selected == true)	DropDownPointer = BaudRateDD;
break;
case 9:
LEDIndicatorModeADD.display();
if(LEDIndicatorModeADD.Selected == true)	DropDownPointer = LEDIndicatorModeADD;
break;	
case 10:
DisplayModeDD.display();
if(DisplayModeDD.Selected == true)	DropDownPointer = DisplayModeDD;
break;	
case 11:
AutoDetectDD.display();	
if(AutoDetectDD.Selected == true)	DropDownPointer = AutoDetectDD;
break;			
case 12: 
HardwareButtons[3].display();
break;			
case 13: 
AccMeterAutoDetectDD.display();	
if(AccMeterAutoDetectDD.Selected == true)	DropDownPointer = AccMeterAutoDetectDD;		
AccMeterAutoDetectModeDD.display();	
if(AccMeterAutoDetectModeDD.Selected == true)	DropDownPointer = AccMeterAutoDetectModeDD;
break;				
case 14: 
HardwareButtons[4].display();
break;
case 15: 
AccMeterTapDD.display();	
if(AccMeterTapDD.Selected == true)	DropDownPointer = AccMeterTapDD;
break;
case 16: 
PowerDownTimeOutDD.display();	
if(PowerDownTimeOutDD.Selected == true)	DropDownPointer = PowerDownTimeOutDD;
break;		
case 17: 
TextFields[15].display();
break;	
case 18: 
TextFields[16].display();
break;
case 19: 
HardwareCheckBox[1].display();	
fill(0);
textAlign(LEFT);
text("Enable", HardwareCheckBox[1].xpos-45 , HardwareCheckBox[1].ypos+15); 
break;	
case 20: 
PWMFreqADD.display();
break;
case 21: 
StandAloneADD.display();
TextFields[13].display();
fill(0);
textAlign(LEFT);
textSize(12);
text("Enter Sequence ID#:", TextFields[13].xpos-90, TextFields[13].ypos-5);
break;
}textAlign(CENTER);
textSize(12);  
fill(0);
text(Label, xpos+5, ypos+10, bWidth-10, bHeight-10);  
} 
public void InitPositions()
{switch(IDnumber)
{case 0:	
HardwareButtons[0].xpos = xpos+30;
HardwareButtons[0].ypos = ypos+55;
break;		
case 1:	
LEDIndicatorModeBDD.xpos = xpos+10;
LEDIndicatorModeBDD.ypos = (ypos+(bHeight))-40;
break;		  
case 2:	
HardwareColSwapDD.xpos = xpos+10;						
HardwareColSwapDD.ypos = ypos+60;			
break;		  
case 3:	
PixelChipsetDD.xpos = xpos+10;		
PixelChipsetDD.ypos = ypos+25;		
break;				
case 4:	
HardwareButtons[2].xpos = xpos+60;
HardwareButtons[2].ypos = ypos+55;	
break;	
case 5:	
TextFields[2].xpos = xpos+20;
TextFields[2].ypos = (ypos+(bHeight))-50;				
break;				
case 6: 
DMXModesDD.xpos = xpos+5;
DMXModesDD.ypos = (ypos+(bHeight))-35;			
break;			
case 7: 
if(device.Bit16Mode == true)
{MasterModeDD.Labels = cDDMasterModesMultiBit;
MasterModeDD.numStrs = cDDMasterModesMultiBit.length;	
}else
{MasterModeDD.Labels = cDDMasterModes8Bit;
MasterModeDD.numStrs = cDDMasterModes8Bit.length;		
}MasterModeDD.xpos = xpos+10;
MasterModeDD.ypos = (ypos+(bHeight))-35;	
break;			
case 8:
BaudRateDD.xpos = xpos+10;
BaudRateDD.ypos = (ypos+(bHeight))-52;	
HardwareCheckBox[0].xpos = xpos+10;
HardwareCheckBox[0].ypos = (ypos+(bHeight))-25;	
if(IsOndtSTkNT("f8or16Bit") == true) HardwareCheckBox[0].Status = 0; 
else HardwareCheckBox[0].Status = 1; 
break;	
case 9:
LEDIndicatorModeADD.xpos = xpos+10;
LEDIndicatorModeADD.ypos = (ypos+(bHeight))-40;
break;	
case 10:
DisplayModeDD.xpos = xpos+10;
DisplayModeDD.ypos = (ypos+(bHeight))-40;
break;	
case 11:
AutoDetectDD.xpos = xpos+10;
AutoDetectDD.ypos = (ypos+(bHeight))-40;			
break;			
case 12:
HardwareButtons[3].xpos = xpos+30;
HardwareButtons[3].ypos = ypos+55;	
break;	
case 13: 
AccMeterAutoDetectDD.xpos = xpos+20;		
AccMeterAutoDetectDD.ypos = ypos+65;		
AccMeterAutoDetectModeDD.xpos = xpos+20;		
AccMeterAutoDetectModeDD.ypos = ypos+40;
break;				
case 14: 
HardwareButtons[4].xpos = xpos+30;
HardwareButtons[4].ypos = ypos+45;	
break;
case 15: 
AccMeterTapDD.xpos = xpos+20;		
AccMeterTapDD.ypos = ypos+55;	
break;		
case 16: 
PowerDownTimeOutDD.xpos = xpos+10;
PowerDownTimeOutDD.ypos = (ypos+(bHeight))-40;	
break;
case 17: 
break;	
case 18: 
break;	
case 19: 
HardwareCheckBox[1].xpos=xpos+70;	
HardwareCheckBox[1].ypos=ypos+65;	
break;	
case 20: 
PWMFreqADD.xpos=xpos+10;
PWMFreqADD.ypos=(ypos+(bHeight))-40;	
break;
case 21: 
StandAloneADD.xpos=xpos+5;	
StandAloneADD.ypos=(ypos+(bHeight))-35;			
TextFields[13].xpos=xpos+125;	
TextFields[13].ypos=(ypos+(bHeight))-35;	
break;
}	    
}public int GetBitValues(int passedID)
{switch(IDnumber)
{case 0:	
if(HardwareButtons[0].Selected && passedID == 0)  return 1;
if(HardwareCheckBox[0].Selected && passedID == 1) return 1;
break;		
case 1: 
break;		  
case 2:	
break;		  
case 3:	
break;				
case 4: 
break;	
case 5:	
break;				
case 6: 
break;			
case 7: 
if(IsOndtSTkNT("fMaster16Bit") == true) 
{switch(MasterModeDD.SelStr)
{case 0: 
return 0;
case 1: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1;
if(passedID == 2) 			return 0;
break;
case 2: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1;
if(passedID == 2) 			return 1;
break;
case 3:	
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 0;
if(passedID == 2) 			return 0;
break;	
case 4:	
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 0;
if(passedID == 2) 			return 1;
break;		
}}
else
{switch(MasterModeDD.SelStr)
{case 0: 
return 0;
case 1: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1; 
break;
case 2: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 0;
break;
}}
break;			
case 8: 
if(HardwareCheckBox[0].Selected == true) return 1;	
return 0;
case 9: 
switch(LEDIndicatorModeADD.SelStr) 
{case 0: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1;
break;
case 1: 
if(passedID == 0) 			return 0;
if(passedID == 1) 			return 1;			
break;
case 2: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 0;				
break;
case 3: 
return 0;
}break;	
case 10: 
switch(DisplayModeDD.SelStr)
{case 0: 
return 0;
case 1: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 0;
break;
case 2: 
if(passedID == 0) 			return 0;
if(passedID == 1) 			return 1;
break;
case 3: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1;
break;
}break;	
case 11: 
switch(AutoDetectDD.SelStr)
{case 0: 
return 0;
case 1: 
if(passedID == 0) 			return 1;
if(passedID == 1) 			return 1;
break;
case 2: 
if(passedID == 0) 			return 0;
if(passedID == 1) 			return 1;
break;
}break;			
case 12: 
if(HardwareButtons[3].Selected == true) return 1;
return 0;
case 13: 
if(passedID == 0) if(AccMeterAutoDetectDD.SelStr > 0) return 1;
if(passedID == 1) if(AccMeterAutoDetectModeDD.SelStr == 1) return 1;
return 0; 
case 14: 
if(HardwareButtons[4].Selected)	return 1;
return 0; 
case 15: 
if(AccMeterTapDD.SelStr > 0) return 1;
return 0; 
case 16: 
break;
case 17:
break;	
case 18:
break;	
case 19: 
if(HardwareCheckBox[1].Selected == true) return 1; 
return 0; 
case 20: 
break;
case 21: 
break;
}	  
AppendLogFile("Did not find InputModule[] to GetBitValues() from");
return 0;
} 
public int GetByteValues(int passedID)
{switch(IDnumber)
{case 0:	
break;		
case 1:
break;		  
case 2:	
return (HardwareColSwapDD.SelStr); 
case 3:	
return (PixelChipsetID[PixelChipsetDD.SelStr]); 
case 4: 
break;	
case 5:	
if(passedID == 0) 	return ((PApplet.parseInt(TextFields[2].Label) >> 8) & 0xFF); 
if(passedID == 1) 	return (PApplet.parseInt(TextFields[2].Label) & 0xFF); 
break;				
case 6: 
return DMXModesDD.SelStr;	
case 7: 
break;			
case 8: 
return BaudRateDD.SelStr; 
case 9: 
break;	
case 10: 
break;	
case 11: 
break;			
case 12: 
break;	
case 13: 
return (cAccMeterShutOffVals[AccMeterAutoDetectDD.SelStr]); 	
case 14: 
break;
case 15: 
return (AccMeterTapDD.SelStr);	
case 16: 
break;
case 17:
break;	
case 18:
break;	
case 19: 
break; 
case 20: 
break;
case 21: 
break;
}	  
AppendLogFile("Did not find InputModule[] to GetByteValues() from");
return 0;
} 
public boolean over() 
{if(Enabled == false) return false;  
if (EMCDldB >= xpos && EMCDldB <= xpos+bWidth && bJxobsd >= ypos && bJxobsd <= ypos+bHeight) 
{      
return true;
} 
else {
return false;
}}
public void PlaceTile()
{if(InputModule[IDnumber].bWidth < moduleHoldSz)
{InputModule[IDnumber].xpos = moduleHoldX;		
InputModule[IDnumber].ypos = moduleHoldY;
moduleHoldX = 0;
moduleHoldY = 0;
moduleHoldSz = 0;
}  
else if((modulePosX + InputModule[IDnumber].bWidth) < 800)	
{InputModule[IDnumber].xpos = modulePosX;		
modulePosX += (InputModule[IDnumber].bWidth+10);
InputModule[IDnumber].ypos = modulePosY;	
}else 
{if((800 - modulePosX) > moduleHoldSz)
{moduleHoldX = modulePosX;
moduleHoldY = modulePosY;
moduleHoldSz = 800 - modulePosX;		
}
modulePosY += 100;
InputModule[IDnumber].xpos = 140;
modulePosX = 140 + (InputModule[IDnumber].bWidth+10);
InputModule[IDnumber].ypos = modulePosY;	
}InputModule[IDnumber].Enabled = true;
InputModule[IDnumber].InitPositions();	  
} 
}  
public void SetSlideDataTypeBoxStates(int PassedID)
{AppendLogFile("SetSlideDataTypeBoxStates() with "+PassedID);
FrameCheckBoxes[0].Selected = false; 
FrameCheckBoxes[1].Selected = false; 
FrameCheckBoxes[2].Selected = false; 
if (PassedID != 0)	
{FrameCheckBoxes[PassedID-1].Selected = true;
FrameCheckBoxes[0].Status = 0; 
FrameCheckBoxes[1].Status = 0;
FrameCheckBoxes[2].Status = 0;	
}else
{FrameCheckBoxes[0].Status = 1; 
FrameCheckBoxes[1].Status = 1;
FrameCheckBoxes[2].Status = 1;
}} 
public void HandleSequenceModeDropDown()
{int PassedID = SequenceModeDD.SelStr+1;
AppendLogFile("HandleSequenceModeDropDown() with "+PassedID); 
if(device.BasicVersion > 0 && PassedID > 2)
{if(device.LinkedSupport == false) { SequenceModeDD.SelStr = UserSequences[AkOQmUe].SeqMode-1; return; }
else if(PassedID != 4) { SequenceModeDD.SelStr = UserSequences[AkOQmUe].SeqMode-1; return; }
}switch(PassedID)
{case EqPnOUb: 
UserSequences[AkOQmUe].SeqMode = EqPnOUb;
UpdateSequence(AkOQmUe);
break;   
case kRMfOXG: 
UserSequences[AkOQmUe].SeqMode = kRMfOXG;  
for (int x = 0; x != UserSequences[AkOQmUe].SeqFrameAmount+1;x++) 
{switch(QCZOouc)
{case 0: 
for (int i = 0; i != UserSequences[AkOQmUe].DataSize;i++)  UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
break;		
case 1: 
for (int i = 0; i < UserSequences[AkOQmUe].DataSize-2;i+=3)  
{UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
UserSequences[AkOQmUe].DataFrames[x][i+1] = UserSequences[AkOQmUe].DataFrames[x][1];
UserSequences[AkOQmUe].DataFrames[x][i+2] = UserSequences[AkOQmUe].DataFrames[x][2];
}break;
case 2: 
for (int i = 0; i < UserSequences[AkOQmUe].DataSize-3;i+=4)  
{UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
UserSequences[AkOQmUe].DataFrames[x][i+1] = UserSequences[AkOQmUe].DataFrames[x][1];
UserSequences[AkOQmUe].DataFrames[x][i+2] = UserSequences[AkOQmUe].DataFrames[x][2];
UserSequences[AkOQmUe].DataFrames[x][i+3] = UserSequences[AkOQmUe].DataFrames[x][3];
}		
break;
}	  
}UpdateSequence(AkOQmUe);
BuildGradientMenu();
break; 
case lMBafjD: 
UserSequences[AkOQmUe].SeqMode = lMBafjD;  
UserSequences[AkOQmUe].StartValues = new int[UserSequences[AkOQmUe].DataSize]; 
UpdateSequence(AkOQmUe);
break;		
case mTKKGDu: 
if(device.BasicVersion > 0) return; 
UserSequences[AkOQmUe].SeqMode = mTKKGDu; 
UpdateSequence(AkOQmUe);
break; 
case qzXknoY: 
if(device.LinkedSupport == false) return; 
if(UserSequences[AkOQmUe].SeqMode != qzXknoY)
{UserSequences[AkOQmUe].SeqFrameAmount = 1; 
UserSequences[AkOQmUe].DataFrameVar = new int[(UserSequences[AkOQmUe].SeqFrameAmount+1)]; 
UserSequences[AkOQmUe].SlideValues = new int[(UserSequences[AkOQmUe].SeqFrameAmount+1)]; 
UserSequences[AkOQmUe].SlideFlags = new int[(UserSequences[AkOQmUe].SeqFrameAmount+1)];
}	
UserSequences[AkOQmUe].SeqMode = qzXknoY;  
InitLinkedBuffer(); 
UpdateSequence(AkOQmUe);
break;
case XyiEbAJ: 
if(device.BasicVersion > 0) return; 
UserSequences[AkOQmUe].SeqMode = XyiEbAJ;    
UpdateSequence(AkOQmUe);
break;			
case xvXsTNs:
if(device.BasicVersion > 0) return; 
UserSequences[AkOQmUe].SeqMode = xvXsTNs;  
UpdateSequence(AkOQmUe);
break;	
} 
UpdateSideBarButtonStates();
}public void HandleSliders(boolean bMoveEnable)
{if(prevSliderSetNum != SliderPointer.SetNumber)	{ prevSliderSetNum = SliderPointer.SetNumber;	AppendLogFile("Dragging Set# "+SliderPointer.SetNumber); }
EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);
if (bMoveEnable == true)
{SliderPointer.move(EMCDldB, bJxobsd);
}switch(SliderPointer.SetNumber)
{case 0: 
YLWNFLV =  TimeLineScrollBar.Value;
break;
case 1: 
int holdPixelType = QCZOouc;
if(uBYXrqM == 2 && CrytrWK == 1) 
{holdPixelType = LiveConDataType;
}switch(holdPixelType)
{case 0: 
ColorSelector.slRed = 0;
ColorSelector.slGreen = 0;
ColorSelector.slBlue = 0;
ColorSelector.slWhite = ColorSelectorSliders[3].Value;
break;
case 1: 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;
ColorSelector.slWhite = 0;	
break;	
case 2: 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
break;
}	
TextFields[10].Label = ""+SliderPointer.Value; 
break;
case 2: 
break;
case 3: 
break;
case 4: 
break;      
case 5: 
break;
case 6: 
break;
case 7:
break;
case 8: 
TextFields[5].Label = ""+ControlSliders[PApplet.parseInt( TextFields[4].Label)-1].Value;
AJcBVWK = true;
break;
case 9: 
if (SliderPointer == StandaloneSliders[0])  TextFields[8].Label = ""+SliderPointer.Value;  
if (SliderPointer == StandaloneSliders[1])  TextFields[9].Label = ""+SliderPointer.Value * StandaloneSliders[2].Value;  
if (SliderPointer == StandaloneSliders[2])  TextFields[9].Label = ""+StandaloneSliders[1].Value * StandaloneSliders[2].Value;  
break;
case 10: 
break;   
case 11: 
break;   
case 12: 
break;
case 13: 
PlaceSequenceIconsMenu();
break;		
} 
} 
public void keyPressed()
{AppendLogFile("keyPressed() - "+key);	
if (emEPIOg == true)
{redraw();
if (key == ENTER || key == RETURN) 
{emEPIOg = false;
textFieldPtr.Label = textFieldPtr.Label.replaceAll("[^\\x00-\\x7f]", ""); 
textFieldPtr.Selected = false;
method(textFieldPtr.txtfCallback);
return;
}  
else if (key == BACKSPACE) 
{try {
AppendLogFile("Trying");
textFieldPtr.Label = textFieldPtr.Label.substring(0, textFieldPtr.Label.length()-1);
}catch(Exception e) { }	
redraw();
return;
}	
if(textFieldPtr.InputMethod == 0)
{if(textFieldPtr.Label.length() > textFieldPtr.maxValue) return;
if((byte)key > 0 && (byte)key < 127) textFieldPtr.Label =  ""+textFieldPtr.Label + PApplet.parseChar(key);
else AppendLogFile("KEY IGNORED"); 
redraw();
return;
}else
{if (key=='1' || key== '2' || key=='3' || key=='4' || key=='5' || key=='6' || key=='7' || key=='8' || key=='9' || key=='0' || key=='-' || (key =='.' && textFieldPtr.InputMethod == 3))
{textFieldPtr.Label =  ""+textFieldPtr.Label + PApplet.parseChar(key);
redraw();
}return;
}} 
if((key == ENTER || key == RETURN) && GraphicImageResize == true) { GraphicImageResize = false; MenuTabs[0].refresh(); redraw(); return; }
if((key == ENTER || key == RETURN) && DXcJNIU == true) { ApplyColorSelection(); redraw(); return; }
if((key == ENTER || key == RETURN) && (CrytrWK == 6 || CrytrWK == 7)) { CrytrWK = 0; redraw(); return; } 
if (key == CODED) 
{redraw();	
switch(keyCode)
{case UP:
AppendLogFile("Up on "+SliderPointer);
SliderPointer.Value--;
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);
break;
case DOWN:
AppendLogFile("Down on "+SliderPointer); 
SliderPointer.Value++;    
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);
break;
case RIGHT:
AppendLogFile("Right on "+SliderPointer);
SliderPointer.Value++;
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);  
break;
case LEFT:
AppendLogFile("Left on "+SliderPointer); 
SliderPointer.Value--;    
SliderPointer.setValue(SliderPointer.Value);
HandleSliders(false);	  
break;
}}
if (key == 's')
{SaveUserSequencesFile("saves"+File.separator+"quicksave-"+hour()+"-"+minute()+"-"+day()+"-"+month()+".txt");
NyqOxsk(3);
}if (key == ESC) 
{ 
key = 0; 
AppendLogFile("ESCAPE DISABLED");
if(iuxjTaT == true) CloseLiveControlMenu();
CrytrWK = 0; 
DXcJNIU = false; 
redraw();
}}
public void mouseMoved()
{EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);
if(uBYXrqM == 0 && UserSequences[AkOQmUe].SeqMode != qzXknoY) 
{	
if(EMCDldB >= aVMHNFe && EMCDldB <= (aVMHNFe+qxXNcNf) && bJxobsd >= 35 && bJxobsd <= (35+575)) 
{ 
redraw();
}}
if(wtoALPx == 1 )
{for (int i = 0; i != ButtonList.size(); i++) 
{ 
PointerButton = ButtonList.get(i);	
if(PointerButton.mouseOver()) redraw();  
} 
for (int i = 0; i != DropDownList.size(); i++) 
{ 
DropDownListPointer = DropDownList.get(i); 
if(DropDownListPointer.mouseOver()) redraw(); 
if(DropDownListPointer.mouseOverOpen()) redraw(); 
} 
for (int i =0; i != GradientRects.length; i++) 
{if(GradientRects[i].mouseOver()) redraw(); 
}} 
} 
public void mouseDragged()
{if(TFbtzSb == true) redraw();
if(AzUdiEH == true) redraw();
if(uBYXrqM == 0 && UserSequences[AkOQmUe].SeqMode != qzXknoY && GraphicImageResize == true) redraw();
}public void mouseReleased()
{if(AzUdiEH == true){AppendLogFile("Done dragging #:"+SliderPointer.SetNumber); prevSliderSetNum = 1000;}
if(GraphicImageResize == true && ImageDraggingState > 0) 
{ImageDraggingState = 0;
GraphicLayoutUpdateIcons(); 
}AzUdiEH = false;
TFbtzSb = false;
redraw(); 
}public void mouseWheel(MouseEvent event) 
{EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);
try {	
float e = event.getCount();
if(CrytrWK == 4) 
{if(OverlayMenus[CrytrWK].over()) 
{ 	
SequenceSelectScrollBar.setValue(PApplet.parseInt(SequenceSelectScrollBar.Value+e));
HandleSliders(false);
}return;
}else
{switch(uBYXrqM)
{case 0:	
if(EMCDldB >= osqIpiO && EMCDldB <= 800 && bJxobsd >= XuFFMGQ && bJxobsd <= XuFFMGQ+ZpIfePQ) 
{ 
if(UserSequences[AkOQmUe].SeqMode == qzXknoY) LinkedScrollBar.setValue(PApplet.parseInt(LinkedScrollBar.Value+(e)));
} 	
break;
case 1:
if(EMCDldB >= osqIpiO && EMCDldB <= 800 && bJxobsd >= XuFFMGQ && bJxobsd <= XuFFMGQ+ZpIfePQ) 
{ 
if(UserSequences[AkOQmUe].SeqMode == qzXknoY) LinkedScrollBar.setValue(PApplet.parseInt(LinkedScrollBar.Value+(e)));
else TimeLineScrollBar.setValue(PApplet.parseInt(TimeLineScrollBar.Value+(dodEQlf*(e*2))));
YLWNFLV = TimeLineScrollBar.Value;
} 
break;
case 2:	
if (EMCDldB >= 596 && EMCDldB <= 800 && bJxobsd >= gEfHGFk &&  bJxobsd <= 600) 
{      
IndexScrollBar.setValue(PApplet.parseInt(IndexScrollBar.Value+e));
} 
break;
} 
}}
catch(Exception ee) { AppendLogFile("Mousewheel ignored, would have errored"); }
redraw();
} 
public void SendMonitor()
{SendCounter++; 
SendCounterB++; 
if(device.HardwareID == 44  || (device.HardwareID == 43 && device.FirmwareRevision >= 5)) 
{	
if(SendCounter == device.CurrentBlockSize)
{AppendLogFile("Waiting for ACK, SendCounter: "+SendCounter);
SendCounter = 0;
while(OJQfYqn == false) 
{delay(1);
}OJQfYqn = false; 
AppendLogFile("ACK RECEIVED FOR PACKET# "+USBpacketCount);	
USBpacketCount++;
redraw();
}else delay(2); 
} 
else if (SendCounter >= device.EraseBlockSize)
{delay(10); 
SendCounter = 0;
}
delay(1); 
}public void SendLegacyData() 
{delay(50); 
if(device.LinkedSupport == true) SendLegacyWithLinked();
else SendLegacy();
yQKiGIj = false; 
} 
public void SendLegacyWithLinked()
{AppendLogFile("SendLegacyWithLinked()");
AppendLogFile("=========================================================================");
int LegacyMaxSequences = 32;
SequenceLength = device.BasicSeqLength;
for (int q = 1; q != UserSequences.length; q++) 
{UserSequences[q].LinkerUtilized = false;
UserSequences[q].assignedIDNum = 255;
UserSequences[q].assignedLinkedIDNum = 255;
UserSequences[q].IDassigned = false;
}int offsetVar = 0;	
for (int i = 0; i != 32; i++) 
{	 	
if(IndexMapArray[i] < 255 && UserSequences[IndexMapArray[i]].IDassigned == false)
{UserSequences[IndexMapArray[i]].LinkerUtilized = true;
UserSequences[IndexMapArray[i]].assignedIDNum = i - offsetVar;
UserSequences[IndexMapArray[i]].IDassigned = true;
} 
else if(IndexMapArray[i] < 255 && UserSequences[IndexMapArray[i]].IDassigned == true)
{	
offsetVar++;	
}else if(IndexMapArray[i] > 255) 
{offsetVar++;		
}else
{label:
for (int q = 1; q != UserSequences.length; q++)
{if(UserSequences[q].SeqMode == qzXknoY && UserSequences[q].LinkerUtilized == true)
{	
for (int yy = 0; yy != UserSequences[q].SeqFrameAmount; yy++)
{if(UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized == false && UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned == false)
{	
AppendLogFile("One yet to be linked, SoftID: "+UserSequences[q].SlideFlags[yy]+" will be "+(i - offsetVar)+" instead of "+(i));
UserSequences[UserSequences[q].SlideFlags[yy]].LinkerUtilized = true;
UserSequences[UserSequences[q].SlideFlags[yy]].assignedIDNum = i - offsetVar;
UserSequences[UserSequences[q].SlideFlags[yy]].IDassigned = true;
break label;
}	
}}	
}	
}} 
for (int q = 1; q != UserSequences.length; q++) AppendLogFile(q+" : assigned: "+UserSequences[q].assignedIDNum+" : Utilized: "+UserSequences[q].LinkerUtilized);
AppendLogFile("===================================="+SequenceLength+"=====================================");
for (int q = 1; q != UserSequences.length; q++) AppendLogFile("SoftSeq#: "+q+" - Assigned: "+UserSequences[q].assignedIDNum+" - LinkerAssiD: "+UserSequences[q].assignedLinkedIDNum);
int tempPointer = 0;
int[] tempArray = new int[32];
int tempIDnum = 0;
for (int i = 0; i != 32; i++) tempArray[i] = 255;
for (int i = 1; i != UserSequences.length; i++) 
{if(UserSequences[i].assignedIDNum == tempIDnum)
{	
tempArray[tempPointer] = i;
tempPointer++;
i = 0; 
tempIDnum++;
}}	
delay(30); 
int CalcMapStart=0; 
int qq = 0; 
int DeviceMaxFrames = PApplet.parseInt((float)((float)device.DataSpace) / (float)device.Channels); 
SendCounter = 0;
SendCounterB = 0;
int[] SlideBuild = new int[DeviceMaxFrames];
int g=0;
for(int i=0; i != SlideBuild.length;i++)  SlideBuild[i] = 127; 
for(int q=0; q != LegacyMaxSequences;q++) 
{	
try 
{	
qq = tempArray[q];	
if(qq == 255) qq = 0;
if(UserSequences[qq].SeqMode != qzXknoY) 
{	
for(int i=0; i != (UserSequences[qq].SeqFrameAmount+1);i++)   
{g++; 
} 
} 
} 
catch(Exception e)
{g++; 
}		
} 
for(int i=0; i != DeviceMaxFrames;i++)
{myPort.write(SlideBuild[i]);
SendMonitor();
}for(int i=0; i != LegacyMaxSequences;i++) 
{qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
temp = 	UserSequences[qq].Speed;
if(temp > 255) temp = 255; 
myPort.write(temp); 
}catch(Exception e)
{myPort.write(0); 
}SendMonitor();
}for(int i=0; i != LegacyMaxSequences;i++) 
{qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
if(UserSequences[qq].SeqMode == qzXknoY) myPort.write(UserSequences[qq].SeqFrameAmount); 
else myPort.write(UserSequences[qq].SeqFrameAmount); 
}catch(Exception e)
{myPort.write(0);  
}SendMonitor();
}for(int i=0; i != LegacyMaxSequences;i++)  
{qq = tempArray[i];
if(qq == 255) qq = 0;
try 
{	
if(UserSequences[qq].SeqMode == EqPnOUb || UserSequences[qq].SeqMode == kRMfOXG) myPort.write(EqPnOUb);
else myPort.write(UserSequences[qq].SeqMode);
}catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}for(int i=0; i != LegacyMaxSequences;i++)  
{qq = tempArray[i];
if(qq == 255) qq = 0;	
if(i==0) 
{myPort.write(0);
CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;		
}else if(UserSequences[qq].SeqMode == qzXknoY)  myPort.write(0);
else
{try 
{	
AppendLogFile("Cacling Map with ID: "+qq+", its "+(UserSequences[qq].SeqFrameAmount+1)+" frames.");
myPort.write(CalcMapStart);
CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;
AppendLogFile("CalcMapStart: "+CalcMapStart);
}catch(Exception e)
{myPort.write(0);	
AppendLogFile("Sequence Not Found Sent 0");
}}
SendMonitor();
}for(int q=0; q != LegacyMaxSequences;q++) 
{qq = tempArray[q];
if(qq == 255) qq = 0;	
try 
{if(UserSequences[qq].SeqMode == qzXknoY)
{AppendLogFile("qq = "+qq);
for(int i=0; i != device.Channels;i++)  
{UserSequences[qq].StartValues[i] = UserSequences[UserSequences[qq].SlideFlags[i]].assignedIDNum;			
UserSequences[qq].DataFrameVar[i] = UserSequences[qq].SlideValues[i];
AppendLogFile("assigned: "+UserSequences[qq].StartValues[i] +" : Iterations: "+UserSequences[qq].DataFrameVar[i]);
}
}}
catch(Exception e)
{}
}
for(int q=0; q != LegacyMaxSequences;q++) 
for(int i=0; i != device.Channels;i++)  
{qq = tempArray[q];
if(qq == 255) qq =0;	
try 
{myPort.write(UserSequences[qq].StartValues[i]); 		
}catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}for(int q=0; q != LegacyMaxSequences;q++) 
for(int i=0; i != device.Channels;i++)  
{qq = tempArray[q];
if(qq == 255) qq = 0;
try 
{myPort.write(UserSequences[qq].DataFrameVar[i]);
}catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}CalcMapStart=0;
for(int q=0; q != LegacyMaxSequences;q++) 
{qq = tempArray[q];
if(qq != 255) 
{if(UserSequences[qq].SeqMode != qzXknoY) 
{		
try 
{	
for(int z=0; z != (UserSequences[qq].SeqFrameAmount+1);z++)
for(int i=0; i != device.Channels;i++) 
{myPort.write(UserSequences[qq].DataFrames[z][i]);
SendMonitor();
CalcMapStart++;
}}
catch(Exception e)
{AppendLogFile("DataValue exception "+q);
}}
}		
} 
AppendLogFile("Data Values Left to Send: "+(device.DataSpace - CalcMapStart)+" and "+(device.CurrentBlockSize - (SendCounterB%device.CurrentBlockSize))+"left to match memory block"); 
CalcMapStart = (device.DataSpace - CalcMapStart) + (device.CurrentBlockSize - (SendCounterB%device.CurrentBlockSize));
for(int i=0; i != CalcMapStart;i++) 
{myPort.write(0); 
SendMonitor();
}AppendLogFile("LegacyDataWithLinked() Done");
} 
public void SendLegacy()
{AppendLogFile("SendLegacy()");
delay(20); 
int CalcMapStart=0; 
int qq = 0; 
int DeviceMaxFrames = PApplet.parseInt((float)((float)device.DataSpace) / (float)device.Channels); 
int[] SlideBuild = new int[64];
int g=0;
for(int i=0; i != 64;i++)  SlideBuild[i] = 127; 
for(int q=0; q != 8;q++) 
{	
try 
{	
qq = IndexMapArray[q];	
if(qq == 255) qq = 1;
for(int i=0; i != (UserSequences[qq].SeqFrameAmount+1);i++)   
{g++; 
} 
} 
catch(Exception e)
{g++; 
}		
} 
AppendLogFile("Slides Built "+DeviceMaxFrames);
for(int i=0; i != DeviceMaxFrames;i++)
{myPort.write(SlideBuild[i]);
SendMonitor();
}for(int i=0; i != 8;i++) 
{qq = IndexMapArray[i];
if(qq == 255) qq = 1;
try 
{	
temp = 	UserSequences[qq].Speed;
if(temp > device.MaxSpeed) temp = device.MaxSpeed; 
myPort.write(temp); 
}catch(Exception e)
{myPort.write(0); 
}SendMonitor();
}AppendLogFile("Speeds Sent");
for(int i=0; i != 8;i++) 
{qq = IndexMapArray[i];
if(qq == 255) qq = 1;
try 
{		
myPort.write(UserSequences[qq].SeqFrameAmount); 
}catch(Exception e)
{myPort.write(0);  
}SendMonitor();
}for(int i=0; i != 8;i++)  
{qq = IndexMapArray[i];
if(qq == 255) qq = 1;
try 
{	
if(UserSequences[qq].SeqMode == EqPnOUb || UserSequences[qq].SeqMode == kRMfOXG) myPort.write(EqPnOUb);
else myPort.write(lMBafjD);
}catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}for(int i=0; i != 8;i++)  
{qq = IndexMapArray[i];
if(qq == 255) qq = 1;	
if(qq==1) 
{myPort.write(0);
CalcMapStart = CalcMapStart + UserSequences[1].SeqFrameAmount+1;		
}	
else
{try 
{	
AppendLogFile("Cacling Map with "+qq+", its "+UserSequences[qq].SeqFrameAmount);
myPort.write(CalcMapStart);
CalcMapStart = CalcMapStart + UserSequences[qq].SeqFrameAmount+1;
AppendLogFile("CalcMapStart: "+CalcMapStart);
}catch(Exception e)
{myPort.write(0);	
AppendLogFile("Sequence Not Found Sent 0");
}}
SendMonitor();
}for(int q=0; q != 8;q++) 
for(int i=0; i != device.Channels;i++)  
{qq = IndexMapArray[q];
if(qq == 255) qq = 1;	
try 
{myPort.write(UserSequences[qq].StartValues[i]); 
}
catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}AppendLogFile("Start Values Sent");	
for(int q=0; q != 8;q++) 
for(int i=0; i != device.Channels;i++)  
{qq = IndexMapArray[q];
if(qq == 255) qq = 1;
try 
{myPort.write(UserSequences[qq].DataFrameVar[i]);
}catch(Exception e)
{myPort.write(0);	
}SendMonitor();
}AppendLogFile("FrameVars Sent");	
CalcMapStart=0;
for(int q=0; q != 8;q++) 
{qq = IndexMapArray[q];
if(qq == 255) qq = 1;	
try 
{	
for(int z=0; z != (UserSequences[qq].SeqFrameAmount+1);z++)
for(int i=0; i != device.Channels;i++) 
{myPort.write(UserSequences[qq].DataFrames[z][i]);
SendMonitor();
CalcMapStart++;
}}
catch(Exception e)
{AppendLogFile("DataValue exception "+q);
}} 
CalcMapStart = device.DataSpace - CalcMapStart;
AppendLogFile("Data Values Left to Send: "+CalcMapStart); 
for(int i=0; i != CalcMapStart;i++) 
{myPort.write(i); 
SendMonitor();
}AppendLogFile("LegacyData() Done");
}public void settings() 
{size(800, 600); 
}public void setup() 
{if (hSgZeBG == false) 
{gTaWjjx = height;  
rJUZtcV = width;   
insets = frame.getInsets();
sequencesImg = loadImage("sequences.png");
fullNameImg = loadImage("logo.png");
fullNameRGB = loadImage("NLED-full-rainbow-1.png");
gradientImg = loadImage("gradient-1.png");
auroraLogoImg = loadImage("aurora-logo.png");
PImage titlebaricon = loadImage("favicon.gif");
surface.setIcon(titlebaricon);
surface.setTitle("NLED Aurora Control Software - "+TATbaZv+""+cRevisionIDstr[OhKywff]+" - Northern Lights Electronic Design, LLC");
surface.setResizable(true);
noLoop();
frame.setMinimumSize(new Dimension(480, 360));
fNormal = loadFont("SansSerif.bold-48.vlw");
fDigital = loadFont("IrisUPCBold-48.vlw");
textFont(fNormal, 48);
oiHkAsJ = 1; 
IndexScrollBuffer = createGraphics(180, 800);
LinkedScrollBuffer = createGraphics(545, 470);  
SeqIconBuffer = createGraphics(140, 580); 
}ButtonList = new ArrayList<Button>();	
DropDownList = new ArrayList<DropDown>();	
FrameButtons = new Button[11]; 
for (int i =0; i != FrameButtons.length; i++) 
{FrameButtons[i] = new Button(""+(i+1), 175+(i*35), 555, 30, 30, HoBBOyq, VySlFUN, wwboXgE, true, false, true);  
}FrameButtons[lQGtaTe].Selected = true;
MenuTabs = new TabButton[5];
MenuTabs[0] = new TabButton("Graphic Layout", 130, 10, 90, 20, JCZFGSk, color(255), color(0), false, true);
MenuTabs[1] = new TabButton("Timeline", 230, 10, 90, 20, JCZFGSk, color(255),  color(0), false, true);
MenuTabs[2] = new TabButton("Connection", 330, 10, 90, 20, WcWJAym, color(255), color(0), false, true);
MenuTabs[3] = new TabButton("Software Config", 430, 10, 100, 20, JCZFGSk, color(255), color(0), false, true);
MenuTabs[4] = new TabButton("Hardware Config", 540, 10, 100, 20, JCZFGSk, color(255), color(0), false, true);
MenuTabs[uBYXrqM].Selected = true;
ToolTabs = new TabButton[4];
ToolTabs[0] = new TabButton("Sequ.", 0, 115, 60, 25, emrZzJV, DqoHydg, color(255), false, true); 
ToolTabs[1] = new TabButton("Tools", 65, 115, 60, 25, emrZzJV, DqoHydg, color(255), false, true);
ToolTabs[2] = new TabButton("Frame", 65, 85, 60, 25, emrZzJV, DqoHydg, color(255), false, true); 
ToolTabs[3] = new TabButton("Icons", 0, 85, 60, 25, emrZzJV, DqoHydg, color(255), false, true);  
ToolTabs[TDWCxom].Selected = true;
SeqCheckBoxes = new CheckBox[3];
SeqCheckBoxes[0] = new CheckBox(15, 235, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[1] = new CheckBox(55, 235, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[2] = new CheckBox(95, 235, 15, 15, color(255), color(0), color(0), false);
SeqCheckBoxes[QCZOouc].Selected = true; 
FrameCheckBoxes = new CheckBox[3];
FrameCheckBoxes[0] = new CheckBox(10, 570, 15, 15, color(255), color(0), color(0), false);
FrameCheckBoxes[1] = new CheckBox(50, 570, 15, 15, color(255), color(0), color(0), false);
FrameCheckBoxes[2] = new CheckBox(90, 570, 15, 15, color(255), color(0), color(0), false);
SetSlideDataTypeBoxStates(0);
SoftwareCheckBox = new CheckBox[3];
SoftwareCheckBox[0] = new CheckBox(760, 435, 20, 20, color(255), color(0), color(0), false); 
SoftwareCheckBox[2] = new CheckBox(760, 491, 20, 20, color(255), color(0), color(0), false);
SoftwareCheckBox[1] = new CheckBox(760, 463, 20, 20, color(255), color(0), color(0), false);
SoftwareButtons = new Button[18]; 
SoftwareButtons[0] = new Button("Save Sequence File", 620, 40, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[1] = new Button("Load Sequence File", 620, 75, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[2] = new Button("Manual", 390, 95, 70, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[3] = new Button("Load File", 405, 425, 80, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true); 
SoftwareButtons[4] = new Button("Edit User ID Text", 620, 325, 150, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[5] = new Button("Delete Sequence", 620, 290, 150, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[6] = new Button("Website", 300, 95, 70, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[7] = new Button("Duplicate Sequence", 620, 255, 150, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[8] = new Button("Load Device File", 635, 110, 130, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[9] = new Button("Clear All Sequences", 620, 160, 150, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[10] = new Button("Apply", 250, 365, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[11] = new Button("800 x 600", 10, 115, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[12] = new Button("1024 x 768", 10, 180, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[13] = new Button("1280 x 960", 10, 215, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[14] = new Button("Reset LED Icons", 550, 425, 130, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[15] = new Button("Add Layout To Group", 290, 485, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[16] = new Button("Merge Groups", 290, 520, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[17] = new Button("Clear Group", 290, 550, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SoftwareButtons[17].Status = 1; 
SoftwareButtons[16].Status = 1; 
SoftwareButtons[15].Status = 1; 
HardwareButtons = new Button[6];
HardwareButtons[0] = new Button("Enabled", 125, 470, 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
HardwareButtons[1] = new Button("Enabled", 300, 470, 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
HardwareButtons[2] = new Button("Enabled", 300, 470, 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
HardwareButtons[3] = new Button("Enabled", 255, 330, 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
HardwareButtons[4] = new Button("Enabled", 300, 470, 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true);  
HardwareCheckBox = new CheckBox[2];
HardwareCheckBox[0] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);
HardwareCheckBox[1] = new CheckBox(255, 285, 20, 20, color(255), color(0), color(0), false);
ConnectionButtons = new Button[6];
ConnectionButtons[0] = new Button("Upload Sequences & Index", 360, 560, 200, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConnectionButtons[1] = new Button("Upload Configurations", 360, 515, 200, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConnectionButtons[2] = new Button("Reset Index", 475, 90, 110, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConnectionButtons[3] = new Button("Live Control", 420, 40, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConnectionButtons[4] = new Button("Stand-Alone Control", 250, 40, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConnectionButtons[5] = new Button("Gamma Correction", 140, 375, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
POVOptionButtons  = new Button[4];
POVOptionButtons[3] = new Button("",740,85,50,50, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
POVOptionButtons[2] = new Button("", 680,85,50,50, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
POVOptionButtons[1] = new Button("", 620,85,50,50, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
POVOptionButtons[0] = new Button("", 560,85,50,50, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
POVRestart = new Button("Restart",640,565,60,25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
POVPlay = new Button("Play",710,565,50,25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
POVPause = new Button("||",765,565,25,25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
povButtonsImgs = new PImage[4]; 
povButtonsImgs[0] = loadImage("pov-button-graphic-1.png");
povButtonsImgs[1] = loadImage("pov-button-graphic-2.png");
povButtonsImgs[2] = loadImage("pov-button-graphic-3.png");
povButtonsImgs[3] = loadImage("pov-button-graphic-4.png");
POVModeDD = new DropDown(cDDPOVModeString, cDDPOVModeString.length, 0, OvprrrD+10, 110, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false);
ColorSelectorSliders = new SliderBar[4];
ColorSelectorSliders[0] = new SliderBar(1, 160, 325, 120, 10, 0, 0, 255, color(255), color(0), color(255, 0, 0), color(0), true, false, false); 
ColorSelectorSliders[1] = new SliderBar(1, 160, 345, 120, 10, 0, 0, 255, color(255), color(0), color(0, 255, 0), color(0), true, false, false); 
ColorSelectorSliders[2] = new SliderBar(1, 160, 365, 120, 10, 0, 0, 255, color(255), color(0), color(0, 0, 255), color(0), true, false, false); 
ColorSelectorSliders[3] = new SliderBar(1, 160, 385, 120, 10, 0, 0, 255, color(255), color(0), color(128), color(0), true, false, false); 
ColorSelectorApply = new  Button("Apply", 5, 5, 40, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ColorSelectorCancel = new  Button("Cancel", 5, 5, 45, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
GraphicFuncPaintButton = new  Button("Paint Tool", 10, 210, 100, 25, DYViHZj, VySlFUN, wwboXgE, true, false, true);
MainToolsAllSame = new  Button("All", 5, 260, 50, 25, DYViHZj, VySlFUN, wwboXgE, false, false, true); 
MainToolsColorGroup = new  Button("Group", 65, 260, 50, 25, DYViHZj, VySlFUN, wwboXgE, false, false, true);
MainToolsShowStartValues = new  Button("Show Color Icons", 10, 310, 100, 20, HoBBOyq, HoBBOyq, wwboXgE, true, false, true);
StartValReset = new Button("Reset Values", 10, 340, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true);  
GradientDrawRadialButton = new  Button("Radial Tool", 10, 390, 100, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
GradientDrawLinearButton  = new  Button("Linear Tool", 10, 420, 100, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
GradientGenerate = new Button("Generate", 20, 570, 80, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
PaintRects = new ColorRect[4]; 
PaintRects[0] = new ColorRect(5, 180, 25, 25, 0, 0, 0, 0, "A");	
PaintRects[1] = new ColorRect(35, 180, 25, 25, 0, 0, 0, 0, "B");	
PaintRects[2] = new ColorRect(65, 180, 25, 25, 0, 0, 0, 0, "C");	
PaintRects[3] = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "D");	
TechnicalColorStart  = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "");	
TechnicalColorEnd  = new ColorRect(95, 180, 25, 25, 0, 0, 0, 0, "");	
FrameSeqToolInsantDD = new DropDown(cDDFrameSeqInstant, cDDFrameSeqInstant.length, 0, 5, 420, 115, 25, HoBBOyq, VySlFUN, wwboXgE, false);  
FrameSeqToolTechDD = new DropDown(cDDFrameSeqTech, cDDFrameSeqTech.length, 0, 5, 420, 115, 25, HoBBOyq, VySlFUN, wwboXgE, false);  
CopyFrameButton = new Button("Copy", 5, 200, 50, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
PasteFrameButton = new Button("Paste", 65, 200, 50, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
EnableGroupMode = new  Button("Enable", 10, 270, 100, 25, DYViHZj, VySlFUN, wwboXgE, true, false, true);
MouseIconPlace = new Button("Place Icons", 5, 495, 115, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
MouseIconRemove = new Button("Remove Icons", 5, 530, 115, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
MouseIconReset = new Button("Reset Icons", 5, 565, 115, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true); 
IconToolGroupIDDec = new Button("<", 15, 360, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
IconToolGroupIDInc = new Button(">", 80, 360, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ImageHandleTR = new  Button("", 10, 335, 10, 10, color(255), VySlFUN, wwboXgE, false, false, true); 
ImageHandleTL = new  Button("", 10, 335, 10, 10, color(255), VySlFUN, wwboXgE, false, false, true); 
ImageHandleBR = new  Button("", 10, 335, 10, 10, color(255), VySlFUN, wwboXgE, false, false, true); 
ImageHandleBL = new  Button("", 10, 335, 10, 10, color(255), VySlFUN, wwboXgE, false, false, true); 
ImageHandleCenter = new  Button("", 10, 335, 20, 20, color(255), VySlFUN, wwboXgE, false, false, true); 
ObjButtonPlus  = new Button[5];
ObjButtonMinus  = new Button[5];
ObjTextField  = new TextField[5];
SequenceSpeedObject = new TextFieldObject(0,5,275,25,1,65535);
SequenceChannelObject = new TextFieldObject(1,5,380,25,1,65535);
PixelAmountObject = new TextFieldObject(2,505,485,25,1,65535);
GradientStepsObject = new TextFieldObject(3,5,535,25,-1024,1024);
GradientMultiplierObject = new TextFieldObject(4,5,470,25,0,100);
ObjTextField[4].InputMethod = 3;
ObjTextField[4].Label = ""+MultiplierToolValue/10;
LObjButtonPlus  = new Button[5];
LObjButtonMinus  = new Button[5];
LObjTextField  = new TextField[5];
LinkedTextFieldObject = new TextFieldObjectL[5]; 
for (int i = 0; i != LinkedTextFieldObject.length; i++) LinkedTextFieldObject[i] = new TextFieldObjectL(i,340,(i+1)*hwAmagv,25, 1, 65535);
TextFields = new TextField[15];
TextFields[0] = new TextField("Enter#", 35, 510, 50, 25, color(255), color(200, 40, 40), 1, 0, 255, true, false, "txtHandleSlideValue"); 
TextFields[1] = new TextField("Enter#", 225, 470, 50, 20, color(255), color(200, 40, 40),  1, 0, 100, true, false, "txtHandleGenericNumber"); 
TextFields[2] = new TextField("1", 120, 195, 80, 20, color(255), color(200, 40, 40),  1, 1, 512, true, false, "txtHandleGenericNumber"); 
TextFields[3] = new TextField("Enter Text ID", 630, 360, 130, 25, color(255), color(200, 40, 40),  0, 0, 30, true, false, "txtHandleUserIDField");
TextFields[4] = new TextField("1", 155, 50, 50, 25, color(255), color(200, 40, 40),  1, 1, 512, true, false, "txtHandleLiveControlAddress"); 
TextFields[5] = new TextField("0", 290, 50, 70, 25, color(255), color(200, 40, 40),  1, 0, 255, true, false, "txtHandleLiveControlValue"); 
TextFields[6] = new TextField("1", 25, 365, 70, 25, color(255), color(200, 40, 40),  1, 1, 65535, true, false, "txtHandleFrameSpeed");
TextFields[7] = new TextField("Enter#", 265, 145, 60, 25, color(255), color(200, 40, 40),  1, 0, XwgQulc, true, false, "txtHandleGenericNumber");
TextFields[8] = new TextField("1", 270, 200, 80, 25, color(255), color(200, 40, 40),  1, 0, 0xFFFF, true, false, "txtHandleGenericNumber"); 
TextFields[9] = new TextField("1", 305, 350, 50, 25, color(255), color(200, 40, 40),  1, 0, 0xFFFF, true, false, "txtHandleGenericNumber"); 
TextFields[10] = new TextField("", 0, 0, 50, 20, color(255), color(200, 40, 40),  1, 0, 255, true, false, "txtHandleColorPickerFields"); 
TextFields[11] = new TextField("Enter#", 175, 365, 60, 25, color(255), color(200, 40, 40),  1, 0, 512, true, false, "txtHandleuqdivtD"); 
TextFields[13] = new TextField("1", 20, 265, 25, 25, color(255), color(200, 40, 40),  1, 1, 32, true, false, "txtHandleGenericNumber");  
TextFields[14] = new TextField("100", 235, 520, 50, 25, color(255), color(200, 40, 40),  2, 0, 100, true, false, "txtHandleGenericNumber");  
TXTFSeqIntensity = new TextField("100", 70, 315, 50, 25, color(255), color(200, 40, 40), 2, 1, 100, true, false, "txtHandleSequenceIntensity");
TXTFTechTime = new TextField("65535", 70, 315, 50, 25, color(255), color(200, 40, 40), 1, 1, 0xFFFF, true, false, "txtHandleTechTime");
textFieldPtr = TXTFSeqIntensity; 
OverlayMenus = new OverlayMenu[8];
OverlayMenus[0] = new OverlayMenu(0,0,0,0,0); 
OverlayMenus[1] = new OverlayMenu(1, 10, 40, 780, 550); 
OverlayMenus[2] = new OverlayMenu(2, 10, 40, 780, 550); 
OverlayMenus[3] = new OverlayMenu(3, 10, 40, 780, 550); 
OverlayMenus[4] = new OverlayMenu(4, 70, 40, 660, 550); 
OverlayMenus[5] = new OverlayMenu(5, 10, 40, 780, 550); 
OverlayMenus[6] = new OverlayMenu(6, 100, 100, 125, 125); 
OverlayMenus[7] = new OverlayMenu(7, 100, 100, 140, 140); 
LiveControlCheckBox = new CheckBox[4];
LiveControlCheckBox[0] = new CheckBox(60, 20, 20, 20, color(255), color(0), color(0), false); 
LiveControlCheckBox[1] = new CheckBox(100, 20, 20, 20, color(255), color(0), color(0), true); 
LiveControlCheckBox[2] = new CheckBox(140, 20, 20, 20, color(255), color(0), color(0), false);	
LiveControlCheckBox[3] = new CheckBox(280, 20, 20, 20, color(255), color(0), color(0), false);	
StandAloneClose = new  Button("Close", (OverlayMenus[3].xpos+OverlayMenus[3].Width)-100, 60, 80, 25, DYViHZj, VySlFUN, wwboXgE, false, false, true);
LiveControlClose = new  Button("Close", 700, 60, 80, 25, VySlFUN, DYViHZj, wwboXgE, false, false, true);
LiveControlToggle = new  Button("Sliders/Color", 200, 60, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
SequenceSelectClose = new  Button("Close", 700, 40, 50, 25, VySlFUN, DYViHZj, wwboXgE, false, false, true);  
SequenceSelectAdd = new  Button("New Sequence", 700, 40, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);   
RadialMenuTechColorMode = new  Button[3];
RadialMenuTechColorMode[0] = new  Button("Single", 700, 60, 60, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
RadialMenuTechColorMode[1] = new  Button("RGB", 700, 40, 50, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, true);
RadialMenuTechColorMode[2] = new  Button("RGBW", 700, 40, 50, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, true); 
RadialTechSolidButton = new  Button("Solid", 700, 40, 50, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, true);   
RadialTechFadeButton = new  Button("Fade Up/Down", 700, 40, 90, 20, HoBBOyq, VySlFUN, wwboXgE, true, false, true);   
StandaloneSliders = new   SliderBar[3];
StandaloneSliders[0] = new SliderBar(9, 95, 230, 260, 16, 0, 1, 65535, color(255), color(0), JCZFGSk, color(0), true, false, false);  
StandaloneSliders[1] = new SliderBar(9, 175, 350, 120, 16, 0, 0, 1023, color(255), color(0), JCZFGSk, color(0), true, false, false); 
StandaloneSliders[2] = new SliderBar(9, 175, 380, 120, 16, 1, 1, 64, color(255), color(0), JCZFGSk, color(0), true, false, false);  
StandaloneButtons = new Button[11];
StandaloneButtons[0] = new  Button("Send", 370, 55, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[1] = new  Button("Send", 370, 130, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[2] = new  Button("Send", 370, 210, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[3] = new  Button("Step Forward", 140, 285, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[4] = new  Button("Step Backward", 280, 285, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[5] = new  Button("Send", 370, 350, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true); 
StandaloneButtons[6] = new  Button("Sequence Up", 480, 125, 140, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[7] = new  Button("Sequence Down", 480, 165, 140, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[8] = new  Button("Play/Pause", 480, 205, 140, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[9] = new  Button("Speed+1", 480, 300, 140, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneButtons[10] = new  Button("Speed-1", 480, 270, 140, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
StandaloneCheckBox = new CheckBox[2];
StandaloneCheckBox[0] = new CheckBox(190, 135, 20, 20, color(255), color(0), color(0), false);
StandaloneCheckBox[1] = new CheckBox(190, 150, 20, 20, color(255), color(0), color(0), false);
IntensityOverrideCheckBox  = new CheckBox(235, 560, 20, 20, color(255), color(0), color(0), false);
IconLayoutAdvancedMode  = new CheckBox(290, 460, 20, 20, color(255), color(0), color(0), false);
POVVideoModeCheckBox  = new CheckBox(300, 110, 20, 20, color(255), color(0), color(0), false);
AccMeterAutoDetectDD = new DropDown(cDDAccMeterShutOff, cDDAccMeterShutOff.length, 0, 420, 180, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
AccMeterAutoDetectModeDD = new DropDown(cDDAccMeterShutOffMode, cDDAccMeterShutOffMode.length, 0, 420, 180, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
AccMeterTapDD  = new DropDown(cDDAccMeterTapMode, cDDAccMeterTapMode.length, 0, 420, 180, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
LEDIndicatorModeADD = new DropDown(cDDLEDMstring, cDDLEDMstring.length, 0, 420, 180, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
LEDIndicatorModeBDD = new DropDown(cDDLEDMstring, cDDLEDMstring.length, 0, 420, 180, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
DMXModesDD = new DropDown(cNoneStr, 1, 0, 85, 280, 170, 20, HoBBOyq, VySlFUN, wwboXgE, false);
BaudRateDD = new DropDown(cDDBaudstring, cDDBaudstring.length, 0, 260, 215, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
DisplayModeDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, HoBBOyq, VySlFUN, wwboXgE, false);
DisplayModeBDD = new DropDown(cDDDisplayModes, cDDDisplayModes.length, 0, 415, 240, 120, 20, HoBBOyq, VySlFUN, wwboXgE, false);
MasterModeDD = new DropDown(cDDMasterModes8Bit, cDDMasterModes8Bit.length, 0, 90, 340, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false);
AutoDetectDD = new DropDown(cDDAutoDetectModesT1, cDDAutoDetectModesT1.length, 0, 405, 300, 120, 20, HoBBOyq, VySlFUN, wwboXgE, false);
HardwareColSwapDD = new DropDown(cGlobalColSwapStr, cGlobalColSwapStr.length, 0, 480, 470, 100, 20, HoBBOyq, VySlFUN, wwboXgE, false);
PixelChipsetDD = new DropDown(cNoneStr, cNoneStr.length, 0, 350, 470, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false); 
ShapeOptionsDD = new DropDown(cDDShapeOptions, cDDShapeOptions.length, 0, 290, 425, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false);
PowerDownTimeOutDD = new DropDown(cDDPowerTimeOut, cDDPowerTimeOut.length, 0, 405, 300, 120, 20, HoBBOyq, VySlFUN, wwboXgE, false);
SequenceModeDD = new DropDown(cDDSequenceMode, cDDSequenceMode.length, 0, 5, 185, 115, 25, HoBBOyq, VySlFUN, wwboXgE, false);
PWMFreqADD = new DropDown(cDDPWMFreqA, cDDPWMFreqA.length, 0, 5, 160, 100, 25, HoBBOyq, VySlFUN, wwboXgE, false); 
StandAloneADD = new DropDown(cDDStandAloneA, cDDStandAloneA.length, 0, 5, 160, 110, 25, HoBBOyq, VySlFUN, wwboXgE, false);
StandAloneDD = new DropDown(cColorSwapStr, cColorSwapStr.length, 0, 215, 60, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false);
SeqTransistionDD = new DropDown(cDDSeqTransistion, cDDSeqTransistion.length, 0, 5, 520, 115, 25, HoBBOyq, VySlFUN, wwboXgE, true);
PlayModeDD = new DropDown(cDDSeqPlayMode, cDDSeqPlayMode.length, 0, 5, 570, 115, 25, HoBBOyq, VySlFUN, wwboXgE, true);
PacketCloneDD = new DropDown(cDDPacketClone, cDDPacketClone.length, 0, 5, 415, 115, 25, HoBBOyq, VySlFUN, wwboXgE, true); 
DropDownPointer = new DropDown(cNoneStr, 1, 0, 405, 360, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false);
HardwarePrevIcon = new  Button("Click to\nSelect a Sequence\nPreview it on\nthe Device", 170, 220, 110, ZtBHbDg, JOHAtnJ, VySlFUN, color(255), false, false, true);
IdleSequenceIcon = new  Button("Click to\nSelect Idle\nSequence", 440, 250, 110, ZtBHbDg, JOHAtnJ, VySlFUN, color(255), false, false, true);
DMXSequenceIcon = new  Button("DMX Reception\n\nClick to Select", 300, 200, 110, ZtBHbDg, JCZFGSk, VySlFUN, color(0), false, false, true);
SerialSequenceIcon = new  Button("Serial Reception\n\nClick to Select", 300, 280, 110, ZtBHbDg, JCZFGSk, VySlFUN, color(0), false, false, true);
DeviceConnect = new Button("Connect", 60, 40, 60, 20, VySlFUN, color(0,155,0), wwboXgE, true, false, true);
POVModeButton = new Button("Load File", 330, 40, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConfirmButtonYes = new Button("Yes", 325, 325, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ConfirmButtonNo = new Button("No", 415, 325, 60, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
DeviceWebpage = new Button("Open Device Webpage", 610, 40, 180, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
RequestConfigurations = new Button("Request Configurations", 630, 160, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
HardwareTabUploadConfigurations = new Button("Upload Configurations", 480, 160, 140, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
EnterBootloaderButton = new Button("Enter Bootloader Mode", 610, 75, 180, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
OpenTCPButton = new Button("Open TCP", 30, 110, 70, 20, HoBBOyq, VySlFUN, wwboXgE, false, false, true); 
GroupIDDecf = new Button("<", 710, 565, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
GroupIDIncf = new Button(">", 765, 565, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
AddFrame = new Button("+", 650, 555, 30, 30, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
RemoveFrame = new Button("-", 610, 555, 30, 30, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
IncFrameBar = new Button(">", 560, 555, 30, 30, DYViHZj, VySlFUN, wwboXgE, false, false, true);
DecFrameBar  = new Button("<", 140, 555, 30, 30, DYViHZj, VySlFUN, wwboXgE, false, false, true);
SequenceMenuButton  = new Button("Sequences", 670, 0, 130, 35, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
LayoutGroupInc = new Button(">", 580, 545, 30, 30, DYViHZj, VySlFUN, wwboXgE, false, false, true);
LayoutGroupDec = new Button("<", 510, 545, 30, 30, DYViHZj, VySlFUN, wwboXgE, false, false, true);
ImagePlaceButton = new Button("Place Image", 140, 460, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ImageRemoveButton = new Button("Remove Image", 140, 495, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ImageResizeButton = new Button("Resize Image", 140, 530, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
ImageResetButton = new Button("Reset Position", 140, 565, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
UploadProgressCancel = new Button("Cancel", 340, 340, 120, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
GammaOverlayCloseButton = new Button("Close", 650, 70, 100, 25, DYViHZj, VySlFUN, wwboXgE, false, false, true);
GammaLoadFileButton = new Button("Load Gamma File", 405, 245, 160, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
GammaUploadButton = new Button("Upload Gamma Table", 600, 245, 180, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
GammaUploadDefaultButton = new Button("Upload Default Gamma Table", 50, 245, 240, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
FilePlayLoadButton = new Button("Load Play File", 270, 38, 120, 23, HoBBOyq, VySlFUN, wwboXgE, false, false, true);
PixelAmountObject.setStatus(1);
LayoutGroupInc.Status = 1;
LayoutGroupDec.Status = 1;
TimeLineScrollBar = new SliderBar(0, 776, XuFFMGQ, 24, ZpIfePQ, 0, 0, (oiHkAsJ*dodEQlf), color(255), VySlFUN, color(255), color(0), true, true, true);
TechnicalScrollVert = new SliderBar(2, 776, XuFFMGQ, 24, mzFoUAv, 0, 0, 10, color(255), VySlFUN, color(255), color(0), true, true, true);
TechnicalScrollHoriz = new SliderBar(3, osqIpiO+35, 520, 605, 24, 0, 0, 10, color(255), VySlFUN, color(255), color(0), true, false, true);
IndexScrollBar = new SliderBar(5, 776, 35, 24, 560, 0, 0, 2, color(255), VySlFUN, color(255), color(0), false, true, true);
LinkedScrollBar = new SliderBar(6, 776, XuFFMGQ, 24, ZpIfePQ, 0, 0, 1, color(255), VySlFUN, color(255), color(0), false, true, true);
SequenceSelectScrollBar = new SliderBar(13, 776, XuFFMGQ, 24, OverlayMenus[4].Height-70, 0, 0, 10, color(255), VySlFUN, color(255), color(0), false, true, true);
SliderPointer = new SliderBar(0, 0, 0, 0, 0, 0, 0, 0, color(255), VySlFUN, color(255), color(0), false, false, true); 
device = new DeviceObj("No Device");
GradientRects = new ColorRect[11];
for (int i =0; i != GradientRects.length; i++) 
{GradientRects[i] = new ColorRect(175+(i*35), 555, 30, 30, (int)ZhmkwyF, (int)IwpariG, (int)dyrGyHh, (int)roIonSV, ""+(i+1));
}for (int i=0; i != paletteColors.length;i++) for (int z=0; z != paletteColors[i].length;z++) paletteColors[i][z] = 0;
ColorSelector = new ColorPickerObj(100, 100, 270, 290, 0, 0, 0,0,0,0);
InputModule = new SpecHWModules[22];
InputModule[0] = new SpecHWModules(0,"Serial RS-485 Enable:\n(Disable for TTL Serial)",0, 0,140, 90,"fRS485Enable","BYTE",0);
InputModule[1] = new SpecHWModules(1,"Second Activity\nLED Mode:",0, 0,130, 90,"fLEDModeMSBb,fLEDModeLSBb","BYTE",0);
InputModule[2] = new SpecHWModules(2,"Select Correct Color Order For Chipset:",0, 0,120, 90,"CONFIG","bGlobalColorShift",210);
InputModule[3] = new SpecHWModules(3,"Select The Pixel Chipset:\n\n\nRecommended Color: varies / R>G>B",0, 0,160, 90,"CONFIG","bPixelChipset",250);
InputModule[4] = new SpecHWModules(4,"Enable Serial Reception Instead of DMX reception. Auto-Detect is disabled during serial reception.",0,0, 200, 90,"CONFIG","BYTE",0);
InputModule[5] = new SpecHWModules(5,"DMX Address:\n(Enter Number)\n\n\n(1-512)",0,0, 120, 90,"CONFIG","bDMXAdrMSB,bDMXAdrLSB",0);
InputModule[6] = new SpecHWModules(6,"DMX Reception\nMode - ID Number: "+DMXModesDD.SelStr,0,0, 180, 90,"CONFIG","bDMXModeID",190); 
InputModule[7] = new SpecHWModules(7,"DMX Master Mode:\n(Not all listed options are valid)",0,0, 160, 90,"fMasterEnable,fMasterFullPkts,fMaster16Bit","BYTE",190); 
InputModule[8] = new SpecHWModules(8,"Serial Baud Rate:\nID Number: "+BaudRateDD.SelStr,0,0, 120, 90,"f8or16Bit","bBaudRateID",200); 
InputModule[9] = new SpecHWModules(9,"Activity\nLED Mode:",0,0, 120, 90,"fLEDModeMSBa,fLEDModeLSBa","BYTE",0); 
InputModule[10] = new SpecHWModules(10,"External\nLED Display Mode:",0,0, 140, 90,"fDisModeMSBa,fDisModeLSBa","BYTE",190); 
InputModule[11] = new SpecHWModules(11,"Auto-Detect Data Control Reception:",0,0, 140, 90,"fAutoDetectID,fAutoDetect","BYTE",180); 
InputModule[12] = new SpecHWModules(12,"Enable Gamma\nCorrection:\n(See Connection tab)",0,0, 140, 90,"fGammaCorrectionEnabled","CONFIG",0); 
InputModule[13] = new SpecHWModules(13,"Accelerometer Movement Detection:",0,0, 140, 90,"fAccMeterAutoShutOff,fAccMeterAutoShutOffMode","bAccmeterTimeoutVal",210); 
InputModule[14] = new SpecHWModules(14,"Enable Accelerometer Speed Adjustment",0,0, 140, 90,"fAccMeterMovement","BYTE",0); 
InputModule[15] = new SpecHWModules(15,"Enable Accelerometer Double Tap Button Press",0,0, 140, 90,"fAccMeterDoubleTap","bAccmeterDoubleTapVal",200); 
InputModule[16] = new SpecHWModules(16,"Power Down\nTime Out",0,0, 140, 90,"fTimeOutEnabledMSB,fTimeOutEnabledLSB","BYTE",0); 
InputModule[17] = new SpecHWModules(17,"Pixel Data Packet Cloning:\n(0 is Disabled)",0,0, 120, 90,"DELETE","DELETE",0); 
InputModule[18] = new SpecHWModules(18,"Sequence Fade Transition:\n(0 is Disabled)",0,0, 120, 90,"DELETE","DELETE",0); 
InputModule[19] = new SpecHWModules(19,"Dual Communication Mode (Serial\n/WiFi/Bluetooth)",0,0, 120, 90,"fDualModeCom","BYTE",0); 
InputModule[20] = new SpecHWModules(20,"PWM Frequency:",0,0, 120, 90,"CONFIG","BYTE",180); 
InputModule[21] = new SpecHWModules(21,"Stand-Alone Mode\n& Signal Loss Mode:",0,0, 160, 90,"CONFIG","BYTE",160);
device.WebpageURL = "www.NLEDshop.com"; 
wSlKztR = "log-"+hour()+"-"+minute()+"-"+day()+"-"+month()+"-"+year()+".txt";
POVBuffer = createGraphics(560, 360);
POVBuffer.beginDraw();
POVBuffer.background(0, 0, 0, 0);
POVBuffer.endDraw();
POVImg = createGraphics(1, 1);
graphicImg = loadImage("imagelayouts"+File.separator+"default.png"); 	
PixelIcon = new LEDgraphic[wqajEny];
GraphicLayoutBuffer = createGraphics(qxXNcNf, tuCbyyd);
if(hSgZeBG == false) InitNoSequences();
hSgZeBG = true; 
AppendLogFile("====Starting Software Version "+TATbaZv+" Revision "+OhKywff+"====");
thread("CheckForUpdate");	
InitNoSequences();
InitCOMButtons();
LoadConfigFile(); 
}public void CheckForUpdate()
{try {
String VersionCheckFile[] = loadStrings("http://www.nledshop.com/nledaurora/auroraversion2.txt");
String[] WorkString  = new String[3];
WorkString = split(VersionCheckFile[0], '\t');
if(PApplet.parseInt(WorkString[1]) > TATbaZv || PApplet.parseInt(WorkString[2]) > OhKywff)
{AppendLogFile("Software out of date");
NyqOxsk(23);
}else AppendLogFile("Software up to date");
}catch(Exception e)
{AppendLogFile("Unable to Check for Software Updates");
}} 
public void TryLastCOMPort()
{AppendLogFile("TryLastCOMPort()");
InitCOMButtons();
for (int x =0; x != Serial.list().length; x++) 
{if(baRtlHT.equals(Serial.list()[x]))
{		
AppendLogFile("This ran, but shouldn't during setup()");	
OpenCOMPort(baRtlHT);
}}	
} 
public void InitCOMButtons()
{AppendLogFile("InitCOMButtons() "+Serial.list().length);
try {
if(COMButtons.length != Serial.list().length) 
{redraw();
}}
catch(Exception e) {  }
try 
{COMButtons = new Button[Serial.list().length];  
String[] COMPortNames = new String[Serial.list().length];
int varStart = 0;
int varEnd = 0;
for (int i=0; i != Serial.list().length;i++)
{if (Serial.list()[i].length() > 7) 
{ 
varStart = Serial.list()[i].length() - 7; 
varEnd =  Serial.list()[i].length();
}else 
{ 
varStart = 0; 
varEnd = Serial.list()[i].length();
}COMPortNames[i] = Serial.list()[i].substring(varStart, varEnd);
COMButtons[i] = new Button(COMPortNames[i], 25, 190+(i*30), 80, 25, HoBBOyq, VySlFUN, wwboXgE, true, false, false);
if(Serial.list()[i].indexOf("cu") > 0) COMButtons[i].Status = 1; 
} 
}catch(Exception e) {AppendLogFile("Exception in InitCOMButtons()"); }	
}	
public void mousePressed()
{if(myMousePressed()) redraw();
else { 
AppendLogFile("Click returned false");
if(XEfHstU == true) { DropDownPointer.Selected = false;XEfHstU = false; }
}}
public boolean myMousePressed()
{EMCDldB = round((float)mouseX / gwFwycD);
bJxobsd = round((float)mouseY / gwFwycD);
if(NyqOxsk > 0)
{if(NyqOxskMinFlag == true) { NyqOxsk = 0; NyqOxskMinFlag = false; }
return true;
}if(pressHandlerConfirmBox() == true) return true;
if (mouseButton == RIGHT)
{pressHandlerRightClick(); 
return false;
} 
if(textFieldPtr.Selected == true) 
{textFieldPtr.Selected = false; 
textFieldPtr.Label = wnluxLL;
redraw();
}	
if (DXcJNIU == true) 
{if(pressHandlerDXcJNIU() == true) return true; 
}	
if(UploadProgressCancel.over() && yQKiGIj == true)
{yQKiGIj = false;
WQDHyMM = true;
NyqOxsk(21); 
return true;
}	
if(CrytrWK > 0)
{OverlayMenus[CrytrWK].mousePressed(); 
return true;
}if(DeviceConnect.over()) 
{DeviceConnect.Selected = false; 
TryLastCOMPort();	
}if(pressHandlerMenuTabs() == true) return true; 
if (uBYXrqM == 0 || uBYXrqM == 1)
{	
if(pressHandlerFrameButtonOptions() == true) return true; 
for(int i = 0; i != ToolTabs.length;i++)
{if(ToolTabs[i].Selected == false && ToolTabs[i].over())
{ToolTabs[TDWCxom].Selected = false; 
TDWCxom = i; 
EnableGroupMode.Selected = false;	
return true;
}}
switch(TDWCxom)
{case 0: 
if (SequenceModeDD.over()) return true;
else if(SequenceModeDD.overOpen()) 
{HandleSequenceModeDropDown();
return true;
}	
if (PacketCloneDD.over()) return true;
else if(PacketCloneDD.overOpen()) 
{UserSequences[AkOQmUe].PacketCloneMode = PacketCloneDD.SelStr;
MenuTabs[0].refresh(); 
return true;
}	
if (SeqTransistionDD.over()) return true;
else if(SeqTransistionDD.overOpen()) 
{UserSequences[AkOQmUe].SeqTransitionFlags = SeqTransistionDD.SelStr;
return true;
}if (PlayModeDD.over()) return true;
else if(PlayModeDD.overOpen()) 
{UserSequences[AkOQmUe].SeqPlayMode = PlayModeDD.SelStr;
return true;
}if(TXTFSeqIntensity.over())
{TXTFSeqIntensity.SelectField();	
return true;
}			
for (int i =0; i != SeqCheckBoxes.length; i++)
{if (SeqCheckBoxes[i].overB())
{AppendLogFile("SeqCheckBox "+i+" pressed"); 
if(UserSequences[AkOQmUe].DataType != i)
{UserSequences[AkOQmUe].DataType = i;
UpdateSequence(AkOQmUe);
UpdateSideBarButtonStates();
}return true;
}}	
if(SequenceSpeedObject.over() > 0)
{AppendLogFile("SequenceSpeedObject "+SequenceSpeedObject.over());
switch(SequenceSpeedObject.over())
{case 1: 
if(UserSequences[AkOQmUe].Speed > 1) UserSequences[AkOQmUe].Speed--;
ObjTextField[SequenceSpeedObject.ObjID].Label = ""+UserSequences[AkOQmUe].Speed;
break;
case 2: 
if(UserSequences[AkOQmUe].Speed < device.MaxSpeed) UserSequences[AkOQmUe].Speed++;
ObjTextField[SequenceSpeedObject.ObjID].Label = ""+UserSequences[AkOQmUe].Speed;
break;
case 3:
ObjTextField[SequenceSpeedObject.ObjID].SelectField();
break;
} 
return true;
} 
if(SequenceChannelObject.over() > 0)
{AppendLogFile("SequenceChannelObject "+SequenceChannelObject.over());
switch(SequenceChannelObject.over())
{case 1:
if(UserSequences[AkOQmUe].DataSize > 1) UserSequences[AkOQmUe].DataSize--;
ObjTextField[SequenceChannelObject.ObjID].Label = ""+UserSequences[AkOQmUe].DataSize;
UpdateSequence(AkOQmUe);
break;
case 2:
if(UserSequences[AkOQmUe].DataSize < device.Channels) UserSequences[AkOQmUe].DataSize++;
ObjTextField[SequenceChannelObject.ObjID].Label = ""+UserSequences[AkOQmUe].DataSize;
UpdateSequence(AkOQmUe);
break;
case 3:
ObjTextField[SequenceChannelObject.ObjID].SelectField();
break;
} 
return true;
} 
break;
case 1: 
if(pressHandlerToolsMenu() == true) return true;
break;
case 2: 
if(pressHandlerFrameTools() == true) return true;
if(CopyFrameButton.over() && EnableGroupMode.Selected == false)
{NyqOxsk(10); 
CopyBuffer = expand(CopyBuffer, UserSequences[AkOQmUe].DataSize); 
arrayCopy(UserSequences[AkOQmUe].DataFrames[lQGtaTe], CopyBuffer, UserSequences[AkOQmUe].DataSize); 
return true;
}else if(PasteFrameButton.over() && EnableGroupMode.Selected == false)
{arrayCopy(CopyBuffer, UserSequences[AkOQmUe].DataFrames[lQGtaTe], uqdivtD); 
MenuTabs[0].refresh();
MenuTabs[1].refresh();
return true;
}	
break;		
case 3: 
if(IconToolGroupIDDec.over())
{if(vXzCEzG == 0) vXzCEzG = 7;
else vXzCEzG--;
return true;
}if(IconToolGroupIDInc.over())
{if(vXzCEzG == 7) vXzCEzG = 0;
else vXzCEzG++;
return true;
}if(EnableGroupMode.over())
{return true;
}	
if(MouseIconPlace.over()) { MouseIconRemove.Selected = false; return true; }
if(MouseIconRemove.over()) { MouseIconPlace.Selected = false; return true; }
if(MouseIconReset.over()) {  ResetLEDIcons(); return true; }
break;
} 
if(SequenceMenuButton.over())
{AppendLogFile("Open Sequence Overlay Menu");
InitializeSequenceSelect(0, 0);
return true;
}	
} 
switch(uBYXrqM) 
{case 0: 
if (UserSequences[AkOQmUe].SeqMode == qzXknoY)
{if(pressHandlerLinkedBuffer() == true) return true;
return true;
}if(GradientDrawState > 0) 
{if(EMCDldB >= aVMHNFe && EMCDldB <= (aVMHNFe+qxXNcNf) && bJxobsd >= gEfHGFk && bJxobsd <= (gEfHGFk+575)) 
{      	
if(GradientDrawInit == false) 
{GradientDrawStartX = EMCDldB; 
GradientDrawStartY = bJxobsd;
GradientDrawInit = true;
}else
{GradientDrawInit = false;
GradientDrawEndX = EMCDldB; 
GradientDrawEndY = bJxobsd;
if(GradientDrawState == 1)	GenerateRadialGradient();
else if(GradientDrawState == 2)	GenerateLinearGradient();	
}return true; 
} 
} 
if(GraphicImageResize == true)
{GraphicImageInitX = EMCDldB;
GraphicImageInitY = bJxobsd;
if(ImageHandleTL.overGLBuf()) 
{AppendLogFile("ImageHandleTL 1");
ImageHandleTL.displayGLBuf();
ImageDraggingState = 1;	
}if(ImageHandleTR.overGLBuf()) 
{AppendLogFile("ImageHandleTR 2");
ImageHandleTR.displayGLBuf();
ImageDraggingState = 2;			
}		
if(ImageHandleBR.overGLBuf())
{AppendLogFile("ImageHandleBR 3");
ImageHandleBR.displayGLBuf();
ImageDraggingState = 3;		
}		
if(ImageHandleBL.overGLBuf()) 
{AppendLogFile("ImageHandleBL 4");
ImageHandleBL.displayGLBuf();
ImageDraggingState = 4;	
}if(ImageHandleCenter.overGLBuf()) 
{AppendLogFile("ImageHandleCenter 5");
ImageHandleCenter.displayGLBuf();
ImageDraggingState = 5;	
}	
return true;			
} 
if(UserSequences[AkOQmUe].SlideFlags[lQGtaTe] == 0 && GradientDrawState == 0 && bJxobsd > gEfHGFk && UserSequences[AkOQmUe].SeqMode != qzXknoY)
{for (int i = 0; i != nRudTeq; i++)
{try {
if (PixelIcon[i].over() && PixelIcon[i].GroupID == gdHgLUO)
{AppendLogFile("LEDIcon Pressed: "+i);	
if(MouseIconRemove.Selected == true)
{AppendLogFile("PixelIcon "+i+" right clicked");
SDdpJto = i;
PixelIcon[i].GroupID = zIQLTNT;
GraphicLayoutUpdateIcons();	
return true;
} 
else if(EnableGroupMode.Selected == true)
{AppendLogFile("Attempting to assign Group ID");	
PixelIcon[i].GroupID = (byte)vXzCEzG;
GraphicLayoutUpdateIcons();
return true;
}	
else if(GraphicFuncPaintButton.Selected == true)
{switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i] = oxBdCTX[3];
break;
case 1: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya] = oxBdCTX[0];
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya+1] = oxBdCTX[1];
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya+2] = oxBdCTX[2];
break;
case 2: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya] = oxBdCTX[0];
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya+1] = oxBdCTX[1];
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya+2] = oxBdCTX[2];
UserSequences[AkOQmUe].DataFrames[lQGtaTe][i * ByoKxya+3] = oxBdCTX[3];
break;
}MenuTabs[1].refresh();	
}															
else
{AppendLogFile("USED "+i+" and "+PixelIcon[i].ChanID);
ATLudLs = PixelIcon[i].ChanID;
ColorSelector.InitPosition(0,PixelIcon[i].ChanID,lQGtaTe);
}return true;
} 
}catch(Exception e)
{break;		
} 
} 
if(fdJgaNC == 6 && MouseIconPlace.Selected == true) 
{	
AppendLogFile("Building Icon with naJDfWm: "+naJDfWm+" : "+oiHkAsJ);
TempnaJDfWm = naJDfWm; 
for (int i = 0; i != naJDfWm; i++) if(PixelIcon[i].GroupID == zIQLTNT) { TempnaJDfWm = i; break; }
if(TempnaJDfWm >= oiHkAsJ) break; 
if(EMCDldB < AqFFYoX || bJxobsd < gEfHGFk || bJxobsd > (gEfHGFk+tuCbyyd)) break;
CalMNxHTMd();
PixelIcon[TempnaJDfWm] = new LEDgraphic(TempnaJDfWm, EMCDldB-AqFFYoX, bJxobsd-gEfHGFk, LEDSize);
redraw();
MenuTabs[0].refresh();
PixelIcon[TempnaJDfWm].GroupID = (byte)gdHgLUO;
if(TempnaJDfWm == naJDfWm)
{nRudTeq++; 
naJDfWm++;
}		
} 
} 
break;
case 1: 
if (UserSequences[AkOQmUe].SeqMode == qzXknoY) 
{if(pressHandlerLinkedBuffer() == true) return true;
}else if(UserSequences[AkOQmUe].SeqMode == XyiEbAJ) 
{		
if (POVModeDD.over()) return true;
else if(POVModeDD.overOpen()) 
{AppendLogFile("Pressed POVModeDD DropDown "+POVModeDD.SelStr);				
UserSequences[AkOQmUe].POVUsageMode = POVModeDD.SelStr;
return true;
}if(POVModeButton.over())
{AppendLogFile("Pressed Open Image File Button");
FileBrowserAction = 4; 
selectInput("Select an Image or MOV/AVI file to load:", "fileSelected");
return true;
}			
if(POVPlay.over())
{AppendLogFile("POVPlay Pressed");
loop();
frameRate(30);
PlayVideoFlag = true;
return true;
}if(POVPause.over())
{AppendLogFile("POVPause Pressed");
PlayVideoFlag = false;
return true;
}			
if(POVRestart.over())
{AppendLogFile("POVRestart Pressed");		
PlayVideoFlag = false;
POVVidFrame = 0; 
MovieFrameCount = 0;
DrawPOVBuffer(); 
POVVidFrame+=(UserSequences[AkOQmUe].SeqFrameAmount+1);
return true;
}			
for (int i =0; i != POVOptionButtons.length; i++)
{if(POVOptionButtons[i].overB())
{POVOptionButtons[UserSequences[AkOQmUe].POVConfigType].Selected = false;
UserSequences[AkOQmUe].POVConfigType = i;
POVOptionButtons[UserSequences[AkOQmUe].POVConfigType].Selected = true;
UserSequences[AkOQmUe].POVConfigType = i;
AppendLogFile("POVConfigType Changed: "+POVGraphicBuffer.width+" : "+POVGraphicBuffer.height);
if(UserSequences[AkOQmUe].POVVideoMode == true) { NyqOxsk(27); return true; }
try {
if(!CheckPOVFileDimensions(POVGraphicBuffer.width, POVGraphicBuffer.height)) return true;
LoadPOVFile();
}catch(Exception e) {
AppendLogFile("LoadPOVFile() caused error, data may be null"); 
POVImg = POVGraphicBuffer;
LoadPOVFile();
}return true;
}}
return false;
} 
else if(UserSequences[AkOQmUe].SeqMode  == mTKKGDu)
{if (TechnicalScrollVert.over() && uBYXrqM == 1 && DXcJNIU == false) { TechnicalScrollVert.selectSlider(); return true; }
if (TechnicalScrollHoriz.over() && uBYXrqM == 1 && DXcJNIU == false) { TechnicalScrollHoriz.selectSlider(); return true; }
int currentOffset = 0;
int tempPxLength = 0;
for(int i = 0; i != oiHkAsJ; i++)
{if (EMCDldB >= 130 && EMCDldB <= 260)
{	
if (bJxobsd >= 65+(i*dodEQlf) && bJxobsd <= 65+(i*dodEQlf)+dodEQlf) 
{      
AppendLogFile("Clicked Technical Select: "+i);
InitTechnicalChannelRadial(i);
return true;	
} 
}	
} 
for(int i = 0; i != oiHkAsJ; i++)
{currentOffset = 0;	
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{	
tempPxLength = (UserSequences[AkOQmUe].TechTime[q][i] / 10)+10;
if (EMCDldB >= 260+currentOffset && EMCDldB <= 260+currentOffset+tempPxLength)
{	
if (bJxobsd >= 65+(i*dodEQlf) && bJxobsd <= 65+(i*dodEQlf)+dodEQlf) 
{      
AppendLogFile("Clicked Technical Cell "+i+"   "+q);
SetlQGtaTe(q);
InitTechnicalSelectRadial(i, q);
return true;	
} 
}currentOffset += tempPxLength;
}}
return false;
} 
else if(UserSequences[AkOQmUe].SeqMode  == xvXsTNs)
{if(FilePlayLoadButton.over())
{FileBrowserAction = 8; 
selectInput("Select a File To Play:", "fileSelected");	
return true;
}		
return false; 
} 
try {
if(UserSequences[AkOQmUe].SeqMode != XyiEbAJ && UserSequences[AkOQmUe].SeqMode != qzXknoY)
{		
if (TimeLineScrollBar.over() && uBYXrqM == 1 && DXcJNIU == false)  TimeLineScrollBar.selectSlider();
if(EMCDldB >= osqIpiO && EMCDldB <= (osqIpiO+sGOqkUb) && bJxobsd >= 35 && bJxobsd <= (XuFFMGQ+ZpIfePQ))
{	
if(UserSequences[AkOQmUe].SeqMode != xvXsTNs)
{if(bJxobsd >= XuFFMGQ && bJxobsd <= (XuFFMGQ+ZpIfePQ))
{for (int i =0; i != TLStartIndicators.length; i++)
{	
if (TLStartIndicators[i].over() && bJxobsd < (XuFFMGQ+ZpIfePQ))   
{AppendLogFile("Indicator: "+i);
TFbtzSb = true;
FqANxaN = i;
return true;
}}
}for (int i =0; i != TimeLineFrameButtons.length; i++) 
{if(TimeLineFrameButtons[i].over())
{AppendLogFile("TimeLineFrameButtons: "+i);
SetlQGtaTe(i);
return true;
}}
}for (int i =0; i != oiHkAsJ; i++) 
{for (int q =0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1); q++) 
{	
if(EMCDldB >= osqIpiO+35+(q*TimeLineCellSize) && EMCDldB <= osqIpiO+35+((q+1)*TimeLineCellSize))
{if(bJxobsd >= (XuFFMGQ+(i*dodEQlf))-YLWNFLV && bJxobsd <= (XuFFMGQ+((i+1)*dodEQlf))-YLWNFLV && bJxobsd < (ZpIfePQ+XuFFMGQ) && bJxobsd > XuFFMGQ)
{				
AppendLogFile("Selected Cell, Frame: "+q+"   ColorChannel: "+i);								
SetlQGtaTe(q+UkmBkwh);
ATLudLs = i;
ColorSelector.InitPosition(0,i,q);	
return true;					
}}
} 
}}
}	
} 
catch(Exception e) 
{ 
AppendLogFile("Exception, buttons not yet created");
}   
try {
if(UserSequences[AkOQmUe].SeqMode != XyiEbAJ && UserSequences[AkOQmUe].SeqMode != qzXknoY)
{	
for (int i =0; i != TimeLineLabelButtons.length; i++)
{if(TimeLineLabelButtons[i].overTL() && bJxobsd < (ZpIfePQ+XuFFMGQ) && bJxobsd > XuFFMGQ)
{AppendLogFile("Clicked TimeLineLabelButtons "+i);
ATLudLs = i;
ColorSelector.InitPosition(0,i,lQGtaTe);
return true;
}}
}}
catch(Exception e) 
{ 
AppendLogFile("Exception, TL Label buttons not yet created");
} 
break;
case 2: 
if (IndexScrollBar.over())  IndexScrollBar.selectSlider();
for (int i =0; i != ConnectionButtons.length; i++)
{if (ConnectionButtons[i].over() && device.HardwareID != 0)
{		
switch(i)
{case 0: 
gQWmajl = 1; 
break;
case 1: 
gQWmajl = 12; 
break;
case 2:  
gQWmajl = 4; 
break;
case 3:  
CrytrWK = 1;
OpenLiveControlMenu(); 
break;
case 4:  
CrytrWK = 3;
break;
case 5:  
CrytrWK = 5;
break;						
}  
return true;
}}
if (TextFields[14].over()) { TextFields[14].SelectField(); return true; }	
if(IntensityOverrideCheckBox.over())  return true;
if(IdleSequenceIcon.over())
{AppendLogFile("IdleSequenceIcon Selected");
InitializeSequenceSelect(2, 0); 
return true;
}if(HardwarePrevIcon.over())
{AppendLogFile("HardwarePrevIcon Selected");
InitializeSequenceSelect(3, 0); 
return true;
}			
if (EMCDldB >= (60+596) && EMCDldB <= (60+596+fSAlYpX) && bJxobsd >= gEfHGFk+((5+((IndexMapPointer+1)*GDlXxCI))-(IndexScrollBar.Value*GDlXxCI)) &&  bJxobsd <= (gEfHGFk+ZtBHbDg)+((5+((IndexMapPointer+1)*GDlXxCI))-(IndexScrollBar.Value*GDlXxCI)))     
{AppendLogFile("Add Sequence Icon Selected");
InitializeSequenceSelect(4,0);
return true;
}				
else
{for (int i = 0; i != 7; i++) 
{ 
if(i >= (IndexMapPointer+1)) break;
if (EMCDldB >= (60+596) && EMCDldB <= (60+596+fSAlYpX) && bJxobsd >= gEfHGFk+(5+(i*GDlXxCI)) &&  bJxobsd <= (gEfHGFk+ZtBHbDg)+((5+(i*GDlXxCI))))     
{AppendLogFile("Sequence Icon Selected Index ID: "+i+" with "+IndexScrollBar.Value+" = "+(i+IndexScrollBar.Value));
if(i==0 && IndexMapPointer == 0) InitializeSequenceSelect(4,0);
else InitializeSequenceSelect(5,(i+IndexScrollBar.Value));
return true;
}				
}}
break; 
case 3: 
if (ShapeOptionsDD.over()) return true;
else if(ShapeOptionsDD.overOpen()) 
{AppendLogFile("Pressed ShapeOptionsDD DropDown "+ShapeOptionsDD.SelStr);	
if(fdJgaNC != (ShapeOptionsDD.SelStr+1) && IconLayoutAdvancedMode.Selected == false) 
{fdJgaNC = (ShapeOptionsDD.SelStr+1);
MenuTabs[0].refresh();
}
else fdJgaNC = (ShapeOptionsDD.SelStr+1);
return true;
} 
for (int i =0; i != SoftwareCheckBox.length; i++)
{if(SoftwareCheckBox[i].over())
{AppendLogFile("SoftwareCheckBox["+i+"] clicked");
LEDSizeID = i; 
SetLEDSizeCheckBoxes();
CalMNxHTMd(); 
for (int q=0; q != PixelIcon.length;q++)	
{try 
{	
PixelIcon[q].bSize = LEDSize; 
}catch(Exception e) 
{ 
}
}			
MenuTabs[0].refresh();	
return true;
} 
} 
for (int i =0; i != SoftwareButtons.length; i++)
{if (SoftwareButtons[i].over())
{AppendLogFile("Pressed: "+i);
switch(i)
{case 0:
FileBrowserAction = 2; 
selectOutput("Select a file to Save:", "fileSelected");
break;
case 1:
FileBrowserAction = 1; 
selectInput("Select a file to Load:", "fileSelected");
break;  
case 2:
launch(sketchPath("README.TXT"));
break;
case 3: 
if((ShapeOptionsDD.SelStr+1) != 5) return true; 
FileBrowserAction = 6;
AppendLogFile("Pressed Load Pixel Map Button");
selectInput("Select a Pixel Map file to load:", "fileSelected");	
break;  
case 4: 
InitializeSequenceSelect(8,0);
break;
case 5: 
InitializeSequenceSelect(7,0);					
break;
case 6:
link("http://www.NLEDshop.com/nledaurora");
break;
case 7: 
InitializeSequenceSelect(6,0);
break;
case 8: 
selectInput("Select a Device file to Load:", "fileSelected");
FileBrowserAction = 3; 
break;
case 9: 
gQWmajl = 3;
break;	
case 10: 
if(PApplet.parseInt(TextFields[11].Label) == 0) return true;
gQWmajl = 5;
break;						
case 11: 
surface.setSize(800, 600);							
break;						
case 12: 
surface.setSize(1024, 768);
break;		
case 13: 
surface.setSize(1280, 960);					
break;	
case 14: 
ResetLEDIcons();
break;	
case 15: 
gQWmajl = 13;
break;					
case 16: 
gQWmajl = 14;
break;	
case 17: 
gQWmajl = 15;
break;	
}return true;
} 
} 
if(PixelAmountObject.over() > 0)
{AppendLogFile("PixelAmountObject "+PixelAmountObject.over());
switch(PixelAmountObject.over())
{case 1:
if(PixelIconAmount > 1) PixelIconAmount--;
ObjTextField[PixelAmountObject.ObjID].Label = ""+PixelIconAmount;
break;
case 2:
if(PixelIconAmount < 0xFFFF) PixelIconAmount++;	
ObjTextField[PixelAmountObject.ObjID].Label = ""+PixelIconAmount;
break;
case 3:
ObjTextField[PixelAmountObject.ObjID].SelectField();
break;
} 
return true;
} 
if(IconLayoutAdvancedMode.over())
{naJDfWm = 0; 
nRudTeq = 0;
if(IconLayoutAdvancedMode.Selected == true)
{PixelIcon = new LEDgraphic[wqajEny]; 
SoftwareButtons[17].Status = 0; 
SoftwareButtons[16].Status = 0; 
SoftwareButtons[15].Status = 0; 
PixelAmountObject.setStatus(0);
LayoutGroupInc.Status = 0;
LayoutGroupDec.Status = 0;				
}else
{SoftwareButtons[17].Status = 1; 
SoftwareButtons[16].Status = 1; 
SoftwareButtons[15].Status = 1; 
PixelAmountObject.setStatus(1);
LayoutGroupInc.Status = 1;
LayoutGroupDec.Status = 1;				
GraphicLayoutBuild(0); 
}return true;
} 
if(LayoutGroupDec.over())
{if(vXzCEzG == 0) vXzCEzG = 7;
else vXzCEzG--;
return true;
}if(LayoutGroupInc.over())
{	
if(vXzCEzG == 7) vXzCEzG = 0;
else vXzCEzG++;
return true;
}		
if (ImagePlaceButton.over())
{selectInput("Select an image file to Load:", "fileSelected");
FileBrowserAction = 5; 
return true;		
}				
if (ImageRemoveButton.over())
{GraphicImageEnabled = false;
GraphicImageResize = false;
MenuTabs[0].refresh();
return true;
}if (ImageResizeButton.over() && GraphicImageEnabled == true)
{GraphicImageResize =! GraphicImageResize;
MenuTabs[uBYXrqM].Selected = false;  
uBYXrqM = 0;
MenuTabs[0].Selected = true;
MenuTabs[0].refresh();
return true;
}if (ImageResetButton.over())
{GraphicImageY = 0;
GraphicImageX = 0;
GraphicLayoutUpdateIcons();
return true;
}if (TextFields[1].over()) { TextFields[1].SelectField(); return true; }
if (TextFields[11].over()) { TextFields[11].SelectField(); return true; }
break;    
case 4: 
if(DeviceWebpage.over())
{link(device.WebpageURL);	
return true;	
}if(RequestConfigurations.over())
{gQWmajl = 19;
return true;
}		
if(EnterBootloaderButton.over())
{gQWmajl = 9;
return true;
}		
if(OpenTCPButton.over())
{thread("OpenTCP");
return true;
}		
if(HardwareTabUploadConfigurations.over())
{gQWmajl = 12; 
return true;
}	
for (int i =0; i != COMButtons.length; i++)
{if(COMButtons[i].Selected == true && COMButtons[i].overB())
{CloseCOMPort();	
return true;	
}else if(COMButtons[i].Selected == false && COMButtons[i].over())
{try
{OpenCOMPort(Serial.list()[i]);
}catch(Exception e)
{AppendLogFile("Port Stopped");
CloseCOMPort();
}return true;	
}	
}if (HardwareColSwapDD.over() && InputModule[2].Enabled == true) return true;
else if(HardwareColSwapDD.overOpen()) 
{AppendLogFile("Pressed HardwareColSwapDD DropDown "+HardwareColSwapDD.SelStr);
return true;
}		
if (PixelChipsetDD.over() && InputModule[3].Enabled == true) return true;
else if(PixelChipsetDD.overOpen()) 
{AppendLogFile("Pressed PixelChipsetDD DropDown "+PixelChipsetDD.SelStr);
FuncRecommendColorShift();
return true;
}	
if (LEDIndicatorModeADD.over() && InputModule[9].Enabled == true) return true;
else if(LEDIndicatorModeADD.overOpen()) 
{AppendLogFile("Pressed LEDIndicatorModeADD DropDown "+LEDIndicatorModeADD.SelStr);
return true;
}		
if (LEDIndicatorModeBDD.over() && InputModule[1].Enabled == true) return true;
else if(LEDIndicatorModeBDD.overOpen()) 
{AppendLogFile("Pressed LEDIndicatorModeBDD DropDown "+LEDIndicatorModeBDD.SelStr);
return true;
}		
if (DisplayModeDD.over() && InputModule[10].Enabled == true) return true;
else if(DisplayModeDD.overOpen()) 
{AppendLogFile("Pressed DisplayModeDD DropDown "+DisplayModeDD.SelStr);
return true;
}		
if (MasterModeDD.over() && InputModule[7].Enabled == true) return true;
else if(MasterModeDD.overOpen()) 
{AppendLogFile("Pressed MasterModeDD DropDown "+MasterModeDD.SelStr);
return true;
}		
if (AutoDetectDD.over() && InputModule[11].Enabled == true) return true;
else if(AutoDetectDD.overOpen()) 
{AppendLogFile("Pressed AutoDetectDD DropDown "+AutoDetectDD.SelStr);
return true;
}		
if (BaudRateDD.over() && InputModule[8].Enabled == true) return true;
else if(BaudRateDD.overOpen()) 
{AppendLogFile("Pressed BaudRateDD DropDown "+BaudRateDD.SelStr);
return true;
}		
if (DMXModesDD.over() && InputModule[6].Enabled == true) return true;
else if(DMXModesDD.overOpen()) 
{AppendLogFile("Pressed DMXModesDD DropDown "+DMXModesDD.SelStr);
return true;
}	
if (AccMeterAutoDetectDD.over() && InputModule[14].Enabled == true) return true;
else if(AccMeterAutoDetectDD.overOpen()) 
{AppendLogFile("Pressed AccMeterAutoDetectDD DropDown "+AccMeterAutoDetectDD.SelStr);
return true;
}if (AccMeterAutoDetectModeDD.over() && InputModule[14].Enabled == true) return true;
else if(AccMeterAutoDetectModeDD.overOpen()) 
{AppendLogFile("Pressed AccMeterAutoDetectModeDD DropDown "+AccMeterAutoDetectModeDD.SelStr);
return true;
}		
if (AccMeterTapDD.over() && InputModule[15].Enabled == true) return true;
else if(AccMeterTapDD.overOpen()) 
{AppendLogFile("Pressed AccMeterTapDD DropDown "+AccMeterTapDD.SelStr);
return true;
}	
if (PowerDownTimeOutDD.over() && InputModule[16].Enabled == true) return true;
else if(PowerDownTimeOutDD.overOpen()) 
{AppendLogFile("Pressed PowerDownTimeOutDD DropDown "+PowerDownTimeOutDD.SelStr);
return true;
}			
if (PWMFreqADD.over() && InputModule[20].Enabled == true) return true;
else if(PWMFreqADD.overOpen()) 
{AppendLogFile("Pressed PWMFreqADD DropDown "+PWMFreqADD.SelStr);
return true;
}			
if (StandAloneADD.over() && InputModule[21].Enabled == true) return true;
else if(StandAloneADD.overOpen()) 
{AppendLogFile("Pressed StandAloneADD DropDown "+StandAloneADD.SelStr);
return true;
}			
if (HardwareCheckBox[0].over() && InputModule[8].Enabled == true) return true;
if (HardwareCheckBox[1].over() && InputModule[19].Enabled == true) return true; 
if(HardwareButtons[0].over() && InputModule[0].Enabled == true) return true;
if(HardwareButtons[1].over() && InputModule[1].Enabled == true) return true;	
if(HardwareButtons[2].over() && InputModule[4].Enabled == true) return true;
if(HardwareButtons[3].over() && InputModule[12].Enabled == true) return true;	
if(HardwareButtons[4].over() && InputModule[14].Enabled == true) return true;		
if (TextFields[2].over() && InputModule[5].Enabled == true) { TextFields[2].SelectField(); return true; }
if (TextFields[13].over() && InputModule[21].Enabled == true) { TextFields[13].SelectField(); return true; }
break; 
} 
AppendLogFile("========= MADE IT TO THE END WITH NO CONTACTS ===============");	
if(XEfHstU == true) { DropDownPointer.Selected = false;XEfHstU = false; }
return false;
}public class DeviceObj
{int HardwareID; 
String Name;	
int HardwareVersion;
int FirmwareVersion;
int FirmwareRevision;
int BootloaderVersion;
int Channels; 
int MaxSpeed;	
int MaxIndexedSequences;
int IndexMemoryModel;
int MaxFrames;
int MaxFramesGlobal;
int DataSpace;
int HWPVSpace;
int HPVBlockSize;
int SeqMemoryBlockSize; 
int IndexBlockSize; 
int CurrentBlockSize;
int EraseBlockSize;
boolean LockChannelAmt; 
int GammaCorrection;
boolean LinkedSupport;  
boolean Bit16Mode;	
boolean FillUpperData;
boolean Bit16Processor;
boolean Bit16LiveMode;
int BasicVersion;
int BasicMaxSequences; 
int BasicSeqLength;
int AccelerometerMode;
int DMXModeAmt;
String[] DMXModeLabels;
int ListedChipsets;
int UserConfiguredIDNum; 
int UserIdleSequence;	
String dtSTkNTStr;
String ConfigBytesStr;
String WebpageURL;
String MemorySpaceString; 
DeviceObj(String iName)
{HardwareID = 0;
Name = iName;
HardwareVersion = 0;
FirmwareVersion = 0;
FirmwareRevision = 0;  
Channels = 0;
DataSpace = 0;
BootloaderVersion = 0;
UserConfiguredIDNum = 0;
UserIdleSequence = 0;
MaxFrames = 0;
MaxFramesGlobal = 0;
MaxIndexedSequences = 8; 
EraseBlockSize = 0;
HWPVSpace = 0;
DMXModeAmt = 0;
GammaCorrection = 0;
LinkedSupport = false;
Bit16Mode = false;
DMXModeLabels = new String[1];   
}} 
public class UserSequenceObj
{String UserID; 
int SeqListNum; 
int Length;
int SeqFrameAmount;
int Speed;
int DataSize; 
int SeqMode;	
int[] StartValues;
int[] DataFrameVar;
int[] SlideValues;
int[] SlideFlags; 
int[][] TechFlags;
int[][] TechTime;
int[][] DataFrames; 
int SequenceIntensity;
int SeqTransSpeed;
int PacketCloneMode;	
int SeqPlayMode;  
int SeqTransitionFlags;  
int DataType; 
int gradientSteps;
int POVConfigType; 
int POVUsageMode;	
boolean POVVideoMode; 
int POVFramesAmount;
int bWidth = fSAlYpX; 
int bHeight = ZtBHbDg; 
int xpos;
int ypos;
boolean Highlighted;
boolean LinkerUtilized;
int assignedIDNum; 
boolean IDassigned;
int assignedLinkedIDNum;
int mappedROMAdr;
boolean StartValError; 
PGraphics previewImage;
UserSequenceObj(String iUserID, int iSeqListNum, int iDataSize)
{UserID = iUserID;
SeqListNum = iSeqListNum;
DataSize = iDataSize;
StartValues = new int[1];
DataFrameVar = new int[1];
SlideValues = new int[2];
SlideFlags = new int[2];
DataFrames = new int[2][1];;
TechFlags = new int[2][1];;
TechTime = new int[2][1];;
SeqTransSpeed = 0;
SeqPlayMode = 0;
SeqTransitionFlags = 0;
SeqFrameAmount = 1;
PacketCloneMode = 0;
POVVideoMode = false;
DataSize = uqdivtD;
SeqMode = EqPnOUb; 
DataType = 1;
Speed = 1;
Highlighted = false;
SequenceIntensity = 100; 
gradientSteps = 1;
} 
public void displayIconSmall(int xposB, int yposB)
{noStroke();
fill(JCZFGSk);
stroke(0);
strokeWeight(2);
if (Highlighted == true)  stroke(VySlFUN);
rect(xposB, yposB, 110, 75);
textSize(12);
fill(0);
text(UserID, xposB+5, yposB+15);
if(SeqMode != qzXknoY)text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
text("Mode: "+GetSeqModeString(), xposB+5, yposB+45); 		
image(previewImage, xposB+5, yposB+50);
}  
public void displayIcon(int xposB, int yposB)
{noStroke();
fill(JCZFGSk);
stroke(0);
strokeWeight(2);
if (Highlighted == true)  stroke(VySlFUN);
rect(xposB, yposB, bWidth, bHeight);
textSize(12);
fill(0);
text(UserID, xposB+5, yposB+15);
if(SeqMode != qzXknoY)text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xposB+5, yposB+45); 		
image(previewImage, xposB+5, yposB+65);
}  	
public String GetSeqModeString()
{if(SeqMode == orXQXKN) 
return "USB";
if(SeqMode == tPkEylv) 
return "Serial";
if(SeqMode == VrjUaNV) 
return "DMX";	
return cModeString[SeqMode];
}public void display()
{if (Highlighted == true)  stroke(VySlFUN);  
else 	stroke(0);
fill(JCZFGSk);
strokeWeight(2);		
rect(xpos, ypos, bWidth, bHeight);
textSize(12);
fill(0);
text(UserID, xpos+5, ypos+15);
if(SeqMode != qzXknoY)text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xpos+5, ypos+30);  
text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xpos+5, ypos+45); 
try {
image(previewImage, xpos+5, ypos+65);
} 
catch(Exception e) { }
}  
public void displayIconB(int xposB, int yposB)
{IndexScrollBuffer.fill(JCZFGSk);
IndexScrollBuffer.stroke(0);  
IndexScrollBuffer.rect(xposB, yposB, bWidth, bHeight);
IndexScrollBuffer.textSize(12);
IndexScrollBuffer.fill(0);
IndexScrollBuffer.text(UserID, xposB+5, yposB+15);
IndexScrollBuffer.text("Mode: "+GetSeqModeString()+"\nSize: "+Length, xposB+5, yposB+45); 	
if(SeqMode != qzXknoY)
{IndexScrollBuffer.text("Spd: "+Speed + " : "+cPixelIDStr[DataType], xposB+5, yposB+30);  
IndexScrollBuffer.image(previewImage, xposB+5, yposB+65, bWidth*0.9f, bHeight*0.2f);
}} 
public boolean over()
{if ( EMCDldB >= (xpos) && EMCDldB <= (xpos+bWidth) && bJxobsd >= (ypos) && bJxobsd <= (bHeight+ypos)) 
{      
return true;
} 
else {
return false;
}}
}public void InitializeSequenceSelect(int passedVal, int passedID)
{AppendLogFile("InitializeSequenceSelect("+passedVal+", "+passedID+")");
CrytrWK = 4; 
dDtnlfP = passedVal; 
sXdSznK = passedID;
SliderPointer = SequenceSelectScrollBar;
SequenceSelectScrollBar.xpos =(OverlayMenus[4].xpos+OverlayMenus[4].Width) - (SequenceSelectScrollBar.slWidth+5);
SequenceSelectScrollBar.ypos = OverlayMenus[4].ypos+50;
SequenceSelectScrollBar.Value = 0;
if((UserSequences.length+1) >  25) SequenceSelectScrollBar.Maximum = 1+floor(((UserSequences.length) - 25) / 5);
else SequenceSelectScrollBar.Maximum = 0;
SequenceSelectClose.xpos = OverlayMenus[4].xpos+OverlayMenus[4].Width-60;
SequenceSelectClose.ypos = OverlayMenus[4].ypos+15;
SequenceSelectAdd.xpos = OverlayMenus[4].xpos+OverlayMenus[4].Width-200;
SequenceSelectAdd.ypos = OverlayMenus[4].ypos+15;
DrawUserSeqIconBuffer(9999); 
switch(passedVal)
{case 0:
wpDDAOi = "Select a Sequence to Edit:";
break;
case 1:
wpDDAOi = "Select a Sequence for Linked Slot #"+(passedID+1)+":";
break;
case 2:
wpDDAOi = "Select a Sequence for the Idle Slot:";
break;
case 3:
wpDDAOi = "Select a Sequence for Hardware Preview:";
break;
case 4:
wpDDAOi = "Select a Sequence To Add to Index:";
break;
case 5:
wpDDAOi = "Select a Sequence To Place in Index:";
break;
case 6:
wpDDAOi = "Select a Sequence To Duplicate:";
break;
case 7:
wpDDAOi = "Select a Sequence To Delete:";
break;	
case 8:
wpDDAOi = "Select a Sequence To Edit User ID:";
break;			
} 
PlaceSequenceIconsMenu();	
} 
public void PlaceSequenceIconsMenu()
{int column = 0;
int row = 0;	
gSXKHak = (SequenceSelectScrollBar.Value*5)+1;
int i = 0;
for (i = gSXKHak; i != (gSXKHak+25); i++)
{	
if(i == UserSequences.length) break;
UserSequences[i].xpos = OverlayMenus[4].xpos+20+(column*ZtBHbDgorizSpace);
UserSequences[i].ypos = (OverlayMenus[4].ypos+50)+(row*GDlXxCI);
column++;		
if(column > 4)
{column = 0;
row++;
}	
} 
if((i-gSXKHak) < 25)
{if(DMXSequenceIcon.Status == 0 && dDtnlfP == 4 || dDtnlfP == 5) 
{DMXSequenceIcon.xpos = OverlayMenus[4].xpos+20+((column*ZtBHbDgorizSpace));
DMXSequenceIcon.ypos = (OverlayMenus[4].ypos+50)+(row*GDlXxCI);
column++;		
if(column > 4)
{column = 0;
row++;
}	
}if(SerialSequenceIcon.Status == 0 && dDtnlfP == 4 || dDtnlfP == 5) 
{	
SerialSequenceIcon.xpos = OverlayMenus[4].xpos+20+((column*ZtBHbDgorizSpace));
SerialSequenceIcon.ypos = (OverlayMenus[4].ypos+50)+(row*GDlXxCI);
}}
} 
public void txtHandleTechTime()
{txtHandleGenericNumber();	
UserSequences[AkOQmUe].TechTime[lQGtaTe][SelectedTechID] = PApplet.parseInt(textFieldPtr.Label);
DrawTechnicalBuffer();
}public void txtHandleMultiplier()
{txtHandleGenericNumber();
MultiplierToolValue = PApplet.parseInt(textFieldPtr.Label)*10;
}public void txtGradientSteps()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].gradientSteps = PApplet.parseInt(textFieldPtr.Label);
}public void txtHandleChannels()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].DataSize = PApplet.parseInt(textFieldPtr.Label);
UpdateSequence(AkOQmUe);
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
}public void txtHandlePixelIcon()
{txtHandleGenericNumber();
PixelIconAmount = PApplet.parseInt(textFieldPtr.Label);
}public void txtHandleGenericNumber()
{if(textFieldPtr.InputMethod > 0)
{if(PApplet.parseInt(textFieldPtr.Label) > textFieldPtr.maxValue) textFieldPtr.Label = ""+textFieldPtr.maxValue;
else if(PApplet.parseInt(textFieldPtr.Label) < textFieldPtr.minValue)  textFieldPtr.Label = ""+textFieldPtr.minValue;
}textFieldPtr.Selected = false;
}public void txtHandleSequenceIntensity()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].SequenceIntensity = PApplet.parseInt(textFieldPtr.Label);
}public void txtLinkedIteration()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].SlideValues[lQGtaTe] = PApplet.parseInt(textFieldPtr.Label);
}public void txtHandleuqdivtD()
{txtHandleGenericNumber();
gQWmajl = 5; 
}public void txtHandleSeqSpeed()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].Speed = PApplet.parseInt(textFieldPtr.Label);
MenuTabs[2].refresh();
}public void txtHandleSlideValue()
{txtHandleGenericNumber();
UserSequences[AkOQmUe].SlideValues[lQGtaTe] = PApplet.parseInt(textFieldPtr.Label);
MenuTabs[1].refresh();
}public void txtHandleUserIDField()
{UserSequences[dfXKrgk].UserID = textFieldPtr.Label;
textFieldPtr.Label = "Enter Text";
NyqOxsk(19);
MenuTabs[2].refresh();
}public void txtHandleLiveControlAddress()
{txtHandleGenericNumber();
textFieldPtr.Label = ""+ControlSliders[PApplet.parseInt(textFieldPtr.Label)-1].Value;
}public void txtHandleLiveControlValue()
{txtHandleGenericNumber();
ControlSliders[PApplet.parseInt(textFieldPtr.Label)-1].Value = temp;
AJcBVWK = true;
}public void txtHandleFrameSpeed()
{txtHandleGenericNumber();
AppendLogFile("NO HANDLER CODE FOR FrameSpeed");
}public void txtHandleColorPickerFields()
{if(PApplet.parseInt(textFieldPtr.Label) > ColorSelectorSliders[0].Maximum) textFieldPtr.Label = ""+ColorSelectorSliders[0].Maximum; 
SliderPointer.Value = PApplet.parseInt(textFieldPtr.Label); 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;	
}class TextFieldObject
{int ObjID;
int xpos;
int ypos;
int Height;
int Width;
int Size;
int minValue;
int maxValue;
int Status;
TextFieldObject(int iObjID, int ixpos, int iypos, int iSize, int iminValue, int imaxValue)
{ObjID = iObjID;
xpos = ixpos;
ypos = iypos; 
Size = iSize;
minValue = iminValue;
maxValue = imaxValue;
ObjButtonMinus[ObjID] = new  Button("-", xpos, ypos, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);  
ObjTextField[ObjID] = new TextField(""+minValue, xpos+30, ypos, (Size*2), 25, color(255), color(200, 40, 40), 1, minValue, maxValue, true, false, cTextFieldMethods[ObjID]);
ObjButtonPlus[ObjID] = new  Button("+", xpos+Width+85, ypos, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);  
}public void setStatus(int passedVal)
{Status = passedVal;
if(Status == 0)
{ObjTextField[ObjID].Status = 0;
ObjButtonPlus[ObjID].Status = 0;
ObjButtonMinus[ObjID].Status = 0;
}	
else if(Status == 1)
{ObjTextField[ObjID].Status = 1;
ObjButtonPlus[ObjID].Status = 1;
ObjButtonMinus[ObjID].Status = 1;
}			
else
{ObjTextField[ObjID].Status = 2;
ObjButtonPlus[ObjID].Status = 2;
ObjButtonMinus[ObjID].Status = 2;
}}
public void display()
{ObjTextField[ObjID].display();
ObjButtonPlus[ObjID].display();
ObjButtonMinus[ObjID].display();
}public int value()
{return PApplet.parseInt(ObjTextField[ObjID].Label);
}public void setValue(String passedStr)
{ObjTextField[ObjID].Label = passedStr;
}public int over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+((Size*4)+10) && bJxobsd >= ypos && bJxobsd <= ypos+Size) 
{    
if(ObjButtonPlus[ObjID].over()) { ObjButtonPlus[ObjID].Selected = true; return 2; }
if(ObjButtonMinus[ObjID].over()) { ObjButtonMinus[ObjID].Selected = true; return 1; }
if(ObjTextField[ObjID].over()) return 3;
} 
return 0;
} 
} 
class TextFieldObjectL
{int ObjID;
int xpos;
int ypos;
int Height;
int Width;
int Size;
int minValue;
int maxValue;
TextFieldObjectL(int iObjID, int ixpos, int iypos, int iSize, int iminValue, int imaxValue)
{ObjID = iObjID;
xpos = ixpos;
ypos = iypos; 
Size = iSize;
minValue = iminValue;
maxValue = imaxValue;
LObjButtonMinus[ObjID] = new  Button("-", xpos, ypos, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);  
LObjTextField[ObjID] = new TextField(""+minValue, xpos+30, ypos, (Size*2), 25, color(255), color(200, 40, 40), 1, minValue, maxValue, true, false, "txtLinkedIteration");
LObjButtonPlus[ObjID] = new  Button("+", xpos+Width+85, ypos, 25, 25, HoBBOyq, VySlFUN, wwboXgE, false, false, true);  
}public void display()
{LObjTextField[ObjID].display();
LObjButtonPlus[ObjID].display();
LObjButtonMinus[ObjID].display();
}public int value()
{return PApplet.parseInt(LObjTextField[ObjID].Label);
}public void setValue(String passedStr)
{LObjTextField[ObjID].Label = passedStr;
}	
public int over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+((Size*4)+10) && bJxobsd >= ypos && bJxobsd <= ypos+Size) 
{    
if(LObjButtonPlus[ObjID].over()) { LObjButtonPlus[ObjID].Selected = true; return 2; }
if(LObjButtonMinus[ObjID].over()) { LObjButtonMinus[ObjID].Selected = true; return 1; }
if(LObjTextField[ObjID].over()) return 3;
} 
return 0;
} 
} 
class OverlayMenu
{int ObjID;
int xpos;
int ypos;
int Height;
int Width;
OverlayMenu(int iObjID, int ixpos, int iypos, int ibWidth, int ibHeight)
{ObjID = iObjID;
xpos = ixpos;
ypos = iypos;  
Width = ibWidth;
Height = ibHeight;
}public void display()
{fill(JCZFGSk);
stroke(0);
strokeWeight(4);
switch(ObjID)
{case 1: 
rect(xpos, ypos, Width, Height, 20);
for (int i =0; i != 4; i++)  LiveControlCheckBox[i].display();    
fill(0);   
textSize(12);
text("Single - RGB - RGBW:", LiveControlCheckBox[0].xpos-10, LiveControlCheckBox[0].ypos-5);   
text("16 Bit Mode:",  LiveControlCheckBox[3].xpos-30, LiveControlCheckBox[3].ypos-5);   
text("The amount of channels displayed\nis changed on the software tab",  LiveControlCheckBox[3].xpos+60, LiveControlCheckBox[3].ypos);   		
for (int i = 0; i != LiveConTotalColChan; i++) ControlRects[i].display();
LiveControlClose.display();
LiveControlToggle.display();	
break;
case 2: 
rect(xpos, ypos, Width, Height, 20);
textSize(14);
fill(mYkuUaE); 
for (int i = 0; i != ControlSliders.length; i++) 
{ControlSliders[i].display();  
text((i+1)+"", ControlSliders[i].xpos-25, ControlSliders[i].ypos+14);
}fill(0);   
textSize(14);
text("Selected\nChannel:", xpos+80, ypos+20); 
text("Channel\nValue:", xpos+210, ypos+20); 
LiveControlClose.display();		
LiveControlToggle.display();
TextFields[4].display(); 
TextFields[5].display(); 
break;	
case 3: 
rect(xpos, ypos, Width, Height, 20);
textSize(18);
fill(PlmGjjm);
text("Select Sequence:\n\n\n\nAlter Speed:\n\n\nFlash Stepping:\n\n\nFade Control:", 50, 125);
text("Color Swap:", 50, 70);
textSize(14);
text("Start Stalled:", StandaloneCheckBox[1].xpos-90, StandaloneCheckBox[1].ypos+15);
text("Pauses Sequence When Stepped", 200, 275);
text("Sequence Number:", TextFields[7].xpos-40, TextFields[7].ypos-5);
text("Value:", TextFields[9].xpos, TextFields[9].ypos-5);
text("Value:", StandaloneSliders[1].xpos-45, StandaloneSliders[1].ypos+12); 
text("(1 - 65535)",  TextFields[9].xpos-5, TextFields[9].ypos+45);
text("Multiplier: "+StandaloneSliders[2].Value, StandaloneSliders[2].xpos-90, StandaloneSliders[2].ypos+12); 
text("All Stand-Alone Commands can be ran from custom user created programs. Any language that can interface with serial ports can work. See Command Sheet for details", OverlayMenus[3].xpos+20, 500, 350, 350);
for (int i =0; i != StandaloneSliders.length; i++) StandaloneSliders[i].display();
for (int i =0; i != StandaloneButtons.length; i++) StandaloneButtons[i].display();
StandaloneCheckBox[1].display();
StandAloneClose.display();
TextFields[7].display();
TextFields[8].display();
TextFields[9].display();     
stroke(DqoHydg);
strokeWeight(2);
line(440, 40, 440, 600);
line(660, 40, 660, 600);		
line(OverlayMenus[3].xpos, 100, 440, 100);    
line(OverlayMenus[3].xpos, 190, 440, 190);      
line(OverlayMenus[3].xpos, 255, 660, 255);         
line(OverlayMenus[3].xpos, 320, 440, 320);  
line(OverlayMenus[3].xpos, 410, 440, 410); 
line(440, 100, 660, 100); 
StandAloneDD.display();  	
break;	
case 4: 
rect(xpos, ypos, Width, Height, 20);
SequenceSelectClose.display();
SequenceSelectScrollBar.display();
SequenceSelectAdd.display();		
fill(0);   
textSize(18);
text(wpDDAOi, xpos+20, ypos+30);
int i = 0;
for (i = gSXKHak; i != (gSXKHak+25); i++) 
{	
if(i == UserSequences.length) break;				
UserSequences[i].display();
}	
if((i-gSXKHak) < 25)
{if(DMXSequenceIcon.Status == 0 && dDtnlfP == 4 || dDtnlfP == 5) 
{DMXSequenceIcon.displaySq();
}if(SerialSequenceIcon.Status == 0 && dDtnlfP == 4 || dDtnlfP == 5) 
{	
SerialSequenceIcon.displaySq();
}	
}break;	
case 5: 
rect(xpos, ypos, Width, Height, 20);
GammaOverlayCloseButton.display();
GammaLoadFileButton.display();
GammaUploadButton.display();
GammaUploadDefaultButton.display();
stroke(255);
strokeWeight(2);
noFill();
rect(50,294,256,256);
stroke(0);
for(int q = 0; q!=255; q++) point(50+q,550-cDefaultGammaTable[q]);
stroke(255);
strokeWeight(2);
noFill();
rect(400,294,256,256);
stroke(0);
for(int q = 0; q!=255; q++) point(400+q,550-UserGammaTableArray[q]);
fill(0);
textSize(14);
text("Default Gamma Correction", 50,285);
text("User Gamma Correction", 400,285);		
text("Linear Value", 70,570);		
text("Linear Value", 420,570);		
text("Intensity/\nBrightness", 320,415);	
text("Gamma Correction: Adjusts the linear output values(0 - 255 / 0% - 100%) to compensate for the preceived brightness of LEDs. The software generates linear values to generate"+
" colors, applying gamma correction can more accurately display colors as they are percieved by humans. Not all LED configurations will benefit from gamma correction, and enabling"+
"gamma correction can cause intensities to be more 'jumpy' especially at lower values. Please search online for more information.", 40,70, 600,600);
text("Gamma correction is applied with a commonly used lookup table, the user may create and upload their own tables. See 'assets' folder files for more info.",40,190,600,600);
break;
case 6:
ellipse(xpos, ypos, Width, Height);
for(int q=0; q!= RadialMenuTechColorMode.length;q++)
{RadialMenuTechColorMode[q].display();
}fill(0);
textSize(14);
textAlign(CENTER);
text("Technical\nChannel:\n"+(SelectedTechID+1), OverlayMenus[6].xpos,OverlayMenus[6].ypos+15);
break;
case 7:
ellipse(xpos, ypos, Width, Height);
RadialTechFadeButton.display();
RadialTechSolidButton.display();	
TXTFTechTime.display();
TechnicalColorStart.display();
TechnicalColorEnd.display();
fill(0);
textSize(14);
textAlign(CENTER);
text("Length:\n(millisec.)", OverlayMenus[7].xpos,OverlayMenus[7].ypos+40);
text("Start", OverlayMenus[7].xpos-45,OverlayMenus[7].ypos);
text("End", OverlayMenus[7].xpos+42,OverlayMenus[7].ypos);
fill(255);		
text("Flag: "+UserSequences[AkOQmUe].TechFlags[lQGtaTe][SelectedTechID], OverlayMenus[7].xpos+100,OverlayMenus[7].ypos);
break;		
} 
} 
public boolean over() 
{if (EMCDldB >= xpos && EMCDldB <= xpos+Width && bJxobsd >= ypos && bJxobsd <= ypos+Height) 
{      
return true;
} 
else {
return false;
}} 
public boolean overEllipse() 
{if (EMCDldB >= xpos-(Width/2) && EMCDldB <= xpos+(Width/2) && bJxobsd >= ypos-(Height/2) && bJxobsd <= ypos+(Height/2)) 
{      
return true;
} 
else {
return false;
}} 
public void mousePressed()
{switch(ObjID)
{case 1: 
for (int i = 0; i != LiveControlCheckBox.length; i++) 
{if (LiveControlCheckBox[i].over())
{AppendLogFile("LiveControlCheckBox "+i+" pressed"); 
if(i != 3)
{LiveControlCheckBox[0].Selected = false; 
LiveControlCheckBox[1].Selected = false; 
LiveControlCheckBox[2].Selected = false; 
LiveControlCheckBox[i].Selected = true;
LiveConDataType = i;
LiveConDataMult = 1; 
if (LiveConDataType == 1) LiveConDataMult  = 3;
else if (LiveConDataType == 2) LiveConDataMult  =  4;
}OpenLiveControlMenu();
return;
}}
for (int i = 0; i != LiveConTotalColChan; i++) 
{try {
if(ControlRects[i].over())
{AppendLogFile("Clicked Live Control Square: "+i); 
ColorSelector.InitPosition(3,i,0);  
return;
}}
catch(Exception e) { AppendLogFile("No ControlRect");}
}    
break;
case 2: 
for (int i = 0; i != ControlSliders.length; i++) 
{if (ControlSliders[i].over())
{ControlSliders[i].selectSlider();
TextFields[4].Label = ""+(i+1);
TextFields[5].Label = ""+ControlSliders[i].Value;
}}
if (TextFields[4].over()) TextFields[4].SelectField();   
if (TextFields[5].over()) TextFields[5].SelectField();  
break;	
case 3: 
if (StandAloneDD.over()) return;
else if(StandAloneDD.overOpen()) 
{AppendLogFile("Pressed StandAloneDD DropDown "+StandAloneDD.SelStr);				
return;
}if(StandAloneClose.over()) 
{StandAloneClose.Selected = true;
StandAloneClose.display();
CrytrWK = 0;
}for (int i = 0; i != StandaloneButtons.length; i++) 
{if(StandaloneButtons[i].over())
{StandaloneButtons[i].Selected = true;
AppendLogFile("Pressed StandAlone Button "+i);
int temp = 0;
switch(i)
{case 0: 
rYrXIPl = IQXbmvv;
cmdData[0] = StandAloneDD.SelStr;
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
break;
case 1: 
rYrXIPl = pmnGOnK; 
cmdData[0] = PApplet.parseInt(TextFields[7].Label);
cmdData[1] = 0; 
if(StandaloneCheckBox[1].Selected == true)  cmdData[2] = 1;  
else  cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();        
break;       
case 2: 
temp = PApplet.parseInt(TextFields[8].Label);
rYrXIPl = DuhNPWj;     
cmdData[0] = (temp >> 8) & 0xFF; 
cmdData[1] = temp & 0xFF; 
cmdData[2] = 0;
cmdData[3] = 0;  
RequestCommand();
AppendLogFile("Speed Vals: "+temp+" : "+cmdData[0]+" : "+cmdData[1]+" : "+cmdData[2]);          
break;     
case 3: 
rYrXIPl = UjXqAgR;
cmdData[0] = 1; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();     
break;
case 4: 
rYrXIPl = UjXqAgR;
cmdData[0] = 0; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();             
break;  
case 5: 
temp = PApplet.parseInt(TextFields[9].Label);
AppendLogFile("temp = "+temp);
rYrXIPl = QwTfHDT;
cmdData[0] = (temp >> 8) & 0xFF; 
cmdData[1] = (temp & 0x00FF); 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
break;        
case 6: 
rYrXIPl = pNWXnGU;
cmdData[0] = 1; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();         
break;       
case 7: 
rYrXIPl = lfEkUTG;
cmdData[0] = 0; 
cmdData[1] = 0;
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();         
break;    
case 8: 
rYrXIPl = QvyJPPj;
cmdData[0] = 0; 
cmdData[1] = 0;
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();           
break; 
case 9: 
rYrXIPl = DuhNPWjIncrease;
cmdData[0] = 0; 
cmdData[1] = 0;
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();           
break; 					
case 10: 
rYrXIPl = DuhNPWjDecrease;
cmdData[0] = 0; 
cmdData[1] = 0;
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();           
break; 						
}}
}if(TextFields[7].over()) TextFields[7].SelectField();  
if(TextFields[8].over()) TextFields[8].SelectField();  
if(TextFields[9].over()) TextFields[9].SelectField();  
if(StandaloneCheckBox[0].over()) StandaloneCheckBox[0].Selected =! StandaloneCheckBox[0].Selected;
if(StandaloneCheckBox[1].over()) StandaloneCheckBox[1].Selected =! StandaloneCheckBox[1].Selected;
for (int i = 0; i != StandaloneSliders.length; i++)  if (StandaloneSliders[i].over())  StandaloneSliders[i].selectSlider(); 
break;	
case 4: 
if(SequenceSelectClose.over()) 
{SequenceSelectClose.Selected = true;
SequenceSelectClose.display();
CrytrWK = 0; 
return;
}if (SequenceSelectScrollBar.over())  {SequenceSelectScrollBar.selectSlider(); return;}	
for (int i = 1; i != UserSequences.length; i++) 
{if (UserSequences[i].over())
{	
AppendLogFile("Sequence ID Pressed "+i+" with state of "+dDtnlfP);
CrytrWK = 0; 
switch(dDtnlfP)
{case 0:
MeasureSequenceLength(AkOQmUe);
UserSequences[AkOQmUe].Highlighted = false;
UserSequences[i].Highlighted = true;
AkOQmUe = i;
LoadSequence();
break;
case 1:
UserSequences[AkOQmUe].SlideFlags[YuOyzOP] = i; 
AppendLogFile("ID set to: "+UserSequences[AkOQmUe].SlideFlags[YuOyzOP]);
break;
case 2:
device.UserIdleSequence = i; 
break;
case 3:
AppendLogFile("Over HardwarePreview Rect"); 
RequestToSendPreview(i); 
break;
case 4: 
if((IndexedSequenceLength+UserSequences[i].Length) <= device.DataSpace)
{IndexMapPointer++;
IndexMapArray[IndexMapPointer] = i;
DrawIndexScrollArea();					
}else
{	
AppendLogFile("Sequence Would Overflow the memory");
NyqOxsk(4); 
}	
break;
case 5: 
IndexMapArray[sXdSznK] = i;
DrawIndexScrollArea();	
break;
case 6:	
dfXKrgk = i;
SoftwareButtons[7].Selected = false;  
DuplicateSequence();
NyqOxsk(18);
break;
case 7: 
gQWmajl = 2;
dfXKrgk = i;
break;	
case 8: 
TextFields[3].SelectField();
TextFields[3].Label = UserSequences[i].UserID;
dfXKrgk = i;
break;			
} 
return;			
} 
} 
if(dDtnlfP == 4 || dDtnlfP == 5)
{if(DMXSequenceIcon.over()) 
{AppendLogFile("Clicked DMXSequenceIcon"); 
if(dDtnlfP == 4 )
{if((IndexedSequenceLength+smFWXrf) <= device.DataSpace)
{IndexMapPointer++;
IndexMapArray[IndexMapPointer] = CguezcT;
}else
{	
AppendLogFile("Sequence Would Overflow the memory");
NyqOxsk(4); 
}}
else 	
{IndexMapArray[sXdSznK] = CguezcT;
}DrawIndexScrollArea();	
CrytrWK = 0; 
return;			
}if(SerialSequenceIcon.over()) 
{AppendLogFile("Clicked SerialSequenceIcon"); 
if(dDtnlfP == 4 )
{if((IndexedSequenceLength+smFWXrf) <= device.DataSpace)
{IndexMapPointer++;
IndexMapArray[IndexMapPointer] = bgpbnOG;
}else
{	
AppendLogFile("Sequence Would Overflow the memory");
NyqOxsk(4); 
}	
}else 	
{IndexMapArray[sXdSznK] = bgpbnOG;
}DrawIndexScrollArea();			
CrytrWK = 0; 
return;
} 
}if(SequenceSelectAdd.over())
{AppendLogFile("Attempting to Add Sequence "+UserSequences.length);
if (UserSequences.length < XwgQulc+1) 
{AddSequence();
CrytrWK = 0;
return;
}else
{NyqOxsk(20);
return;
}}
break;
case 5: 
if(GammaUploadDefaultButton.over())
{	
GammaUploadDefaultButton.Selected = true;	
gQWmajl = 17;
return;
}if(GammaOverlayCloseButton.over())
{	
GammaOverlayCloseButton.Selected = true;	
CrytrWK = 0; 
return;
}if(GammaUploadButton.over())
{	
GammaUploadButton.Selected = true;	
gQWmajl = 18;
return;
}		
if(GammaLoadFileButton.over())
{		
GammaLoadFileButton.Selected = true;
FileBrowserAction = 7;
AppendLogFile("Pressed Load  Gamma Correction File Button");
selectInput("Select a Gamma Correction file to load:", "fileSelected");	
return;
}break;		
case 6:
for(int q=0; q != RadialMenuTechColorMode.length;q++)
{if(RadialMenuTechColorMode[q].over())
{RadialMenuTechColorMode[0].Selected = false;
RadialMenuTechColorMode[1].Selected = false;
RadialMenuTechColorMode[2].Selected = false;
RadialMenuTechColorMode[q].Selected = true;
AppendLogFile("pressed tech color mode");
for (int z = 0; z != UserSequences[AkOQmUe].SeqFrameAmount+1; z++)
{UserSequences[AkOQmUe].TechFlags[z][SelectedTechID] = UserSequences[AkOQmUe].TechFlags[z][SelectedTechID] & 0xF8; 
if(q == 0) UserSequences[AkOQmUe].TechFlags[z][SelectedTechID] = UserSequences[AkOQmUe].TechFlags[z][SelectedTechID];
else if(q == 1) UserSequences[AkOQmUe].TechFlags[z][SelectedTechID] |= 0x01;
else if(q == 2) UserSequences[AkOQmUe].TechFlags[z][SelectedTechID] |= 0x02;
}		
RadialMenuTechColorMode[getTechChanColorMode(SelectedTechID)].Selected = true; 
DrawTechnicalBuffer();
return;
}}
if(!overEllipse()) CrytrWK = 0; 
break;
case 7: 
if(RadialTechSolidButton.over())
{AppendLogFile("Pressed RadialTechSolidButton");
RadialTechSolidButton.Selected = true;
RadialTechFadeButton.Selected = false;
UserSequences[AkOQmUe].TechFlags[lQGtaTe][SelectedTechID] &= 0xF7; 
DrawTechnicalBuffer();
return;
}if(RadialTechFadeButton.over())
{AppendLogFile("Pressed RadialTechFadeButton");
RadialTechFadeButton.Selected = true;
RadialTechSolidButton.Selected = false;
UserSequences[AkOQmUe].TechFlags[lQGtaTe][SelectedTechID] |= 0x08; 
DrawTechnicalBuffer();
return;				
}if(TechnicalColorStart.over())
{	
ColorSelector.InitPosition(4,getTechChannelNum(SelectedTechID),SelectedTechFrame);	
return;			
}if(TechnicalColorEnd.over())
{				
ColorSelector.InitPosition(4,getTechChannelNum(SelectedTechID),SelectedTechFrame+1);	
return;
}if(TXTFTechTime.over()) { TXTFTechTime.SelectField(); return; } 
if(!overEllipse()) CrytrWK = 0; 
break;	
} 
if(ObjID == 1 || ObjID == 2)
{if (LiveControlToggle.over())
{AppendLogFile("Pressed");
if(CrytrWK == 1) 
{CrytrWK = 2; 
rYrXIPl = ojafBuR; 
cmdData[0] = 1; 
if(device.Bit16Mode == true && LiveControlCheckBox[3].Selected == true) cmdData[1] = 1; 
else cmdData[1] = 0; 
cmdData[2] = (uqdivtD >> 8) & 0xFF;  
cmdData[3] = uqdivtD & 0xFF;  
RequestCommand();  
}else CrytrWK = 1;
LiveControlToggle.Selected = true;
LiveControlToggle.display();
} 
if (LiveControlClose.over()) 
{LiveControlClose.Selected = true;
LiveControlClose.display();
CrytrWK = 0;
rYrXIPl = ojafBuR; 
cmdData[0] = 0; 
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
} 
} 
} 
} 

public void POVFileLoadFunc()
{AppendLogFile("POVFileLoadFunc()");
if(iKxwBtq.endsWith(".mov") ||iKxwBtq.endsWith(".avi")) 
{				
POVVideoModeCheckBox.Selected = true;
UserSequences[AkOQmUe].POVVideoMode = true; 
POVVidFrame = 0;
MovieFrameCount = 0;
HoldMovieTranscribe = true; 
		


UserSequences[AkOQmUe].DataFrames = (int[][])expand(UserSequences[AkOQmUe].DataFrames, UserSequences[AkOQmUe].POVFramesAmount);
for(int i = 0; i != UserSequences[AkOQmUe].POVFramesAmount; i++)
{UserSequences[AkOQmUe].DataFrames[i] = new int[device.Channels];
}POVVidFrame = 0;
MovieFrameCount = 0;
HoldMovieTranscribe = false;

}else
{POVVideoModeCheckBox.Selected = false;	
UserSequences[AkOQmUe].POVVideoMode = false;
POVImg = loadImage(iKxwBtq);
if(!CheckPOVFileDimensions(POVImg.width,POVImg.height)) return; 
if(POVImg == null) { AppendLogFile("POVImg = null"); POVImg = createGraphics(1,1); } 
LoadPOVFile();
}}	
public boolean CheckPOVFileDimensions(int passedW, int passedH)
{	
AppendLogFile("CheckPOVFileDimensions() with "+passedW+"w & "+passedH+"h");
int holdW = passedW;
int holdH = passedH;
ByoKxya = 1; 
if (UserSequences[AkOQmUe].DataType == 1) ByoKxya  = 3;
else if (UserSequences[AkOQmUe].DataType == 2) ByoKxya  =  4;  
switch(UserSequences[AkOQmUe].POVConfigType)
{case 0: 
if(UserSequences[AkOQmUe].POVVideoMode == true) passedH = UserSequences[AkOQmUe].POVFramesAmount;
if((passedW > (device.Channels / ByoKxya)) || passedH > device.MaxFramesGlobal)
{AppendLogFile("Error Loading, File Width or Height is too large of POVConfigType");
NyqOxsk(26);
return false;
}if(UserSequences[AkOQmUe].POVVideoMode == true) passedH = holdH; 
UserSequences[AkOQmUe].SeqFrameAmount = passedH-1;
UserSequences[AkOQmUe].DataSize = passedW * ByoKxya;
break;
case 1: 
if(UserSequences[AkOQmUe].POVVideoMode == true) passedW = UserSequences[AkOQmUe].POVFramesAmount;
if((passedH > (device.Channels / ByoKxya)) || passedW > device.MaxFramesGlobal)
{AppendLogFile("Error Loading, File Width or Height is too large of POVConfigType");
NyqOxsk(26);
return false;
}if(UserSequences[AkOQmUe].POVVideoMode == true) passedW = holdW; 
UserSequences[AkOQmUe].SeqFrameAmount = passedW-1;
UserSequences[AkOQmUe].DataSize = passedH * ByoKxya;
break;
case 2: 
if(UserSequences[AkOQmUe].POVVideoMode == true) passedH = UserSequences[AkOQmUe].POVFramesAmount;
if((passedW > (device.Channels / ByoKxya)) || passedH > device.MaxFramesGlobal)
{AppendLogFile("Error Loading, File Width or Height is too large of POVConfigType");
NyqOxsk(26);
return false;
}if(UserSequences[AkOQmUe].POVVideoMode == true) passedH = holdH; 
UserSequences[AkOQmUe].SeqFrameAmount = passedH-1;
UserSequences[AkOQmUe].DataSize = passedW * ByoKxya;
break;
case 3: 
if(UserSequences[AkOQmUe].POVVideoMode == true) passedW = UserSequences[AkOQmUe].POVFramesAmount;
if((passedH > (device.Channels / ByoKxya)) || passedW > device.MaxFramesGlobal)
{AppendLogFile("Error Loading, File Width or Height is too large of POVConfigType");
NyqOxsk(26);
return false;
}if(UserSequences[AkOQmUe].POVVideoMode == true) passedW = holdW; 
UserSequences[AkOQmUe].SeqFrameAmount = passedW-1;
UserSequences[AkOQmUe].DataSize = passedH * ByoKxya;
break;		
} 
if (UserSequences[AkOQmUe].DataType == 0) oiHkAsJ = UserSequences[AkOQmUe].DataSize;
else oiHkAsJ = UserSequences[AkOQmUe].DataSize / ByoKxya;
UpdateSideBarButtonStates();
ResizeSequenceFrameAmt(AkOQmUe);
return true;	
} 
public void LoadPOVFile()
{int x = 0;
CurrentPOVW = POVImg.width;		
CurrentPOVH = POVImg.height;
int tempColor;
if(POVVideoModeCheckBox.Selected == false) AppendLogFile("Loading POV from width: "+POVImg.width+" : height: "+POVImg.height);
if(POVVideoModeCheckBox.Selected == false) POVVidFrame = 0;
switch(UserSequences[AkOQmUe].POVConfigType)
{case 0: 
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{x = 0;
for(int i = oiHkAsJ-1; i >= 0; i--)
{tempColor = POVImg.get(i,q);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
x+=3;
} 
}break;
case 1: 
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{tempColor = POVImg.get(q,i); 
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
x+=3;
} 
}break;
case 2: 
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{x = 0;
for (int i=0; i != oiHkAsJ;i++)
{tempColor = POVImg.get(i,q);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
x+=3;
} 
}break;
case 3: 
for (int q=0; q != (UserSequences[AkOQmUe].SeqFrameAmount+1);q++)
{x = 0;
for (int i=oiHkAsJ-1; i >= 0;i--)
{tempColor = POVImg.get(q,i); 
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x] = (int)red(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+1] = (int)green(tempColor);
UserSequences[AkOQmUe].DataFrames[q+POVVidFrame][x+2] = (int)blue(tempColor);
x+=3;
} 
}break;		
} 
if(POVVideoModeCheckBox.Selected == false) DrawPOVBuffer(); 
} 
public boolean pressHandlerLinkedBuffer()
{if (LinkedScrollBar.over())	{ LinkedScrollBar.selectSlider();  return true; }
for (int i = 0; i != 5; i++)
{if (EMCDldB >= (60+osqIpiO) && EMCDldB <= (60+110+osqIpiO) && bJxobsd >= gEfHGFk+((40+(i*hwAmagv))-LinkedScrollBar.Value) &&  bJxobsd <= (gEfHGFk+70)+((45+(i*hwAmagv))-LinkedScrollBar.Value))     
{AppendLogFile("Clicked the Linked Icon! "+i+" : "+UserSequences[AkOQmUe].SeqFrameAmount);
YuOyzOP = i+LinkedScrollBar.Value;
InitializeSequenceSelect(1, YuOyzOP); 
return true;
}}
try 
{for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1)*4; i++)
{     
if (LinkedCheckBox[i].over())
{AppendLogFile("Over Linked Check Box: "+i+" : "+(i%4));
temp = i+(LinkedScrollBar.Value*4);
LinkedCheckBox[((i/4)*4)].Selected = false;  
LinkedCheckBox[((i/4)*4)+1].Selected = false;  
LinkedCheckBox[((i/4)*4)+2].Selected = false;  
LinkedCheckBox[((i/4)*4)+3].Selected = false;  
switch((temp%4))
{case 0:	
UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)] = 0;
break;
case 1: 
UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)] = 1;
break;	
case 3: 
UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)] = 2;
break;
case 2:	
case 7: 
UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)] = 7;
break;							
}if(LinkedTimerCheckBox[ceil(temp/4)].Selected == true) 
{UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)] |= 0x80;
}AppendLogFile("Saved as: "+binary(UserSequences[AkOQmUe].DataFrameVar[ceil(temp/4)]));
return true;
}}
}catch(Exception e) {  }    	
try 
{for (int i = 0; i != (UserSequences[AkOQmUe].SeqFrameAmount+1); i++)
{if(LinkedTimerCheckBox[i].over())
{temp = i+(LinkedScrollBar.Value);	
if(LinkedTimerCheckBox[i].Selected == false)
{UserSequences[AkOQmUe].DataFrameVar[temp] &= 0x7F;
}else
{UserSequences[AkOQmUe].DataFrameVar[temp] |= 0x80;
}AppendLogFile("Saved as: "+binary(UserSequences[AkOQmUe].DataFrameVar[temp]));
} 
}}
catch(Exception e) {  }     
try 
{for (int i = 0; i != UserSequences[AkOQmUe].SeqFrameAmount+1; i++)
{    	
if(LinkedTextFieldObject[i].over() > 0)
{lQGtaTe = i+LinkedScrollBar.Value;
AppendLogFile("LinkedTextFieldObject["+i+"] "+LinkedTextFieldObject[i].over()+" Using : "+lQGtaTe);
emEPIOg = false; 
textFieldPtr.Selected = false;		
switch(LinkedTextFieldObject[i].over())
{case 1: 
if(UserSequences[AkOQmUe].SlideValues[lQGtaTe] > LinkedTextFieldObject[i].minValue) UserSequences[AkOQmUe].SlideValues[lQGtaTe]--;
LObjTextField[LinkedTextFieldObject[i].ObjID].Label = ""+UserSequences[AkOQmUe].SlideValues[lQGtaTe];
break;
case 2: 
if(UserSequences[AkOQmUe].SlideValues[lQGtaTe] < LinkedTextFieldObject[i].maxValue) UserSequences[AkOQmUe].SlideValues[lQGtaTe]++;
LObjTextField[LinkedTextFieldObject[i].ObjID].Label = ""+UserSequences[AkOQmUe].SlideValues[lQGtaTe];
break;
case 3:
LObjTextField[LinkedTextFieldObject[i].ObjID].SelectField();
break;
} 
return true;
} 
}}
catch(Exception e) {  }   
return false;
}public boolean pressHandlerFrameButtonOptions()
{if(AddFrame.over()) 	
{	
AppendLogFile("AddFrame button pressed");
if (UserSequences[AkOQmUe].SeqFrameAmount != (device.MaxFrames-1))  
{UserSequences[AkOQmUe].SeqFrameAmount++;
ResizeSequenceFrameAmt(AkOQmUe);
}if (UserSequences[AkOQmUe].SeqMode == qzXknoY)
{if(device.BasicVersion > 0 && device.LinkedSupport == true)
{if(UserSequences[AkOQmUe].SeqFrameAmount > 8) 
{UserSequences[AkOQmUe].SeqFrameAmount = 8;
NyqOxsk(14);
}}
InitLinkedBuffer();
return true;
} 
if(UserSequences[AkOQmUe].SeqFrameAmount > 10) 
{UkmBkwh++;
if(UserSequences[AkOQmUe].SeqFrameAmount > (UkmBkwh-10)) UkmBkwh = UserSequences[AkOQmUe].SeqFrameAmount-10;
}if (lQGtaTe < UserSequences[AkOQmUe].SeqFrameAmount)
{  
SetlQGtaTe(UserSequences[AkOQmUe].SeqFrameAmount);
}else SetlQGtaTe(lQGtaTe);
MenuTabs[1].refresh(); 
MenuTabs[0].refresh(); 
return true;
} 
if(RemoveFrame.over()) 	
{	
AppendLogFile("RemoveFrame button pressed");	
if (UserSequences[AkOQmUe].SeqFrameAmount != 1)  UserSequences[AkOQmUe].SeqFrameAmount--; 
UkmBkwh--;
if(UkmBkwh < 0) UkmBkwh = 0;
if (lQGtaTe > UserSequences[AkOQmUe].SeqFrameAmount)
{    
SetlQGtaTe(UserSequences[AkOQmUe].SeqFrameAmount);
}else SetlQGtaTe(lQGtaTe);
if (UserSequences[AkOQmUe].SeqMode == qzXknoY) InitLinkedBuffer(); 
MenuTabs[1].refresh(); 
MenuTabs[0].refresh(); 
return true;	
} 
if(IncFrameBar.over())
{	
if((UserSequences[AkOQmUe].SeqFrameAmount-10) > UkmBkwh) UkmBkwh++;
SetlQGtaTe(lQGtaTe);
return true;
}if(DecFrameBar.over())
{	
UkmBkwh--;
if(UkmBkwh < 0) UkmBkwh = 0;
SetlQGtaTe(lQGtaTe);
return true;
}if (UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{for (int i = 0; i != GradientRects.length; i++) 
{try {
if (GradientRects[i].over())
{AppendLogFile("Pressed Rect: "+i);
SetlQGtaTe(i+UkmBkwh);
ColorSelector.InitPosition(0,0,i); 
MenuTabs[1].refresh(); 
MenuTabs[0].refresh(); 
return true; 
}}
catch(Exception e) {
}}
}else
{for (int i = 0; i != FrameButtons.length; i++)
{if (FrameButtons[i].over())
{if(i+UkmBkwh > UserSequences[AkOQmUe].SeqFrameAmount) return false;
AppendLogFile("FrameButtons "+i+" pressed "); 
SetlQGtaTe(i+UkmBkwh); 
MenuTabs[0].refresh(); 
return true; 
} 
} 
}
if(GroupIDDecf.over())
{if(gdHgLUO == 0) gdHgLUO = 7;
else gdHgLUO--;
GraphicLayoutUpdateIcons();
return true;
}if(GroupIDIncf.over())
{if(gdHgLUO == 7) gdHgLUO = 0;
else gdHgLUO++;
GraphicLayoutUpdateIcons();
return true;
}return false;
} 
public boolean pressHandlerToolsMenu()
{	
if(StartValReset.over() && TimeLineBuffer != null)
{gQWmajl = 16;
return true;
} 
if(GradientMultiplierObject.over() > 0)
{AppendLogFile("GradientMultiplierObject "+GradientMultiplierObject.over()+"    "+MultiplierToolValue);
switch(GradientMultiplierObject.over())
{case 1:
if(MultiplierToolValue > GradientMultiplierObject.minValue) MultiplierToolValue--;
ObjTextField[GradientMultiplierObject.ObjID].Label = ""+((float)MultiplierToolValue/10);	
break;
case 2:
if(MultiplierToolValue < (GradientMultiplierObject.maxValue*10)) MultiplierToolValue++;
ObjTextField[GradientMultiplierObject.ObjID].Label = ""+((float)MultiplierToolValue/10);	
break;
case 3:
ObjTextField[GradientMultiplierObject.ObjID].SelectField();
break;
} 
return true;
} 
if(GradientStepsObject.over() > 0)
{switch(GradientStepsObject.over())
{case 1:
if(UserSequences[AkOQmUe].gradientSteps > GradientStepsObject.minValue) UserSequences[AkOQmUe].gradientSteps--;
ObjTextField[GradientStepsObject.ObjID].Label = ""+UserSequences[AkOQmUe].gradientSteps ;
break;
case 2:
if(UserSequences[AkOQmUe].gradientSteps < GradientStepsObject.maxValue) UserSequences[AkOQmUe].gradientSteps++;
ObjTextField[GradientStepsObject.ObjID].Label = ""+UserSequences[AkOQmUe].gradientSteps;
break;
case 3:
ObjTextField[GradientStepsObject.ObjID].SelectField();
break;
} 
return true;
} 
if (GradientGenerate.over())
{GenerateGradient();
return true;
}		
for (int i =0; i != PaintRects.length; i++)
{if(PaintRects[i].over())
{if(PaintRectID == i)
{AppendLogFile("Paint Rect Pressed - Choose Color");
oxBdCTXPick = true;
DXcJNIU = true;  
ColorSelector.InitPosition(0,0,0);		
}else
{PaintRectID = i;
oxBdCTX[0] = PaintRects[PaintRectID].Red;
oxBdCTX[1] = PaintRects[PaintRectID].Green;
oxBdCTX[2] = PaintRects[PaintRectID].Blue;
oxBdCTX[3] = PaintRects[PaintRectID].White;
}} 
} 
if (GraphicFuncPaintButton.over())
{			
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG) { NyqOxsk(11); return true; }
if(GraphicFuncPaintButton.Selected == true) AppendLogFile("Enable Painting");
return true;
}		
else if (MainToolsColorGroup.over())
{AppendLogFile("Apply Color to Group");
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG) { NyqOxsk(11); return true; }
GraphicFuncPaintButton.Selected = false;		
ColorSelector.InitPosition(2,0,0);	
return true;
}		
else if (MainToolsAllSame.over())
{AppendLogFile("Apply Color to All");
GraphicFuncPaintButton.Selected = false;	
ColorSelector.InitPosition(1,0,lQGtaTe); 
return true;
}else if(MainToolsShowStartValues.over())
{if(MainToolsShowStartValues.Selected == true) MainToolsShowStartValues.Label = "Hide Color Icons";
else MainToolsShowStartValues.Label = "Show Color Icons";
MenuTabs[0].refresh();
return true;
}else if(GradientDrawRadialButton.overB())
{if(GradientDrawRadialButton.Selected == true)
{GradientDrawRadialButton.Selected = false;	
GradientDrawState = 0;
return true;
}GradientDrawRadialButton.Selected = true;
GradientDrawLinearButton.Selected = false;
GradientDrawState = 1;
return true;
}else if(GradientDrawLinearButton.overB())
{if(GradientDrawLinearButton.Selected == true)
{GradientDrawLinearButton.Selected = false;	
GradientDrawState = 0;
return true;
}GradientDrawRadialButton.Selected = false;
GradientDrawLinearButton.Selected = true;
GradientDrawState = 2;
return true;
}return false;
} 
public boolean pressHandlerMenuTabs()
{for (int i =0; i != MenuTabs.length; i++) 
{if (MenuTabs[i].over())
{MenuTabs[uBYXrqM].Selected = false;  
uBYXrqM = i;
MenuTabs[i].Selected = true;
AppendLogFile("Changed Menu Tabs, uBYXrqM ="+uBYXrqM);
MouseIconPlace.Selected = false;
MouseIconRemove.Selected = false;
MouseIconReset.Selected = false;
GraphicFuncPaintButton.Selected = false; 
GradientDrawRadialButton.Selected = false; 
GradientDrawLinearButton.Selected = false; 
GradientDrawState = 0;
GraphicImageResize = false;
if(MenuTabs[0].ReqRefresh || MenuTabs[1].ReqRefresh) MenuTabs[2].ReqRefresh = true; 
if (MenuTabs[i].ReqRefresh == true) { MenuTabs[i].refresh(); AppendLogFile("REFRESHED =========== "+i); }
if(uBYXrqM == 4) thread("PortMonitorThread"); 
noLoop(); 
return true;
}}
return false;
}public boolean pressHandlerRightClick()
{AppendLogFile("X: "+EMCDldB+" - Y: "+bJxobsd);
if(uBYXrqM == dqimCOA)
{AppendLogFile("Checking Index Icons");
for (int i =0; i != IndexMapPointer+2; i++)
{if (i <= IndexMapPointer)
{if (EMCDldB >= (60+596) && EMCDldB <= (60+596+fSAlYpX) && bJxobsd >= 35+((5+(i*GDlXxCI))-(IndexScrollBar.Value*GDlXxCI)) && bJxobsd <= (35+ZtBHbDg)+((5+(i*GDlXxCI))-(IndexScrollBar.Value*GDlXxCI)))     
{AppendLogFile("Clicked Populated Connection SeqIcon "+i+"   IndexMapPointer: "+IndexMapPointer);
IndexMapArray[i] = cfXHabo; 
if(IndexMapPointer > i)
{AppendLogFile("need to shift data down");
for (int q = i; q != IndexMapPointer+1; q++)
{AppendLogFile("shifting slot "+i+" to "+(i+1));
if(q != device.MaxIndexedSequences)
{	
IndexMapArray[q] = IndexMapArray[q+1]; 
}else IndexMapArray[q] = cfXHabo; 
}
}IndexMapPointer--;
DrawIndexScrollArea();
break; 
}}
} 
if(IdleSequenceIcon.over())
{AppendLogFile("IdleSequenceIcon Right Clicked");
device.UserIdleSequence = 0; 
return true;
}		
} 
DXcJNIU = false;
GradientDrawInit = false;
return true;		
}public boolean pressHandlerFrameTools()
{if (uBYXrqM == WTkKqlA || uBYXrqM == xsyaBOR) 
{for (int i =0; i != FrameCheckBoxes.length; i++)
{if (FrameCheckBoxes[i].over()) 
{AppendLogFile("FrameCheckBox "+i+" pressed"); 
UserSequences[AkOQmUe].SlideFlags[lQGtaTe] = UserSequences[AkOQmUe].SlideFlags[lQGtaTe] & 0xF8; 
UserSequences[AkOQmUe].SlideFlags[lQGtaTe] = UserSequences[AkOQmUe].SlideFlags[lQGtaTe] | i;
SetSlideDataTypeBoxStates(i+1); 
UpdateSideBarButtonStates();
return true;
}}
if (FrameSeqToolInsantDD.over()) return true;
else if(FrameSeqToolInsantDD.overOpen()) 
{AppendLogFile("Pressed FrameSeqToolInsantDD DropDown "+FrameSeqToolInsantDD.SelStr );
switch(FrameSeqToolInsantDD.SelStr)
{case 0:
UserSequences[AkOQmUe].SlideValues[lQGtaTe] = 0;
UserSequences[AkOQmUe].SlideFlags[lQGtaTe] = 0x00; 
break;
case 1:
UserSequences[AkOQmUe].SlideValues[lQGtaTe] = 1;
UserSequences[AkOQmUe].SlideFlags[lQGtaTe] = unbinary("11000"+binary(QCZOouc,3)); 
break; 
case 2:
UserSequences[AkOQmUe].SlideValues[lQGtaTe] = 1;
UserSequences[AkOQmUe].SlideFlags[lQGtaTe] = unbinary("10000"+binary(QCZOouc,3)); 
break;
}UpdateSideBarButtonStates();
MenuTabs[0].refresh();
MenuTabs[1].refresh();
return true;
}if (FrameSeqToolTechDD.over()) return true;
else if(FrameSeqToolTechDD.overOpen()) 
{AppendLogFile("Pressed FrameSeqToolTechDD DropDown "+FrameSeqToolTechDD.SelStr );
switch(FrameSeqToolTechDD.SelStr)
{case 0:
break;
case 1:
break; 
}MenuTabs[1].refresh();
return true;
}if (TextFields[0].over()) { TextFields[0].SelectField(); return true; }  
if (TextFields[6].over() && UserSequences[AkOQmUe].SeqMode == mTKKGDu) { TextFields[6].SelectField(); return true; }  
}
return false;
}public boolean pressHandlerDXcJNIU()
{if (ColorSelector.overPicker())
{ColorSelector.PickColor();
return true;
}else if (ColorSelector.over())
{for (int i =0; i != ColorSelectorSliders.length; i++)
{if (ColorSelectorSliders[i].over())
{AppendLogFile("ColorSelectSlider "+i);
ColorSelectorSliders[i].selectSlider();
}} 
if(TextFields[10].over()) TextFields[10].SelectField();
if (ColorSelectorCancel.over())
{DXcJNIU = false;
return true;
}if (ColorSelectorApply.over())
{ApplyColorSelection();
}}		
else
{	
DXcJNIU = false; 
}	
return true;
} 
public void ApplyColorSelection()
{DXcJNIU = false;
if(TextFields[10].Selected == true)
{TextFields[10].Selected = false; 
if(!TextFields[10].Label.equals("")) 
{if(PApplet.parseInt(TextFields[10].Label) > ColorSelectorSliders[0].Maximum) TextFields[10].Label = ""+ColorSelectorSliders[0].Maximum; 
SliderPointer.Value = PApplet.parseInt(TextFields[10].Label); 
ColorSelector.slRed = ColorSelectorSliders[0].Value;
ColorSelector.slGreen = ColorSelectorSliders[1].Value;
ColorSelector.slBlue = ColorSelectorSliders[2].Value;	
ColorSelector.slWhite = ColorSelectorSliders[3].Value;
}			
}			
if(GraphicFuncPaintButton.Selected == true || oxBdCTXPick == true)
{oxBdCTX[0] = ColorSelectorSliders[0].Value;
oxBdCTX[1] = ColorSelectorSliders[1].Value;
oxBdCTX[2] = ColorSelectorSliders[2].Value;
oxBdCTX[3] = ColorSelectorSliders[3].Value;
PaintRects[PaintRectID].Red = oxBdCTX[0];
PaintRects[PaintRectID].Green = oxBdCTX[1];
PaintRects[PaintRectID].Blue = oxBdCTX[2];
PaintRects[PaintRectID].White = oxBdCTX[3];
oxBdCTXPick = false;
return; 
}else if (ColorSelector.mode == 3) 
{AppendLogFile("LiveConDataType: "+LiveConDataType);
switch(LiveConDataType)
{case 0: 
ControlSliders[ColorSelector.passedChan*LiveConDataMult].Value = ColorSelectorSliders[3].Value;
break;
case 1: 
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)].Value = ColorSelectorSliders[0].Value;
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+1].Value = ColorSelectorSliders[1].Value;
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+2].Value = ColorSelectorSliders[2].Value;
break;
case 2: 
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)].Value = ColorSelectorSliders[0].Value;
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+1].Value = ColorSelectorSliders[1].Value;
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+2].Value = ColorSelectorSliders[2].Value;
ControlSliders[(ColorSelector.passedChan*LiveConDataMult)+3].Value = ColorSelectorSliders[3].Value;            
break;
}ControlRects[ColorSelector.passedChan].Red = ColorSelectorSliders[0].Value;
ControlRects[ColorSelector.passedChan].Green = ColorSelectorSliders[1].Value;
ControlRects[ColorSelector.passedChan].Blue = ColorSelectorSliders[2].Value;
ControlRects[ColorSelector.passedChan].White = ColorSelectorSliders[3].Value;
AJcBVWK = true;
}				
else if (ColorSelector.mode == 2) 
{AppendLogFile("Run Apply Color to Group");
for (int q = 0; q != nRudTeq; q++)  
{  
if(PixelIcon[q].GroupID == gdHgLUO)
{AppendLogFile("LED Icon "+q+" is in group "+gdHgLUO);
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[3].Value;
break;
case 1: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+2] = ColorSelectorSliders[2].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+3] = ColorSelectorSliders[3].Value;
break;
}}	
} 
}else if (ColorSelector.mode == 1 || UserSequences[AkOQmUe].SeqMode == kRMfOXG) 
{AppendLogFile("Run Apply All");
for (int q = 0; q != oiHkAsJ; q++)  
{  
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[3].Value;
break;
case 1: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
UserSequences[AkOQmUe].DataFrames[lQGtaTe][q * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+2] = ColorSelectorSliders[2].Value;
UserSequences[AkOQmUe].DataFrames[lQGtaTe][(q * ByoKxya)+3] = ColorSelectorSliders[3].Value;
break;
}} 
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{GradientRects[lQGtaTe-UkmBkwh].Red = ColorSelectorSliders[0].Value;
GradientRects[lQGtaTe-UkmBkwh].Green = ColorSelectorSliders[1].Value;
GradientRects[lQGtaTe-UkmBkwh].Blue = ColorSelectorSliders[2].Value;
GradientRects[lQGtaTe-UkmBkwh].White = ColorSelectorSliders[3].Value;
}		
}else if(ColorSelector.mode == 4)
{AppendLogFile("Filling Tech Color");
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[3].Value;
break;
case 1: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+2] = ColorSelectorSliders[2].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan+3] = ColorSelectorSliders[3].Value;
break;
}fillTechColorRects();
}else 
{AppendLogFile("Filling Color Normally");
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya] = ColorSelectorSliders[3].Value;
break;
case 1: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya+2] = ColorSelectorSliders[2].Value;
break;
case 2: 
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya] = ColorSelectorSliders[0].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya+1] = ColorSelectorSliders[1].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya+2] = ColorSelectorSliders[2].Value;
UserSequences[AkOQmUe].DataFrames[ColorSelector.passedFrame][ColorSelector.passedChan * ByoKxya+3] = ColorSelectorSliders[3].Value;
break;
}if(UserSequences[AkOQmUe].SeqMode == XyiEbAJ) MenuTabs[1].refresh();
MenuTabs[0].refresh();
}redraw();
for (int i=0; i != paletteColors.length;i++)
{if(paletteColors[i][0] == ColorSelectorSliders[0].Value && paletteColors[i][1] == ColorSelectorSliders[1].Value && paletteColors[i][2] == ColorSelectorSliders[2].Value && paletteColors[i][3] == ColorSelectorSliders[3].Value)
{AppendLogFile("Color already on palette, not added");
break; 
}if(i == 5) 
{paletteColors[UoTDXgS][0] = ColorSelectorSliders[0].Value;
paletteColors[UoTDXgS][1] = ColorSelectorSliders[1].Value;
paletteColors[UoTDXgS][2] = ColorSelectorSliders[2].Value;
paletteColors[UoTDXgS][3] = ColorSelectorSliders[3].Value;
UoTDXgS++;
if(UoTDXgS == 6) UoTDXgS = 0; 
}} 
switch(uBYXrqM)
{case 0:
if(ColorSelector.mode == 2 || UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
}else UpdateColorChannelBuffer(ColorSelector.passedChan);	
break;
case 1:
if(ColorSelector.mode == 1 || UserSequences[AkOQmUe].SeqMode == kRMfOXG)
{BuildGradientMenu();
DrawTimeLineBuffer();
}
else if(UserSequences[AkOQmUe].SeqMode != mTKKGDu) UpdateColorChannelBuffer(ColorSelector.passedChan);
else MenuTabs[1].refresh(); 
MenuTabs[0].refresh(); 
break;
} 		
}public boolean pressHandlerConfirmBox()
{	
if(gQWmajl > 0) 
{		
if(ConfirmButtonYes.overB())
{AppendLogFile("Pressed Yes on ID#: "+gQWmajl);
AppendLogFile(cConfirmBoxText[gQWmajl]);
redraw();
int holdgQWmajl = gQWmajl;
gQWmajl = 0;
switch(holdgQWmajl)
{case 0:
break;		
case 1:
RequestFullUpload();	
break;		
case 2: 
DeleteSequence();		
break;		
case 3: 
InitNoSequences();
case 4: 
for (int q =0; q != IndexMapArray.length; q++) IndexMapArray[q] = cfXHabo;
IndexMapPointer = 1;   
IndexScrollBar.Value = 0;
DrawIndexScrollArea(); 		
device.UserIdleSequence = 0; 
break;	
case 5: 
if(device.BasicVersion > 0) 
{NyqOxsk(13);
}else
{	
uqdivtD = PApplet.parseInt(TextFields[11].Label);
if(uqdivtD > device.Channels)
{uqdivtD = device.Channels;
TextFields[11].Label = ""+uqdivtD;
}MenuTabs[1].refresh(); 
MenuTabs[0].refresh();
}				
TextFields[11].Selected = false; 
break;	
case 6: 
break;
case 7: 
DACOCBN = true;
RequestFullUpload();
break;	
case 8: 
break;
case 9: 
rYrXIPl = WojVIii; 
cmdData[0] = 0;
cmdData[1] = 0; 
cmdData[2] = 0;  
cmdData[3] = 0;  
RequestCommand();
break;
case 10: 
try {
LoadUserSequencesFile(iKxwBtq);
}catch(Exception e)	{
gQWmajl = 6;
}break;
case 12:		
if(device.BasicVersion == 2) RequestConfigurationUploadType2();
else RequestConfigurationUpload(); 
break;	
case 13: 
AddToLayout();
break;	
case 14: 
try {	
for (int i = 0; i != naJDfWm; i++)
{PixelIcon[i].GroupID = vXzCEzG;
} 
}catch(Exception e) { AppendLogFile("Couldn't merge all Icons");}	
break;
case 15: 
try {	
for (int i = 0; i != naJDfWm; i++)
{if(PixelIcon[i].GroupID == vXzCEzG) PixelIcon[i].GroupID = zIQLTNT; 
} 
}catch(Exception e) { AppendLogFile("Catch at Clear Group");}					
break;
case 16: 
StartValReset.Selected = true;
ResetStartValuesCommon(AkOQmUe);
NyqOxsk(2); 
MenuTabs[0].refresh();	
MenuTabs[1].refresh();	
break;	
case 17: 
RequestGammaTableUpload(0); 
break;	
case 18: 
RequestGammaTableUpload(1); 
break;	
case 19: 
RequestDeviceConfigurations();
break;					
} 
}
if(ConfirmButtonNo.overB())
{AppendLogFile("Pressed No on");
AppendLogFile(cConfirmBoxText[gQWmajl]);
redraw();
switch(gQWmajl)
{case 0:
break;
case 1:
break;
case 2:
SoftwareButtons[4].Selected = false;
SoftwareButtons[7].Selected = false;		  
break;		
case 3:
break;
case 4:
break;
case 5: 
TextFields[11].Label = ""+uqdivtD;
break;	
case 6: 
break;
case 7: 
UserSequences[AkOQmUe].Highlighted = false;
AkOQmUe = NHYXqPY;
UserSequences[AkOQmUe].Highlighted = true;
MenuTabs[uBYXrqM].Selected = false;  
uBYXrqM = 1;
MenuTabs[uBYXrqM].Selected = true;
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
MenuTabs[2].refresh(); 
LoadSequence();
break;		
case 8: 
break;
case 9: 
break;	
case 10: 
break;
case 16: 
break;		
}	
gQWmajl = 0;
}return true;
}return false;
}public void CheckStartVals(int passedSequence)
{int tempFrameVar = 0;
int RStart = 0;
int GStart = 0;
int BStart = 0;
int WStart = 0;
int CurrentStartR = 0;
int CurrentStartG = 0;
int CurrentStartB = 0;
int CurrentStartW = 0;
int CurrentEndR = 0;
int CurrentEndG = 0;
int CurrentEndB = 0;
int CurrentEndW = 0;
for (int i = 0; i != oiHkAsJ; i++)
{if (UserSequences[passedSequence].SeqMode != lMBafjD)
{switch(QCZOouc)
{case 2: 
WStart = UserSequences[passedSequence].StartValues[(i*ByoKxya)+3]; 
case 1: 
RStart = UserSequences[passedSequence].StartValues[(i*ByoKxya)];
GStart = UserSequences[passedSequence].StartValues[(i*ByoKxya)+1];
BStart = UserSequences[passedSequence].StartValues[(i*ByoKxya)+2];
break;
case 0: 
WStart = UserSequences[passedSequence].StartValues[(i*ByoKxya)]; 
break;	
}	
tempFrameVar = UserSequences[passedSequence].DataFrameVar[(i*ByoKxya)];
switch(QCZOouc)
{case 2: 
CurrentStartW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+3];
case 1: 
CurrentStartR = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)];
CurrentStartG = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+1];
CurrentStartB = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+2];
break;
case 0: 
CurrentStartW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)];
break;	
}	  	  
if (tempFrameVar < UserSequences[passedSequence].SeqFrameAmount) tempFrameVar++;
else tempFrameVar = 0; 
switch(QCZOouc)
{case 2: 
CurrentEndW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+3];
case 1: 
CurrentEndR = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)];
CurrentEndG = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+1]; 
CurrentEndB = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)+2];
break;
case 0: 
CurrentEndW = UserSequences[passedSequence].DataFrames[tempFrameVar][(i*ByoKxya)];
break;	
}	 	  
tempFrameVar = UserSequences[passedSequence].DataFrameVar[(i*ByoKxya)];
switch(QCZOouc)
{case 0: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[passedSequence].StartValError = true;
break;	
case 2: 
if(WithinStartLimits(WStart, CurrentStartW, CurrentEndW) == false) UserSequences[passedSequence].StartValError = true;
case 1: 
if(WithinStartLimits(RStart, CurrentStartR, CurrentEndR) == false) UserSequences[passedSequence].StartValError = true;
if(WithinStartLimits(GStart, CurrentStartG, CurrentEndG) == false) UserSequences[passedSequence].StartValError = true;
if(WithinStartLimits(BStart, CurrentStartB, CurrentEndB) == false) UserSequences[passedSequence].StartValError = true;			
break;
}					
}} 
} 
public void MeasureSequenceLength(int SelSeq)
{int SeqLength = smFWXrf; 
if(UserSequences[SelSeq].SeqMode == EqPnOUb)
{SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);		
SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);		
}else if(UserSequences[SelSeq].SeqMode == kRMfOXG)
{SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);		
SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*4);
}	
else if(UserSequences[SelSeq].SeqMode == lMBafjD)
{SeqLength += (UserSequences[SelSeq].DataSize+UserSequences[SelSeq].DataSize);			
SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * 2);
SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);
}		
else if(UserSequences[SelSeq].SeqMode == mTKKGDu)
{SeqLength += (UserSequences[SelSeq].DataSize);		
SeqLength += (UserSequences[SelSeq].SeqFrameAmount+1) * updateTechTotalColorChannel(SelSeq);	
SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * updateTechTotalColorChannel(SelSeq)) * 2; 
SeqLength += (((UserSequences[SelSeq].SeqFrameAmount+1) * 2) * UserSequences[SelSeq].DataSize); 
}		
else if(UserSequences[SelSeq].SeqMode == XyiEbAJ)
{if(UserSequences[AkOQmUe].POVVideoMode == true)  SeqLength += (UserSequences[SelSeq].POVFramesAmount*UserSequences[SelSeq].DataSize);
else SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);
}			
else if(UserSequences[SelSeq].SeqMode == xvXsTNs)
{SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1)*UserSequences[SelSeq].DataSize);
}		
else if(UserSequences[SelSeq].SeqMode == qzXknoY)
{SeqLength += ((UserSequences[SelSeq].SeqFrameAmount+1) * 4);
}		
UserSequences[SelSeq].Length = SeqLength; 
AppendLogFile("MeasureSequenceLength() with "+SelSeq+"   Result: "+SeqLength);	
} 
public void AddSequence()
{UserSequences = (UserSequenceObj[]) expand(UserSequences, UserSequences.length+1); 
AppendLogFile("AddSequence() - Length is now "+UserSequences.length);	
UserSequences[UserSequences.length-1] = UserSequences[UserSequences.length-1] = new UserSequenceObj("User Added "+(UserSequences.length-1), (UserSequences.length-1), device.Channels); 
UserSequences[UserSequences.length-1].DataFrameVar = new int[device.Channels];
UserSequences[UserSequences.length-1].StartValues = new int[device.Channels];
UserSequences[UserSequences.length-1].SlideValues = new int[2];	
UserSequences[UserSequences.length-1].SlideFlags = new int[2];
UserSequences[UserSequences.length-1].DataFrames = new int[2][device.Channels];   
UserSequences[UserSequences.length-1].TechFlags = new int[2][wqajEny];  
UserSequences[UserSequences.length-1].TechTime = new int[2][wqajEny];  
UserSequences[AkOQmUe].Highlighted = false;
AkOQmUe = (UserSequences.length-1);
lQGtaTe = 0;
SetlQGtaTe(lQGtaTe);
UserSequences[AkOQmUe].Highlighted = true;
UpdateSequence(AkOQmUe);
UpdateSideBarButtonStates();
if(PixelIcon[0] == null) 
{ 
fdJgaNC = 0; 
GraphicLayoutBuild(0); 
AppendLogFile("Defaulted Config Shape");
}} 
public void ResizeSequenceFrameAmt(int SelSeq)
{AppendLogFile("ResizeSequences() with "+SelSeq);	
int newFrameAmt = (UserSequences[SelSeq].SeqFrameAmount+1); 
UserSequences[SelSeq].SlideFlags = expand(UserSequences[SelSeq].SlideFlags, newFrameAmt);		
UserSequences[SelSeq].SlideValues = expand(UserSequences[SelSeq].SlideValues, newFrameAmt);
UserSequences[SelSeq].DataFrames = (int[][])expand(UserSequences[SelSeq].DataFrames, newFrameAmt);
for(int i = 0; i != UserSequences[SelSeq].DataFrames.length; i++)
{if(UserSequences[SelSeq].DataFrames[i] == null)	
UserSequences[SelSeq].DataFrames[i] = new int[device.Channels];	
}	
UserSequences[SelSeq].TechFlags = (int[][])expand(UserSequences[SelSeq].TechFlags, newFrameAmt);
if(UserSequences[SelSeq].TechFlags[UserSequences[SelSeq].TechFlags.length-1] == null)	
UserSequences[SelSeq].TechFlags[UserSequences[SelSeq].TechFlags.length-1] = new int[device.Channels];	
UserSequences[SelSeq].TechTime = (int[][])expand(UserSequences[SelSeq].TechTime, newFrameAmt);
if(UserSequences[SelSeq].TechTime[UserSequences[SelSeq].TechTime.length-1] == null)	
UserSequences[SelSeq].TechTime[UserSequences[SelSeq].TechTime.length-1] = new int[device.Channels];		
if(UserSequences[SelSeq].SeqMode == qzXknoY) UserSequences[SelSeq].DataFrameVar = expand(UserSequences[SelSeq].DataFrameVar, newFrameAmt);
} 
public void InitNoSequences()
{AppendLogFile("InitNoSequences()");
UserSequences = new UserSequenceObj[1];
for (int i =0; i != UserSequences.length; i++)
{UserSequences[i] = new UserSequenceObj("EMPTY", i, 1);
UserSequences[i].DataFrameVar = new int[1];
UserSequences[i].StartValues = new int[1];
UserSequences[i].SlideValues = new int[2];
UserSequences[i].SlideFlags = new int[2];
UserSequences[i].DataFrames = new int[2][1];  
UserSequences[i].TechFlags = new int[2][1];  
UserSequences[i].TechTime = new int[2][1];  
} 
AkOQmUe = 0;
for (int i =0; i != IndexMapArray.length; i++) IndexMapArray[i] = cfXHabo; 
SequenceSelectScrollBar.Value = 0;	
DrawUserSeqIconBuffer(9999);
} 
public void DuplicateSequence()
{AppendLogFile("DuplicateSequence() "+dfXKrgk+" : "+UserSequences.length);
UserSequences = (UserSequenceObj[]) expand(UserSequences, UserSequences.length+1);
UserSequences[UserSequences.length-1] = new UserSequenceObj("User Added "+(UserSequences.length-1), (UserSequences.length-1), UserSequences[dfXKrgk].DataSize); 
int newFrameAmt = UserSequences[dfXKrgk].SeqFrameAmount+1;
UserSequences[UserSequences.length-1].DataFrameVar = new int[device.Channels];
UserSequences[UserSequences.length-1].StartValues = new int[device.Channels];
UserSequences[UserSequences.length-1].SlideValues = new int[newFrameAmt]; 
UserSequences[UserSequences.length-1].SlideFlags = new int[newFrameAmt];
if(UserSequences[dfXKrgk].SeqMode == mTKKGDu) UserSequences[UserSequences.length-1].DataFrames = new int[newFrameAmt*2][device.Channels];
else UserSequences[UserSequences.length-1].DataFrames = new int[newFrameAmt][device.Channels];
UserSequences[UserSequences.length-1].TechFlags = new int[newFrameAmt][device.Channels];  
UserSequences[UserSequences.length-1].TechTime = new int[newFrameAmt][device.Channels];  	
for(int i = 0; i != UserSequences[dfXKrgk].DataSize; i++) 
{UserSequences[UserSequences.length-1].DataFrameVar[i] = UserSequences[dfXKrgk].DataFrameVar[i];
UserSequences[UserSequences.length-1].StartValues[i] = UserSequences[dfXKrgk].StartValues[i];
}for(int i = 0; i != (UserSequences[dfXKrgk].SeqFrameAmount+1); i++)
{UserSequences[UserSequences.length-1].SlideValues[i] = UserSequences[dfXKrgk].SlideValues[i];
UserSequences[UserSequences.length-1].SlideFlags[i] = UserSequences[dfXKrgk].SlideFlags[i];
for(int q = 0; q != UserSequences[dfXKrgk].DataSize; q++)
{if(UserSequences[dfXKrgk].SeqMode != mTKKGDu) UserSequences[UserSequences.length-1].DataFrames[i][q] = UserSequences[dfXKrgk].DataFrames[i][q];
UserSequences[UserSequences.length-1].TechFlags[i][q] = UserSequences[dfXKrgk].TechFlags[i][q];
UserSequences[UserSequences.length-1].TechTime[i][q] = UserSequences[dfXKrgk].TechTime[i][q];
}}
if(UserSequences[dfXKrgk].SeqMode == mTKKGDu)
{for(int i = 0; i != (UserSequences[dfXKrgk].SeqFrameAmount+1)*2; i++)
{for(int q = 0; q != UserSequences[dfXKrgk].DataSize; q++)
{UserSequences[UserSequences.length-1].DataFrames[i][q] = UserSequences[dfXKrgk].DataFrames[i][q];
}}
}UserSequences[UserSequences.length-1].UserID = UserSequences[dfXKrgk].UserID;
UserSequences[UserSequences.length-1].SeqListNum = UserSequences[dfXKrgk].SeqListNum;
UserSequences[UserSequences.length-1].Length = UserSequences[dfXKrgk].Length;
UserSequences[UserSequences.length-1].SeqFrameAmount = UserSequences[dfXKrgk].SeqFrameAmount;
UserSequences[UserSequences.length-1].Speed = UserSequences[dfXKrgk].Speed;
UserSequences[UserSequences.length-1].DataSize = UserSequences[dfXKrgk].DataSize;
UserSequences[UserSequences.length-1].SeqMode = UserSequences[dfXKrgk].SeqMode;
UserSequences[UserSequences.length-1].DataType = UserSequences[dfXKrgk].DataType;
UserSequences[UserSequences.length-1].SeqPlayMode = UserSequences[dfXKrgk].SeqPlayMode;
UserSequences[UserSequences.length-1].SeqTransitionFlags = UserSequences[dfXKrgk].SeqTransitionFlags;
UserSequences[UserSequences.length-1].PacketCloneMode = UserSequences[dfXKrgk].PacketCloneMode;
UserSequences[UserSequences.length-1].SeqTransSpeed = UserSequences[dfXKrgk].SeqTransSpeed; 
UserSequences[UserSequences.length-1].SequenceIntensity = UserSequences[dfXKrgk].SequenceIntensity;
UserSequences[UserSequences.length-1].gradientSteps = UserSequences[dfXKrgk].gradientSteps;
UserSequences[UserSequences.length-1].POVConfigType = UserSequences[dfXKrgk].POVConfigType;
UserSequences[UserSequences.length-1].POVUsageMode = UserSequences[dfXKrgk].POVUsageMode;
UserSequences[UserSequences.length-1].POVFramesAmount = UserSequences[dfXKrgk].POVFramesAmount;
UserSequences[UserSequences.length-1].POVVideoMode = UserSequences[dfXKrgk].POVVideoMode;
} 
public void DeleteSequence()
{AppendLogFile("DeleteSequence() "+dfXKrgk+" : "+UserSequences.length);
if (dfXKrgk == 0 && UserSequences.length < 2) return;
for (int i = dfXKrgk; i < UserSequences.length; i++) 
{try 
{UserSequences[i] = UserSequences[i+1];
}catch(Exception e) {
AppendLogFile("Exception attempting to shift sequence objects down");
}} 
for (int q = 0; q != device.MaxIndexedSequences; q++) 
{if(IndexMapArray[q] == dfXKrgk) 
{IndexMapArray[q] = cfXHabo;
for (int i = q; i != (device.MaxIndexedSequences-1); i++) 
{IndexMapArray[i] = IndexMapArray[i+1]; 	
}}		
}for (int q = 0; q != device.MaxIndexedSequences; q++) 
{	
if(IndexMapArray[q] < cfXHabo && IndexMapArray[q] > dfXKrgk)
{AppendLogFile("IndexMapArray: "+IndexMapArray[q]);
IndexMapArray[q]--;
}		
} 
UserSequences = (UserSequenceObj[])shorten(UserSequences); 
for (int i = 0; i != UserSequences.length; i++) 
{	
UserSequences[i].SeqListNum = i; 
UserSequences[i].Highlighted = false; 
}for (int q = 1; q != UserSequences.length; q++)
{if(UserSequences[q].SeqMode == qzXknoY)
{	
AppendLogFile("Found a linked with to check"+q);
for (int yy = 0; yy != UserSequences[q].SeqFrameAmount+1; yy++)
{if(UserSequences[q].SlideFlags[yy] == dfXKrgk)
{	
AppendLogFile("One sequence to be removed from linked");
UserSequences[q].SlideFlags[yy] = 0;
NyqOxsk(25); 
}	
else if(UserSequences[q].SlideFlags[yy] > dfXKrgk)
{UserSequences[q].SlideFlags[yy]--;	
}}
} 
}	
if(device.UserIdleSequence == dfXKrgk) device.UserIdleSequence = 0; 
else if(device.UserIdleSequence > dfXKrgk) device.UserIdleSequence--; 
AkOQmUe = 1;
UserSequences[AkOQmUe].Highlighted = true;
LoadSequence();
DrawUserSeqIconBuffer(9999); 
MenuTabs[2].refresh(); 
} 
public void UpdateSequence(int passedID)
{AppendLogFile("UpdateSequence() "+passedID);
ByoKxya = 1; 
if (UserSequences[passedID].DataType == 1) ByoKxya  = 3;
else if (UserSequences[passedID].DataType == 2) ByoKxya  =  4;  
QCZOouc = UserSequences[passedID].DataType; 
if (UserSequences[passedID].DataType == 0) oiHkAsJ = UserSequences[passedID].DataSize;
else oiHkAsJ = UserSequences[passedID].DataSize / ByoKxya;
if(oiHkAsJ == 0) oiHkAsJ = 1; 
TimeLineBuffer = createGraphics(sGOqkUb, (oiHkAsJ*dodEQlf));
AppendLogFile("===============oiHkAsJ: "+oiHkAsJ+"    nRudTeq: "+nRudTeq+"   naJDfWm: "+naJDfWm);  
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
MenuTabs[2].refresh(); 
if(UserSequences[passedID].POVConfigType > 3) UserSequences[passedID].POVConfigType = 0; 
for (int i =0; i != POVOptionButtons.length; i++) POVOptionButtons[i].Selected = false;
POVOptionButtons[UserSequences[passedID].POVConfigType].Selected = true; 	
TimeLineScrollBar.Maximum = (oiHkAsJ*dodEQlf) - ZpIfePQ; 
TimeLineScrollBar.Value = 0;
if(UserSequences[passedID].SeqMode == kRMfOXG)
{for (int x = 0; x != UserSequences[AkOQmUe].SeqFrameAmount+1;x++) 
{switch(QCZOouc)
{case 0: 
for (int i = 0; i != UserSequences[AkOQmUe].DataSize;i++)  UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
break;		
case 1: 
for (int i = 0; i < UserSequences[AkOQmUe].DataSize-2;i+=3)  
{UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
UserSequences[AkOQmUe].DataFrames[x][i+1] = UserSequences[AkOQmUe].DataFrames[x][1];
UserSequences[AkOQmUe].DataFrames[x][i+2] = UserSequences[AkOQmUe].DataFrames[x][2];
}break;
case 2: 
for (int i = 0; i < UserSequences[AkOQmUe].DataSize-3;i+=4)  
{UserSequences[AkOQmUe].DataFrames[x][i] = UserSequences[AkOQmUe].DataFrames[x][0];
UserSequences[AkOQmUe].DataFrames[x][i+1] = UserSequences[AkOQmUe].DataFrames[x][1];
UserSequences[AkOQmUe].DataFrames[x][i+2] = UserSequences[AkOQmUe].DataFrames[x][2];
UserSequences[AkOQmUe].DataFrames[x][i+3] = UserSequences[AkOQmUe].DataFrames[x][3];
}		
break;
}	  
}	
}	
MeasureSequenceLength(passedID);
DrawUserSeqIconBuffer(passedID);
} 
public void LoadSequence()
{AppendLogFile("LoadSequence() "+AkOQmUe);
lQGtaTe = 0;
SetlQGtaTe(lQGtaTe);
UkmBkwh = 0;
YLWNFLV = 0; 
noLoop(); 
if(UserSequences[AkOQmUe].SeqMode == qzXknoY) InitLinkedBuffer(); 
UpdateSideBarButtonStates();
UpdateSequence(AkOQmUe);
if(UserSequences[AkOQmUe].SeqMode == kRMfOXG)  BuildGradientMenu();
if(UserSequences[AkOQmUe].SeqMode == XyiEbAJ)
{POVVidFrame = 0; 
POVModeDD.SelStr = UserSequences[AkOQmUe].POVUsageMode;
POVVideoModeCheckBox.Selected = UserSequences[AkOQmUe].POVVideoMode;
DrawPOVBuffer(); 
POVImg = POVGraphicBuffer; 
}	
} 
public void GenerateGradient()
{AppendLogFile("GenerateGradient()");  
float LocationVar = (256 * (UserSequences[AkOQmUe].SeqFrameAmount+1)); 
float StepFactorH = (float)UserSequences[AkOQmUe].gradientSteps;
if(StepFactorH < 0) StepFactorH = StepFactorH * -1; 
StepFactorH = LocationVar  / StepFactorH;
int FrameVarCurrent = 0; 
int FrameVarNext = 1; 
float StepFactor = 0; 
AppendLogFile("LocationVar: "+LocationVar+" : StepFactorH: "+StepFactorH); 
LocationVar = 0;
switch(QCZOouc)
{case 0: 
UserSequences[AkOQmUe].StartValues[0] = UserSequences[AkOQmUe].DataFrames[0][0];
break;  
case 1:
UserSequences[AkOQmUe].StartValues[0] = UserSequences[AkOQmUe].DataFrames[0][0];
UserSequences[AkOQmUe].StartValues[1] = UserSequences[AkOQmUe].DataFrames[0][1];
UserSequences[AkOQmUe].StartValues[2] = UserSequences[AkOQmUe].DataFrames[0][2];
break;
case 2: 
UserSequences[AkOQmUe].StartValues[0] = UserSequences[AkOQmUe].DataFrames[0][0];
UserSequences[AkOQmUe].StartValues[1] = UserSequences[AkOQmUe].DataFrames[0][1];
UserSequences[AkOQmUe].StartValues[2] = UserSequences[AkOQmUe].DataFrames[0][2];
UserSequences[AkOQmUe].StartValues[3] = UserSequences[AkOQmUe].DataFrames[0][3];
break;
}UserSequences[AkOQmUe].DataFrameVar[0] = 0;
UserSequences[AkOQmUe].DataFrameVar[1] = 0;
UserSequences[AkOQmUe].DataFrameVar[2] = 0;
int HoldCurrent = 0;
int HoldNext = 0;
for (int i=ByoKxya; i != UserSequences[AkOQmUe].DataSize; i++) 
{if ((i%ByoKxya) == 0)
{LocationVar+= StepFactorH; 
if (LocationVar > 255)
{LocationVar -= 256;    
if (FrameVarNext == (UserSequences[AkOQmUe].SeqFrameAmount))
{FrameVarNext = 0; 
FrameVarCurrent = (UserSequences[AkOQmUe].SeqFrameAmount);
}else
{FrameVarNext++;
FrameVarCurrent++;	
if(FrameVarCurrent > UserSequences[AkOQmUe].SeqFrameAmount) FrameVarCurrent = 0;
}} 
}StepFactor = (float)LocationVar / 256; 
HoldCurrent = UserSequences[AkOQmUe].DataFrames[FrameVarCurrent][i];
HoldNext = UserSequences[AkOQmUe].DataFrames[FrameVarNext][i];
if (HoldCurrent == HoldNext) 
{ 
UserSequences[AkOQmUe].StartValues[i] = PApplet.parseInt(255*StepFactor); 
}  
else if (HoldCurrent < HoldNext)  
{UserSequences[AkOQmUe].StartValues[i] = (round((HoldNext - HoldCurrent) * StepFactor)) + HoldCurrent;
}else
{UserSequences[AkOQmUe].StartValues[i] = HoldCurrent - (round((HoldCurrent - HoldNext) * StepFactor));
}UserSequences[AkOQmUe].DataFrameVar[i] = FrameVarCurrent;
} 
if(UserSequences[AkOQmUe].gradientSteps < 0)
{int x = 0;
int[] HoldChanSz = new int[device.Channels];	
switch(QCZOouc)
{case 0: 
arrayCopy(UserSequences[AkOQmUe].DataFrameVar, HoldChanSz, UserSequences[AkOQmUe].DataSize);
x = UserSequences[AkOQmUe].DataSize - 1;  
for(int i = 0; i != UserSequences[AkOQmUe].DataSize; i++)
{UserSequences[AkOQmUe].DataFrameVar[i] = HoldChanSz[x-i];
}	
arrayCopy(UserSequences[AkOQmUe].StartValues, HoldChanSz, UserSequences[AkOQmUe].DataSize);
for(int i = 0; i != UserSequences[AkOQmUe].DataSize; i++) 
{UserSequences[AkOQmUe].StartValues[i] = HoldChanSz[x-i];
} 
break;  
case 1:
arrayCopy(UserSequences[AkOQmUe].DataFrameVar, HoldChanSz, UserSequences[AkOQmUe].DataSize);
x = oiHkAsJ - 1;  
for(int i = 0; i != oiHkAsJ; i++)
{UserSequences[AkOQmUe].DataFrameVar[(i*3)] = HoldChanSz[((x-i)*3)];
UserSequences[AkOQmUe].DataFrameVar[(i*3)+1] = HoldChanSz[((x-i)*3)+1];
UserSequences[AkOQmUe].DataFrameVar[(i*3)+2] = HoldChanSz[((x-i)*3)+2];
}				
arrayCopy(UserSequences[AkOQmUe].StartValues, HoldChanSz, UserSequences[AkOQmUe].DataSize);
for(int i = 0; i != oiHkAsJ; i++) 
{UserSequences[AkOQmUe].StartValues[i*3] = HoldChanSz[((x-i)*3)];
UserSequences[AkOQmUe].StartValues[(i*3)+1] = HoldChanSz[((x-i)*3)+1];
UserSequences[AkOQmUe].StartValues[(i*3)+2] = HoldChanSz[((x-i)*3)+2];
}break;
case 2: 
break;
} 
} 
MenuTabs[0].refresh(); 
MenuTabs[1].refresh(); 
}  
public int updateTechTotalColorChannel(int SelSeq)
{int channelCounter = 0;
tempoiHkAsJ = 0;
for (int i = 0; i != UserSequences[SelSeq].DataSize; i++)
{switch((UserSequences[SelSeq].TechFlags[0][tempoiHkAsJ] & 0x03)) 
{case 0:
channelCounter++;
break;		
case 1:
channelCounter += 3;	
break;
case 2:
channelCounter += 4;	
break;
}	
if(channelCounter > UserSequences[SelSeq].DataSize)
{switch((UserSequences[SelSeq].TechFlags[0][tempoiHkAsJ] & 0x03)) 
{case 0:
channelCounter--;
break;		
case 1:
channelCounter -= 3;	
break;
case 2:
channelCounter -= 4;	
break;
}		
UserSequences[SelSeq].TechFlags[0][tempoiHkAsJ] &= 0xF8; 
while(channelCounter < UserSequences[SelSeq].DataSize)
{channelCounter++;	
tempoiHkAsJ++;
UserSequences[SelSeq].TechFlags[0][tempoiHkAsJ] &= 0xF8; 
}break;
}	
else tempoiHkAsJ++; 
} 
AppendLogFile("updateTechTotalColorChannel() returning "+tempoiHkAsJ);
return tempoiHkAsJ;
} 
public void fillTechColorRects()
{int tempChan = getTechChannelNum(SelectedTechID);
switch(ByoKxya)
{case 1: 
TechnicalColorStart.White = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan];
TechnicalColorEnd.White = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan];
break;
case 3: 
TechnicalColorStart.Red = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan];
TechnicalColorStart.Green = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan+1];
TechnicalColorStart.Blue = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan+2];
TechnicalColorEnd.Red = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan];
TechnicalColorEnd.Green = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan+1];
TechnicalColorEnd.Blue = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan+2];
break;
case 4: 
TechnicalColorStart.Red = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan];
TechnicalColorStart.Green = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan+1];
TechnicalColorStart.Blue = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan+2];
TechnicalColorStart.White = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame][tempChan+3];
TechnicalColorEnd.Red = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan];
TechnicalColorEnd.Green = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan+1];
TechnicalColorEnd.Blue = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan+2];
TechnicalColorEnd.White = UserSequences[AkOQmUe].DataFrames[SelectedTechFrame+1][tempChan+3];
break;
}} 
public int getTechChannelNum(int passedID)
{int channelCounter = 0;
for (int i = 0; i != passedID; i++)
{switch((UserSequences[AkOQmUe].TechFlags[0][i] & 0x03)) 
{case 0:
channelCounter++;
break;		
case 1:
channelCounter += 3;		
break;
case 2:
channelCounter += 4;			
break;
}	
} 
return channelCounter;
} 
public int getTechChanColorMode(int passedChan)
{return (UserSequences[AkOQmUe].TechFlags[0][passedChan] & 0x0003);
}public void InitTechnicalSelectRadial(int passedID, int passedFrame)
{AppendLogFile("InitTechnicalSelectRadial("+passedID+", "+passedFrame+")");
OverlayMenus[7].xpos = EMCDldB;
OverlayMenus[7].ypos = bJxobsd;
RadialTechSolidButton.xpos = OverlayMenus[7].xpos - 25;
RadialTechSolidButton.ypos = OverlayMenus[7].ypos - 60;
RadialTechFadeButton.xpos = OverlayMenus[7].xpos - 45;
RadialTechFadeButton.ypos = OverlayMenus[7].ypos - 35;
TechnicalColorStart.xpos = OverlayMenus[7].xpos - 55;
TechnicalColorStart.ypos = OverlayMenus[7].ypos + 2;
TechnicalColorEnd.xpos = OverlayMenus[7].xpos + 30; 
TechnicalColorEnd.ypos = OverlayMenus[7].ypos + 2;
TXTFTechTime.xpos = OverlayMenus[7].xpos - 25;
TXTFTechTime.ypos = OverlayMenus[7].ypos + 2;
TXTFTechTime.Label = ""+UserSequences[AkOQmUe].TechTime[lQGtaTe][passedID];
RadialTechSolidButton.Selected = false;
RadialTechFadeButton.Selected = false;
SelectedTechID = passedID; 
SelectedTechFrame = (passedFrame*2);
TextFields[6].Label = TXTFTechTime.Label;
if((UserSequences[AkOQmUe].TechFlags[lQGtaTe][passedID] & 0x08) > 0) FrameSeqToolTechDD.SelStr = 0;
else FrameSeqToolTechDD.SelStr = 1;
QCZOouc = getTechChanColorMode(passedID);
ByoKxya = 1; 
if (getTechChanColorMode(passedID) == 1) ByoKxya  = 3;
else if (getTechChanColorMode(passedID) == 2) ByoKxya  =  4;  
fillTechColorRects();
if((UserSequences[AkOQmUe].TechFlags[lQGtaTe][passedID] & 0x08) > 0) RadialTechFadeButton.Selected = true; 
else RadialTechSolidButton.Selected = true;
CrytrWK = 7;
} 
public void InitTechnicalChannelRadial(int passedID)
{AppendLogFile("InitTechnicalChannelRadial()");
OverlayMenus[6].xpos = EMCDldB;
OverlayMenus[6].ypos = bJxobsd;
RadialMenuTechColorMode[0].xpos	= OverlayMenus[6].xpos - 30;
RadialMenuTechColorMode[0].ypos	= OverlayMenus[6].ypos - 45;
RadialMenuTechColorMode[1].xpos	= OverlayMenus[6].xpos - 55;
RadialMenuTechColorMode[1].ypos = OverlayMenus[6].ypos - 20;
RadialMenuTechColorMode[2].xpos	= OverlayMenus[6].xpos + 5;
RadialMenuTechColorMode[2].ypos = OverlayMenus[6].ypos - 20;	
RadialMenuTechColorMode[0].Selected = false;
RadialMenuTechColorMode[1].Selected = false;
RadialMenuTechColorMode[2].Selected = false;
RadialMenuTechColorMode[getTechChanColorMode(passedID)].Selected = true;	
SelectedTechID = passedID;
CrytrWK = 6;
} 
public void FillTechDebug()
{AppendLogFile("FillTechDebug()");	
} 
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "NLEDAurora" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
